// SPDX-License-Identifier: Apache-2.0

// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.36.2
// 	protoc        (unknown)
// source: substrait/algebra.proto

package proto

import (
	extensions "github.com/substrait-io/substrait-go/v3/proto/extensions"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	anypb "google.golang.org/protobuf/types/known/anypb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// Describes which part of an aggregation or window function to perform within
// the context of distributed algorithms.
type AggregationPhase int32

const (
	// Implies `INTERMEDIATE_TO_RESULT`.
	AggregationPhase_AGGREGATION_PHASE_UNSPECIFIED AggregationPhase = 0
	// Specifies that the function should be run only up to the point of
	// generating an intermediate value, to be further aggregated later using
	// INTERMEDIATE_TO_INTERMEDIATE or INTERMEDIATE_TO_RESULT.
	AggregationPhase_AGGREGATION_PHASE_INITIAL_TO_INTERMEDIATE AggregationPhase = 1
	// Specifies that the inputs of the aggregate or window function are the
	// intermediate values of the function, and that the output should also be
	// an intermediate value, to be further aggregated later using
	// INTERMEDIATE_TO_INTERMEDIATE or INTERMEDIATE_TO_RESULT.
	AggregationPhase_AGGREGATION_PHASE_INTERMEDIATE_TO_INTERMEDIATE AggregationPhase = 2
	// A complete invocation: the function should aggregate the given set of
	// inputs to yield a single return value. This style must be used for
	// aggregate or window functions that are not decomposable.
	AggregationPhase_AGGREGATION_PHASE_INITIAL_TO_RESULT AggregationPhase = 3
	// Specifies that the inputs of the aggregate or window function are the
	// intermediate values of the function, generated previously using
	// INITIAL_TO_INTERMEDIATE and possibly INTERMEDIATE_TO_INTERMEDIATE calls.
	// This call should combine the intermediate values to yield the final
	// return value.
	AggregationPhase_AGGREGATION_PHASE_INTERMEDIATE_TO_RESULT AggregationPhase = 4
)

// Enum value maps for AggregationPhase.
var (
	AggregationPhase_name = map[int32]string{
		0: "AGGREGATION_PHASE_UNSPECIFIED",
		1: "AGGREGATION_PHASE_INITIAL_TO_INTERMEDIATE",
		2: "AGGREGATION_PHASE_INTERMEDIATE_TO_INTERMEDIATE",
		3: "AGGREGATION_PHASE_INITIAL_TO_RESULT",
		4: "AGGREGATION_PHASE_INTERMEDIATE_TO_RESULT",
	}
	AggregationPhase_value = map[string]int32{
		"AGGREGATION_PHASE_UNSPECIFIED":                  0,
		"AGGREGATION_PHASE_INITIAL_TO_INTERMEDIATE":      1,
		"AGGREGATION_PHASE_INTERMEDIATE_TO_INTERMEDIATE": 2,
		"AGGREGATION_PHASE_INITIAL_TO_RESULT":            3,
		"AGGREGATION_PHASE_INTERMEDIATE_TO_RESULT":       4,
	}
)

func (x AggregationPhase) Enum() *AggregationPhase {
	p := new(AggregationPhase)
	*p = x
	return p
}

func (x AggregationPhase) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (AggregationPhase) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[0].Descriptor()
}

func (AggregationPhase) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[0]
}

func (x AggregationPhase) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use AggregationPhase.Descriptor instead.
func (AggregationPhase) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0}
}

type RelCommon_Hint_ComputationType int32

const (
	RelCommon_Hint_COMPUTATION_TYPE_UNSPECIFIED  RelCommon_Hint_ComputationType = 0
	RelCommon_Hint_COMPUTATION_TYPE_HASHTABLE    RelCommon_Hint_ComputationType = 1
	RelCommon_Hint_COMPUTATION_TYPE_BLOOM_FILTER RelCommon_Hint_ComputationType = 2
	RelCommon_Hint_COMPUTATION_TYPE_UNKNOWN      RelCommon_Hint_ComputationType = 9999
)

// Enum value maps for RelCommon_Hint_ComputationType.
var (
	RelCommon_Hint_ComputationType_name = map[int32]string{
		0:    "COMPUTATION_TYPE_UNSPECIFIED",
		1:    "COMPUTATION_TYPE_HASHTABLE",
		2:    "COMPUTATION_TYPE_BLOOM_FILTER",
		9999: "COMPUTATION_TYPE_UNKNOWN",
	}
	RelCommon_Hint_ComputationType_value = map[string]int32{
		"COMPUTATION_TYPE_UNSPECIFIED":  0,
		"COMPUTATION_TYPE_HASHTABLE":    1,
		"COMPUTATION_TYPE_BLOOM_FILTER": 2,
		"COMPUTATION_TYPE_UNKNOWN":      9999,
	}
)

func (x RelCommon_Hint_ComputationType) Enum() *RelCommon_Hint_ComputationType {
	p := new(RelCommon_Hint_ComputationType)
	*p = x
	return p
}

func (x RelCommon_Hint_ComputationType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (RelCommon_Hint_ComputationType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[1].Descriptor()
}

func (RelCommon_Hint_ComputationType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[1]
}

func (x RelCommon_Hint_ComputationType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use RelCommon_Hint_ComputationType.Descriptor instead.
func (RelCommon_Hint_ComputationType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 2, 0}
}

type JoinRel_JoinType int32

const (
	JoinRel_JOIN_TYPE_UNSPECIFIED  JoinRel_JoinType = 0
	JoinRel_JOIN_TYPE_INNER        JoinRel_JoinType = 1
	JoinRel_JOIN_TYPE_OUTER        JoinRel_JoinType = 2
	JoinRel_JOIN_TYPE_LEFT         JoinRel_JoinType = 3
	JoinRel_JOIN_TYPE_RIGHT        JoinRel_JoinType = 4
	JoinRel_JOIN_TYPE_LEFT_SEMI    JoinRel_JoinType = 5
	JoinRel_JOIN_TYPE_LEFT_ANTI    JoinRel_JoinType = 6
	JoinRel_JOIN_TYPE_LEFT_SINGLE  JoinRel_JoinType = 7
	JoinRel_JOIN_TYPE_RIGHT_SEMI   JoinRel_JoinType = 8
	JoinRel_JOIN_TYPE_RIGHT_ANTI   JoinRel_JoinType = 9
	JoinRel_JOIN_TYPE_RIGHT_SINGLE JoinRel_JoinType = 10
	JoinRel_JOIN_TYPE_LEFT_MARK    JoinRel_JoinType = 11
	JoinRel_JOIN_TYPE_RIGHT_MARK   JoinRel_JoinType = 12
)

// Enum value maps for JoinRel_JoinType.
var (
	JoinRel_JoinType_name = map[int32]string{
		0:  "JOIN_TYPE_UNSPECIFIED",
		1:  "JOIN_TYPE_INNER",
		2:  "JOIN_TYPE_OUTER",
		3:  "JOIN_TYPE_LEFT",
		4:  "JOIN_TYPE_RIGHT",
		5:  "JOIN_TYPE_LEFT_SEMI",
		6:  "JOIN_TYPE_LEFT_ANTI",
		7:  "JOIN_TYPE_LEFT_SINGLE",
		8:  "JOIN_TYPE_RIGHT_SEMI",
		9:  "JOIN_TYPE_RIGHT_ANTI",
		10: "JOIN_TYPE_RIGHT_SINGLE",
		11: "JOIN_TYPE_LEFT_MARK",
		12: "JOIN_TYPE_RIGHT_MARK",
	}
	JoinRel_JoinType_value = map[string]int32{
		"JOIN_TYPE_UNSPECIFIED":  0,
		"JOIN_TYPE_INNER":        1,
		"JOIN_TYPE_OUTER":        2,
		"JOIN_TYPE_LEFT":         3,
		"JOIN_TYPE_RIGHT":        4,
		"JOIN_TYPE_LEFT_SEMI":    5,
		"JOIN_TYPE_LEFT_ANTI":    6,
		"JOIN_TYPE_LEFT_SINGLE":  7,
		"JOIN_TYPE_RIGHT_SEMI":   8,
		"JOIN_TYPE_RIGHT_ANTI":   9,
		"JOIN_TYPE_RIGHT_SINGLE": 10,
		"JOIN_TYPE_LEFT_MARK":    11,
		"JOIN_TYPE_RIGHT_MARK":   12,
	}
)

func (x JoinRel_JoinType) Enum() *JoinRel_JoinType {
	p := new(JoinRel_JoinType)
	*p = x
	return p
}

func (x JoinRel_JoinType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (JoinRel_JoinType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[2].Descriptor()
}

func (JoinRel_JoinType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[2]
}

func (x JoinRel_JoinType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use JoinRel_JoinType.Descriptor instead.
func (JoinRel_JoinType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{3, 0}
}

type SetRel_SetOp int32

const (
	SetRel_SET_OP_UNSPECIFIED               SetRel_SetOp = 0
	SetRel_SET_OP_MINUS_PRIMARY             SetRel_SetOp = 1
	SetRel_SET_OP_MINUS_PRIMARY_ALL         SetRel_SetOp = 7
	SetRel_SET_OP_MINUS_MULTISET            SetRel_SetOp = 2
	SetRel_SET_OP_INTERSECTION_PRIMARY      SetRel_SetOp = 3
	SetRel_SET_OP_INTERSECTION_MULTISET     SetRel_SetOp = 4
	SetRel_SET_OP_INTERSECTION_MULTISET_ALL SetRel_SetOp = 8
	SetRel_SET_OP_UNION_DISTINCT            SetRel_SetOp = 5
	SetRel_SET_OP_UNION_ALL                 SetRel_SetOp = 6
)

// Enum value maps for SetRel_SetOp.
var (
	SetRel_SetOp_name = map[int32]string{
		0: "SET_OP_UNSPECIFIED",
		1: "SET_OP_MINUS_PRIMARY",
		7: "SET_OP_MINUS_PRIMARY_ALL",
		2: "SET_OP_MINUS_MULTISET",
		3: "SET_OP_INTERSECTION_PRIMARY",
		4: "SET_OP_INTERSECTION_MULTISET",
		8: "SET_OP_INTERSECTION_MULTISET_ALL",
		5: "SET_OP_UNION_DISTINCT",
		6: "SET_OP_UNION_ALL",
	}
	SetRel_SetOp_value = map[string]int32{
		"SET_OP_UNSPECIFIED":               0,
		"SET_OP_MINUS_PRIMARY":             1,
		"SET_OP_MINUS_PRIMARY_ALL":         7,
		"SET_OP_MINUS_MULTISET":            2,
		"SET_OP_INTERSECTION_PRIMARY":      3,
		"SET_OP_INTERSECTION_MULTISET":     4,
		"SET_OP_INTERSECTION_MULTISET_ALL": 8,
		"SET_OP_UNION_DISTINCT":            5,
		"SET_OP_UNION_ALL":                 6,
	}
)

func (x SetRel_SetOp) Enum() *SetRel_SetOp {
	p := new(SetRel_SetOp)
	*p = x
	return p
}

func (x SetRel_SetOp) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (SetRel_SetOp) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[3].Descriptor()
}

func (SetRel_SetOp) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[3]
}

func (x SetRel_SetOp) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use SetRel_SetOp.Descriptor instead.
func (SetRel_SetOp) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{10, 0}
}

type DdlRel_DdlObject int32

const (
	DdlRel_DDL_OBJECT_UNSPECIFIED DdlRel_DdlObject = 0
	// A Table object in the system
	DdlRel_DDL_OBJECT_TABLE DdlRel_DdlObject = 1
	// A View object in the system
	DdlRel_DDL_OBJECT_VIEW DdlRel_DdlObject = 2
)

// Enum value maps for DdlRel_DdlObject.
var (
	DdlRel_DdlObject_name = map[int32]string{
		0: "DDL_OBJECT_UNSPECIFIED",
		1: "DDL_OBJECT_TABLE",
		2: "DDL_OBJECT_VIEW",
	}
	DdlRel_DdlObject_value = map[string]int32{
		"DDL_OBJECT_UNSPECIFIED": 0,
		"DDL_OBJECT_TABLE":       1,
		"DDL_OBJECT_VIEW":        2,
	}
)

func (x DdlRel_DdlObject) Enum() *DdlRel_DdlObject {
	p := new(DdlRel_DdlObject)
	*p = x
	return p
}

func (x DdlRel_DdlObject) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (DdlRel_DdlObject) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[4].Descriptor()
}

func (DdlRel_DdlObject) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[4]
}

func (x DdlRel_DdlObject) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use DdlRel_DdlObject.Descriptor instead.
func (DdlRel_DdlObject) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{20, 0}
}

type DdlRel_DdlOp int32

const (
	DdlRel_DDL_OP_UNSPECIFIED DdlRel_DdlOp = 0
	// A create operation (for any object)
	DdlRel_DDL_OP_CREATE DdlRel_DdlOp = 1
	// A create operation if the object does not exist, or replaces it (equivalent to a DROP + CREATE) if the object already exists
	DdlRel_DDL_OP_CREATE_OR_REPLACE DdlRel_DdlOp = 2
	// An operation that modifies the schema (e.g., column names, types, default values) for the target object
	DdlRel_DDL_OP_ALTER DdlRel_DdlOp = 3
	// An operation that removes an object from the system
	DdlRel_DDL_OP_DROP DdlRel_DdlOp = 4
	// An operation that removes an object from the system (without throwing an exception if the object did not exist)
	DdlRel_DDL_OP_DROP_IF_EXIST DdlRel_DdlOp = 5
)

// Enum value maps for DdlRel_DdlOp.
var (
	DdlRel_DdlOp_name = map[int32]string{
		0: "DDL_OP_UNSPECIFIED",
		1: "DDL_OP_CREATE",
		2: "DDL_OP_CREATE_OR_REPLACE",
		3: "DDL_OP_ALTER",
		4: "DDL_OP_DROP",
		5: "DDL_OP_DROP_IF_EXIST",
	}
	DdlRel_DdlOp_value = map[string]int32{
		"DDL_OP_UNSPECIFIED":       0,
		"DDL_OP_CREATE":            1,
		"DDL_OP_CREATE_OR_REPLACE": 2,
		"DDL_OP_ALTER":             3,
		"DDL_OP_DROP":              4,
		"DDL_OP_DROP_IF_EXIST":     5,
	}
)

func (x DdlRel_DdlOp) Enum() *DdlRel_DdlOp {
	p := new(DdlRel_DdlOp)
	*p = x
	return p
}

func (x DdlRel_DdlOp) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (DdlRel_DdlOp) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[5].Descriptor()
}

func (DdlRel_DdlOp) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[5]
}

func (x DdlRel_DdlOp) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use DdlRel_DdlOp.Descriptor instead.
func (DdlRel_DdlOp) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{20, 1}
}

type WriteRel_WriteOp int32

const (
	WriteRel_WRITE_OP_UNSPECIFIED WriteRel_WriteOp = 0
	// The insert of new records in a table
	WriteRel_WRITE_OP_INSERT WriteRel_WriteOp = 1
	// The removal of records from a table
	WriteRel_WRITE_OP_DELETE WriteRel_WriteOp = 2
	// The modification of existing records within a table
	WriteRel_WRITE_OP_UPDATE WriteRel_WriteOp = 3
	// The Creation of a new table, and the insert of new records in the table
	WriteRel_WRITE_OP_CTAS WriteRel_WriteOp = 4
)

// Enum value maps for WriteRel_WriteOp.
var (
	WriteRel_WriteOp_name = map[int32]string{
		0: "WRITE_OP_UNSPECIFIED",
		1: "WRITE_OP_INSERT",
		2: "WRITE_OP_DELETE",
		3: "WRITE_OP_UPDATE",
		4: "WRITE_OP_CTAS",
	}
	WriteRel_WriteOp_value = map[string]int32{
		"WRITE_OP_UNSPECIFIED": 0,
		"WRITE_OP_INSERT":      1,
		"WRITE_OP_DELETE":      2,
		"WRITE_OP_UPDATE":      3,
		"WRITE_OP_CTAS":        4,
	}
)

func (x WriteRel_WriteOp) Enum() *WriteRel_WriteOp {
	p := new(WriteRel_WriteOp)
	*p = x
	return p
}

func (x WriteRel_WriteOp) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (WriteRel_WriteOp) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[6].Descriptor()
}

func (WriteRel_WriteOp) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[6]
}

func (x WriteRel_WriteOp) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use WriteRel_WriteOp.Descriptor instead.
func (WriteRel_WriteOp) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{21, 0}
}

type WriteRel_CreateMode int32

const (
	WriteRel_CREATE_MODE_UNSPECIFIED       WriteRel_CreateMode = 0
	WriteRel_CREATE_MODE_APPEND_IF_EXISTS  WriteRel_CreateMode = 1 // Append the data to the table if it already exists
	WriteRel_CREATE_MODE_REPLACE_IF_EXISTS WriteRel_CreateMode = 2 // Replace the table if it already exists ("OR REPLACE")
	WriteRel_CREATE_MODE_IGNORE_IF_EXISTS  WriteRel_CreateMode = 3 // Ignore the request if the table already exists ("IF NOT EXISTS")
	WriteRel_CREATE_MODE_ERROR_IF_EXISTS   WriteRel_CreateMode = 4 // Throw an error if the table already exists (default behavior)
)

// Enum value maps for WriteRel_CreateMode.
var (
	WriteRel_CreateMode_name = map[int32]string{
		0: "CREATE_MODE_UNSPECIFIED",
		1: "CREATE_MODE_APPEND_IF_EXISTS",
		2: "CREATE_MODE_REPLACE_IF_EXISTS",
		3: "CREATE_MODE_IGNORE_IF_EXISTS",
		4: "CREATE_MODE_ERROR_IF_EXISTS",
	}
	WriteRel_CreateMode_value = map[string]int32{
		"CREATE_MODE_UNSPECIFIED":       0,
		"CREATE_MODE_APPEND_IF_EXISTS":  1,
		"CREATE_MODE_REPLACE_IF_EXISTS": 2,
		"CREATE_MODE_IGNORE_IF_EXISTS":  3,
		"CREATE_MODE_ERROR_IF_EXISTS":   4,
	}
)

func (x WriteRel_CreateMode) Enum() *WriteRel_CreateMode {
	p := new(WriteRel_CreateMode)
	*p = x
	return p
}

func (x WriteRel_CreateMode) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (WriteRel_CreateMode) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[7].Descriptor()
}

func (WriteRel_CreateMode) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[7]
}

func (x WriteRel_CreateMode) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use WriteRel_CreateMode.Descriptor instead.
func (WriteRel_CreateMode) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{21, 1}
}

type WriteRel_OutputMode int32

const (
	WriteRel_OUTPUT_MODE_UNSPECIFIED WriteRel_OutputMode = 0
	// return no records at all
	WriteRel_OUTPUT_MODE_NO_OUTPUT WriteRel_OutputMode = 1
	// this mode makes the operator return all the record INSERTED/DELETED/UPDATED by the operator.
	// The operator returns the AFTER-image of any change. This can be further manipulated by operators upstreams
	// (e.g., retunring the typical "count of modified records").
	// For scenarios in which the BEFORE image is required, the user must implement a spool (via references to
	// subplans in the body of the Rel input) and return those with anounter PlanRel.relations.
	WriteRel_OUTPUT_MODE_MODIFIED_RECORDS WriteRel_OutputMode = 2
)

// Enum value maps for WriteRel_OutputMode.
var (
	WriteRel_OutputMode_name = map[int32]string{
		0: "OUTPUT_MODE_UNSPECIFIED",
		1: "OUTPUT_MODE_NO_OUTPUT",
		2: "OUTPUT_MODE_MODIFIED_RECORDS",
	}
	WriteRel_OutputMode_value = map[string]int32{
		"OUTPUT_MODE_UNSPECIFIED":      0,
		"OUTPUT_MODE_NO_OUTPUT":        1,
		"OUTPUT_MODE_MODIFIED_RECORDS": 2,
	}
)

func (x WriteRel_OutputMode) Enum() *WriteRel_OutputMode {
	p := new(WriteRel_OutputMode)
	*p = x
	return p
}

func (x WriteRel_OutputMode) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (WriteRel_OutputMode) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[8].Descriptor()
}

func (WriteRel_OutputMode) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[8]
}

func (x WriteRel_OutputMode) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use WriteRel_OutputMode.Descriptor instead.
func (WriteRel_OutputMode) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{21, 2}
}

// Most joins will use one of the following behaviors.  To avoid the complexity
// of a function lookup we define the common behaviors here
type ComparisonJoinKey_SimpleComparisonType int32

const (
	ComparisonJoinKey_SIMPLE_COMPARISON_TYPE_UNSPECIFIED ComparisonJoinKey_SimpleComparisonType = 0
	// Returns true only if both values are equal and not null
	ComparisonJoinKey_SIMPLE_COMPARISON_TYPE_EQ ComparisonJoinKey_SimpleComparisonType = 1
	// Returns true if both values are equal and not null
	// Returns true if both values are null
	// Returns false if one value is null and the other value is not null
	//
	// This can be expressed as a = b OR (isnull(a) AND isnull(b))
	ComparisonJoinKey_SIMPLE_COMPARISON_TYPE_IS_NOT_DISTINCT_FROM ComparisonJoinKey_SimpleComparisonType = 2
	// Returns true if both values are equal and not null
	// Returns true if either value is null
	//
	// This can be expressed as a = b OR isnull(a = b)
	ComparisonJoinKey_SIMPLE_COMPARISON_TYPE_MIGHT_EQUAL ComparisonJoinKey_SimpleComparisonType = 3
)

// Enum value maps for ComparisonJoinKey_SimpleComparisonType.
var (
	ComparisonJoinKey_SimpleComparisonType_name = map[int32]string{
		0: "SIMPLE_COMPARISON_TYPE_UNSPECIFIED",
		1: "SIMPLE_COMPARISON_TYPE_EQ",
		2: "SIMPLE_COMPARISON_TYPE_IS_NOT_DISTINCT_FROM",
		3: "SIMPLE_COMPARISON_TYPE_MIGHT_EQUAL",
	}
	ComparisonJoinKey_SimpleComparisonType_value = map[string]int32{
		"SIMPLE_COMPARISON_TYPE_UNSPECIFIED":          0,
		"SIMPLE_COMPARISON_TYPE_EQ":                   1,
		"SIMPLE_COMPARISON_TYPE_IS_NOT_DISTINCT_FROM": 2,
		"SIMPLE_COMPARISON_TYPE_MIGHT_EQUAL":          3,
	}
)

func (x ComparisonJoinKey_SimpleComparisonType) Enum() *ComparisonJoinKey_SimpleComparisonType {
	p := new(ComparisonJoinKey_SimpleComparisonType)
	*p = x
	return p
}

func (x ComparisonJoinKey_SimpleComparisonType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (ComparisonJoinKey_SimpleComparisonType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[9].Descriptor()
}

func (ComparisonJoinKey_SimpleComparisonType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[9]
}

func (x ComparisonJoinKey_SimpleComparisonType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use ComparisonJoinKey_SimpleComparisonType.Descriptor instead.
func (ComparisonJoinKey_SimpleComparisonType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{24, 0}
}

type HashJoinRel_JoinType int32

const (
	HashJoinRel_JOIN_TYPE_UNSPECIFIED  HashJoinRel_JoinType = 0
	HashJoinRel_JOIN_TYPE_INNER        HashJoinRel_JoinType = 1
	HashJoinRel_JOIN_TYPE_OUTER        HashJoinRel_JoinType = 2
	HashJoinRel_JOIN_TYPE_LEFT         HashJoinRel_JoinType = 3
	HashJoinRel_JOIN_TYPE_RIGHT        HashJoinRel_JoinType = 4
	HashJoinRel_JOIN_TYPE_LEFT_SEMI    HashJoinRel_JoinType = 5
	HashJoinRel_JOIN_TYPE_RIGHT_SEMI   HashJoinRel_JoinType = 6
	HashJoinRel_JOIN_TYPE_LEFT_ANTI    HashJoinRel_JoinType = 7
	HashJoinRel_JOIN_TYPE_RIGHT_ANTI   HashJoinRel_JoinType = 8
	HashJoinRel_JOIN_TYPE_LEFT_SINGLE  HashJoinRel_JoinType = 9
	HashJoinRel_JOIN_TYPE_RIGHT_SINGLE HashJoinRel_JoinType = 10
	HashJoinRel_JOIN_TYPE_LEFT_MARK    HashJoinRel_JoinType = 11
	HashJoinRel_JOIN_TYPE_RIGHT_MARK   HashJoinRel_JoinType = 12
)

// Enum value maps for HashJoinRel_JoinType.
var (
	HashJoinRel_JoinType_name = map[int32]string{
		0:  "JOIN_TYPE_UNSPECIFIED",
		1:  "JOIN_TYPE_INNER",
		2:  "JOIN_TYPE_OUTER",
		3:  "JOIN_TYPE_LEFT",
		4:  "JOIN_TYPE_RIGHT",
		5:  "JOIN_TYPE_LEFT_SEMI",
		6:  "JOIN_TYPE_RIGHT_SEMI",
		7:  "JOIN_TYPE_LEFT_ANTI",
		8:  "JOIN_TYPE_RIGHT_ANTI",
		9:  "JOIN_TYPE_LEFT_SINGLE",
		10: "JOIN_TYPE_RIGHT_SINGLE",
		11: "JOIN_TYPE_LEFT_MARK",
		12: "JOIN_TYPE_RIGHT_MARK",
	}
	HashJoinRel_JoinType_value = map[string]int32{
		"JOIN_TYPE_UNSPECIFIED":  0,
		"JOIN_TYPE_INNER":        1,
		"JOIN_TYPE_OUTER":        2,
		"JOIN_TYPE_LEFT":         3,
		"JOIN_TYPE_RIGHT":        4,
		"JOIN_TYPE_LEFT_SEMI":    5,
		"JOIN_TYPE_RIGHT_SEMI":   6,
		"JOIN_TYPE_LEFT_ANTI":    7,
		"JOIN_TYPE_RIGHT_ANTI":   8,
		"JOIN_TYPE_LEFT_SINGLE":  9,
		"JOIN_TYPE_RIGHT_SINGLE": 10,
		"JOIN_TYPE_LEFT_MARK":    11,
		"JOIN_TYPE_RIGHT_MARK":   12,
	}
)

func (x HashJoinRel_JoinType) Enum() *HashJoinRel_JoinType {
	p := new(HashJoinRel_JoinType)
	*p = x
	return p
}

func (x HashJoinRel_JoinType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (HashJoinRel_JoinType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[10].Descriptor()
}

func (HashJoinRel_JoinType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[10]
}

func (x HashJoinRel_JoinType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use HashJoinRel_JoinType.Descriptor instead.
func (HashJoinRel_JoinType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{25, 0}
}

type MergeJoinRel_JoinType int32

const (
	MergeJoinRel_JOIN_TYPE_UNSPECIFIED  MergeJoinRel_JoinType = 0
	MergeJoinRel_JOIN_TYPE_INNER        MergeJoinRel_JoinType = 1
	MergeJoinRel_JOIN_TYPE_OUTER        MergeJoinRel_JoinType = 2
	MergeJoinRel_JOIN_TYPE_LEFT         MergeJoinRel_JoinType = 3
	MergeJoinRel_JOIN_TYPE_RIGHT        MergeJoinRel_JoinType = 4
	MergeJoinRel_JOIN_TYPE_LEFT_SEMI    MergeJoinRel_JoinType = 5
	MergeJoinRel_JOIN_TYPE_RIGHT_SEMI   MergeJoinRel_JoinType = 6
	MergeJoinRel_JOIN_TYPE_LEFT_ANTI    MergeJoinRel_JoinType = 7
	MergeJoinRel_JOIN_TYPE_RIGHT_ANTI   MergeJoinRel_JoinType = 8
	MergeJoinRel_JOIN_TYPE_LEFT_SINGLE  MergeJoinRel_JoinType = 9
	MergeJoinRel_JOIN_TYPE_RIGHT_SINGLE MergeJoinRel_JoinType = 10
	MergeJoinRel_JOIN_TYPE_LEFT_MARK    MergeJoinRel_JoinType = 11
	MergeJoinRel_JOIN_TYPE_RIGHT_MARK   MergeJoinRel_JoinType = 12
)

// Enum value maps for MergeJoinRel_JoinType.
var (
	MergeJoinRel_JoinType_name = map[int32]string{
		0:  "JOIN_TYPE_UNSPECIFIED",
		1:  "JOIN_TYPE_INNER",
		2:  "JOIN_TYPE_OUTER",
		3:  "JOIN_TYPE_LEFT",
		4:  "JOIN_TYPE_RIGHT",
		5:  "JOIN_TYPE_LEFT_SEMI",
		6:  "JOIN_TYPE_RIGHT_SEMI",
		7:  "JOIN_TYPE_LEFT_ANTI",
		8:  "JOIN_TYPE_RIGHT_ANTI",
		9:  "JOIN_TYPE_LEFT_SINGLE",
		10: "JOIN_TYPE_RIGHT_SINGLE",
		11: "JOIN_TYPE_LEFT_MARK",
		12: "JOIN_TYPE_RIGHT_MARK",
	}
	MergeJoinRel_JoinType_value = map[string]int32{
		"JOIN_TYPE_UNSPECIFIED":  0,
		"JOIN_TYPE_INNER":        1,
		"JOIN_TYPE_OUTER":        2,
		"JOIN_TYPE_LEFT":         3,
		"JOIN_TYPE_RIGHT":        4,
		"JOIN_TYPE_LEFT_SEMI":    5,
		"JOIN_TYPE_RIGHT_SEMI":   6,
		"JOIN_TYPE_LEFT_ANTI":    7,
		"JOIN_TYPE_RIGHT_ANTI":   8,
		"JOIN_TYPE_LEFT_SINGLE":  9,
		"JOIN_TYPE_RIGHT_SINGLE": 10,
		"JOIN_TYPE_LEFT_MARK":    11,
		"JOIN_TYPE_RIGHT_MARK":   12,
	}
)

func (x MergeJoinRel_JoinType) Enum() *MergeJoinRel_JoinType {
	p := new(MergeJoinRel_JoinType)
	*p = x
	return p
}

func (x MergeJoinRel_JoinType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (MergeJoinRel_JoinType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[11].Descriptor()
}

func (MergeJoinRel_JoinType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[11]
}

func (x MergeJoinRel_JoinType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use MergeJoinRel_JoinType.Descriptor instead.
func (MergeJoinRel_JoinType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{26, 0}
}

type NestedLoopJoinRel_JoinType int32

const (
	NestedLoopJoinRel_JOIN_TYPE_UNSPECIFIED  NestedLoopJoinRel_JoinType = 0
	NestedLoopJoinRel_JOIN_TYPE_INNER        NestedLoopJoinRel_JoinType = 1
	NestedLoopJoinRel_JOIN_TYPE_OUTER        NestedLoopJoinRel_JoinType = 2
	NestedLoopJoinRel_JOIN_TYPE_LEFT         NestedLoopJoinRel_JoinType = 3
	NestedLoopJoinRel_JOIN_TYPE_RIGHT        NestedLoopJoinRel_JoinType = 4
	NestedLoopJoinRel_JOIN_TYPE_LEFT_SEMI    NestedLoopJoinRel_JoinType = 5
	NestedLoopJoinRel_JOIN_TYPE_RIGHT_SEMI   NestedLoopJoinRel_JoinType = 6
	NestedLoopJoinRel_JOIN_TYPE_LEFT_ANTI    NestedLoopJoinRel_JoinType = 7
	NestedLoopJoinRel_JOIN_TYPE_RIGHT_ANTI   NestedLoopJoinRel_JoinType = 8
	NestedLoopJoinRel_JOIN_TYPE_LEFT_SINGLE  NestedLoopJoinRel_JoinType = 9
	NestedLoopJoinRel_JOIN_TYPE_RIGHT_SINGLE NestedLoopJoinRel_JoinType = 10
	NestedLoopJoinRel_JOIN_TYPE_LEFT_MARK    NestedLoopJoinRel_JoinType = 11
	NestedLoopJoinRel_JOIN_TYPE_RIGHT_MARK   NestedLoopJoinRel_JoinType = 12
)

// Enum value maps for NestedLoopJoinRel_JoinType.
var (
	NestedLoopJoinRel_JoinType_name = map[int32]string{
		0:  "JOIN_TYPE_UNSPECIFIED",
		1:  "JOIN_TYPE_INNER",
		2:  "JOIN_TYPE_OUTER",
		3:  "JOIN_TYPE_LEFT",
		4:  "JOIN_TYPE_RIGHT",
		5:  "JOIN_TYPE_LEFT_SEMI",
		6:  "JOIN_TYPE_RIGHT_SEMI",
		7:  "JOIN_TYPE_LEFT_ANTI",
		8:  "JOIN_TYPE_RIGHT_ANTI",
		9:  "JOIN_TYPE_LEFT_SINGLE",
		10: "JOIN_TYPE_RIGHT_SINGLE",
		11: "JOIN_TYPE_LEFT_MARK",
		12: "JOIN_TYPE_RIGHT_MARK",
	}
	NestedLoopJoinRel_JoinType_value = map[string]int32{
		"JOIN_TYPE_UNSPECIFIED":  0,
		"JOIN_TYPE_INNER":        1,
		"JOIN_TYPE_OUTER":        2,
		"JOIN_TYPE_LEFT":         3,
		"JOIN_TYPE_RIGHT":        4,
		"JOIN_TYPE_LEFT_SEMI":    5,
		"JOIN_TYPE_RIGHT_SEMI":   6,
		"JOIN_TYPE_LEFT_ANTI":    7,
		"JOIN_TYPE_RIGHT_ANTI":   8,
		"JOIN_TYPE_LEFT_SINGLE":  9,
		"JOIN_TYPE_RIGHT_SINGLE": 10,
		"JOIN_TYPE_LEFT_MARK":    11,
		"JOIN_TYPE_RIGHT_MARK":   12,
	}
)

func (x NestedLoopJoinRel_JoinType) Enum() *NestedLoopJoinRel_JoinType {
	p := new(NestedLoopJoinRel_JoinType)
	*p = x
	return p
}

func (x NestedLoopJoinRel_JoinType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (NestedLoopJoinRel_JoinType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[12].Descriptor()
}

func (NestedLoopJoinRel_JoinType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[12]
}

func (x NestedLoopJoinRel_JoinType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use NestedLoopJoinRel_JoinType.Descriptor instead.
func (NestedLoopJoinRel_JoinType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{27, 0}
}

type Expression_WindowFunction_BoundsType int32

const (
	Expression_WindowFunction_BOUNDS_TYPE_UNSPECIFIED Expression_WindowFunction_BoundsType = 0
	// The lower and upper bound specify how many rows before and after the current row
	// the window should extend.
	Expression_WindowFunction_BOUNDS_TYPE_ROWS Expression_WindowFunction_BoundsType = 1
	// The lower and upper bound describe a range of values.  The window should include all rows
	// where the value of the ordering column is greater than or equal to (current_value - lower bound)
	// and less than or equal to (current_value + upper bound).  This bounds type is only valid if there
	// is a single ordering column.
	Expression_WindowFunction_BOUNDS_TYPE_RANGE Expression_WindowFunction_BoundsType = 2
)

// Enum value maps for Expression_WindowFunction_BoundsType.
var (
	Expression_WindowFunction_BoundsType_name = map[int32]string{
		0: "BOUNDS_TYPE_UNSPECIFIED",
		1: "BOUNDS_TYPE_ROWS",
		2: "BOUNDS_TYPE_RANGE",
	}
	Expression_WindowFunction_BoundsType_value = map[string]int32{
		"BOUNDS_TYPE_UNSPECIFIED": 0,
		"BOUNDS_TYPE_ROWS":        1,
		"BOUNDS_TYPE_RANGE":       2,
	}
)

func (x Expression_WindowFunction_BoundsType) Enum() *Expression_WindowFunction_BoundsType {
	p := new(Expression_WindowFunction_BoundsType)
	*p = x
	return p
}

func (x Expression_WindowFunction_BoundsType) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Expression_WindowFunction_BoundsType) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[13].Descriptor()
}

func (Expression_WindowFunction_BoundsType) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[13]
}

func (x Expression_WindowFunction_BoundsType) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Expression_WindowFunction_BoundsType.Descriptor instead.
func (Expression_WindowFunction_BoundsType) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4, 0}
}

type Expression_Cast_FailureBehavior int32

const (
	Expression_Cast_FAILURE_BEHAVIOR_UNSPECIFIED     Expression_Cast_FailureBehavior = 0
	Expression_Cast_FAILURE_BEHAVIOR_RETURN_NULL     Expression_Cast_FailureBehavior = 1
	Expression_Cast_FAILURE_BEHAVIOR_THROW_EXCEPTION Expression_Cast_FailureBehavior = 2
)

// Enum value maps for Expression_Cast_FailureBehavior.
var (
	Expression_Cast_FailureBehavior_name = map[int32]string{
		0: "FAILURE_BEHAVIOR_UNSPECIFIED",
		1: "FAILURE_BEHAVIOR_RETURN_NULL",
		2: "FAILURE_BEHAVIOR_THROW_EXCEPTION",
	}
	Expression_Cast_FailureBehavior_value = map[string]int32{
		"FAILURE_BEHAVIOR_UNSPECIFIED":     0,
		"FAILURE_BEHAVIOR_RETURN_NULL":     1,
		"FAILURE_BEHAVIOR_THROW_EXCEPTION": 2,
	}
)

func (x Expression_Cast_FailureBehavior) Enum() *Expression_Cast_FailureBehavior {
	p := new(Expression_Cast_FailureBehavior)
	*p = x
	return p
}

func (x Expression_Cast_FailureBehavior) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Expression_Cast_FailureBehavior) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[14].Descriptor()
}

func (Expression_Cast_FailureBehavior) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[14]
}

func (x Expression_Cast_FailureBehavior) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Expression_Cast_FailureBehavior.Descriptor instead.
func (Expression_Cast_FailureBehavior) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 6, 0}
}

type Expression_Subquery_SetPredicate_PredicateOp int32

const (
	Expression_Subquery_SetPredicate_PREDICATE_OP_UNSPECIFIED Expression_Subquery_SetPredicate_PredicateOp = 0
	Expression_Subquery_SetPredicate_PREDICATE_OP_EXISTS      Expression_Subquery_SetPredicate_PredicateOp = 1
	Expression_Subquery_SetPredicate_PREDICATE_OP_UNIQUE      Expression_Subquery_SetPredicate_PredicateOp = 2
)

// Enum value maps for Expression_Subquery_SetPredicate_PredicateOp.
var (
	Expression_Subquery_SetPredicate_PredicateOp_name = map[int32]string{
		0: "PREDICATE_OP_UNSPECIFIED",
		1: "PREDICATE_OP_EXISTS",
		2: "PREDICATE_OP_UNIQUE",
	}
	Expression_Subquery_SetPredicate_PredicateOp_value = map[string]int32{
		"PREDICATE_OP_UNSPECIFIED": 0,
		"PREDICATE_OP_EXISTS":      1,
		"PREDICATE_OP_UNIQUE":      2,
	}
)

func (x Expression_Subquery_SetPredicate_PredicateOp) Enum() *Expression_Subquery_SetPredicate_PredicateOp {
	p := new(Expression_Subquery_SetPredicate_PredicateOp)
	*p = x
	return p
}

func (x Expression_Subquery_SetPredicate_PredicateOp) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Expression_Subquery_SetPredicate_PredicateOp) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[15].Descriptor()
}

func (Expression_Subquery_SetPredicate_PredicateOp) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[15]
}

func (x Expression_Subquery_SetPredicate_PredicateOp) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Expression_Subquery_SetPredicate_PredicateOp.Descriptor instead.
func (Expression_Subquery_SetPredicate_PredicateOp) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 2, 0}
}

type Expression_Subquery_SetComparison_ComparisonOp int32

const (
	Expression_Subquery_SetComparison_COMPARISON_OP_UNSPECIFIED Expression_Subquery_SetComparison_ComparisonOp = 0
	Expression_Subquery_SetComparison_COMPARISON_OP_EQ          Expression_Subquery_SetComparison_ComparisonOp = 1
	Expression_Subquery_SetComparison_COMPARISON_OP_NE          Expression_Subquery_SetComparison_ComparisonOp = 2
	Expression_Subquery_SetComparison_COMPARISON_OP_LT          Expression_Subquery_SetComparison_ComparisonOp = 3
	Expression_Subquery_SetComparison_COMPARISON_OP_GT          Expression_Subquery_SetComparison_ComparisonOp = 4
	Expression_Subquery_SetComparison_COMPARISON_OP_LE          Expression_Subquery_SetComparison_ComparisonOp = 5
	Expression_Subquery_SetComparison_COMPARISON_OP_GE          Expression_Subquery_SetComparison_ComparisonOp = 6
)

// Enum value maps for Expression_Subquery_SetComparison_ComparisonOp.
var (
	Expression_Subquery_SetComparison_ComparisonOp_name = map[int32]string{
		0: "COMPARISON_OP_UNSPECIFIED",
		1: "COMPARISON_OP_EQ",
		2: "COMPARISON_OP_NE",
		3: "COMPARISON_OP_LT",
		4: "COMPARISON_OP_GT",
		5: "COMPARISON_OP_LE",
		6: "COMPARISON_OP_GE",
	}
	Expression_Subquery_SetComparison_ComparisonOp_value = map[string]int32{
		"COMPARISON_OP_UNSPECIFIED": 0,
		"COMPARISON_OP_EQ":          1,
		"COMPARISON_OP_NE":          2,
		"COMPARISON_OP_LT":          3,
		"COMPARISON_OP_GT":          4,
		"COMPARISON_OP_LE":          5,
		"COMPARISON_OP_GE":          6,
	}
)

func (x Expression_Subquery_SetComparison_ComparisonOp) Enum() *Expression_Subquery_SetComparison_ComparisonOp {
	p := new(Expression_Subquery_SetComparison_ComparisonOp)
	*p = x
	return p
}

func (x Expression_Subquery_SetComparison_ComparisonOp) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Expression_Subquery_SetComparison_ComparisonOp) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[16].Descriptor()
}

func (Expression_Subquery_SetComparison_ComparisonOp) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[16]
}

func (x Expression_Subquery_SetComparison_ComparisonOp) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Expression_Subquery_SetComparison_ComparisonOp.Descriptor instead.
func (Expression_Subquery_SetComparison_ComparisonOp) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 3, 0}
}

type Expression_Subquery_SetComparison_ReductionOp int32

const (
	Expression_Subquery_SetComparison_REDUCTION_OP_UNSPECIFIED Expression_Subquery_SetComparison_ReductionOp = 0
	Expression_Subquery_SetComparison_REDUCTION_OP_ANY         Expression_Subquery_SetComparison_ReductionOp = 1
	Expression_Subquery_SetComparison_REDUCTION_OP_ALL         Expression_Subquery_SetComparison_ReductionOp = 2
)

// Enum value maps for Expression_Subquery_SetComparison_ReductionOp.
var (
	Expression_Subquery_SetComparison_ReductionOp_name = map[int32]string{
		0: "REDUCTION_OP_UNSPECIFIED",
		1: "REDUCTION_OP_ANY",
		2: "REDUCTION_OP_ALL",
	}
	Expression_Subquery_SetComparison_ReductionOp_value = map[string]int32{
		"REDUCTION_OP_UNSPECIFIED": 0,
		"REDUCTION_OP_ANY":         1,
		"REDUCTION_OP_ALL":         2,
	}
)

func (x Expression_Subquery_SetComparison_ReductionOp) Enum() *Expression_Subquery_SetComparison_ReductionOp {
	p := new(Expression_Subquery_SetComparison_ReductionOp)
	*p = x
	return p
}

func (x Expression_Subquery_SetComparison_ReductionOp) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (Expression_Subquery_SetComparison_ReductionOp) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[17].Descriptor()
}

func (Expression_Subquery_SetComparison_ReductionOp) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[17]
}

func (x Expression_Subquery_SetComparison_ReductionOp) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use Expression_Subquery_SetComparison_ReductionOp.Descriptor instead.
func (Expression_Subquery_SetComparison_ReductionOp) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 3, 1}
}

type SortField_SortDirection int32

const (
	SortField_SORT_DIRECTION_UNSPECIFIED      SortField_SortDirection = 0
	SortField_SORT_DIRECTION_ASC_NULLS_FIRST  SortField_SortDirection = 1
	SortField_SORT_DIRECTION_ASC_NULLS_LAST   SortField_SortDirection = 2
	SortField_SORT_DIRECTION_DESC_NULLS_FIRST SortField_SortDirection = 3
	SortField_SORT_DIRECTION_DESC_NULLS_LAST  SortField_SortDirection = 4
	SortField_SORT_DIRECTION_CLUSTERED        SortField_SortDirection = 5
)

// Enum value maps for SortField_SortDirection.
var (
	SortField_SortDirection_name = map[int32]string{
		0: "SORT_DIRECTION_UNSPECIFIED",
		1: "SORT_DIRECTION_ASC_NULLS_FIRST",
		2: "SORT_DIRECTION_ASC_NULLS_LAST",
		3: "SORT_DIRECTION_DESC_NULLS_FIRST",
		4: "SORT_DIRECTION_DESC_NULLS_LAST",
		5: "SORT_DIRECTION_CLUSTERED",
	}
	SortField_SortDirection_value = map[string]int32{
		"SORT_DIRECTION_UNSPECIFIED":      0,
		"SORT_DIRECTION_ASC_NULLS_FIRST":  1,
		"SORT_DIRECTION_ASC_NULLS_LAST":   2,
		"SORT_DIRECTION_DESC_NULLS_FIRST": 3,
		"SORT_DIRECTION_DESC_NULLS_LAST":  4,
		"SORT_DIRECTION_CLUSTERED":        5,
	}
)

func (x SortField_SortDirection) Enum() *SortField_SortDirection {
	p := new(SortField_SortDirection)
	*p = x
	return p
}

func (x SortField_SortDirection) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (SortField_SortDirection) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[18].Descriptor()
}

func (SortField_SortDirection) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[18]
}

func (x SortField_SortDirection) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use SortField_SortDirection.Descriptor instead.
func (SortField_SortDirection) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{31, 0}
}

// Method in which equivalent records are merged before being aggregated.
type AggregateFunction_AggregationInvocation int32

const (
	// This default value implies AGGREGATION_INVOCATION_ALL.
	AggregateFunction_AGGREGATION_INVOCATION_UNSPECIFIED AggregateFunction_AggregationInvocation = 0
	// Use all values in the aggregation calculation.
	AggregateFunction_AGGREGATION_INVOCATION_ALL AggregateFunction_AggregationInvocation = 1
	// Use only distinct values in the aggregation calculation.
	AggregateFunction_AGGREGATION_INVOCATION_DISTINCT AggregateFunction_AggregationInvocation = 2
)

// Enum value maps for AggregateFunction_AggregationInvocation.
var (
	AggregateFunction_AggregationInvocation_name = map[int32]string{
		0: "AGGREGATION_INVOCATION_UNSPECIFIED",
		1: "AGGREGATION_INVOCATION_ALL",
		2: "AGGREGATION_INVOCATION_DISTINCT",
	}
	AggregateFunction_AggregationInvocation_value = map[string]int32{
		"AGGREGATION_INVOCATION_UNSPECIFIED": 0,
		"AGGREGATION_INVOCATION_ALL":         1,
		"AGGREGATION_INVOCATION_DISTINCT":    2,
	}
)

func (x AggregateFunction_AggregationInvocation) Enum() *AggregateFunction_AggregationInvocation {
	p := new(AggregateFunction_AggregationInvocation)
	*p = x
	return p
}

func (x AggregateFunction_AggregationInvocation) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (AggregateFunction_AggregationInvocation) Descriptor() protoreflect.EnumDescriptor {
	return file_substrait_algebra_proto_enumTypes[19].Descriptor()
}

func (AggregateFunction_AggregationInvocation) Type() protoreflect.EnumType {
	return &file_substrait_algebra_proto_enumTypes[19]
}

func (x AggregateFunction_AggregationInvocation) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use AggregateFunction_AggregationInvocation.Descriptor instead.
func (AggregateFunction_AggregationInvocation) EnumDescriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{32, 0}
}

// Common fields for all relational operators
type RelCommon struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to EmitKind:
	//
	//	*RelCommon_Direct_
	//	*RelCommon_Emit_
	EmitKind          isRelCommon_EmitKind          `protobuf_oneof:"emit_kind"`
	Hint              *RelCommon_Hint               `protobuf:"bytes,3,opt,name=hint,proto3" json:"hint,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,4,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *RelCommon) Reset() {
	*x = RelCommon{}
	mi := &file_substrait_algebra_proto_msgTypes[0]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon) ProtoMessage() {}

func (x *RelCommon) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[0]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon.ProtoReflect.Descriptor instead.
func (*RelCommon) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0}
}

func (x *RelCommon) GetEmitKind() isRelCommon_EmitKind {
	if x != nil {
		return x.EmitKind
	}
	return nil
}

func (x *RelCommon) GetDirect() *RelCommon_Direct {
	if x != nil {
		if x, ok := x.EmitKind.(*RelCommon_Direct_); ok {
			return x.Direct
		}
	}
	return nil
}

func (x *RelCommon) GetEmit() *RelCommon_Emit {
	if x != nil {
		if x, ok := x.EmitKind.(*RelCommon_Emit_); ok {
			return x.Emit
		}
	}
	return nil
}

func (x *RelCommon) GetHint() *RelCommon_Hint {
	if x != nil {
		return x.Hint
	}
	return nil
}

func (x *RelCommon) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

type isRelCommon_EmitKind interface {
	isRelCommon_EmitKind()
}

type RelCommon_Direct_ struct {
	// The underlying relation is output as is (no reordering or projection of columns)
	Direct *RelCommon_Direct `protobuf:"bytes,1,opt,name=direct,proto3,oneof"`
}

type RelCommon_Emit_ struct {
	// Allows to control for order and inclusion of fields
	Emit *RelCommon_Emit `protobuf:"bytes,2,opt,name=emit,proto3,oneof"`
}

func (*RelCommon_Direct_) isRelCommon_EmitKind() {}

func (*RelCommon_Emit_) isRelCommon_EmitKind() {}

// The scan operator of base data (physical or virtual), including filtering and projection.
type ReadRel struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Common            *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	BaseSchema        *NamedStruct                  `protobuf:"bytes,2,opt,name=base_schema,json=baseSchema,proto3" json:"base_schema,omitempty"`
	Filter            *Expression                   `protobuf:"bytes,3,opt,name=filter,proto3" json:"filter,omitempty"`
	BestEffortFilter  *Expression                   `protobuf:"bytes,11,opt,name=best_effort_filter,json=bestEffortFilter,proto3" json:"best_effort_filter,omitempty"`
	Projection        *Expression_MaskExpression    `protobuf:"bytes,4,opt,name=projection,proto3" json:"projection,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	// Definition of which type of scan operation is to be performed
	//
	// Types that are valid to be assigned to ReadType:
	//
	//	*ReadRel_VirtualTable_
	//	*ReadRel_LocalFiles_
	//	*ReadRel_NamedTable_
	//	*ReadRel_ExtensionTable_
	//	*ReadRel_IcebergTable_
	ReadType      isReadRel_ReadType `protobuf_oneof:"read_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel) Reset() {
	*x = ReadRel{}
	mi := &file_substrait_algebra_proto_msgTypes[1]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel) ProtoMessage() {}

func (x *ReadRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[1]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel.ProtoReflect.Descriptor instead.
func (*ReadRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1}
}

func (x *ReadRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ReadRel) GetBaseSchema() *NamedStruct {
	if x != nil {
		return x.BaseSchema
	}
	return nil
}

func (x *ReadRel) GetFilter() *Expression {
	if x != nil {
		return x.Filter
	}
	return nil
}

func (x *ReadRel) GetBestEffortFilter() *Expression {
	if x != nil {
		return x.BestEffortFilter
	}
	return nil
}

func (x *ReadRel) GetProjection() *Expression_MaskExpression {
	if x != nil {
		return x.Projection
	}
	return nil
}

func (x *ReadRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

func (x *ReadRel) GetReadType() isReadRel_ReadType {
	if x != nil {
		return x.ReadType
	}
	return nil
}

func (x *ReadRel) GetVirtualTable() *ReadRel_VirtualTable {
	if x != nil {
		if x, ok := x.ReadType.(*ReadRel_VirtualTable_); ok {
			return x.VirtualTable
		}
	}
	return nil
}

func (x *ReadRel) GetLocalFiles() *ReadRel_LocalFiles {
	if x != nil {
		if x, ok := x.ReadType.(*ReadRel_LocalFiles_); ok {
			return x.LocalFiles
		}
	}
	return nil
}

func (x *ReadRel) GetNamedTable() *ReadRel_NamedTable {
	if x != nil {
		if x, ok := x.ReadType.(*ReadRel_NamedTable_); ok {
			return x.NamedTable
		}
	}
	return nil
}

func (x *ReadRel) GetExtensionTable() *ReadRel_ExtensionTable {
	if x != nil {
		if x, ok := x.ReadType.(*ReadRel_ExtensionTable_); ok {
			return x.ExtensionTable
		}
	}
	return nil
}

func (x *ReadRel) GetIcebergTable() *ReadRel_IcebergTable {
	if x != nil {
		if x, ok := x.ReadType.(*ReadRel_IcebergTable_); ok {
			return x.IcebergTable
		}
	}
	return nil
}

type isReadRel_ReadType interface {
	isReadRel_ReadType()
}

type ReadRel_VirtualTable_ struct {
	VirtualTable *ReadRel_VirtualTable `protobuf:"bytes,5,opt,name=virtual_table,json=virtualTable,proto3,oneof"`
}

type ReadRel_LocalFiles_ struct {
	LocalFiles *ReadRel_LocalFiles `protobuf:"bytes,6,opt,name=local_files,json=localFiles,proto3,oneof"`
}

type ReadRel_NamedTable_ struct {
	NamedTable *ReadRel_NamedTable `protobuf:"bytes,7,opt,name=named_table,json=namedTable,proto3,oneof"`
}

type ReadRel_ExtensionTable_ struct {
	ExtensionTable *ReadRel_ExtensionTable `protobuf:"bytes,8,opt,name=extension_table,json=extensionTable,proto3,oneof"`
}

type ReadRel_IcebergTable_ struct {
	IcebergTable *ReadRel_IcebergTable `protobuf:"bytes,9,opt,name=iceberg_table,json=icebergTable,proto3,oneof"`
}

func (*ReadRel_VirtualTable_) isReadRel_ReadType() {}

func (*ReadRel_LocalFiles_) isReadRel_ReadType() {}

func (*ReadRel_NamedTable_) isReadRel_ReadType() {}

func (*ReadRel_ExtensionTable_) isReadRel_ReadType() {}

func (*ReadRel_IcebergTable_) isReadRel_ReadType() {}

// This operator allows to represent calculated expressions of fields (e.g., a+b). Direct/Emit are used to represent classical relational projections
type ProjectRel struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Common            *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input             *Rel                          `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	Expressions       []*Expression                 `protobuf:"bytes,3,rep,name=expressions,proto3" json:"expressions,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *ProjectRel) Reset() {
	*x = ProjectRel{}
	mi := &file_substrait_algebra_proto_msgTypes[2]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ProjectRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ProjectRel) ProtoMessage() {}

func (x *ProjectRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[2]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ProjectRel.ProtoReflect.Descriptor instead.
func (*ProjectRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{2}
}

func (x *ProjectRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ProjectRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *ProjectRel) GetExpressions() []*Expression {
	if x != nil {
		return x.Expressions
	}
	return nil
}

func (x *ProjectRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The binary JOIN relational operator left-join-right, including various join types, a join condition and post_join_filter expression
type JoinRel struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Common            *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Left              *Rel                          `protobuf:"bytes,2,opt,name=left,proto3" json:"left,omitempty"`
	Right             *Rel                          `protobuf:"bytes,3,opt,name=right,proto3" json:"right,omitempty"`
	Expression        *Expression                   `protobuf:"bytes,4,opt,name=expression,proto3" json:"expression,omitempty"`
	PostJoinFilter    *Expression                   `protobuf:"bytes,5,opt,name=post_join_filter,json=postJoinFilter,proto3" json:"post_join_filter,omitempty"`
	Type              JoinRel_JoinType              `protobuf:"varint,6,opt,name=type,proto3,enum=substrait.JoinRel_JoinType" json:"type,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *JoinRel) Reset() {
	*x = JoinRel{}
	mi := &file_substrait_algebra_proto_msgTypes[3]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *JoinRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*JoinRel) ProtoMessage() {}

func (x *JoinRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[3]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use JoinRel.ProtoReflect.Descriptor instead.
func (*JoinRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{3}
}

func (x *JoinRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *JoinRel) GetLeft() *Rel {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *JoinRel) GetRight() *Rel {
	if x != nil {
		return x.Right
	}
	return nil
}

func (x *JoinRel) GetExpression() *Expression {
	if x != nil {
		return x.Expression
	}
	return nil
}

func (x *JoinRel) GetPostJoinFilter() *Expression {
	if x != nil {
		return x.PostJoinFilter
	}
	return nil
}

func (x *JoinRel) GetType() JoinRel_JoinType {
	if x != nil {
		return x.Type
	}
	return JoinRel_JOIN_TYPE_UNSPECIFIED
}

func (x *JoinRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// Cartesian product relational operator of two tables (left and right)
type CrossRel struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Common            *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Left              *Rel                          `protobuf:"bytes,2,opt,name=left,proto3" json:"left,omitempty"`
	Right             *Rel                          `protobuf:"bytes,3,opt,name=right,proto3" json:"right,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *CrossRel) Reset() {
	*x = CrossRel{}
	mi := &file_substrait_algebra_proto_msgTypes[4]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *CrossRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*CrossRel) ProtoMessage() {}

func (x *CrossRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[4]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use CrossRel.ProtoReflect.Descriptor instead.
func (*CrossRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{4}
}

func (x *CrossRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *CrossRel) GetLeft() *Rel {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *CrossRel) GetRight() *Rel {
	if x != nil {
		return x.Right
	}
	return nil
}

func (x *CrossRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The relational operator representing LIMIT/OFFSET or TOP type semantics.
type FetchRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input  *Rel                   `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	// Note: A oneof field is inherently optional, whereas individual fields
	// within a oneof cannot be marked as optional. The unset state of offset
	// should therefore be checked at the oneof level. Unset is treated as 0.
	//
	// Types that are valid to be assigned to OffsetMode:
	//
	//	*FetchRel_Offset
	//	*FetchRel_OffsetExpr
	OffsetMode isFetchRel_OffsetMode `protobuf_oneof:"offset_mode"`
	// Note: A oneof field is inherently optional, whereas individual fields
	// within a oneof cannot be marked as optional. The unset state of count
	// should therefore be checked at the oneof level. Unset is treated as ALL.
	//
	// Types that are valid to be assigned to CountMode:
	//
	//	*FetchRel_Count
	//	*FetchRel_CountExpr
	CountMode         isFetchRel_CountMode          `protobuf_oneof:"count_mode"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *FetchRel) Reset() {
	*x = FetchRel{}
	mi := &file_substrait_algebra_proto_msgTypes[5]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *FetchRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*FetchRel) ProtoMessage() {}

func (x *FetchRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[5]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use FetchRel.ProtoReflect.Descriptor instead.
func (*FetchRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{5}
}

func (x *FetchRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *FetchRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *FetchRel) GetOffsetMode() isFetchRel_OffsetMode {
	if x != nil {
		return x.OffsetMode
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *FetchRel) GetOffset() int64 {
	if x != nil {
		if x, ok := x.OffsetMode.(*FetchRel_Offset); ok {
			return x.Offset
		}
	}
	return 0
}

func (x *FetchRel) GetOffsetExpr() *Expression {
	if x != nil {
		if x, ok := x.OffsetMode.(*FetchRel_OffsetExpr); ok {
			return x.OffsetExpr
		}
	}
	return nil
}

func (x *FetchRel) GetCountMode() isFetchRel_CountMode {
	if x != nil {
		return x.CountMode
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *FetchRel) GetCount() int64 {
	if x != nil {
		if x, ok := x.CountMode.(*FetchRel_Count); ok {
			return x.Count
		}
	}
	return 0
}

func (x *FetchRel) GetCountExpr() *Expression {
	if x != nil {
		if x, ok := x.CountMode.(*FetchRel_CountExpr); ok {
			return x.CountExpr
		}
	}
	return nil
}

func (x *FetchRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

type isFetchRel_OffsetMode interface {
	isFetchRel_OffsetMode()
}

type FetchRel_Offset struct {
	// the offset expressed in number of records
	// Deprecated: use `offset_expr` instead
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Offset int64 `protobuf:"varint,3,opt,name=offset,proto3,oneof"`
}

type FetchRel_OffsetExpr struct {
	// Expression evaluated into a non-negative integer specifying the number
	// of records to skip. An expression evaluating to null is treated as 0.
	// Evaluating to a negative integer should result in an error.
	// Recommended type for offset is int64.
	OffsetExpr *Expression `protobuf:"bytes,5,opt,name=offset_expr,json=offsetExpr,proto3,oneof"`
}

func (*FetchRel_Offset) isFetchRel_OffsetMode() {}

func (*FetchRel_OffsetExpr) isFetchRel_OffsetMode() {}

type isFetchRel_CountMode interface {
	isFetchRel_CountMode()
}

type FetchRel_Count struct {
	// the amount of records to return
	// use -1 to signal that ALL records should be returned
	// Deprecated: use `count_expr` instead
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Count int64 `protobuf:"varint,4,opt,name=count,proto3,oneof"`
}

type FetchRel_CountExpr struct {
	// Expression evaluated into a non-negative integer specifying the number
	// of records to return. An expression evaluating to null signals that ALL
	// records should be returned.
	// Evaluating to a negative integer should result in an error.
	// Recommended type for count is int64.
	CountExpr *Expression `protobuf:"bytes,6,opt,name=count_expr,json=countExpr,proto3,oneof"`
}

func (*FetchRel_Count) isFetchRel_CountMode() {}

func (*FetchRel_CountExpr) isFetchRel_CountMode() {}

// The relational operator representing a GROUP BY Aggregate
type AggregateRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	// Input of the aggregation
	Input *Rel `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	// A list of zero or more grouping sets that the aggregation measures should
	// be calculated for. There must be at least one grouping set if there are no
	// measures (but it can be the empty grouping set).
	Groupings []*AggregateRel_Grouping `protobuf:"bytes,3,rep,name=groupings,proto3" json:"groupings,omitempty"`
	// A list of one or more aggregate expressions along with an optional filter.
	// Required if there are no groupings.
	Measures []*AggregateRel_Measure `protobuf:"bytes,4,rep,name=measures,proto3" json:"measures,omitempty"`
	// A list of zero or more grouping expressions that grouping sets (i.e.,
	// `Grouping` messages in the `groupings` field) can reference. Each
	// expression in this list must be referred to by at least one
	// `Grouping.expression_references`.
	GroupingExpressions []*Expression                 `protobuf:"bytes,5,rep,name=grouping_expressions,json=groupingExpressions,proto3" json:"grouping_expressions,omitempty"`
	AdvancedExtension   *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields       protoimpl.UnknownFields
	sizeCache           protoimpl.SizeCache
}

func (x *AggregateRel) Reset() {
	*x = AggregateRel{}
	mi := &file_substrait_algebra_proto_msgTypes[6]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *AggregateRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*AggregateRel) ProtoMessage() {}

func (x *AggregateRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[6]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use AggregateRel.ProtoReflect.Descriptor instead.
func (*AggregateRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{6}
}

func (x *AggregateRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *AggregateRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *AggregateRel) GetGroupings() []*AggregateRel_Grouping {
	if x != nil {
		return x.Groupings
	}
	return nil
}

func (x *AggregateRel) GetMeasures() []*AggregateRel_Measure {
	if x != nil {
		return x.Measures
	}
	return nil
}

func (x *AggregateRel) GetGroupingExpressions() []*Expression {
	if x != nil {
		return x.GroupingExpressions
	}
	return nil
}

func (x *AggregateRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// ConsistentPartitionWindowRel provides the ability to perform calculations across sets of rows
// that are related to the current query row. It can be used to execute window functions where
// all the windows share the same partitioning and ordering.
type ConsistentPartitionWindowRel struct {
	state                protoimpl.MessageState                            `protogen:"open.v1"`
	Common               *RelCommon                                        `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input                *Rel                                              `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	WindowFunctions      []*ConsistentPartitionWindowRel_WindowRelFunction `protobuf:"bytes,3,rep,name=window_functions,json=windowFunctions,proto3" json:"window_functions,omitempty"`
	PartitionExpressions []*Expression                                     `protobuf:"bytes,4,rep,name=partition_expressions,json=partitionExpressions,proto3" json:"partition_expressions,omitempty"`
	Sorts                []*SortField                                      `protobuf:"bytes,5,rep,name=sorts,proto3" json:"sorts,omitempty"`
	AdvancedExtension    *extensions.AdvancedExtension                     `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields        protoimpl.UnknownFields
	sizeCache            protoimpl.SizeCache
}

func (x *ConsistentPartitionWindowRel) Reset() {
	*x = ConsistentPartitionWindowRel{}
	mi := &file_substrait_algebra_proto_msgTypes[7]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ConsistentPartitionWindowRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ConsistentPartitionWindowRel) ProtoMessage() {}

func (x *ConsistentPartitionWindowRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[7]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ConsistentPartitionWindowRel.ProtoReflect.Descriptor instead.
func (*ConsistentPartitionWindowRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{7}
}

func (x *ConsistentPartitionWindowRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ConsistentPartitionWindowRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *ConsistentPartitionWindowRel) GetWindowFunctions() []*ConsistentPartitionWindowRel_WindowRelFunction {
	if x != nil {
		return x.WindowFunctions
	}
	return nil
}

func (x *ConsistentPartitionWindowRel) GetPartitionExpressions() []*Expression {
	if x != nil {
		return x.PartitionExpressions
	}
	return nil
}

func (x *ConsistentPartitionWindowRel) GetSorts() []*SortField {
	if x != nil {
		return x.Sorts
	}
	return nil
}

func (x *ConsistentPartitionWindowRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The ORDERY BY (or sorting) relational operator. Beside describing a base relation, it includes a list of fields to sort on
type SortRel struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Common            *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input             *Rel                          `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	Sorts             []*SortField                  `protobuf:"bytes,3,rep,name=sorts,proto3" json:"sorts,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *SortRel) Reset() {
	*x = SortRel{}
	mi := &file_substrait_algebra_proto_msgTypes[8]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *SortRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*SortRel) ProtoMessage() {}

func (x *SortRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[8]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use SortRel.ProtoReflect.Descriptor instead.
func (*SortRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{8}
}

func (x *SortRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *SortRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *SortRel) GetSorts() []*SortField {
	if x != nil {
		return x.Sorts
	}
	return nil
}

func (x *SortRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The relational operator capturing simple FILTERs (as in the WHERE clause of SQL)
type FilterRel struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Common            *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input             *Rel                          `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	Condition         *Expression                   `protobuf:"bytes,3,opt,name=condition,proto3" json:"condition,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *FilterRel) Reset() {
	*x = FilterRel{}
	mi := &file_substrait_algebra_proto_msgTypes[9]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *FilterRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*FilterRel) ProtoMessage() {}

func (x *FilterRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[9]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use FilterRel.ProtoReflect.Descriptor instead.
func (*FilterRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{9}
}

func (x *FilterRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *FilterRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *FilterRel) GetCondition() *Expression {
	if x != nil {
		return x.Condition
	}
	return nil
}

func (x *FilterRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The relational set operators (intersection/union/etc..)
type SetRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	// The first input is the primary input, the remaining are secondary
	// inputs.  There must be at least two inputs.
	Inputs            []*Rel                        `protobuf:"bytes,2,rep,name=inputs,proto3" json:"inputs,omitempty"`
	Op                SetRel_SetOp                  `protobuf:"varint,3,opt,name=op,proto3,enum=substrait.SetRel_SetOp" json:"op,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *SetRel) Reset() {
	*x = SetRel{}
	mi := &file_substrait_algebra_proto_msgTypes[10]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *SetRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*SetRel) ProtoMessage() {}

func (x *SetRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[10]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use SetRel.ProtoReflect.Descriptor instead.
func (*SetRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{10}
}

func (x *SetRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *SetRel) GetInputs() []*Rel {
	if x != nil {
		return x.Inputs
	}
	return nil
}

func (x *SetRel) GetOp() SetRel_SetOp {
	if x != nil {
		return x.Op
	}
	return SetRel_SET_OP_UNSPECIFIED
}

func (x *SetRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// Stub to support extension with a single input
type ExtensionSingleRel struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Common        *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input         *Rel                   `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	Detail        *anypb.Any             `protobuf:"bytes,3,opt,name=detail,proto3" json:"detail,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExtensionSingleRel) Reset() {
	*x = ExtensionSingleRel{}
	mi := &file_substrait_algebra_proto_msgTypes[11]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExtensionSingleRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExtensionSingleRel) ProtoMessage() {}

func (x *ExtensionSingleRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[11]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExtensionSingleRel.ProtoReflect.Descriptor instead.
func (*ExtensionSingleRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{11}
}

func (x *ExtensionSingleRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ExtensionSingleRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *ExtensionSingleRel) GetDetail() *anypb.Any {
	if x != nil {
		return x.Detail
	}
	return nil
}

// Stub to support extension with a zero inputs
type ExtensionLeafRel struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Common        *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Detail        *anypb.Any             `protobuf:"bytes,2,opt,name=detail,proto3" json:"detail,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExtensionLeafRel) Reset() {
	*x = ExtensionLeafRel{}
	mi := &file_substrait_algebra_proto_msgTypes[12]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExtensionLeafRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExtensionLeafRel) ProtoMessage() {}

func (x *ExtensionLeafRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[12]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExtensionLeafRel.ProtoReflect.Descriptor instead.
func (*ExtensionLeafRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{12}
}

func (x *ExtensionLeafRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ExtensionLeafRel) GetDetail() *anypb.Any {
	if x != nil {
		return x.Detail
	}
	return nil
}

// Stub to support extension with multiple inputs
type ExtensionMultiRel struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Common        *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Inputs        []*Rel                 `protobuf:"bytes,2,rep,name=inputs,proto3" json:"inputs,omitempty"`
	Detail        *anypb.Any             `protobuf:"bytes,3,opt,name=detail,proto3" json:"detail,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExtensionMultiRel) Reset() {
	*x = ExtensionMultiRel{}
	mi := &file_substrait_algebra_proto_msgTypes[13]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExtensionMultiRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExtensionMultiRel) ProtoMessage() {}

func (x *ExtensionMultiRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[13]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExtensionMultiRel.ProtoReflect.Descriptor instead.
func (*ExtensionMultiRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{13}
}

func (x *ExtensionMultiRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ExtensionMultiRel) GetInputs() []*Rel {
	if x != nil {
		return x.Inputs
	}
	return nil
}

func (x *ExtensionMultiRel) GetDetail() *anypb.Any {
	if x != nil {
		return x.Detail
	}
	return nil
}

// A redistribution operation
type ExchangeRel struct {
	state          protoimpl.MessageState        `protogen:"open.v1"`
	Common         *RelCommon                    `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input          *Rel                          `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	PartitionCount int32                         `protobuf:"varint,3,opt,name=partition_count,json=partitionCount,proto3" json:"partition_count,omitempty"`
	Targets        []*ExchangeRel_ExchangeTarget `protobuf:"bytes,4,rep,name=targets,proto3" json:"targets,omitempty"`
	// the type of exchange used
	//
	// Types that are valid to be assigned to ExchangeKind:
	//
	//	*ExchangeRel_ScatterByFields
	//	*ExchangeRel_SingleTarget
	//	*ExchangeRel_MultiTarget
	//	*ExchangeRel_RoundRobin_
	//	*ExchangeRel_Broadcast_
	ExchangeKind      isExchangeRel_ExchangeKind    `protobuf_oneof:"exchange_kind"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *ExchangeRel) Reset() {
	*x = ExchangeRel{}
	mi := &file_substrait_algebra_proto_msgTypes[14]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel) ProtoMessage() {}

func (x *ExchangeRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[14]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel.ProtoReflect.Descriptor instead.
func (*ExchangeRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14}
}

func (x *ExchangeRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ExchangeRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *ExchangeRel) GetPartitionCount() int32 {
	if x != nil {
		return x.PartitionCount
	}
	return 0
}

func (x *ExchangeRel) GetTargets() []*ExchangeRel_ExchangeTarget {
	if x != nil {
		return x.Targets
	}
	return nil
}

func (x *ExchangeRel) GetExchangeKind() isExchangeRel_ExchangeKind {
	if x != nil {
		return x.ExchangeKind
	}
	return nil
}

func (x *ExchangeRel) GetScatterByFields() *ExchangeRel_ScatterFields {
	if x != nil {
		if x, ok := x.ExchangeKind.(*ExchangeRel_ScatterByFields); ok {
			return x.ScatterByFields
		}
	}
	return nil
}

func (x *ExchangeRel) GetSingleTarget() *ExchangeRel_SingleBucketExpression {
	if x != nil {
		if x, ok := x.ExchangeKind.(*ExchangeRel_SingleTarget); ok {
			return x.SingleTarget
		}
	}
	return nil
}

func (x *ExchangeRel) GetMultiTarget() *ExchangeRel_MultiBucketExpression {
	if x != nil {
		if x, ok := x.ExchangeKind.(*ExchangeRel_MultiTarget); ok {
			return x.MultiTarget
		}
	}
	return nil
}

func (x *ExchangeRel) GetRoundRobin() *ExchangeRel_RoundRobin {
	if x != nil {
		if x, ok := x.ExchangeKind.(*ExchangeRel_RoundRobin_); ok {
			return x.RoundRobin
		}
	}
	return nil
}

func (x *ExchangeRel) GetBroadcast() *ExchangeRel_Broadcast {
	if x != nil {
		if x, ok := x.ExchangeKind.(*ExchangeRel_Broadcast_); ok {
			return x.Broadcast
		}
	}
	return nil
}

func (x *ExchangeRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

type isExchangeRel_ExchangeKind interface {
	isExchangeRel_ExchangeKind()
}

type ExchangeRel_ScatterByFields struct {
	ScatterByFields *ExchangeRel_ScatterFields `protobuf:"bytes,5,opt,name=scatter_by_fields,json=scatterByFields,proto3,oneof"`
}

type ExchangeRel_SingleTarget struct {
	SingleTarget *ExchangeRel_SingleBucketExpression `protobuf:"bytes,6,opt,name=single_target,json=singleTarget,proto3,oneof"`
}

type ExchangeRel_MultiTarget struct {
	MultiTarget *ExchangeRel_MultiBucketExpression `protobuf:"bytes,7,opt,name=multi_target,json=multiTarget,proto3,oneof"`
}

type ExchangeRel_RoundRobin_ struct {
	RoundRobin *ExchangeRel_RoundRobin `protobuf:"bytes,8,opt,name=round_robin,json=roundRobin,proto3,oneof"`
}

type ExchangeRel_Broadcast_ struct {
	Broadcast *ExchangeRel_Broadcast `protobuf:"bytes,9,opt,name=broadcast,proto3,oneof"`
}

func (*ExchangeRel_ScatterByFields) isExchangeRel_ExchangeKind() {}

func (*ExchangeRel_SingleTarget) isExchangeRel_ExchangeKind() {}

func (*ExchangeRel_MultiTarget) isExchangeRel_ExchangeKind() {}

func (*ExchangeRel_RoundRobin_) isExchangeRel_ExchangeKind() {}

func (*ExchangeRel_Broadcast_) isExchangeRel_ExchangeKind() {}

// Duplicates records by emitting one or more rows per input row.  The number of rows emitted per
// input row is the same for all input rows.
//
// In addition to a field being emitted per input field an extra int64 field is emitted which
// contains a zero-indexed ordinal corresponding to the duplicate definition.
type ExpandRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Input  *Rel                   `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	// There should be one definition here for each input field.  Any fields beyond the provided
	// definitions will be emitted as is (as if a consistent_field record with an identity
	// expression was provided).
	Fields        []*ExpandRel_ExpandField `protobuf:"bytes,4,rep,name=fields,proto3" json:"fields,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExpandRel) Reset() {
	*x = ExpandRel{}
	mi := &file_substrait_algebra_proto_msgTypes[15]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExpandRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExpandRel) ProtoMessage() {}

func (x *ExpandRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[15]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExpandRel.ProtoReflect.Descriptor instead.
func (*ExpandRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{15}
}

func (x *ExpandRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *ExpandRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *ExpandRel) GetFields() []*ExpandRel_ExpandField {
	if x != nil {
		return x.Fields
	}
	return nil
}

// A relation with output field names.
//
// This is for use at the root of a `Rel` tree.
type RelRoot struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A relation
	Input *Rel `protobuf:"bytes,1,opt,name=input,proto3" json:"input,omitempty"`
	// Field names in depth-first order
	Names         []string `protobuf:"bytes,2,rep,name=names,proto3" json:"names,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *RelRoot) Reset() {
	*x = RelRoot{}
	mi := &file_substrait_algebra_proto_msgTypes[16]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelRoot) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelRoot) ProtoMessage() {}

func (x *RelRoot) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[16]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelRoot.ProtoReflect.Descriptor instead.
func (*RelRoot) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{16}
}

func (x *RelRoot) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *RelRoot) GetNames() []string {
	if x != nil {
		return x.Names
	}
	return nil
}

// A relation (used internally in a plan)
type Rel struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to RelType:
	//
	//	*Rel_Read
	//	*Rel_Filter
	//	*Rel_Fetch
	//	*Rel_Aggregate
	//	*Rel_Sort
	//	*Rel_Join
	//	*Rel_Project
	//	*Rel_Set
	//	*Rel_ExtensionSingle
	//	*Rel_ExtensionMulti
	//	*Rel_ExtensionLeaf
	//	*Rel_Cross
	//	*Rel_Reference
	//	*Rel_Write
	//	*Rel_Ddl
	//	*Rel_Update
	//	*Rel_HashJoin
	//	*Rel_MergeJoin
	//	*Rel_NestedLoopJoin
	//	*Rel_Window
	//	*Rel_Exchange
	//	*Rel_Expand
	RelType       isRel_RelType `protobuf_oneof:"rel_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Rel) Reset() {
	*x = Rel{}
	mi := &file_substrait_algebra_proto_msgTypes[17]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Rel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Rel) ProtoMessage() {}

func (x *Rel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[17]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Rel.ProtoReflect.Descriptor instead.
func (*Rel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{17}
}

func (x *Rel) GetRelType() isRel_RelType {
	if x != nil {
		return x.RelType
	}
	return nil
}

func (x *Rel) GetRead() *ReadRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Read); ok {
			return x.Read
		}
	}
	return nil
}

func (x *Rel) GetFilter() *FilterRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Filter); ok {
			return x.Filter
		}
	}
	return nil
}

func (x *Rel) GetFetch() *FetchRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Fetch); ok {
			return x.Fetch
		}
	}
	return nil
}

func (x *Rel) GetAggregate() *AggregateRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Aggregate); ok {
			return x.Aggregate
		}
	}
	return nil
}

func (x *Rel) GetSort() *SortRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Sort); ok {
			return x.Sort
		}
	}
	return nil
}

func (x *Rel) GetJoin() *JoinRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Join); ok {
			return x.Join
		}
	}
	return nil
}

func (x *Rel) GetProject() *ProjectRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Project); ok {
			return x.Project
		}
	}
	return nil
}

func (x *Rel) GetSet() *SetRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Set); ok {
			return x.Set
		}
	}
	return nil
}

func (x *Rel) GetExtensionSingle() *ExtensionSingleRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_ExtensionSingle); ok {
			return x.ExtensionSingle
		}
	}
	return nil
}

func (x *Rel) GetExtensionMulti() *ExtensionMultiRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_ExtensionMulti); ok {
			return x.ExtensionMulti
		}
	}
	return nil
}

func (x *Rel) GetExtensionLeaf() *ExtensionLeafRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_ExtensionLeaf); ok {
			return x.ExtensionLeaf
		}
	}
	return nil
}

func (x *Rel) GetCross() *CrossRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Cross); ok {
			return x.Cross
		}
	}
	return nil
}

func (x *Rel) GetReference() *ReferenceRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Reference); ok {
			return x.Reference
		}
	}
	return nil
}

func (x *Rel) GetWrite() *WriteRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Write); ok {
			return x.Write
		}
	}
	return nil
}

func (x *Rel) GetDdl() *DdlRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Ddl); ok {
			return x.Ddl
		}
	}
	return nil
}

func (x *Rel) GetUpdate() *UpdateRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Update); ok {
			return x.Update
		}
	}
	return nil
}

func (x *Rel) GetHashJoin() *HashJoinRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_HashJoin); ok {
			return x.HashJoin
		}
	}
	return nil
}

func (x *Rel) GetMergeJoin() *MergeJoinRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_MergeJoin); ok {
			return x.MergeJoin
		}
	}
	return nil
}

func (x *Rel) GetNestedLoopJoin() *NestedLoopJoinRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_NestedLoopJoin); ok {
			return x.NestedLoopJoin
		}
	}
	return nil
}

func (x *Rel) GetWindow() *ConsistentPartitionWindowRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Window); ok {
			return x.Window
		}
	}
	return nil
}

func (x *Rel) GetExchange() *ExchangeRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Exchange); ok {
			return x.Exchange
		}
	}
	return nil
}

func (x *Rel) GetExpand() *ExpandRel {
	if x != nil {
		if x, ok := x.RelType.(*Rel_Expand); ok {
			return x.Expand
		}
	}
	return nil
}

type isRel_RelType interface {
	isRel_RelType()
}

type Rel_Read struct {
	Read *ReadRel `protobuf:"bytes,1,opt,name=read,proto3,oneof"`
}

type Rel_Filter struct {
	Filter *FilterRel `protobuf:"bytes,2,opt,name=filter,proto3,oneof"`
}

type Rel_Fetch struct {
	Fetch *FetchRel `protobuf:"bytes,3,opt,name=fetch,proto3,oneof"`
}

type Rel_Aggregate struct {
	Aggregate *AggregateRel `protobuf:"bytes,4,opt,name=aggregate,proto3,oneof"`
}

type Rel_Sort struct {
	Sort *SortRel `protobuf:"bytes,5,opt,name=sort,proto3,oneof"`
}

type Rel_Join struct {
	Join *JoinRel `protobuf:"bytes,6,opt,name=join,proto3,oneof"`
}

type Rel_Project struct {
	Project *ProjectRel `protobuf:"bytes,7,opt,name=project,proto3,oneof"`
}

type Rel_Set struct {
	Set *SetRel `protobuf:"bytes,8,opt,name=set,proto3,oneof"`
}

type Rel_ExtensionSingle struct {
	ExtensionSingle *ExtensionSingleRel `protobuf:"bytes,9,opt,name=extension_single,json=extensionSingle,proto3,oneof"`
}

type Rel_ExtensionMulti struct {
	ExtensionMulti *ExtensionMultiRel `protobuf:"bytes,10,opt,name=extension_multi,json=extensionMulti,proto3,oneof"`
}

type Rel_ExtensionLeaf struct {
	ExtensionLeaf *ExtensionLeafRel `protobuf:"bytes,11,opt,name=extension_leaf,json=extensionLeaf,proto3,oneof"`
}

type Rel_Cross struct {
	Cross *CrossRel `protobuf:"bytes,12,opt,name=cross,proto3,oneof"`
}

type Rel_Reference struct {
	Reference *ReferenceRel `protobuf:"bytes,21,opt,name=reference,proto3,oneof"`
}

type Rel_Write struct {
	Write *WriteRel `protobuf:"bytes,19,opt,name=write,proto3,oneof"`
}

type Rel_Ddl struct {
	Ddl *DdlRel `protobuf:"bytes,20,opt,name=ddl,proto3,oneof"`
}

type Rel_Update struct {
	Update *UpdateRel `protobuf:"bytes,22,opt,name=update,proto3,oneof"`
}

type Rel_HashJoin struct {
	// Physical relations
	HashJoin *HashJoinRel `protobuf:"bytes,13,opt,name=hash_join,json=hashJoin,proto3,oneof"`
}

type Rel_MergeJoin struct {
	MergeJoin *MergeJoinRel `protobuf:"bytes,14,opt,name=merge_join,json=mergeJoin,proto3,oneof"`
}

type Rel_NestedLoopJoin struct {
	NestedLoopJoin *NestedLoopJoinRel `protobuf:"bytes,18,opt,name=nested_loop_join,json=nestedLoopJoin,proto3,oneof"`
}

type Rel_Window struct {
	Window *ConsistentPartitionWindowRel `protobuf:"bytes,17,opt,name=window,proto3,oneof"`
}

type Rel_Exchange struct {
	Exchange *ExchangeRel `protobuf:"bytes,15,opt,name=exchange,proto3,oneof"`
}

type Rel_Expand struct {
	Expand *ExpandRel `protobuf:"bytes,16,opt,name=expand,proto3,oneof"`
}

func (*Rel_Read) isRel_RelType() {}

func (*Rel_Filter) isRel_RelType() {}

func (*Rel_Fetch) isRel_RelType() {}

func (*Rel_Aggregate) isRel_RelType() {}

func (*Rel_Sort) isRel_RelType() {}

func (*Rel_Join) isRel_RelType() {}

func (*Rel_Project) isRel_RelType() {}

func (*Rel_Set) isRel_RelType() {}

func (*Rel_ExtensionSingle) isRel_RelType() {}

func (*Rel_ExtensionMulti) isRel_RelType() {}

func (*Rel_ExtensionLeaf) isRel_RelType() {}

func (*Rel_Cross) isRel_RelType() {}

func (*Rel_Reference) isRel_RelType() {}

func (*Rel_Write) isRel_RelType() {}

func (*Rel_Ddl) isRel_RelType() {}

func (*Rel_Update) isRel_RelType() {}

func (*Rel_HashJoin) isRel_RelType() {}

func (*Rel_MergeJoin) isRel_RelType() {}

func (*Rel_NestedLoopJoin) isRel_RelType() {}

func (*Rel_Window) isRel_RelType() {}

func (*Rel_Exchange) isRel_RelType() {}

func (*Rel_Expand) isRel_RelType() {}

// A base object for writing (e.g., a table or a view).
type NamedObjectWrite struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// The list of string is used to represent namespacing (e.g., mydb.mytable).
	// This assumes shared catalog between systems exchanging a message.
	Names             []string                      `protobuf:"bytes,1,rep,name=names,proto3" json:"names,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *NamedObjectWrite) Reset() {
	*x = NamedObjectWrite{}
	mi := &file_substrait_algebra_proto_msgTypes[18]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *NamedObjectWrite) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*NamedObjectWrite) ProtoMessage() {}

func (x *NamedObjectWrite) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[18]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use NamedObjectWrite.ProtoReflect.Descriptor instead.
func (*NamedObjectWrite) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{18}
}

func (x *NamedObjectWrite) GetNames() []string {
	if x != nil {
		return x.Names
	}
	return nil
}

func (x *NamedObjectWrite) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// A stub type that can be used to extend/introduce new table types outside
// the specification.
type ExtensionObject struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Detail        *anypb.Any             `protobuf:"bytes,1,opt,name=detail,proto3" json:"detail,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExtensionObject) Reset() {
	*x = ExtensionObject{}
	mi := &file_substrait_algebra_proto_msgTypes[19]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExtensionObject) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExtensionObject) ProtoMessage() {}

func (x *ExtensionObject) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[19]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExtensionObject.ProtoReflect.Descriptor instead.
func (*ExtensionObject) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{19}
}

func (x *ExtensionObject) GetDetail() *anypb.Any {
	if x != nil {
		return x.Detail
	}
	return nil
}

type DdlRel struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Definition of which type of object we are operating on
	//
	// Types that are valid to be assigned to WriteType:
	//
	//	*DdlRel_NamedObject
	//	*DdlRel_ExtensionObject
	WriteType isDdlRel_WriteType `protobuf_oneof:"write_type"`
	// The columns that will be modified (representing after-image of a schema change)
	TableSchema *NamedStruct `protobuf:"bytes,3,opt,name=table_schema,json=tableSchema,proto3" json:"table_schema,omitempty"`
	// The default values for the columns (representing after-image of a schema change)
	// E.g., in case of an ALTER TABLE that changes some of the column default values, we expect
	// the table_defaults Struct to report a full list of default values reflecting the result of applying
	// the ALTER TABLE operator successfully
	TableDefaults *Expression_Literal_Struct `protobuf:"bytes,4,opt,name=table_defaults,json=tableDefaults,proto3" json:"table_defaults,omitempty"`
	// Which type of object we operate on
	Object DdlRel_DdlObject `protobuf:"varint,5,opt,name=object,proto3,enum=substrait.DdlRel_DdlObject" json:"object,omitempty"`
	// The type of operation to perform
	Op DdlRel_DdlOp `protobuf:"varint,6,opt,name=op,proto3,enum=substrait.DdlRel_DdlOp" json:"op,omitempty"`
	// The body of the CREATE VIEW
	ViewDefinition *Rel       `protobuf:"bytes,7,opt,name=view_definition,json=viewDefinition,proto3" json:"view_definition,omitempty"`
	Common         *RelCommon `protobuf:"bytes,8,opt,name=common,proto3" json:"common,omitempty"`
	unknownFields  protoimpl.UnknownFields
	sizeCache      protoimpl.SizeCache
}

func (x *DdlRel) Reset() {
	*x = DdlRel{}
	mi := &file_substrait_algebra_proto_msgTypes[20]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *DdlRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*DdlRel) ProtoMessage() {}

func (x *DdlRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[20]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use DdlRel.ProtoReflect.Descriptor instead.
func (*DdlRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{20}
}

func (x *DdlRel) GetWriteType() isDdlRel_WriteType {
	if x != nil {
		return x.WriteType
	}
	return nil
}

func (x *DdlRel) GetNamedObject() *NamedObjectWrite {
	if x != nil {
		if x, ok := x.WriteType.(*DdlRel_NamedObject); ok {
			return x.NamedObject
		}
	}
	return nil
}

func (x *DdlRel) GetExtensionObject() *ExtensionObject {
	if x != nil {
		if x, ok := x.WriteType.(*DdlRel_ExtensionObject); ok {
			return x.ExtensionObject
		}
	}
	return nil
}

func (x *DdlRel) GetTableSchema() *NamedStruct {
	if x != nil {
		return x.TableSchema
	}
	return nil
}

func (x *DdlRel) GetTableDefaults() *Expression_Literal_Struct {
	if x != nil {
		return x.TableDefaults
	}
	return nil
}

func (x *DdlRel) GetObject() DdlRel_DdlObject {
	if x != nil {
		return x.Object
	}
	return DdlRel_DDL_OBJECT_UNSPECIFIED
}

func (x *DdlRel) GetOp() DdlRel_DdlOp {
	if x != nil {
		return x.Op
	}
	return DdlRel_DDL_OP_UNSPECIFIED
}

func (x *DdlRel) GetViewDefinition() *Rel {
	if x != nil {
		return x.ViewDefinition
	}
	return nil
}

func (x *DdlRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

type isDdlRel_WriteType interface {
	isDdlRel_WriteType()
}

type DdlRel_NamedObject struct {
	NamedObject *NamedObjectWrite `protobuf:"bytes,1,opt,name=named_object,json=namedObject,proto3,oneof"`
}

type DdlRel_ExtensionObject struct {
	ExtensionObject *ExtensionObject `protobuf:"bytes,2,opt,name=extension_object,json=extensionObject,proto3,oneof"`
}

func (*DdlRel_NamedObject) isDdlRel_WriteType() {}

func (*DdlRel_ExtensionObject) isDdlRel_WriteType() {}

// The operator that modifies the content of a database (operates on 1 table at a time, but record-selection/source can be
// based on joining of multiple tables).
type WriteRel struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Definition of which TABLE we are operating on
	//
	// Types that are valid to be assigned to WriteType:
	//
	//	*WriteRel_NamedTable
	//	*WriteRel_ExtensionTable
	WriteType isWriteRel_WriteType `protobuf_oneof:"write_type"`
	// The schema of the table (must align with Rel input (e.g., number of leaf fields must match))
	TableSchema *NamedStruct `protobuf:"bytes,3,opt,name=table_schema,json=tableSchema,proto3" json:"table_schema,omitempty"`
	// The type of operation to perform
	Op WriteRel_WriteOp `protobuf:"varint,4,opt,name=op,proto3,enum=substrait.WriteRel_WriteOp" json:"op,omitempty"`
	// The relation that determines the records to add/remove/modify
	// the schema must match with table_schema. Default values must be explicitly stated
	// in a ProjectRel at the top of the input. The match must also
	// occur in case of DELETE to ensure multi-engine plans are unequivocal.
	Input      *Rel                `protobuf:"bytes,5,opt,name=input,proto3" json:"input,omitempty"`
	CreateMode WriteRel_CreateMode `protobuf:"varint,8,opt,name=create_mode,json=createMode,proto3,enum=substrait.WriteRel_CreateMode" json:"create_mode,omitempty"` // Used with CTAS to determine what to do if the table already exists
	// Output mode determines what is the output of executing this rel
	Output        WriteRel_OutputMode `protobuf:"varint,6,opt,name=output,proto3,enum=substrait.WriteRel_OutputMode" json:"output,omitempty"`
	Common        *RelCommon          `protobuf:"bytes,7,opt,name=common,proto3" json:"common,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *WriteRel) Reset() {
	*x = WriteRel{}
	mi := &file_substrait_algebra_proto_msgTypes[21]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *WriteRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*WriteRel) ProtoMessage() {}

func (x *WriteRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[21]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use WriteRel.ProtoReflect.Descriptor instead.
func (*WriteRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{21}
}

func (x *WriteRel) GetWriteType() isWriteRel_WriteType {
	if x != nil {
		return x.WriteType
	}
	return nil
}

func (x *WriteRel) GetNamedTable() *NamedObjectWrite {
	if x != nil {
		if x, ok := x.WriteType.(*WriteRel_NamedTable); ok {
			return x.NamedTable
		}
	}
	return nil
}

func (x *WriteRel) GetExtensionTable() *ExtensionObject {
	if x != nil {
		if x, ok := x.WriteType.(*WriteRel_ExtensionTable); ok {
			return x.ExtensionTable
		}
	}
	return nil
}

func (x *WriteRel) GetTableSchema() *NamedStruct {
	if x != nil {
		return x.TableSchema
	}
	return nil
}

func (x *WriteRel) GetOp() WriteRel_WriteOp {
	if x != nil {
		return x.Op
	}
	return WriteRel_WRITE_OP_UNSPECIFIED
}

func (x *WriteRel) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *WriteRel) GetCreateMode() WriteRel_CreateMode {
	if x != nil {
		return x.CreateMode
	}
	return WriteRel_CREATE_MODE_UNSPECIFIED
}

func (x *WriteRel) GetOutput() WriteRel_OutputMode {
	if x != nil {
		return x.Output
	}
	return WriteRel_OUTPUT_MODE_UNSPECIFIED
}

func (x *WriteRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

type isWriteRel_WriteType interface {
	isWriteRel_WriteType()
}

type WriteRel_NamedTable struct {
	NamedTable *NamedObjectWrite `protobuf:"bytes,1,opt,name=named_table,json=namedTable,proto3,oneof"`
}

type WriteRel_ExtensionTable struct {
	ExtensionTable *ExtensionObject `protobuf:"bytes,2,opt,name=extension_table,json=extensionTable,proto3,oneof"`
}

func (*WriteRel_NamedTable) isWriteRel_WriteType() {}

func (*WriteRel_ExtensionTable) isWriteRel_WriteType() {}

// The operator that modifies the columns of a table
type UpdateRel struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to UpdateType:
	//
	//	*UpdateRel_NamedTable
	UpdateType  isUpdateRel_UpdateType `protobuf_oneof:"update_type"`
	TableSchema *NamedStruct           `protobuf:"bytes,2,opt,name=table_schema,json=tableSchema,proto3" json:"table_schema,omitempty"` // The full schema of the named_table
	Condition   *Expression            `protobuf:"bytes,3,opt,name=condition,proto3" json:"condition,omitempty"`                        // condition to be met for the update to be applied on a record
	// The list of transformations to apply to the columns of the named_table
	Transformations []*UpdateRel_TransformExpression `protobuf:"bytes,4,rep,name=transformations,proto3" json:"transformations,omitempty"`
	unknownFields   protoimpl.UnknownFields
	sizeCache       protoimpl.SizeCache
}

func (x *UpdateRel) Reset() {
	*x = UpdateRel{}
	mi := &file_substrait_algebra_proto_msgTypes[22]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *UpdateRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*UpdateRel) ProtoMessage() {}

func (x *UpdateRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[22]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use UpdateRel.ProtoReflect.Descriptor instead.
func (*UpdateRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{22}
}

func (x *UpdateRel) GetUpdateType() isUpdateRel_UpdateType {
	if x != nil {
		return x.UpdateType
	}
	return nil
}

func (x *UpdateRel) GetNamedTable() *NamedTable {
	if x != nil {
		if x, ok := x.UpdateType.(*UpdateRel_NamedTable); ok {
			return x.NamedTable
		}
	}
	return nil
}

func (x *UpdateRel) GetTableSchema() *NamedStruct {
	if x != nil {
		return x.TableSchema
	}
	return nil
}

func (x *UpdateRel) GetCondition() *Expression {
	if x != nil {
		return x.Condition
	}
	return nil
}

func (x *UpdateRel) GetTransformations() []*UpdateRel_TransformExpression {
	if x != nil {
		return x.Transformations
	}
	return nil
}

type isUpdateRel_UpdateType interface {
	isUpdateRel_UpdateType()
}

type UpdateRel_NamedTable struct {
	NamedTable *NamedTable `protobuf:"bytes,1,opt,name=named_table,json=namedTable,proto3,oneof"`
}

func (*UpdateRel_NamedTable) isUpdateRel_UpdateType() {}

// A base table. The list of string is used to represent namespacing (e.g., mydb.mytable).
// This assumes shared catalog between systems exchanging a message.
type NamedTable struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Names             []string                      `protobuf:"bytes,1,rep,name=names,proto3" json:"names,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *NamedTable) Reset() {
	*x = NamedTable{}
	mi := &file_substrait_algebra_proto_msgTypes[23]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *NamedTable) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*NamedTable) ProtoMessage() {}

func (x *NamedTable) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[23]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use NamedTable.ProtoReflect.Descriptor instead.
func (*NamedTable) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{23}
}

func (x *NamedTable) GetNames() []string {
	if x != nil {
		return x.Names
	}
	return nil
}

func (x *NamedTable) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// Hash joins and merge joins are a specialization of the general join where the join
// expression is an series of comparisons between fields that are ANDed together.  The
// behavior of this comparison is flexible
type ComparisonJoinKey struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// The key to compare from the left table
	Left *Expression_FieldReference `protobuf:"bytes,1,opt,name=left,proto3" json:"left,omitempty"`
	// The key to compare from the right table
	Right *Expression_FieldReference `protobuf:"bytes,2,opt,name=right,proto3" json:"right,omitempty"`
	// Describes how to compare the two keys
	Comparison    *ComparisonJoinKey_ComparisonType `protobuf:"bytes,3,opt,name=comparison,proto3" json:"comparison,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ComparisonJoinKey) Reset() {
	*x = ComparisonJoinKey{}
	mi := &file_substrait_algebra_proto_msgTypes[24]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ComparisonJoinKey) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ComparisonJoinKey) ProtoMessage() {}

func (x *ComparisonJoinKey) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[24]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ComparisonJoinKey.ProtoReflect.Descriptor instead.
func (*ComparisonJoinKey) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{24}
}

func (x *ComparisonJoinKey) GetLeft() *Expression_FieldReference {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *ComparisonJoinKey) GetRight() *Expression_FieldReference {
	if x != nil {
		return x.Right
	}
	return nil
}

func (x *ComparisonJoinKey) GetComparison() *ComparisonJoinKey_ComparisonType {
	if x != nil {
		return x.Comparison
	}
	return nil
}

// The hash equijoin join operator will build a hash table out of the right input based on a set of join keys.
// It will then probe that hash table for incoming inputs, finding matches.
//
// Two rows are a match if the comparison function returns true for all keys
type HashJoinRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Left   *Rel                   `protobuf:"bytes,2,opt,name=left,proto3" json:"left,omitempty"`
	Right  *Rel                   `protobuf:"bytes,3,opt,name=right,proto3" json:"right,omitempty"`
	// These fields are deprecated in favor of `keys`.  If they are set then
	// the two lists (left_keys and right_keys) must have the same length and
	// the comparion function is considered to be SimpleEqualityType::EQ
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	LeftKeys []*Expression_FieldReference `protobuf:"bytes,4,rep,name=left_keys,json=leftKeys,proto3" json:"left_keys,omitempty"`
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	RightKeys []*Expression_FieldReference `protobuf:"bytes,5,rep,name=right_keys,json=rightKeys,proto3" json:"right_keys,omitempty"`
	// One or more keys to join on.  The relation is invalid if this is empty
	// (unless the deprecated left_keys/right_keys fields are being used).
	//
	// If a custom comparison function is used then it must be consistent with
	// the hash function used for the keys.
	//
	// In other words, the hash function must return the same hash code when the
	// comparison returns true.  For example, if the comparison function is
	// "equals ignoring case" then the hash function must return the same hash
	// code for strings that differ only by case.  Note: the hash function is not
	// specified here.  It is the responsibility of the consumer to find an appropriate
	// hash function for a given comparsion function or to reject the plan if it cannot
	// do so.
	Keys              []*ComparisonJoinKey          `protobuf:"bytes,8,rep,name=keys,proto3" json:"keys,omitempty"`
	PostJoinFilter    *Expression                   `protobuf:"bytes,6,opt,name=post_join_filter,json=postJoinFilter,proto3" json:"post_join_filter,omitempty"`
	Type              HashJoinRel_JoinType          `protobuf:"varint,7,opt,name=type,proto3,enum=substrait.HashJoinRel_JoinType" json:"type,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *HashJoinRel) Reset() {
	*x = HashJoinRel{}
	mi := &file_substrait_algebra_proto_msgTypes[25]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *HashJoinRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*HashJoinRel) ProtoMessage() {}

func (x *HashJoinRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[25]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use HashJoinRel.ProtoReflect.Descriptor instead.
func (*HashJoinRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{25}
}

func (x *HashJoinRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *HashJoinRel) GetLeft() *Rel {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *HashJoinRel) GetRight() *Rel {
	if x != nil {
		return x.Right
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *HashJoinRel) GetLeftKeys() []*Expression_FieldReference {
	if x != nil {
		return x.LeftKeys
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *HashJoinRel) GetRightKeys() []*Expression_FieldReference {
	if x != nil {
		return x.RightKeys
	}
	return nil
}

func (x *HashJoinRel) GetKeys() []*ComparisonJoinKey {
	if x != nil {
		return x.Keys
	}
	return nil
}

func (x *HashJoinRel) GetPostJoinFilter() *Expression {
	if x != nil {
		return x.PostJoinFilter
	}
	return nil
}

func (x *HashJoinRel) GetType() HashJoinRel_JoinType {
	if x != nil {
		return x.Type
	}
	return HashJoinRel_JOIN_TYPE_UNSPECIFIED
}

func (x *HashJoinRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The merge equijoin does a join by taking advantage of two sets that are sorted on the join keys.
// This allows the join operation to be done in a streaming fashion.
type MergeJoinRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Left   *Rel                   `protobuf:"bytes,2,opt,name=left,proto3" json:"left,omitempty"`
	Right  *Rel                   `protobuf:"bytes,3,opt,name=right,proto3" json:"right,omitempty"`
	// These fields are deprecated in favor of `keys`.  If they are set then
	// the two lists (left_keys and right_keys) must have the same length and
	// the comparion function is considered to be SimpleEqualityType::EQ
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	LeftKeys []*Expression_FieldReference `protobuf:"bytes,4,rep,name=left_keys,json=leftKeys,proto3" json:"left_keys,omitempty"`
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	RightKeys []*Expression_FieldReference `protobuf:"bytes,5,rep,name=right_keys,json=rightKeys,proto3" json:"right_keys,omitempty"`
	// One or more keys to join on.  The relation is invalid if this is empty
	// (unless the deprecated left_keys/right_keys fields are being used).
	//
	// If a custom comparison function is used then it must be consistent with
	// the ordering of the input data.  For example, if the comparison function
	// is "<" then we generally expect the data to be sorted in ascending order.
	//
	// If the comparison function is something like "less than ignoring case" then
	// the data should be sorted appropriately (e.g. both "A" and "a" should come
	// before "b")
	//
	// The sort order is not specified here.  It is typically the responsibility of
	// the producer to ensure the plan sorts the data if needed (although the consumer
	// is free to do so as well).  If possible, the consumer should verify the sort
	// order and reject invalid plans.
	Keys              []*ComparisonJoinKey          `protobuf:"bytes,8,rep,name=keys,proto3" json:"keys,omitempty"`
	PostJoinFilter    *Expression                   `protobuf:"bytes,6,opt,name=post_join_filter,json=postJoinFilter,proto3" json:"post_join_filter,omitempty"`
	Type              MergeJoinRel_JoinType         `protobuf:"varint,7,opt,name=type,proto3,enum=substrait.MergeJoinRel_JoinType" json:"type,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *MergeJoinRel) Reset() {
	*x = MergeJoinRel{}
	mi := &file_substrait_algebra_proto_msgTypes[26]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *MergeJoinRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*MergeJoinRel) ProtoMessage() {}

func (x *MergeJoinRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[26]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use MergeJoinRel.ProtoReflect.Descriptor instead.
func (*MergeJoinRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{26}
}

func (x *MergeJoinRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *MergeJoinRel) GetLeft() *Rel {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *MergeJoinRel) GetRight() *Rel {
	if x != nil {
		return x.Right
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *MergeJoinRel) GetLeftKeys() []*Expression_FieldReference {
	if x != nil {
		return x.LeftKeys
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *MergeJoinRel) GetRightKeys() []*Expression_FieldReference {
	if x != nil {
		return x.RightKeys
	}
	return nil
}

func (x *MergeJoinRel) GetKeys() []*ComparisonJoinKey {
	if x != nil {
		return x.Keys
	}
	return nil
}

func (x *MergeJoinRel) GetPostJoinFilter() *Expression {
	if x != nil {
		return x.PostJoinFilter
	}
	return nil
}

func (x *MergeJoinRel) GetType() MergeJoinRel_JoinType {
	if x != nil {
		return x.Type
	}
	return MergeJoinRel_JOIN_TYPE_UNSPECIFIED
}

func (x *MergeJoinRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The nested loop join (NLJ) operator will hold the entire right input and iterate over it using the
// left input, evaluating the join expression on the Cartesian product of all rows.
type NestedLoopJoinRel struct {
	state  protoimpl.MessageState `protogen:"open.v1"`
	Common *RelCommon             `protobuf:"bytes,1,opt,name=common,proto3" json:"common,omitempty"`
	Left   *Rel                   `protobuf:"bytes,2,opt,name=left,proto3" json:"left,omitempty"`
	Right  *Rel                   `protobuf:"bytes,3,opt,name=right,proto3" json:"right,omitempty"`
	// optional, defaults to true (a cartesian join)
	Expression        *Expression                   `protobuf:"bytes,4,opt,name=expression,proto3" json:"expression,omitempty"`
	Type              NestedLoopJoinRel_JoinType    `protobuf:"varint,5,opt,name=type,proto3,enum=substrait.NestedLoopJoinRel_JoinType" json:"type,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *NestedLoopJoinRel) Reset() {
	*x = NestedLoopJoinRel{}
	mi := &file_substrait_algebra_proto_msgTypes[27]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *NestedLoopJoinRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*NestedLoopJoinRel) ProtoMessage() {}

func (x *NestedLoopJoinRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[27]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use NestedLoopJoinRel.ProtoReflect.Descriptor instead.
func (*NestedLoopJoinRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{27}
}

func (x *NestedLoopJoinRel) GetCommon() *RelCommon {
	if x != nil {
		return x.Common
	}
	return nil
}

func (x *NestedLoopJoinRel) GetLeft() *Rel {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *NestedLoopJoinRel) GetRight() *Rel {
	if x != nil {
		return x.Right
	}
	return nil
}

func (x *NestedLoopJoinRel) GetExpression() *Expression {
	if x != nil {
		return x.Expression
	}
	return nil
}

func (x *NestedLoopJoinRel) GetType() NestedLoopJoinRel_JoinType {
	if x != nil {
		return x.Type
	}
	return NestedLoopJoinRel_JOIN_TYPE_UNSPECIFIED
}

func (x *NestedLoopJoinRel) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// The argument of a function
type FunctionArgument struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to ArgType:
	//
	//	*FunctionArgument_Enum
	//	*FunctionArgument_Type
	//	*FunctionArgument_Value
	ArgType       isFunctionArgument_ArgType `protobuf_oneof:"arg_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *FunctionArgument) Reset() {
	*x = FunctionArgument{}
	mi := &file_substrait_algebra_proto_msgTypes[28]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *FunctionArgument) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*FunctionArgument) ProtoMessage() {}

func (x *FunctionArgument) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[28]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use FunctionArgument.ProtoReflect.Descriptor instead.
func (*FunctionArgument) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{28}
}

func (x *FunctionArgument) GetArgType() isFunctionArgument_ArgType {
	if x != nil {
		return x.ArgType
	}
	return nil
}

func (x *FunctionArgument) GetEnum() string {
	if x != nil {
		if x, ok := x.ArgType.(*FunctionArgument_Enum); ok {
			return x.Enum
		}
	}
	return ""
}

func (x *FunctionArgument) GetType() *Type {
	if x != nil {
		if x, ok := x.ArgType.(*FunctionArgument_Type); ok {
			return x.Type
		}
	}
	return nil
}

func (x *FunctionArgument) GetValue() *Expression {
	if x != nil {
		if x, ok := x.ArgType.(*FunctionArgument_Value); ok {
			return x.Value
		}
	}
	return nil
}

type isFunctionArgument_ArgType interface {
	isFunctionArgument_ArgType()
}

type FunctionArgument_Enum struct {
	Enum string `protobuf:"bytes,1,opt,name=enum,proto3,oneof"`
}

type FunctionArgument_Type struct {
	Type *Type `protobuf:"bytes,2,opt,name=type,proto3,oneof"`
}

type FunctionArgument_Value struct {
	Value *Expression `protobuf:"bytes,3,opt,name=value,proto3,oneof"`
}

func (*FunctionArgument_Enum) isFunctionArgument_ArgType() {}

func (*FunctionArgument_Type) isFunctionArgument_ArgType() {}

func (*FunctionArgument_Value) isFunctionArgument_ArgType() {}

// An optional function argument.  Typically used for specifying behavior in
// invalid or corner cases.
type FunctionOption struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Name of the option to set. If the consumer does not recognize the
	// option, it must reject the plan. The name is matched case-insensitively
	// with option names defined for the function.
	Name string `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	// List of behavior options allowed by the producer. At least one must be
	// specified; to leave an option unspecified, simply don't add an entry to
	// `options`. The consumer must use the first option from the list that it
	// supports. If the consumer supports none of the specified options, it
	// must reject the plan. The name is matched case-insensitively and must
	// match one of the option values defined for the option.
	Preference    []string `protobuf:"bytes,2,rep,name=preference,proto3" json:"preference,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *FunctionOption) Reset() {
	*x = FunctionOption{}
	mi := &file_substrait_algebra_proto_msgTypes[29]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *FunctionOption) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*FunctionOption) ProtoMessage() {}

func (x *FunctionOption) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[29]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use FunctionOption.ProtoReflect.Descriptor instead.
func (*FunctionOption) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{29}
}

func (x *FunctionOption) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *FunctionOption) GetPreference() []string {
	if x != nil {
		return x.Preference
	}
	return nil
}

type Expression struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to RexType:
	//
	//	*Expression_Literal_
	//	*Expression_Selection
	//	*Expression_ScalarFunction_
	//	*Expression_WindowFunction_
	//	*Expression_IfThen_
	//	*Expression_SwitchExpression_
	//	*Expression_SingularOrList_
	//	*Expression_MultiOrList_
	//	*Expression_Cast_
	//	*Expression_Subquery_
	//	*Expression_Nested_
	//	*Expression_Enum_
	RexType       isExpression_RexType `protobuf_oneof:"rex_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression) Reset() {
	*x = Expression{}
	mi := &file_substrait_algebra_proto_msgTypes[30]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression) ProtoMessage() {}

func (x *Expression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[30]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression.ProtoReflect.Descriptor instead.
func (*Expression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30}
}

func (x *Expression) GetRexType() isExpression_RexType {
	if x != nil {
		return x.RexType
	}
	return nil
}

func (x *Expression) GetLiteral() *Expression_Literal {
	if x != nil {
		if x, ok := x.RexType.(*Expression_Literal_); ok {
			return x.Literal
		}
	}
	return nil
}

func (x *Expression) GetSelection() *Expression_FieldReference {
	if x != nil {
		if x, ok := x.RexType.(*Expression_Selection); ok {
			return x.Selection
		}
	}
	return nil
}

func (x *Expression) GetScalarFunction() *Expression_ScalarFunction {
	if x != nil {
		if x, ok := x.RexType.(*Expression_ScalarFunction_); ok {
			return x.ScalarFunction
		}
	}
	return nil
}

func (x *Expression) GetWindowFunction() *Expression_WindowFunction {
	if x != nil {
		if x, ok := x.RexType.(*Expression_WindowFunction_); ok {
			return x.WindowFunction
		}
	}
	return nil
}

func (x *Expression) GetIfThen() *Expression_IfThen {
	if x != nil {
		if x, ok := x.RexType.(*Expression_IfThen_); ok {
			return x.IfThen
		}
	}
	return nil
}

func (x *Expression) GetSwitchExpression() *Expression_SwitchExpression {
	if x != nil {
		if x, ok := x.RexType.(*Expression_SwitchExpression_); ok {
			return x.SwitchExpression
		}
	}
	return nil
}

func (x *Expression) GetSingularOrList() *Expression_SingularOrList {
	if x != nil {
		if x, ok := x.RexType.(*Expression_SingularOrList_); ok {
			return x.SingularOrList
		}
	}
	return nil
}

func (x *Expression) GetMultiOrList() *Expression_MultiOrList {
	if x != nil {
		if x, ok := x.RexType.(*Expression_MultiOrList_); ok {
			return x.MultiOrList
		}
	}
	return nil
}

func (x *Expression) GetCast() *Expression_Cast {
	if x != nil {
		if x, ok := x.RexType.(*Expression_Cast_); ok {
			return x.Cast
		}
	}
	return nil
}

func (x *Expression) GetSubquery() *Expression_Subquery {
	if x != nil {
		if x, ok := x.RexType.(*Expression_Subquery_); ok {
			return x.Subquery
		}
	}
	return nil
}

func (x *Expression) GetNested() *Expression_Nested {
	if x != nil {
		if x, ok := x.RexType.(*Expression_Nested_); ok {
			return x.Nested
		}
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *Expression) GetEnum() *Expression_Enum {
	if x != nil {
		if x, ok := x.RexType.(*Expression_Enum_); ok {
			return x.Enum
		}
	}
	return nil
}

type isExpression_RexType interface {
	isExpression_RexType()
}

type Expression_Literal_ struct {
	Literal *Expression_Literal `protobuf:"bytes,1,opt,name=literal,proto3,oneof"`
}

type Expression_Selection struct {
	Selection *Expression_FieldReference `protobuf:"bytes,2,opt,name=selection,proto3,oneof"`
}

type Expression_ScalarFunction_ struct {
	ScalarFunction *Expression_ScalarFunction `protobuf:"bytes,3,opt,name=scalar_function,json=scalarFunction,proto3,oneof"`
}

type Expression_WindowFunction_ struct {
	WindowFunction *Expression_WindowFunction `protobuf:"bytes,5,opt,name=window_function,json=windowFunction,proto3,oneof"`
}

type Expression_IfThen_ struct {
	IfThen *Expression_IfThen `protobuf:"bytes,6,opt,name=if_then,json=ifThen,proto3,oneof"`
}

type Expression_SwitchExpression_ struct {
	SwitchExpression *Expression_SwitchExpression `protobuf:"bytes,7,opt,name=switch_expression,json=switchExpression,proto3,oneof"`
}

type Expression_SingularOrList_ struct {
	SingularOrList *Expression_SingularOrList `protobuf:"bytes,8,opt,name=singular_or_list,json=singularOrList,proto3,oneof"`
}

type Expression_MultiOrList_ struct {
	MultiOrList *Expression_MultiOrList `protobuf:"bytes,9,opt,name=multi_or_list,json=multiOrList,proto3,oneof"`
}

type Expression_Cast_ struct {
	Cast *Expression_Cast `protobuf:"bytes,11,opt,name=cast,proto3,oneof"`
}

type Expression_Subquery_ struct {
	Subquery *Expression_Subquery `protobuf:"bytes,12,opt,name=subquery,proto3,oneof"`
}

type Expression_Nested_ struct {
	Nested *Expression_Nested `protobuf:"bytes,13,opt,name=nested,proto3,oneof"`
}

type Expression_Enum_ struct {
	// deprecated: enum literals are only sensible in the context of
	// function arguments, for which FunctionArgument should now be
	// used
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Enum *Expression_Enum `protobuf:"bytes,10,opt,name=enum,proto3,oneof"`
}

func (*Expression_Literal_) isExpression_RexType() {}

func (*Expression_Selection) isExpression_RexType() {}

func (*Expression_ScalarFunction_) isExpression_RexType() {}

func (*Expression_WindowFunction_) isExpression_RexType() {}

func (*Expression_IfThen_) isExpression_RexType() {}

func (*Expression_SwitchExpression_) isExpression_RexType() {}

func (*Expression_SingularOrList_) isExpression_RexType() {}

func (*Expression_MultiOrList_) isExpression_RexType() {}

func (*Expression_Cast_) isExpression_RexType() {}

func (*Expression_Subquery_) isExpression_RexType() {}

func (*Expression_Nested_) isExpression_RexType() {}

func (*Expression_Enum_) isExpression_RexType() {}

// The description of a field to sort on (including the direction of sorting and null semantics)
type SortField struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	Expr  *Expression            `protobuf:"bytes,1,opt,name=expr,proto3" json:"expr,omitempty"`
	// Types that are valid to be assigned to SortKind:
	//
	//	*SortField_Direction
	//	*SortField_ComparisonFunctionReference
	SortKind      isSortField_SortKind `protobuf_oneof:"sort_kind"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *SortField) Reset() {
	*x = SortField{}
	mi := &file_substrait_algebra_proto_msgTypes[31]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *SortField) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*SortField) ProtoMessage() {}

func (x *SortField) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[31]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use SortField.ProtoReflect.Descriptor instead.
func (*SortField) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{31}
}

func (x *SortField) GetExpr() *Expression {
	if x != nil {
		return x.Expr
	}
	return nil
}

func (x *SortField) GetSortKind() isSortField_SortKind {
	if x != nil {
		return x.SortKind
	}
	return nil
}

func (x *SortField) GetDirection() SortField_SortDirection {
	if x != nil {
		if x, ok := x.SortKind.(*SortField_Direction); ok {
			return x.Direction
		}
	}
	return SortField_SORT_DIRECTION_UNSPECIFIED
}

func (x *SortField) GetComparisonFunctionReference() uint32 {
	if x != nil {
		if x, ok := x.SortKind.(*SortField_ComparisonFunctionReference); ok {
			return x.ComparisonFunctionReference
		}
	}
	return 0
}

type isSortField_SortKind interface {
	isSortField_SortKind()
}

type SortField_Direction struct {
	Direction SortField_SortDirection `protobuf:"varint,2,opt,name=direction,proto3,enum=substrait.SortField_SortDirection,oneof"`
}

type SortField_ComparisonFunctionReference struct {
	ComparisonFunctionReference uint32 `protobuf:"varint,3,opt,name=comparison_function_reference,json=comparisonFunctionReference,proto3,oneof"`
}

func (*SortField_Direction) isSortField_SortKind() {}

func (*SortField_ComparisonFunctionReference) isSortField_SortKind() {}

// An aggregate function.
type AggregateFunction struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Points to a function_anchor defined in this plan, which must refer
	// to an aggregate function in the associated YAML file. Required; 0 is
	// considered to be a valid anchor/reference.
	FunctionReference uint32 `protobuf:"varint,1,opt,name=function_reference,json=functionReference,proto3" json:"function_reference,omitempty"`
	// The arguments to be bound to the function. This must have exactly the
	// number of arguments specified in the function definition, and the
	// argument types must also match exactly:
	//
	//   - Value arguments must be bound using FunctionArgument.value, and
	//     the expression in that must yield a value of a type that a function
	//     overload is defined for.
	//   - Type arguments must be bound using FunctionArgument.type, and a
	//     function overload must be defined for that type.
	//   - Enum arguments must be bound using FunctionArgument.enum
	//     followed by Enum.specified, with a string that case-insensitively
	//     matches one of the allowed options.
	//   - Optional enum arguments must be bound using FunctionArgument.enum
	//     followed by either Enum.specified or Enum.unspecified. If specified,
	//     the string must case-insensitively match one of the allowed options.
	Arguments []*FunctionArgument `protobuf:"bytes,7,rep,name=arguments,proto3" json:"arguments,omitempty"`
	// Options to specify behavior for corner cases, or leave behavior
	// unspecified if the consumer does not need specific behavior in these
	// cases.
	Options []*FunctionOption `protobuf:"bytes,8,rep,name=options,proto3" json:"options,omitempty"`
	// Must be set to the return type of the function, exactly as derived
	// using the declaration in the extension.
	OutputType *Type `protobuf:"bytes,5,opt,name=output_type,json=outputType,proto3" json:"output_type,omitempty"`
	// Describes which part of the aggregation to perform within the context of
	// distributed algorithms. Required. Must be set to INITIAL_TO_RESULT for
	// aggregate functions that are not decomposable.
	Phase AggregationPhase `protobuf:"varint,4,opt,name=phase,proto3,enum=substrait.AggregationPhase" json:"phase,omitempty"`
	// If specified, the aggregated records are ordered according to this list
	// before they are aggregated. The first sort field has the highest
	// priority; only if a sort field determines two records to be equivalent is
	// the next field queried. This field is optional.
	Sorts []*SortField `protobuf:"bytes,3,rep,name=sorts,proto3" json:"sorts,omitempty"`
	// Specifies whether equivalent records are merged before being aggregated.
	// Optional, defaults to AGGREGATION_INVOCATION_ALL.
	Invocation AggregateFunction_AggregationInvocation `protobuf:"varint,6,opt,name=invocation,proto3,enum=substrait.AggregateFunction_AggregationInvocation" json:"invocation,omitempty"`
	// deprecated; use arguments instead
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Args          []*Expression `protobuf:"bytes,2,rep,name=args,proto3" json:"args,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *AggregateFunction) Reset() {
	*x = AggregateFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[32]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *AggregateFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*AggregateFunction) ProtoMessage() {}

func (x *AggregateFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[32]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use AggregateFunction.ProtoReflect.Descriptor instead.
func (*AggregateFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{32}
}

func (x *AggregateFunction) GetFunctionReference() uint32 {
	if x != nil {
		return x.FunctionReference
	}
	return 0
}

func (x *AggregateFunction) GetArguments() []*FunctionArgument {
	if x != nil {
		return x.Arguments
	}
	return nil
}

func (x *AggregateFunction) GetOptions() []*FunctionOption {
	if x != nil {
		return x.Options
	}
	return nil
}

func (x *AggregateFunction) GetOutputType() *Type {
	if x != nil {
		return x.OutputType
	}
	return nil
}

func (x *AggregateFunction) GetPhase() AggregationPhase {
	if x != nil {
		return x.Phase
	}
	return AggregationPhase_AGGREGATION_PHASE_UNSPECIFIED
}

func (x *AggregateFunction) GetSorts() []*SortField {
	if x != nil {
		return x.Sorts
	}
	return nil
}

func (x *AggregateFunction) GetInvocation() AggregateFunction_AggregationInvocation {
	if x != nil {
		return x.Invocation
	}
	return AggregateFunction_AGGREGATION_INVOCATION_UNSPECIFIED
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *AggregateFunction) GetArgs() []*Expression {
	if x != nil {
		return x.Args
	}
	return nil
}

// This rel is used  to create references,
// in case we refer to a RelRoot field names will be ignored
type ReferenceRel struct {
	state          protoimpl.MessageState `protogen:"open.v1"`
	SubtreeOrdinal int32                  `protobuf:"varint,1,opt,name=subtree_ordinal,json=subtreeOrdinal,proto3" json:"subtree_ordinal,omitempty"`
	unknownFields  protoimpl.UnknownFields
	sizeCache      protoimpl.SizeCache
}

func (x *ReferenceRel) Reset() {
	*x = ReferenceRel{}
	mi := &file_substrait_algebra_proto_msgTypes[33]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReferenceRel) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReferenceRel) ProtoMessage() {}

func (x *ReferenceRel) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[33]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReferenceRel.ProtoReflect.Descriptor instead.
func (*ReferenceRel) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{33}
}

func (x *ReferenceRel) GetSubtreeOrdinal() int32 {
	if x != nil {
		return x.SubtreeOrdinal
	}
	return 0
}

// Direct indicates no change on presence and ordering of fields in the output
type RelCommon_Direct struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *RelCommon_Direct) Reset() {
	*x = RelCommon_Direct{}
	mi := &file_substrait_algebra_proto_msgTypes[34]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Direct) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Direct) ProtoMessage() {}

func (x *RelCommon_Direct) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[34]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Direct.ProtoReflect.Descriptor instead.
func (*RelCommon_Direct) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 0}
}

// Remap which fields are output and in which order
type RelCommon_Emit struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	OutputMapping []int32                `protobuf:"varint,1,rep,packed,name=output_mapping,json=outputMapping,proto3" json:"output_mapping,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *RelCommon_Emit) Reset() {
	*x = RelCommon_Emit{}
	mi := &file_substrait_algebra_proto_msgTypes[35]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Emit) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Emit) ProtoMessage() {}

func (x *RelCommon_Emit) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[35]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Emit.ProtoReflect.Descriptor instead.
func (*RelCommon_Emit) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 1}
}

func (x *RelCommon_Emit) GetOutputMapping() []int32 {
	if x != nil {
		return x.OutputMapping
	}
	return nil
}

// Changes to the operation that can influence efficiency/performance but
// should not impact correctness.
type RelCommon_Hint struct {
	state      protoimpl.MessageState            `protogen:"open.v1"`
	Stats      *RelCommon_Hint_Stats             `protobuf:"bytes,1,opt,name=stats,proto3" json:"stats,omitempty"`
	Constraint *RelCommon_Hint_RuntimeConstraint `protobuf:"bytes,2,opt,name=constraint,proto3" json:"constraint,omitempty"`
	// Name (alias) for this relation. Can be used for e.g. qualifying the relation (see e.g.
	// Spark's SubqueryAlias), or debugging.
	Alias string `protobuf:"bytes,3,opt,name=alias,proto3" json:"alias,omitempty"`
	// Assigns alternative output field names for any relation.  Equivalent to the names field
	// in RelRoot but applies to the output of the relation this RelCommon is attached to.
	OutputNames       []string                      `protobuf:"bytes,4,rep,name=output_names,json=outputNames,proto3" json:"output_names,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	// Save or load a system-specific computation for use in optimizing a remote operation.
	// The anchor refers to the source/destination of the computation.  The computation type
	// and number refer to the current relation.
	SavedComputations  []*RelCommon_Hint_SavedComputation  `protobuf:"bytes,11,rep,name=saved_computations,json=savedComputations,proto3" json:"saved_computations,omitempty"`
	LoadedComputations []*RelCommon_Hint_LoadedComputation `protobuf:"bytes,12,rep,name=loaded_computations,json=loadedComputations,proto3" json:"loaded_computations,omitempty"`
	unknownFields      protoimpl.UnknownFields
	sizeCache          protoimpl.SizeCache
}

func (x *RelCommon_Hint) Reset() {
	*x = RelCommon_Hint{}
	mi := &file_substrait_algebra_proto_msgTypes[36]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Hint) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Hint) ProtoMessage() {}

func (x *RelCommon_Hint) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[36]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Hint.ProtoReflect.Descriptor instead.
func (*RelCommon_Hint) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 2}
}

func (x *RelCommon_Hint) GetStats() *RelCommon_Hint_Stats {
	if x != nil {
		return x.Stats
	}
	return nil
}

func (x *RelCommon_Hint) GetConstraint() *RelCommon_Hint_RuntimeConstraint {
	if x != nil {
		return x.Constraint
	}
	return nil
}

func (x *RelCommon_Hint) GetAlias() string {
	if x != nil {
		return x.Alias
	}
	return ""
}

func (x *RelCommon_Hint) GetOutputNames() []string {
	if x != nil {
		return x.OutputNames
	}
	return nil
}

func (x *RelCommon_Hint) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

func (x *RelCommon_Hint) GetSavedComputations() []*RelCommon_Hint_SavedComputation {
	if x != nil {
		return x.SavedComputations
	}
	return nil
}

func (x *RelCommon_Hint) GetLoadedComputations() []*RelCommon_Hint_LoadedComputation {
	if x != nil {
		return x.LoadedComputations
	}
	return nil
}

// The statistics related to a hint (physical properties of records)
type RelCommon_Hint_Stats struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	RowCount          float64                       `protobuf:"fixed64,1,opt,name=row_count,json=rowCount,proto3" json:"row_count,omitempty"`
	RecordSize        float64                       `protobuf:"fixed64,2,opt,name=record_size,json=recordSize,proto3" json:"record_size,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *RelCommon_Hint_Stats) Reset() {
	*x = RelCommon_Hint_Stats{}
	mi := &file_substrait_algebra_proto_msgTypes[37]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Hint_Stats) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Hint_Stats) ProtoMessage() {}

func (x *RelCommon_Hint_Stats) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[37]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Hint_Stats.ProtoReflect.Descriptor instead.
func (*RelCommon_Hint_Stats) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 2, 0}
}

func (x *RelCommon_Hint_Stats) GetRowCount() float64 {
	if x != nil {
		return x.RowCount
	}
	return 0
}

func (x *RelCommon_Hint_Stats) GetRecordSize() float64 {
	if x != nil {
		return x.RecordSize
	}
	return 0
}

func (x *RelCommon_Hint_Stats) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

type RelCommon_Hint_RuntimeConstraint struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *RelCommon_Hint_RuntimeConstraint) Reset() {
	*x = RelCommon_Hint_RuntimeConstraint{}
	mi := &file_substrait_algebra_proto_msgTypes[38]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Hint_RuntimeConstraint) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Hint_RuntimeConstraint) ProtoMessage() {}

func (x *RelCommon_Hint_RuntimeConstraint) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[38]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Hint_RuntimeConstraint.ProtoReflect.Descriptor instead.
func (*RelCommon_Hint_RuntimeConstraint) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 2, 1}
}

func (x *RelCommon_Hint_RuntimeConstraint) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

type RelCommon_Hint_SavedComputation struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// The value corresponds to a plan unique number for that datastructure.  Any particular
	// computation may be saved only once but it may be loaded multiple times.
	ComputationId int32 `protobuf:"varint,1,opt,name=computation_id,json=computationId,proto3" json:"computation_id,omitempty"`
	// The type of this computation.  While a plan may use COMPUTATION_TYPE_UNKNOWN for all
	// of its types it is recommended to use a more specific type so that the optimization
	// is more portable.  The consumer should be able to decide if an unknown type here
	// matches the same unknown type at a different plan and ignore the optimization if they
	// are mismatched.
	Type          RelCommon_Hint_ComputationType `protobuf:"varint,2,opt,name=type,proto3,enum=substrait.RelCommon_Hint_ComputationType" json:"type,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *RelCommon_Hint_SavedComputation) Reset() {
	*x = RelCommon_Hint_SavedComputation{}
	mi := &file_substrait_algebra_proto_msgTypes[39]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Hint_SavedComputation) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Hint_SavedComputation) ProtoMessage() {}

func (x *RelCommon_Hint_SavedComputation) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[39]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Hint_SavedComputation.ProtoReflect.Descriptor instead.
func (*RelCommon_Hint_SavedComputation) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 2, 2}
}

func (x *RelCommon_Hint_SavedComputation) GetComputationId() int32 {
	if x != nil {
		return x.ComputationId
	}
	return 0
}

func (x *RelCommon_Hint_SavedComputation) GetType() RelCommon_Hint_ComputationType {
	if x != nil {
		return x.Type
	}
	return RelCommon_Hint_COMPUTATION_TYPE_UNSPECIFIED
}

type RelCommon_Hint_LoadedComputation struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// The value corresponds to a plan unique number for that datastructure.  Any particular
	// computation may be saved only once but it may be loaded multiple times.
	ComputationIdReference int32 `protobuf:"varint,1,opt,name=computation_id_reference,json=computationIdReference,proto3" json:"computation_id_reference,omitempty"`
	// The type of this computation.  While a plan may use COMPUTATION_TYPE_UNKNOWN for all
	// of its types it is recommended to use a more specific type so that the optimization
	// is more portable.  The consumer should be able to decide if an unknown type here
	// matches the same unknown type at a different plan and ignore the optimization if they
	// are mismatched.
	Type          RelCommon_Hint_ComputationType `protobuf:"varint,2,opt,name=type,proto3,enum=substrait.RelCommon_Hint_ComputationType" json:"type,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *RelCommon_Hint_LoadedComputation) Reset() {
	*x = RelCommon_Hint_LoadedComputation{}
	mi := &file_substrait_algebra_proto_msgTypes[40]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RelCommon_Hint_LoadedComputation) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RelCommon_Hint_LoadedComputation) ProtoMessage() {}

func (x *RelCommon_Hint_LoadedComputation) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[40]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RelCommon_Hint_LoadedComputation.ProtoReflect.Descriptor instead.
func (*RelCommon_Hint_LoadedComputation) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{0, 2, 3}
}

func (x *RelCommon_Hint_LoadedComputation) GetComputationIdReference() int32 {
	if x != nil {
		return x.ComputationIdReference
	}
	return 0
}

func (x *RelCommon_Hint_LoadedComputation) GetType() RelCommon_Hint_ComputationType {
	if x != nil {
		return x.Type
	}
	return RelCommon_Hint_COMPUTATION_TYPE_UNSPECIFIED
}

// A base table. The list of string is used to represent namespacing (e.g., mydb.mytable).
// This assumes shared catalog between systems exchanging a message.
type ReadRel_NamedTable struct {
	state             protoimpl.MessageState        `protogen:"open.v1"`
	Names             []string                      `protobuf:"bytes,1,rep,name=names,proto3" json:"names,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *ReadRel_NamedTable) Reset() {
	*x = ReadRel_NamedTable{}
	mi := &file_substrait_algebra_proto_msgTypes[41]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_NamedTable) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_NamedTable) ProtoMessage() {}

func (x *ReadRel_NamedTable) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[41]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_NamedTable.ProtoReflect.Descriptor instead.
func (*ReadRel_NamedTable) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 0}
}

func (x *ReadRel_NamedTable) GetNames() []string {
	if x != nil {
		return x.Names
	}
	return nil
}

func (x *ReadRel_NamedTable) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// Read an Iceberg Table
type ReadRel_IcebergTable struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to TableType:
	//
	//	*ReadRel_IcebergTable_Direct
	TableType     isReadRel_IcebergTable_TableType `protobuf_oneof:"table_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_IcebergTable) Reset() {
	*x = ReadRel_IcebergTable{}
	mi := &file_substrait_algebra_proto_msgTypes[42]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_IcebergTable) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_IcebergTable) ProtoMessage() {}

func (x *ReadRel_IcebergTable) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[42]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_IcebergTable.ProtoReflect.Descriptor instead.
func (*ReadRel_IcebergTable) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 1}
}

func (x *ReadRel_IcebergTable) GetTableType() isReadRel_IcebergTable_TableType {
	if x != nil {
		return x.TableType
	}
	return nil
}

func (x *ReadRel_IcebergTable) GetDirect() *ReadRel_IcebergTable_MetadataFileRead {
	if x != nil {
		if x, ok := x.TableType.(*ReadRel_IcebergTable_Direct); ok {
			return x.Direct
		}
	}
	return nil
}

type isReadRel_IcebergTable_TableType interface {
	isReadRel_IcebergTable_TableType()
}

type ReadRel_IcebergTable_Direct struct {
	Direct *ReadRel_IcebergTable_MetadataFileRead `protobuf:"bytes,1,opt,name=direct,proto3,oneof"` // future: add catalog table types (e.g. rest api, latest metadata in path, etc)
}

func (*ReadRel_IcebergTable_Direct) isReadRel_IcebergTable_TableType() {}

// A table composed of expressions.
type ReadRel_VirtualTable struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Values        []*Expression_Literal_Struct `protobuf:"bytes,1,rep,name=values,proto3" json:"values,omitempty"`
	Expressions   []*Expression_Nested_Struct  `protobuf:"bytes,2,rep,name=expressions,proto3" json:"expressions,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_VirtualTable) Reset() {
	*x = ReadRel_VirtualTable{}
	mi := &file_substrait_algebra_proto_msgTypes[43]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_VirtualTable) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_VirtualTable) ProtoMessage() {}

func (x *ReadRel_VirtualTable) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[43]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_VirtualTable.ProtoReflect.Descriptor instead.
func (*ReadRel_VirtualTable) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 2}
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *ReadRel_VirtualTable) GetValues() []*Expression_Literal_Struct {
	if x != nil {
		return x.Values
	}
	return nil
}

func (x *ReadRel_VirtualTable) GetExpressions() []*Expression_Nested_Struct {
	if x != nil {
		return x.Expressions
	}
	return nil
}

// A stub type that can be used to extend/introduce new table types outside
// the specification.
type ReadRel_ExtensionTable struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Detail        *anypb.Any             `protobuf:"bytes,1,opt,name=detail,proto3" json:"detail,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_ExtensionTable) Reset() {
	*x = ReadRel_ExtensionTable{}
	mi := &file_substrait_algebra_proto_msgTypes[44]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_ExtensionTable) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_ExtensionTable) ProtoMessage() {}

func (x *ReadRel_ExtensionTable) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[44]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_ExtensionTable.ProtoReflect.Descriptor instead.
func (*ReadRel_ExtensionTable) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 3}
}

func (x *ReadRel_ExtensionTable) GetDetail() *anypb.Any {
	if x != nil {
		return x.Detail
	}
	return nil
}

// Represents a list of files in input of a scan operation
type ReadRel_LocalFiles struct {
	state             protoimpl.MessageState            `protogen:"open.v1"`
	Items             []*ReadRel_LocalFiles_FileOrFiles `protobuf:"bytes,1,rep,name=items,proto3" json:"items,omitempty"`
	AdvancedExtension *extensions.AdvancedExtension     `protobuf:"bytes,10,opt,name=advanced_extension,json=advancedExtension,proto3" json:"advanced_extension,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles) Reset() {
	*x = ReadRel_LocalFiles{}
	mi := &file_substrait_algebra_proto_msgTypes[45]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles) ProtoMessage() {}

func (x *ReadRel_LocalFiles) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[45]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4}
}

func (x *ReadRel_LocalFiles) GetItems() []*ReadRel_LocalFiles_FileOrFiles {
	if x != nil {
		return x.Items
	}
	return nil
}

func (x *ReadRel_LocalFiles) GetAdvancedExtension() *extensions.AdvancedExtension {
	if x != nil {
		return x.AdvancedExtension
	}
	return nil
}

// Read an Iceberg table using a metadata file. Implicit assumption: required credentials are already known by plan consumer.
type ReadRel_IcebergTable_MetadataFileRead struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// the specific uri of a metadata file (e.g. s3://mybucket/mytable/<ver>-<uuid>.metadata.json)
	MetadataUri string `protobuf:"bytes,1,opt,name=metadata_uri,json=metadataUri,proto3" json:"metadata_uri,omitempty"`
	// snapshot options. if none set, uses the current snapshot listed in the metadata file
	//
	// Types that are valid to be assigned to Snapshot:
	//
	//	*ReadRel_IcebergTable_MetadataFileRead_SnapshotId
	//	*ReadRel_IcebergTable_MetadataFileRead_SnapshotTimestamp
	Snapshot      isReadRel_IcebergTable_MetadataFileRead_Snapshot `protobuf_oneof:"snapshot"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_IcebergTable_MetadataFileRead) Reset() {
	*x = ReadRel_IcebergTable_MetadataFileRead{}
	mi := &file_substrait_algebra_proto_msgTypes[46]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_IcebergTable_MetadataFileRead) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_IcebergTable_MetadataFileRead) ProtoMessage() {}

func (x *ReadRel_IcebergTable_MetadataFileRead) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[46]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_IcebergTable_MetadataFileRead.ProtoReflect.Descriptor instead.
func (*ReadRel_IcebergTable_MetadataFileRead) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 1, 0}
}

func (x *ReadRel_IcebergTable_MetadataFileRead) GetMetadataUri() string {
	if x != nil {
		return x.MetadataUri
	}
	return ""
}

func (x *ReadRel_IcebergTable_MetadataFileRead) GetSnapshot() isReadRel_IcebergTable_MetadataFileRead_Snapshot {
	if x != nil {
		return x.Snapshot
	}
	return nil
}

func (x *ReadRel_IcebergTable_MetadataFileRead) GetSnapshotId() string {
	if x != nil {
		if x, ok := x.Snapshot.(*ReadRel_IcebergTable_MetadataFileRead_SnapshotId); ok {
			return x.SnapshotId
		}
	}
	return ""
}

func (x *ReadRel_IcebergTable_MetadataFileRead) GetSnapshotTimestamp() int64 {
	if x != nil {
		if x, ok := x.Snapshot.(*ReadRel_IcebergTable_MetadataFileRead_SnapshotTimestamp); ok {
			return x.SnapshotTimestamp
		}
	}
	return 0
}

type isReadRel_IcebergTable_MetadataFileRead_Snapshot interface {
	isReadRel_IcebergTable_MetadataFileRead_Snapshot()
}

type ReadRel_IcebergTable_MetadataFileRead_SnapshotId struct {
	// the snapshot id to read.
	SnapshotId string `protobuf:"bytes,2,opt,name=snapshot_id,json=snapshotId,proto3,oneof"`
}

type ReadRel_IcebergTable_MetadataFileRead_SnapshotTimestamp struct {
	// the timestamp that should be used to select the snapshot (Time passed in microseconds since 1970-01-01 00:00:00.000000 in UTC)
	SnapshotTimestamp int64 `protobuf:"varint,3,opt,name=snapshot_timestamp,json=snapshotTimestamp,proto3,oneof"`
}

func (*ReadRel_IcebergTable_MetadataFileRead_SnapshotId) isReadRel_IcebergTable_MetadataFileRead_Snapshot() {
}

func (*ReadRel_IcebergTable_MetadataFileRead_SnapshotTimestamp) isReadRel_IcebergTable_MetadataFileRead_Snapshot() {
}

// Many files consist of indivisible chunks (e.g. parquet row groups
// or CSV rows).  If a slice partially selects an indivisible chunk
// then the consumer should employ some rule to decide which slice to
// include the chunk in (e.g. include it in the slice that contains
// the midpoint of the chunk)
type ReadRel_LocalFiles_FileOrFiles struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to PathType:
	//
	//	*ReadRel_LocalFiles_FileOrFiles_UriPath
	//	*ReadRel_LocalFiles_FileOrFiles_UriPathGlob
	//	*ReadRel_LocalFiles_FileOrFiles_UriFile
	//	*ReadRel_LocalFiles_FileOrFiles_UriFolder
	PathType isReadRel_LocalFiles_FileOrFiles_PathType `protobuf_oneof:"path_type"`
	// The index of the partition this item belongs to
	PartitionIndex uint64 `protobuf:"varint,6,opt,name=partition_index,json=partitionIndex,proto3" json:"partition_index,omitempty"`
	// The start position in byte to read from this item
	Start uint64 `protobuf:"varint,7,opt,name=start,proto3" json:"start,omitempty"`
	// The length in byte to read from this item
	Length uint64 `protobuf:"varint,8,opt,name=length,proto3" json:"length,omitempty"`
	// The format of the files along with options for reading those files.
	//
	// Types that are valid to be assigned to FileFormat:
	//
	//	*ReadRel_LocalFiles_FileOrFiles_Parquet
	//	*ReadRel_LocalFiles_FileOrFiles_Arrow
	//	*ReadRel_LocalFiles_FileOrFiles_Orc
	//	*ReadRel_LocalFiles_FileOrFiles_Extension
	//	*ReadRel_LocalFiles_FileOrFiles_Dwrf
	//	*ReadRel_LocalFiles_FileOrFiles_Text
	FileFormat    isReadRel_LocalFiles_FileOrFiles_FileFormat `protobuf_oneof:"file_format"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles_FileOrFiles) Reset() {
	*x = ReadRel_LocalFiles_FileOrFiles{}
	mi := &file_substrait_algebra_proto_msgTypes[47]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles_FileOrFiles) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles_FileOrFiles) ProtoMessage() {}

func (x *ReadRel_LocalFiles_FileOrFiles) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[47]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles_FileOrFiles.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles_FileOrFiles) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4, 0}
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetPathType() isReadRel_LocalFiles_FileOrFiles_PathType {
	if x != nil {
		return x.PathType
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetUriPath() string {
	if x != nil {
		if x, ok := x.PathType.(*ReadRel_LocalFiles_FileOrFiles_UriPath); ok {
			return x.UriPath
		}
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetUriPathGlob() string {
	if x != nil {
		if x, ok := x.PathType.(*ReadRel_LocalFiles_FileOrFiles_UriPathGlob); ok {
			return x.UriPathGlob
		}
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetUriFile() string {
	if x != nil {
		if x, ok := x.PathType.(*ReadRel_LocalFiles_FileOrFiles_UriFile); ok {
			return x.UriFile
		}
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetUriFolder() string {
	if x != nil {
		if x, ok := x.PathType.(*ReadRel_LocalFiles_FileOrFiles_UriFolder); ok {
			return x.UriFolder
		}
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetPartitionIndex() uint64 {
	if x != nil {
		return x.PartitionIndex
	}
	return 0
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetStart() uint64 {
	if x != nil {
		return x.Start
	}
	return 0
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetLength() uint64 {
	if x != nil {
		return x.Length
	}
	return 0
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetFileFormat() isReadRel_LocalFiles_FileOrFiles_FileFormat {
	if x != nil {
		return x.FileFormat
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetParquet() *ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions {
	if x != nil {
		if x, ok := x.FileFormat.(*ReadRel_LocalFiles_FileOrFiles_Parquet); ok {
			return x.Parquet
		}
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetArrow() *ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions {
	if x != nil {
		if x, ok := x.FileFormat.(*ReadRel_LocalFiles_FileOrFiles_Arrow); ok {
			return x.Arrow
		}
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetOrc() *ReadRel_LocalFiles_FileOrFiles_OrcReadOptions {
	if x != nil {
		if x, ok := x.FileFormat.(*ReadRel_LocalFiles_FileOrFiles_Orc); ok {
			return x.Orc
		}
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetExtension() *anypb.Any {
	if x != nil {
		if x, ok := x.FileFormat.(*ReadRel_LocalFiles_FileOrFiles_Extension); ok {
			return x.Extension
		}
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetDwrf() *ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions {
	if x != nil {
		if x, ok := x.FileFormat.(*ReadRel_LocalFiles_FileOrFiles_Dwrf); ok {
			return x.Dwrf
		}
	}
	return nil
}

func (x *ReadRel_LocalFiles_FileOrFiles) GetText() *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions {
	if x != nil {
		if x, ok := x.FileFormat.(*ReadRel_LocalFiles_FileOrFiles_Text); ok {
			return x.Text
		}
	}
	return nil
}

type isReadRel_LocalFiles_FileOrFiles_PathType interface {
	isReadRel_LocalFiles_FileOrFiles_PathType()
}

type ReadRel_LocalFiles_FileOrFiles_UriPath struct {
	// A URI that can refer to either a single folder or a single file
	UriPath string `protobuf:"bytes,1,opt,name=uri_path,json=uriPath,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_UriPathGlob struct {
	// A URI where the path portion is a glob expression that can
	// identify zero or more paths.
	// Consumers should support the POSIX syntax.  The recursive
	// globstar (**) may not be supported.
	UriPathGlob string `protobuf:"bytes,2,opt,name=uri_path_glob,json=uriPathGlob,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_UriFile struct {
	// A URI that refers to a single file
	UriFile string `protobuf:"bytes,3,opt,name=uri_file,json=uriFile,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_UriFolder struct {
	// A URI that refers to a single folder
	UriFolder string `protobuf:"bytes,4,opt,name=uri_folder,json=uriFolder,proto3,oneof"`
}

func (*ReadRel_LocalFiles_FileOrFiles_UriPath) isReadRel_LocalFiles_FileOrFiles_PathType() {}

func (*ReadRel_LocalFiles_FileOrFiles_UriPathGlob) isReadRel_LocalFiles_FileOrFiles_PathType() {}

func (*ReadRel_LocalFiles_FileOrFiles_UriFile) isReadRel_LocalFiles_FileOrFiles_PathType() {}

func (*ReadRel_LocalFiles_FileOrFiles_UriFolder) isReadRel_LocalFiles_FileOrFiles_PathType() {}

type isReadRel_LocalFiles_FileOrFiles_FileFormat interface {
	isReadRel_LocalFiles_FileOrFiles_FileFormat()
}

type ReadRel_LocalFiles_FileOrFiles_Parquet struct {
	Parquet *ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions `protobuf:"bytes,9,opt,name=parquet,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_Arrow struct {
	Arrow *ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions `protobuf:"bytes,10,opt,name=arrow,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_Orc struct {
	Orc *ReadRel_LocalFiles_FileOrFiles_OrcReadOptions `protobuf:"bytes,11,opt,name=orc,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_Extension struct {
	Extension *anypb.Any `protobuf:"bytes,12,opt,name=extension,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_Dwrf struct {
	Dwrf *ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions `protobuf:"bytes,13,opt,name=dwrf,proto3,oneof"`
}

type ReadRel_LocalFiles_FileOrFiles_Text struct {
	Text *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions `protobuf:"bytes,14,opt,name=text,proto3,oneof"`
}

func (*ReadRel_LocalFiles_FileOrFiles_Parquet) isReadRel_LocalFiles_FileOrFiles_FileFormat() {}

func (*ReadRel_LocalFiles_FileOrFiles_Arrow) isReadRel_LocalFiles_FileOrFiles_FileFormat() {}

func (*ReadRel_LocalFiles_FileOrFiles_Orc) isReadRel_LocalFiles_FileOrFiles_FileFormat() {}

func (*ReadRel_LocalFiles_FileOrFiles_Extension) isReadRel_LocalFiles_FileOrFiles_FileFormat() {}

func (*ReadRel_LocalFiles_FileOrFiles_Dwrf) isReadRel_LocalFiles_FileOrFiles_FileFormat() {}

func (*ReadRel_LocalFiles_FileOrFiles_Text) isReadRel_LocalFiles_FileOrFiles_FileFormat() {}

type ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions) Reset() {
	*x = ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions{}
	mi := &file_substrait_algebra_proto_msgTypes[48]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions) ProtoMessage() {}

func (x *ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[48]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4, 0, 0}
}

type ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions) Reset() {
	*x = ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions{}
	mi := &file_substrait_algebra_proto_msgTypes[49]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions) ProtoMessage() {}

func (x *ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[49]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4, 0, 1}
}

type ReadRel_LocalFiles_FileOrFiles_OrcReadOptions struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles_FileOrFiles_OrcReadOptions) Reset() {
	*x = ReadRel_LocalFiles_FileOrFiles_OrcReadOptions{}
	mi := &file_substrait_algebra_proto_msgTypes[50]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles_FileOrFiles_OrcReadOptions) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles_FileOrFiles_OrcReadOptions) ProtoMessage() {}

func (x *ReadRel_LocalFiles_FileOrFiles_OrcReadOptions) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[50]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles_FileOrFiles_OrcReadOptions.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles_FileOrFiles_OrcReadOptions) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4, 0, 2}
}

type ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions) Reset() {
	*x = ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions{}
	mi := &file_substrait_algebra_proto_msgTypes[51]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions) ProtoMessage() {}

func (x *ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[51]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4, 0, 3}
}

type ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// The character(s) used to separate fields.  Common values are comma,
	// tab, and pipe.  Multiple characters are allowed.
	FieldDelimiter string `protobuf:"bytes,1,opt,name=field_delimiter,json=fieldDelimiter,proto3" json:"field_delimiter,omitempty"`
	// The maximum number of bytes to read from a single line.  If a line
	// exceeds this limit the resulting behavior is undefined.
	MaxLineSize uint64 `protobuf:"varint,2,opt,name=max_line_size,json=maxLineSize,proto3" json:"max_line_size,omitempty"`
	// The character(s) used to quote strings.  Common values are single
	// and double quotation marks.
	Quote string `protobuf:"bytes,3,opt,name=quote,proto3" json:"quote,omitempty"`
	// The number of lines to skip at the beginning of the file.
	HeaderLinesToSkip uint64 `protobuf:"varint,4,opt,name=header_lines_to_skip,json=headerLinesToSkip,proto3" json:"header_lines_to_skip,omitempty"`
	// The character used to escape characters in strings.  Backslash is
	// a common value.  Note that a double quote mark can also be used as an
	// escape character but the external quotes should be removed first.
	Escape string `protobuf:"bytes,5,opt,name=escape,proto3" json:"escape,omitempty"`
	// If this value is encountered (including empty string), the resulting
	// value is null instead.  Leave unset to disable.  If this value is
	// provided, the effective schema of this file is comprised entirely of
	// nullable strings.  If not provided, the effective schema is instead
	// made up of non-nullable strings.
	ValueTreatedAsNull *string `protobuf:"bytes,6,opt,name=value_treated_as_null,json=valueTreatedAsNull,proto3,oneof" json:"value_treated_as_null,omitempty"`
	unknownFields      protoimpl.UnknownFields
	sizeCache          protoimpl.SizeCache
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) Reset() {
	*x = ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions{}
	mi := &file_substrait_algebra_proto_msgTypes[52]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) ProtoMessage() {}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[52]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions.ProtoReflect.Descriptor instead.
func (*ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{1, 4, 0, 4}
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) GetFieldDelimiter() string {
	if x != nil {
		return x.FieldDelimiter
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) GetMaxLineSize() uint64 {
	if x != nil {
		return x.MaxLineSize
	}
	return 0
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) GetQuote() string {
	if x != nil {
		return x.Quote
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) GetHeaderLinesToSkip() uint64 {
	if x != nil {
		return x.HeaderLinesToSkip
	}
	return 0
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) GetEscape() string {
	if x != nil {
		return x.Escape
	}
	return ""
}

func (x *ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions) GetValueTreatedAsNull() string {
	if x != nil && x.ValueTreatedAsNull != nil {
		return *x.ValueTreatedAsNull
	}
	return ""
}

type AggregateRel_Grouping struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Deprecated in favor of `expression_references` below.
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	GroupingExpressions []*Expression `protobuf:"bytes,1,rep,name=grouping_expressions,json=groupingExpressions,proto3" json:"grouping_expressions,omitempty"`
	// A list of zero or more references to grouping expressions, i.e., indices
	// into the `grouping_expression` list.
	ExpressionReferences []uint32 `protobuf:"varint,2,rep,packed,name=expression_references,json=expressionReferences,proto3" json:"expression_references,omitempty"`
	unknownFields        protoimpl.UnknownFields
	sizeCache            protoimpl.SizeCache
}

func (x *AggregateRel_Grouping) Reset() {
	*x = AggregateRel_Grouping{}
	mi := &file_substrait_algebra_proto_msgTypes[53]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *AggregateRel_Grouping) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*AggregateRel_Grouping) ProtoMessage() {}

func (x *AggregateRel_Grouping) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[53]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use AggregateRel_Grouping.ProtoReflect.Descriptor instead.
func (*AggregateRel_Grouping) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{6, 0}
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *AggregateRel_Grouping) GetGroupingExpressions() []*Expression {
	if x != nil {
		return x.GroupingExpressions
	}
	return nil
}

func (x *AggregateRel_Grouping) GetExpressionReferences() []uint32 {
	if x != nil {
		return x.ExpressionReferences
	}
	return nil
}

type AggregateRel_Measure struct {
	state   protoimpl.MessageState `protogen:"open.v1"`
	Measure *AggregateFunction     `protobuf:"bytes,1,opt,name=measure,proto3" json:"measure,omitempty"`
	// An optional boolean expression that acts to filter which records are
	// included in the measure. True means include this record for calculation
	// within the measure.
	// Helps to support SUM(<c>) FILTER(WHERE...) syntax without masking opportunities for optimization
	Filter        *Expression `protobuf:"bytes,2,opt,name=filter,proto3" json:"filter,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *AggregateRel_Measure) Reset() {
	*x = AggregateRel_Measure{}
	mi := &file_substrait_algebra_proto_msgTypes[54]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *AggregateRel_Measure) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*AggregateRel_Measure) ProtoMessage() {}

func (x *AggregateRel_Measure) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[54]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use AggregateRel_Measure.ProtoReflect.Descriptor instead.
func (*AggregateRel_Measure) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{6, 1}
}

func (x *AggregateRel_Measure) GetMeasure() *AggregateFunction {
	if x != nil {
		return x.Measure
	}
	return nil
}

func (x *AggregateRel_Measure) GetFilter() *Expression {
	if x != nil {
		return x.Filter
	}
	return nil
}

// This message mirrors the `WindowFunction` message but removes the fields defining the partition,
// sorts, and bounds, since those must be consistent across the various functions in this rel.  Refer
// to the `WindowFunction` message for a description of these fields.
type ConsistentPartitionWindowRel_WindowRelFunction struct {
	state             protoimpl.MessageState                  `protogen:"open.v1"`
	FunctionReference uint32                                  `protobuf:"varint,1,opt,name=function_reference,json=functionReference,proto3" json:"function_reference,omitempty"`
	Arguments         []*FunctionArgument                     `protobuf:"bytes,9,rep,name=arguments,proto3" json:"arguments,omitempty"`
	Options           []*FunctionOption                       `protobuf:"bytes,11,rep,name=options,proto3" json:"options,omitempty"`
	OutputType        *Type                                   `protobuf:"bytes,7,opt,name=output_type,json=outputType,proto3" json:"output_type,omitempty"`
	Phase             AggregationPhase                        `protobuf:"varint,6,opt,name=phase,proto3,enum=substrait.AggregationPhase" json:"phase,omitempty"`
	Invocation        AggregateFunction_AggregationInvocation `protobuf:"varint,10,opt,name=invocation,proto3,enum=substrait.AggregateFunction_AggregationInvocation" json:"invocation,omitempty"`
	LowerBound        *Expression_WindowFunction_Bound        `protobuf:"bytes,5,opt,name=lower_bound,json=lowerBound,proto3" json:"lower_bound,omitempty"`
	UpperBound        *Expression_WindowFunction_Bound        `protobuf:"bytes,4,opt,name=upper_bound,json=upperBound,proto3" json:"upper_bound,omitempty"`
	BoundsType        Expression_WindowFunction_BoundsType    `protobuf:"varint,12,opt,name=bounds_type,json=boundsType,proto3,enum=substrait.Expression_WindowFunction_BoundsType" json:"bounds_type,omitempty"`
	unknownFields     protoimpl.UnknownFields
	sizeCache         protoimpl.SizeCache
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) Reset() {
	*x = ConsistentPartitionWindowRel_WindowRelFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[55]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ConsistentPartitionWindowRel_WindowRelFunction) ProtoMessage() {}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[55]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ConsistentPartitionWindowRel_WindowRelFunction.ProtoReflect.Descriptor instead.
func (*ConsistentPartitionWindowRel_WindowRelFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{7, 0}
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetFunctionReference() uint32 {
	if x != nil {
		return x.FunctionReference
	}
	return 0
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetArguments() []*FunctionArgument {
	if x != nil {
		return x.Arguments
	}
	return nil
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetOptions() []*FunctionOption {
	if x != nil {
		return x.Options
	}
	return nil
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetOutputType() *Type {
	if x != nil {
		return x.OutputType
	}
	return nil
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetPhase() AggregationPhase {
	if x != nil {
		return x.Phase
	}
	return AggregationPhase_AGGREGATION_PHASE_UNSPECIFIED
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetInvocation() AggregateFunction_AggregationInvocation {
	if x != nil {
		return x.Invocation
	}
	return AggregateFunction_AGGREGATION_INVOCATION_UNSPECIFIED
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetLowerBound() *Expression_WindowFunction_Bound {
	if x != nil {
		return x.LowerBound
	}
	return nil
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetUpperBound() *Expression_WindowFunction_Bound {
	if x != nil {
		return x.UpperBound
	}
	return nil
}

func (x *ConsistentPartitionWindowRel_WindowRelFunction) GetBoundsType() Expression_WindowFunction_BoundsType {
	if x != nil {
		return x.BoundsType
	}
	return Expression_WindowFunction_BOUNDS_TYPE_UNSPECIFIED
}

type ExchangeRel_ScatterFields struct {
	state         protoimpl.MessageState       `protogen:"open.v1"`
	Fields        []*Expression_FieldReference `protobuf:"bytes,1,rep,name=fields,proto3" json:"fields,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExchangeRel_ScatterFields) Reset() {
	*x = ExchangeRel_ScatterFields{}
	mi := &file_substrait_algebra_proto_msgTypes[56]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel_ScatterFields) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel_ScatterFields) ProtoMessage() {}

func (x *ExchangeRel_ScatterFields) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[56]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel_ScatterFields.ProtoReflect.Descriptor instead.
func (*ExchangeRel_ScatterFields) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14, 0}
}

func (x *ExchangeRel_ScatterFields) GetFields() []*Expression_FieldReference {
	if x != nil {
		return x.Fields
	}
	return nil
}

// Returns a single bucket number per record.
type ExchangeRel_SingleBucketExpression struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Expression    *Expression            `protobuf:"bytes,1,opt,name=expression,proto3" json:"expression,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExchangeRel_SingleBucketExpression) Reset() {
	*x = ExchangeRel_SingleBucketExpression{}
	mi := &file_substrait_algebra_proto_msgTypes[57]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel_SingleBucketExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel_SingleBucketExpression) ProtoMessage() {}

func (x *ExchangeRel_SingleBucketExpression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[57]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel_SingleBucketExpression.ProtoReflect.Descriptor instead.
func (*ExchangeRel_SingleBucketExpression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14, 1}
}

func (x *ExchangeRel_SingleBucketExpression) GetExpression() *Expression {
	if x != nil {
		return x.Expression
	}
	return nil
}

// Returns zero or more bucket numbers per record
type ExchangeRel_MultiBucketExpression struct {
	state              protoimpl.MessageState `protogen:"open.v1"`
	Expression         *Expression            `protobuf:"bytes,1,opt,name=expression,proto3" json:"expression,omitempty"`
	ConstrainedToCount bool                   `protobuf:"varint,2,opt,name=constrained_to_count,json=constrainedToCount,proto3" json:"constrained_to_count,omitempty"`
	unknownFields      protoimpl.UnknownFields
	sizeCache          protoimpl.SizeCache
}

func (x *ExchangeRel_MultiBucketExpression) Reset() {
	*x = ExchangeRel_MultiBucketExpression{}
	mi := &file_substrait_algebra_proto_msgTypes[58]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel_MultiBucketExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel_MultiBucketExpression) ProtoMessage() {}

func (x *ExchangeRel_MultiBucketExpression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[58]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel_MultiBucketExpression.ProtoReflect.Descriptor instead.
func (*ExchangeRel_MultiBucketExpression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14, 2}
}

func (x *ExchangeRel_MultiBucketExpression) GetExpression() *Expression {
	if x != nil {
		return x.Expression
	}
	return nil
}

func (x *ExchangeRel_MultiBucketExpression) GetConstrainedToCount() bool {
	if x != nil {
		return x.ConstrainedToCount
	}
	return false
}

// Send all data to every target.
type ExchangeRel_Broadcast struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExchangeRel_Broadcast) Reset() {
	*x = ExchangeRel_Broadcast{}
	mi := &file_substrait_algebra_proto_msgTypes[59]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel_Broadcast) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel_Broadcast) ProtoMessage() {}

func (x *ExchangeRel_Broadcast) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[59]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel_Broadcast.ProtoReflect.Descriptor instead.
func (*ExchangeRel_Broadcast) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14, 3}
}

// Route approximately
type ExchangeRel_RoundRobin struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// whether the round robin behavior is required to exact (per record) or
	// approximate. Defaults to approximate.
	Exact         bool `protobuf:"varint,1,opt,name=exact,proto3" json:"exact,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExchangeRel_RoundRobin) Reset() {
	*x = ExchangeRel_RoundRobin{}
	mi := &file_substrait_algebra_proto_msgTypes[60]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel_RoundRobin) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel_RoundRobin) ProtoMessage() {}

func (x *ExchangeRel_RoundRobin) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[60]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel_RoundRobin.ProtoReflect.Descriptor instead.
func (*ExchangeRel_RoundRobin) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14, 4}
}

func (x *ExchangeRel_RoundRobin) GetExact() bool {
	if x != nil {
		return x.Exact
	}
	return false
}

// The message to describe partition targets of an exchange
type ExchangeRel_ExchangeTarget struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Describes the partition id(s) to send. If this is empty, all data is sent
	// to this target.
	PartitionId []int32 `protobuf:"varint,1,rep,packed,name=partition_id,json=partitionId,proto3" json:"partition_id,omitempty"`
	// Types that are valid to be assigned to TargetType:
	//
	//	*ExchangeRel_ExchangeTarget_Uri
	//	*ExchangeRel_ExchangeTarget_Extended
	TargetType    isExchangeRel_ExchangeTarget_TargetType `protobuf_oneof:"target_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExchangeRel_ExchangeTarget) Reset() {
	*x = ExchangeRel_ExchangeTarget{}
	mi := &file_substrait_algebra_proto_msgTypes[61]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExchangeRel_ExchangeTarget) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExchangeRel_ExchangeTarget) ProtoMessage() {}

func (x *ExchangeRel_ExchangeTarget) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[61]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExchangeRel_ExchangeTarget.ProtoReflect.Descriptor instead.
func (*ExchangeRel_ExchangeTarget) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{14, 5}
}

func (x *ExchangeRel_ExchangeTarget) GetPartitionId() []int32 {
	if x != nil {
		return x.PartitionId
	}
	return nil
}

func (x *ExchangeRel_ExchangeTarget) GetTargetType() isExchangeRel_ExchangeTarget_TargetType {
	if x != nil {
		return x.TargetType
	}
	return nil
}

func (x *ExchangeRel_ExchangeTarget) GetUri() string {
	if x != nil {
		if x, ok := x.TargetType.(*ExchangeRel_ExchangeTarget_Uri); ok {
			return x.Uri
		}
	}
	return ""
}

func (x *ExchangeRel_ExchangeTarget) GetExtended() *anypb.Any {
	if x != nil {
		if x, ok := x.TargetType.(*ExchangeRel_ExchangeTarget_Extended); ok {
			return x.Extended
		}
	}
	return nil
}

type isExchangeRel_ExchangeTarget_TargetType interface {
	isExchangeRel_ExchangeTarget_TargetType()
}

type ExchangeRel_ExchangeTarget_Uri struct {
	Uri string `protobuf:"bytes,2,opt,name=uri,proto3,oneof"`
}

type ExchangeRel_ExchangeTarget_Extended struct {
	Extended *anypb.Any `protobuf:"bytes,3,opt,name=extended,proto3,oneof"`
}

func (*ExchangeRel_ExchangeTarget_Uri) isExchangeRel_ExchangeTarget_TargetType() {}

func (*ExchangeRel_ExchangeTarget_Extended) isExchangeRel_ExchangeTarget_TargetType() {}

type ExpandRel_ExpandField struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to FieldType:
	//
	//	*ExpandRel_ExpandField_SwitchingField
	//	*ExpandRel_ExpandField_ConsistentField
	FieldType     isExpandRel_ExpandField_FieldType `protobuf_oneof:"field_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExpandRel_ExpandField) Reset() {
	*x = ExpandRel_ExpandField{}
	mi := &file_substrait_algebra_proto_msgTypes[62]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExpandRel_ExpandField) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExpandRel_ExpandField) ProtoMessage() {}

func (x *ExpandRel_ExpandField) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[62]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExpandRel_ExpandField.ProtoReflect.Descriptor instead.
func (*ExpandRel_ExpandField) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{15, 0}
}

func (x *ExpandRel_ExpandField) GetFieldType() isExpandRel_ExpandField_FieldType {
	if x != nil {
		return x.FieldType
	}
	return nil
}

func (x *ExpandRel_ExpandField) GetSwitchingField() *ExpandRel_SwitchingField {
	if x != nil {
		if x, ok := x.FieldType.(*ExpandRel_ExpandField_SwitchingField); ok {
			return x.SwitchingField
		}
	}
	return nil
}

func (x *ExpandRel_ExpandField) GetConsistentField() *Expression {
	if x != nil {
		if x, ok := x.FieldType.(*ExpandRel_ExpandField_ConsistentField); ok {
			return x.ConsistentField
		}
	}
	return nil
}

type isExpandRel_ExpandField_FieldType interface {
	isExpandRel_ExpandField_FieldType()
}

type ExpandRel_ExpandField_SwitchingField struct {
	// Field that switches output based on which duplicate is being output.  Every
	// switching_field should contain the same number of duplicates (so that the output rows
	// are of consistent size and type).  If there are not enough switching field definitions
	// to match the other field definitions NULL will be returned to fill the extras.
	SwitchingField *ExpandRel_SwitchingField `protobuf:"bytes,2,opt,name=switching_field,json=switchingField,proto3,oneof"`
}

type ExpandRel_ExpandField_ConsistentField struct {
	// Field that outputs the same value no matter which duplicate is being output.  Equivalent
	// to a switching_field that lists the same expression multiple times.
	ConsistentField *Expression `protobuf:"bytes,3,opt,name=consistent_field,json=consistentField,proto3,oneof"`
}

func (*ExpandRel_ExpandField_SwitchingField) isExpandRel_ExpandField_FieldType() {}

func (*ExpandRel_ExpandField_ConsistentField) isExpandRel_ExpandField_FieldType() {}

type ExpandRel_SwitchingField struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// All duplicates must return the same type class but may differ in nullability.  The effective
	// type of the output field will be nullable if any of the duplicate expressions are nullable.
	Duplicates    []*Expression `protobuf:"bytes,1,rep,name=duplicates,proto3" json:"duplicates,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ExpandRel_SwitchingField) Reset() {
	*x = ExpandRel_SwitchingField{}
	mi := &file_substrait_algebra_proto_msgTypes[63]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ExpandRel_SwitchingField) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ExpandRel_SwitchingField) ProtoMessage() {}

func (x *ExpandRel_SwitchingField) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[63]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ExpandRel_SwitchingField.ProtoReflect.Descriptor instead.
func (*ExpandRel_SwitchingField) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{15, 1}
}

func (x *ExpandRel_SwitchingField) GetDuplicates() []*Expression {
	if x != nil {
		return x.Duplicates
	}
	return nil
}

type UpdateRel_TransformExpression struct {
	state          protoimpl.MessageState `protogen:"open.v1"`
	Transformation *Expression            `protobuf:"bytes,1,opt,name=transformation,proto3" json:"transformation,omitempty"`                  // the transformation to apply
	ColumnTarget   int32                  `protobuf:"varint,2,opt,name=column_target,json=columnTarget,proto3" json:"column_target,omitempty"` // index of the column to apply the transformation to
	unknownFields  protoimpl.UnknownFields
	sizeCache      protoimpl.SizeCache
}

func (x *UpdateRel_TransformExpression) Reset() {
	*x = UpdateRel_TransformExpression{}
	mi := &file_substrait_algebra_proto_msgTypes[64]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *UpdateRel_TransformExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*UpdateRel_TransformExpression) ProtoMessage() {}

func (x *UpdateRel_TransformExpression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[64]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use UpdateRel_TransformExpression.ProtoReflect.Descriptor instead.
func (*UpdateRel_TransformExpression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{22, 0}
}

func (x *UpdateRel_TransformExpression) GetTransformation() *Expression {
	if x != nil {
		return x.Transformation
	}
	return nil
}

func (x *UpdateRel_TransformExpression) GetColumnTarget() int32 {
	if x != nil {
		return x.ColumnTarget
	}
	return 0
}

// Describes how the relation should consider if two rows are a match
type ComparisonJoinKey_ComparisonType struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to InnerType:
	//
	//	*ComparisonJoinKey_ComparisonType_Simple
	//	*ComparisonJoinKey_ComparisonType_CustomFunctionReference
	InnerType     isComparisonJoinKey_ComparisonType_InnerType `protobuf_oneof:"inner_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *ComparisonJoinKey_ComparisonType) Reset() {
	*x = ComparisonJoinKey_ComparisonType{}
	mi := &file_substrait_algebra_proto_msgTypes[65]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *ComparisonJoinKey_ComparisonType) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ComparisonJoinKey_ComparisonType) ProtoMessage() {}

func (x *ComparisonJoinKey_ComparisonType) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[65]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ComparisonJoinKey_ComparisonType.ProtoReflect.Descriptor instead.
func (*ComparisonJoinKey_ComparisonType) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{24, 0}
}

func (x *ComparisonJoinKey_ComparisonType) GetInnerType() isComparisonJoinKey_ComparisonType_InnerType {
	if x != nil {
		return x.InnerType
	}
	return nil
}

func (x *ComparisonJoinKey_ComparisonType) GetSimple() ComparisonJoinKey_SimpleComparisonType {
	if x != nil {
		if x, ok := x.InnerType.(*ComparisonJoinKey_ComparisonType_Simple); ok {
			return x.Simple
		}
	}
	return ComparisonJoinKey_SIMPLE_COMPARISON_TYPE_UNSPECIFIED
}

func (x *ComparisonJoinKey_ComparisonType) GetCustomFunctionReference() uint32 {
	if x != nil {
		if x, ok := x.InnerType.(*ComparisonJoinKey_ComparisonType_CustomFunctionReference); ok {
			return x.CustomFunctionReference
		}
	}
	return 0
}

type isComparisonJoinKey_ComparisonType_InnerType interface {
	isComparisonJoinKey_ComparisonType_InnerType()
}

type ComparisonJoinKey_ComparisonType_Simple struct {
	// One of the simple comparison behaviors is used
	Simple ComparisonJoinKey_SimpleComparisonType `protobuf:"varint,1,opt,name=simple,proto3,enum=substrait.ComparisonJoinKey_SimpleComparisonType,oneof"`
}

type ComparisonJoinKey_ComparisonType_CustomFunctionReference struct {
	// A custom comparison behavior is used.  This can happen, for example, when using
	// collations, where we might want to do something like a case-insensitive comparison.
	//
	// This must be a binary function with a boolean return type
	CustomFunctionReference uint32 `protobuf:"varint,2,opt,name=custom_function_reference,json=customFunctionReference,proto3,oneof"`
}

func (*ComparisonJoinKey_ComparisonType_Simple) isComparisonJoinKey_ComparisonType_InnerType() {}

func (*ComparisonJoinKey_ComparisonType_CustomFunctionReference) isComparisonJoinKey_ComparisonType_InnerType() {
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
type Expression_Enum struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to EnumKind:
	//
	//	*Expression_Enum_Specified
	//	*Expression_Enum_Unspecified
	EnumKind      isExpression_Enum_EnumKind `protobuf_oneof:"enum_kind"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Enum) Reset() {
	*x = Expression_Enum{}
	mi := &file_substrait_algebra_proto_msgTypes[66]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Enum) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Enum) ProtoMessage() {}

func (x *Expression_Enum) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[66]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Enum.ProtoReflect.Descriptor instead.
func (*Expression_Enum) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 0}
}

func (x *Expression_Enum) GetEnumKind() isExpression_Enum_EnumKind {
	if x != nil {
		return x.EnumKind
	}
	return nil
}

func (x *Expression_Enum) GetSpecified() string {
	if x != nil {
		if x, ok := x.EnumKind.(*Expression_Enum_Specified); ok {
			return x.Specified
		}
	}
	return ""
}

func (x *Expression_Enum) GetUnspecified() *Expression_Enum_Empty {
	if x != nil {
		if x, ok := x.EnumKind.(*Expression_Enum_Unspecified); ok {
			return x.Unspecified
		}
	}
	return nil
}

type isExpression_Enum_EnumKind interface {
	isExpression_Enum_EnumKind()
}

type Expression_Enum_Specified struct {
	Specified string `protobuf:"bytes,1,opt,name=specified,proto3,oneof"`
}

type Expression_Enum_Unspecified struct {
	Unspecified *Expression_Enum_Empty `protobuf:"bytes,2,opt,name=unspecified,proto3,oneof"`
}

func (*Expression_Enum_Specified) isExpression_Enum_EnumKind() {}

func (*Expression_Enum_Unspecified) isExpression_Enum_EnumKind() {}

type Expression_Literal struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to LiteralType:
	//
	//	*Expression_Literal_Boolean
	//	*Expression_Literal_I8
	//	*Expression_Literal_I16
	//	*Expression_Literal_I32
	//	*Expression_Literal_I64
	//	*Expression_Literal_Fp32
	//	*Expression_Literal_Fp64
	//	*Expression_Literal_String_
	//	*Expression_Literal_Binary
	//	*Expression_Literal_Timestamp
	//	*Expression_Literal_Date
	//	*Expression_Literal_Time
	//	*Expression_Literal_IntervalYearToMonth_
	//	*Expression_Literal_IntervalDayToSecond_
	//	*Expression_Literal_IntervalCompound_
	//	*Expression_Literal_FixedChar
	//	*Expression_Literal_VarChar_
	//	*Expression_Literal_FixedBinary
	//	*Expression_Literal_Decimal_
	//	*Expression_Literal_PrecisionTimestamp_
	//	*Expression_Literal_PrecisionTimestampTz
	//	*Expression_Literal_Struct_
	//	*Expression_Literal_Map_
	//	*Expression_Literal_TimestampTz
	//	*Expression_Literal_Uuid
	//	*Expression_Literal_Null
	//	*Expression_Literal_List_
	//	*Expression_Literal_EmptyList
	//	*Expression_Literal_EmptyMap
	//	*Expression_Literal_UserDefined_
	LiteralType isExpression_Literal_LiteralType `protobuf_oneof:"literal_type"`
	// Whether the literal_type above should be treated as a nullable type.
	// Applies to all members of the literal_type oneof EXCEPT:
	//   - Type null             (must be nullable by definition)
	//   - Type.List empty_list  (use Type.List::nullability)
	//   - Type.Map empty_map    (use Type.Map::nullability)
	Nullable bool `protobuf:"varint,50,opt,name=nullable,proto3" json:"nullable,omitempty"`
	// optionally points to a type_variation_anchor defined in this plan.
	// Applies to all members of union other than the Typed null (which should
	// directly declare the type variation).
	TypeVariationReference uint32 `protobuf:"varint,51,opt,name=type_variation_reference,json=typeVariationReference,proto3" json:"type_variation_reference,omitempty"`
	unknownFields          protoimpl.UnknownFields
	sizeCache              protoimpl.SizeCache
}

func (x *Expression_Literal) Reset() {
	*x = Expression_Literal{}
	mi := &file_substrait_algebra_proto_msgTypes[67]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal) ProtoMessage() {}

func (x *Expression_Literal) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[67]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal.ProtoReflect.Descriptor instead.
func (*Expression_Literal) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1}
}

func (x *Expression_Literal) GetLiteralType() isExpression_Literal_LiteralType {
	if x != nil {
		return x.LiteralType
	}
	return nil
}

func (x *Expression_Literal) GetBoolean() bool {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Boolean); ok {
			return x.Boolean
		}
	}
	return false
}

func (x *Expression_Literal) GetI8() int32 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_I8); ok {
			return x.I8
		}
	}
	return 0
}

func (x *Expression_Literal) GetI16() int32 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_I16); ok {
			return x.I16
		}
	}
	return 0
}

func (x *Expression_Literal) GetI32() int32 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_I32); ok {
			return x.I32
		}
	}
	return 0
}

func (x *Expression_Literal) GetI64() int64 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_I64); ok {
			return x.I64
		}
	}
	return 0
}

func (x *Expression_Literal) GetFp32() float32 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Fp32); ok {
			return x.Fp32
		}
	}
	return 0
}

func (x *Expression_Literal) GetFp64() float64 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Fp64); ok {
			return x.Fp64
		}
	}
	return 0
}

func (x *Expression_Literal) GetString_() string {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_String_); ok {
			return x.String_
		}
	}
	return ""
}

func (x *Expression_Literal) GetBinary() []byte {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Binary); ok {
			return x.Binary
		}
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *Expression_Literal) GetTimestamp() int64 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Timestamp); ok {
			return x.Timestamp
		}
	}
	return 0
}

func (x *Expression_Literal) GetDate() int32 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Date); ok {
			return x.Date
		}
	}
	return 0
}

func (x *Expression_Literal) GetTime() int64 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Time); ok {
			return x.Time
		}
	}
	return 0
}

func (x *Expression_Literal) GetIntervalYearToMonth() *Expression_Literal_IntervalYearToMonth {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_IntervalYearToMonth_); ok {
			return x.IntervalYearToMonth
		}
	}
	return nil
}

func (x *Expression_Literal) GetIntervalDayToSecond() *Expression_Literal_IntervalDayToSecond {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_IntervalDayToSecond_); ok {
			return x.IntervalDayToSecond
		}
	}
	return nil
}

func (x *Expression_Literal) GetIntervalCompound() *Expression_Literal_IntervalCompound {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_IntervalCompound_); ok {
			return x.IntervalCompound
		}
	}
	return nil
}

func (x *Expression_Literal) GetFixedChar() string {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_FixedChar); ok {
			return x.FixedChar
		}
	}
	return ""
}

func (x *Expression_Literal) GetVarChar() *Expression_Literal_VarChar {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_VarChar_); ok {
			return x.VarChar
		}
	}
	return nil
}

func (x *Expression_Literal) GetFixedBinary() []byte {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_FixedBinary); ok {
			return x.FixedBinary
		}
	}
	return nil
}

func (x *Expression_Literal) GetDecimal() *Expression_Literal_Decimal {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Decimal_); ok {
			return x.Decimal
		}
	}
	return nil
}

func (x *Expression_Literal) GetPrecisionTimestamp() *Expression_Literal_PrecisionTimestamp {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_PrecisionTimestamp_); ok {
			return x.PrecisionTimestamp
		}
	}
	return nil
}

func (x *Expression_Literal) GetPrecisionTimestampTz() *Expression_Literal_PrecisionTimestamp {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_PrecisionTimestampTz); ok {
			return x.PrecisionTimestampTz
		}
	}
	return nil
}

func (x *Expression_Literal) GetStruct() *Expression_Literal_Struct {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Struct_); ok {
			return x.Struct
		}
	}
	return nil
}

func (x *Expression_Literal) GetMap() *Expression_Literal_Map {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Map_); ok {
			return x.Map
		}
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *Expression_Literal) GetTimestampTz() int64 {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_TimestampTz); ok {
			return x.TimestampTz
		}
	}
	return 0
}

func (x *Expression_Literal) GetUuid() []byte {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Uuid); ok {
			return x.Uuid
		}
	}
	return nil
}

func (x *Expression_Literal) GetNull() *Type {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_Null); ok {
			return x.Null
		}
	}
	return nil
}

func (x *Expression_Literal) GetList() *Expression_Literal_List {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_List_); ok {
			return x.List
		}
	}
	return nil
}

func (x *Expression_Literal) GetEmptyList() *Type_List {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_EmptyList); ok {
			return x.EmptyList
		}
	}
	return nil
}

func (x *Expression_Literal) GetEmptyMap() *Type_Map {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_EmptyMap); ok {
			return x.EmptyMap
		}
	}
	return nil
}

func (x *Expression_Literal) GetUserDefined() *Expression_Literal_UserDefined {
	if x != nil {
		if x, ok := x.LiteralType.(*Expression_Literal_UserDefined_); ok {
			return x.UserDefined
		}
	}
	return nil
}

func (x *Expression_Literal) GetNullable() bool {
	if x != nil {
		return x.Nullable
	}
	return false
}

func (x *Expression_Literal) GetTypeVariationReference() uint32 {
	if x != nil {
		return x.TypeVariationReference
	}
	return 0
}

type isExpression_Literal_LiteralType interface {
	isExpression_Literal_LiteralType()
}

type Expression_Literal_Boolean struct {
	Boolean bool `protobuf:"varint,1,opt,name=boolean,proto3,oneof"`
}

type Expression_Literal_I8 struct {
	I8 int32 `protobuf:"varint,2,opt,name=i8,proto3,oneof"`
}

type Expression_Literal_I16 struct {
	I16 int32 `protobuf:"varint,3,opt,name=i16,proto3,oneof"`
}

type Expression_Literal_I32 struct {
	I32 int32 `protobuf:"varint,5,opt,name=i32,proto3,oneof"`
}

type Expression_Literal_I64 struct {
	I64 int64 `protobuf:"varint,7,opt,name=i64,proto3,oneof"`
}

type Expression_Literal_Fp32 struct {
	Fp32 float32 `protobuf:"fixed32,10,opt,name=fp32,proto3,oneof"`
}

type Expression_Literal_Fp64 struct {
	Fp64 float64 `protobuf:"fixed64,11,opt,name=fp64,proto3,oneof"`
}

type Expression_Literal_String_ struct {
	String_ string `protobuf:"bytes,12,opt,name=string,proto3,oneof"`
}

type Expression_Literal_Binary struct {
	Binary []byte `protobuf:"bytes,13,opt,name=binary,proto3,oneof"`
}

type Expression_Literal_Timestamp struct {
	// Timestamp in units of microseconds since the UNIX epoch.
	// Deprecated in favor of `precision_timestamp`
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Timestamp int64 `protobuf:"varint,14,opt,name=timestamp,proto3,oneof"`
}

type Expression_Literal_Date struct {
	// Date in units of days since the UNIX epoch.
	Date int32 `protobuf:"varint,16,opt,name=date,proto3,oneof"`
}

type Expression_Literal_Time struct {
	// Time in units of microseconds past midnight
	Time int64 `protobuf:"varint,17,opt,name=time,proto3,oneof"`
}

type Expression_Literal_IntervalYearToMonth_ struct {
	IntervalYearToMonth *Expression_Literal_IntervalYearToMonth `protobuf:"bytes,19,opt,name=interval_year_to_month,json=intervalYearToMonth,proto3,oneof"`
}

type Expression_Literal_IntervalDayToSecond_ struct {
	IntervalDayToSecond *Expression_Literal_IntervalDayToSecond `protobuf:"bytes,20,opt,name=interval_day_to_second,json=intervalDayToSecond,proto3,oneof"`
}

type Expression_Literal_IntervalCompound_ struct {
	IntervalCompound *Expression_Literal_IntervalCompound `protobuf:"bytes,36,opt,name=interval_compound,json=intervalCompound,proto3,oneof"`
}

type Expression_Literal_FixedChar struct {
	FixedChar string `protobuf:"bytes,21,opt,name=fixed_char,json=fixedChar,proto3,oneof"`
}

type Expression_Literal_VarChar_ struct {
	VarChar *Expression_Literal_VarChar `protobuf:"bytes,22,opt,name=var_char,json=varChar,proto3,oneof"`
}

type Expression_Literal_FixedBinary struct {
	FixedBinary []byte `protobuf:"bytes,23,opt,name=fixed_binary,json=fixedBinary,proto3,oneof"`
}

type Expression_Literal_Decimal_ struct {
	Decimal *Expression_Literal_Decimal `protobuf:"bytes,24,opt,name=decimal,proto3,oneof"`
}

type Expression_Literal_PrecisionTimestamp_ struct {
	PrecisionTimestamp *Expression_Literal_PrecisionTimestamp `protobuf:"bytes,34,opt,name=precision_timestamp,json=precisionTimestamp,proto3,oneof"`
}

type Expression_Literal_PrecisionTimestampTz struct {
	PrecisionTimestampTz *Expression_Literal_PrecisionTimestamp `protobuf:"bytes,35,opt,name=precision_timestamp_tz,json=precisionTimestampTz,proto3,oneof"`
}

type Expression_Literal_Struct_ struct {
	Struct *Expression_Literal_Struct `protobuf:"bytes,25,opt,name=struct,proto3,oneof"`
}

type Expression_Literal_Map_ struct {
	Map *Expression_Literal_Map `protobuf:"bytes,26,opt,name=map,proto3,oneof"`
}

type Expression_Literal_TimestampTz struct {
	// Timestamp in units of microseconds since the UNIX epoch.
	// Deprecated in favor of `precision_timestamp_tz`
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	TimestampTz int64 `protobuf:"varint,27,opt,name=timestamp_tz,json=timestampTz,proto3,oneof"`
}

type Expression_Literal_Uuid struct {
	Uuid []byte `protobuf:"bytes,28,opt,name=uuid,proto3,oneof"`
}

type Expression_Literal_Null struct {
	Null *Type `protobuf:"bytes,29,opt,name=null,proto3,oneof"` // a typed null literal
}

type Expression_Literal_List_ struct {
	List *Expression_Literal_List `protobuf:"bytes,30,opt,name=list,proto3,oneof"`
}

type Expression_Literal_EmptyList struct {
	EmptyList *Type_List `protobuf:"bytes,31,opt,name=empty_list,json=emptyList,proto3,oneof"`
}

type Expression_Literal_EmptyMap struct {
	EmptyMap *Type_Map `protobuf:"bytes,32,opt,name=empty_map,json=emptyMap,proto3,oneof"`
}

type Expression_Literal_UserDefined_ struct {
	UserDefined *Expression_Literal_UserDefined `protobuf:"bytes,33,opt,name=user_defined,json=userDefined,proto3,oneof"`
}

func (*Expression_Literal_Boolean) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_I8) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_I16) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_I32) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_I64) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Fp32) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Fp64) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_String_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Binary) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Timestamp) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Date) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Time) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_IntervalYearToMonth_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_IntervalDayToSecond_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_IntervalCompound_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_FixedChar) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_VarChar_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_FixedBinary) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Decimal_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_PrecisionTimestamp_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_PrecisionTimestampTz) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Struct_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Map_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_TimestampTz) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Uuid) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_Null) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_List_) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_EmptyList) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_EmptyMap) isExpression_Literal_LiteralType() {}

func (*Expression_Literal_UserDefined_) isExpression_Literal_LiteralType() {}

// Expression to dynamically construct nested types.
type Expression_Nested struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Whether the returned nested type is nullable.
	Nullable bool `protobuf:"varint,1,opt,name=nullable,proto3" json:"nullable,omitempty"`
	// Optionally points to a type_variation_anchor defined in this plan for
	// the returned nested type.
	TypeVariationReference uint32 `protobuf:"varint,2,opt,name=type_variation_reference,json=typeVariationReference,proto3" json:"type_variation_reference,omitempty"`
	// Types that are valid to be assigned to NestedType:
	//
	//	*Expression_Nested_Struct_
	//	*Expression_Nested_List_
	//	*Expression_Nested_Map_
	NestedType    isExpression_Nested_NestedType `protobuf_oneof:"nested_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Nested) Reset() {
	*x = Expression_Nested{}
	mi := &file_substrait_algebra_proto_msgTypes[68]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Nested) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Nested) ProtoMessage() {}

func (x *Expression_Nested) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[68]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Nested.ProtoReflect.Descriptor instead.
func (*Expression_Nested) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 2}
}

func (x *Expression_Nested) GetNullable() bool {
	if x != nil {
		return x.Nullable
	}
	return false
}

func (x *Expression_Nested) GetTypeVariationReference() uint32 {
	if x != nil {
		return x.TypeVariationReference
	}
	return 0
}

func (x *Expression_Nested) GetNestedType() isExpression_Nested_NestedType {
	if x != nil {
		return x.NestedType
	}
	return nil
}

func (x *Expression_Nested) GetStruct() *Expression_Nested_Struct {
	if x != nil {
		if x, ok := x.NestedType.(*Expression_Nested_Struct_); ok {
			return x.Struct
		}
	}
	return nil
}

func (x *Expression_Nested) GetList() *Expression_Nested_List {
	if x != nil {
		if x, ok := x.NestedType.(*Expression_Nested_List_); ok {
			return x.List
		}
	}
	return nil
}

func (x *Expression_Nested) GetMap() *Expression_Nested_Map {
	if x != nil {
		if x, ok := x.NestedType.(*Expression_Nested_Map_); ok {
			return x.Map
		}
	}
	return nil
}

type isExpression_Nested_NestedType interface {
	isExpression_Nested_NestedType()
}

type Expression_Nested_Struct_ struct {
	Struct *Expression_Nested_Struct `protobuf:"bytes,3,opt,name=struct,proto3,oneof"`
}

type Expression_Nested_List_ struct {
	List *Expression_Nested_List `protobuf:"bytes,4,opt,name=list,proto3,oneof"`
}

type Expression_Nested_Map_ struct {
	Map *Expression_Nested_Map `protobuf:"bytes,5,opt,name=map,proto3,oneof"`
}

func (*Expression_Nested_Struct_) isExpression_Nested_NestedType() {}

func (*Expression_Nested_List_) isExpression_Nested_NestedType() {}

func (*Expression_Nested_Map_) isExpression_Nested_NestedType() {}

// A scalar function call.
type Expression_ScalarFunction struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Points to a function_anchor defined in this plan, which must refer
	// to a scalar function in the associated YAML file. Required; avoid
	// using anchor/reference zero.
	FunctionReference uint32 `protobuf:"varint,1,opt,name=function_reference,json=functionReference,proto3" json:"function_reference,omitempty"`
	// The arguments to be bound to the function. This must have exactly the
	// number of arguments specified in the function definition, and the
	// argument types must also match exactly:
	//
	//   - Value arguments must be bound using FunctionArgument.value, and
	//     the expression in that must yield a value of a type that a function
	//     overload is defined for.
	//   - Type arguments must be bound using FunctionArgument.type.
	//   - Enum arguments must be bound using FunctionArgument.enum
	//     followed by Enum.specified, with a string that case-insensitively
	//     matches one of the allowed options.
	Arguments []*FunctionArgument `protobuf:"bytes,4,rep,name=arguments,proto3" json:"arguments,omitempty"`
	// Options to specify behavior for corner cases, or leave behavior
	// unspecified if the consumer does not need specific behavior in these
	// cases.
	Options []*FunctionOption `protobuf:"bytes,5,rep,name=options,proto3" json:"options,omitempty"`
	// Must be set to the return type of the function, exactly as derived
	// using the declaration in the extension.
	OutputType *Type `protobuf:"bytes,3,opt,name=output_type,json=outputType,proto3" json:"output_type,omitempty"`
	// Deprecated; use arguments instead.
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Args          []*Expression `protobuf:"bytes,2,rep,name=args,proto3" json:"args,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_ScalarFunction) Reset() {
	*x = Expression_ScalarFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[69]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_ScalarFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_ScalarFunction) ProtoMessage() {}

func (x *Expression_ScalarFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[69]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_ScalarFunction.ProtoReflect.Descriptor instead.
func (*Expression_ScalarFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 3}
}

func (x *Expression_ScalarFunction) GetFunctionReference() uint32 {
	if x != nil {
		return x.FunctionReference
	}
	return 0
}

func (x *Expression_ScalarFunction) GetArguments() []*FunctionArgument {
	if x != nil {
		return x.Arguments
	}
	return nil
}

func (x *Expression_ScalarFunction) GetOptions() []*FunctionOption {
	if x != nil {
		return x.Options
	}
	return nil
}

func (x *Expression_ScalarFunction) GetOutputType() *Type {
	if x != nil {
		return x.OutputType
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *Expression_ScalarFunction) GetArgs() []*Expression {
	if x != nil {
		return x.Args
	}
	return nil
}

// A window function call.
type Expression_WindowFunction struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Points to a function_anchor defined in this plan. The function must be:
	//   - a window function
	//   - an aggregate function
	//
	// An aggregate function referenced here should be treated as a window
	// function with Window Type STREAMING
	//
	// Required; 0 is considered to be a valid anchor/reference.
	FunctionReference uint32 `protobuf:"varint,1,opt,name=function_reference,json=functionReference,proto3" json:"function_reference,omitempty"`
	// The arguments to be bound to the function. This must have exactly the
	// number of arguments specified in the function definition, and the
	// argument types must also match exactly:
	//
	//   - Value arguments must be bound using FunctionArgument.value, and
	//     the expression in that must yield a value of a type that a function
	//     overload is defined for.
	//   - Type arguments must be bound using FunctionArgument.type, and a
	//     function overload must be defined for that type.
	//   - Enum arguments must be bound using FunctionArgument.enum
	//     followed by Enum.specified, with a string that case-insensitively
	//     matches one of the allowed options.
	Arguments []*FunctionArgument `protobuf:"bytes,9,rep,name=arguments,proto3" json:"arguments,omitempty"`
	// Options to specify behavior for corner cases, or leave behavior
	// unspecified if the consumer does not need specific behavior in these
	// cases.
	Options []*FunctionOption `protobuf:"bytes,11,rep,name=options,proto3" json:"options,omitempty"`
	// Must be set to the return type of the function, exactly as derived
	// using the declaration in the extension.
	OutputType *Type `protobuf:"bytes,7,opt,name=output_type,json=outputType,proto3" json:"output_type,omitempty"`
	// Describes which part of the window function to perform within the
	// context of distributed algorithms. Required. Must be set to
	// INITIAL_TO_RESULT for window functions that are not decomposable.
	Phase AggregationPhase `protobuf:"varint,6,opt,name=phase,proto3,enum=substrait.AggregationPhase" json:"phase,omitempty"`
	// If specified, the records that are part of the window defined by
	// upper_bound and lower_bound are ordered according to this list
	// before they are aggregated. The first sort field has the highest
	// priority; only if a sort field determines two records to be equivalent
	// is the next field queried. This field is optional, and is only allowed
	// if the window function is defined to support sorting.
	Sorts []*SortField `protobuf:"bytes,3,rep,name=sorts,proto3" json:"sorts,omitempty"`
	// Specifies whether equivalent records are merged before being aggregated.
	// Optional, defaults to AGGREGATION_INVOCATION_ALL.
	Invocation AggregateFunction_AggregationInvocation `protobuf:"varint,10,opt,name=invocation,proto3,enum=substrait.AggregateFunction_AggregationInvocation" json:"invocation,omitempty"`
	// When one or more partition expressions are specified, two records are
	// considered to be in the same partition if and only if these expressions
	// yield an equal record of values for both. When computing the window
	// function, only the subset of records within the bounds that are also in
	// the same partition as the current record are aggregated.
	Partitions []*Expression `protobuf:"bytes,2,rep,name=partitions,proto3" json:"partitions,omitempty"`
	// Defines the bounds type: ROWS, RANGE
	BoundsType Expression_WindowFunction_BoundsType `protobuf:"varint,12,opt,name=bounds_type,json=boundsType,proto3,enum=substrait.Expression_WindowFunction_BoundsType" json:"bounds_type,omitempty"`
	// Defines the record relative to the current record from which the window
	// extends. The bound is inclusive. If the lower bound indexes a record
	// greater than the upper bound, TODO (null range/no records passed?
	// wrapping around as if lower/upper were swapped? error? null?).
	// Optional; defaults to the start of the partition.
	LowerBound *Expression_WindowFunction_Bound `protobuf:"bytes,5,opt,name=lower_bound,json=lowerBound,proto3" json:"lower_bound,omitempty"`
	// Defines the record relative to the current record up to which the window
	// extends. The bound is inclusive. If the upper bound indexes a record
	// less than the lower bound, TODO (null range/no records passed?
	// wrapping around as if lower/upper were swapped? error? null?).
	// Optional; defaults to the end of the partition.
	UpperBound *Expression_WindowFunction_Bound `protobuf:"bytes,4,opt,name=upper_bound,json=upperBound,proto3" json:"upper_bound,omitempty"`
	// Deprecated; use arguments instead.
	//
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Args          []*Expression `protobuf:"bytes,8,rep,name=args,proto3" json:"args,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_WindowFunction) Reset() {
	*x = Expression_WindowFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[70]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_WindowFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_WindowFunction) ProtoMessage() {}

func (x *Expression_WindowFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[70]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_WindowFunction.ProtoReflect.Descriptor instead.
func (*Expression_WindowFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4}
}

func (x *Expression_WindowFunction) GetFunctionReference() uint32 {
	if x != nil {
		return x.FunctionReference
	}
	return 0
}

func (x *Expression_WindowFunction) GetArguments() []*FunctionArgument {
	if x != nil {
		return x.Arguments
	}
	return nil
}

func (x *Expression_WindowFunction) GetOptions() []*FunctionOption {
	if x != nil {
		return x.Options
	}
	return nil
}

func (x *Expression_WindowFunction) GetOutputType() *Type {
	if x != nil {
		return x.OutputType
	}
	return nil
}

func (x *Expression_WindowFunction) GetPhase() AggregationPhase {
	if x != nil {
		return x.Phase
	}
	return AggregationPhase_AGGREGATION_PHASE_UNSPECIFIED
}

func (x *Expression_WindowFunction) GetSorts() []*SortField {
	if x != nil {
		return x.Sorts
	}
	return nil
}

func (x *Expression_WindowFunction) GetInvocation() AggregateFunction_AggregationInvocation {
	if x != nil {
		return x.Invocation
	}
	return AggregateFunction_AGGREGATION_INVOCATION_UNSPECIFIED
}

func (x *Expression_WindowFunction) GetPartitions() []*Expression {
	if x != nil {
		return x.Partitions
	}
	return nil
}

func (x *Expression_WindowFunction) GetBoundsType() Expression_WindowFunction_BoundsType {
	if x != nil {
		return x.BoundsType
	}
	return Expression_WindowFunction_BOUNDS_TYPE_UNSPECIFIED
}

func (x *Expression_WindowFunction) GetLowerBound() *Expression_WindowFunction_Bound {
	if x != nil {
		return x.LowerBound
	}
	return nil
}

func (x *Expression_WindowFunction) GetUpperBound() *Expression_WindowFunction_Bound {
	if x != nil {
		return x.UpperBound
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *Expression_WindowFunction) GetArgs() []*Expression {
	if x != nil {
		return x.Args
	}
	return nil
}

type Expression_IfThen struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A list of one or more IfClauses
	Ifs []*Expression_IfThen_IfClause `protobuf:"bytes,1,rep,name=ifs,proto3" json:"ifs,omitempty"`
	// The returned Expression if no IfClauses are satisified
	Else          *Expression `protobuf:"bytes,2,opt,name=else,proto3" json:"else,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_IfThen) Reset() {
	*x = Expression_IfThen{}
	mi := &file_substrait_algebra_proto_msgTypes[71]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_IfThen) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_IfThen) ProtoMessage() {}

func (x *Expression_IfThen) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[71]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_IfThen.ProtoReflect.Descriptor instead.
func (*Expression_IfThen) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 5}
}

func (x *Expression_IfThen) GetIfs() []*Expression_IfThen_IfClause {
	if x != nil {
		return x.Ifs
	}
	return nil
}

func (x *Expression_IfThen) GetElse() *Expression {
	if x != nil {
		return x.Else
	}
	return nil
}

type Expression_Cast struct {
	state           protoimpl.MessageState          `protogen:"open.v1"`
	Type            *Type                           `protobuf:"bytes,1,opt,name=type,proto3" json:"type,omitempty"`
	Input           *Expression                     `protobuf:"bytes,2,opt,name=input,proto3" json:"input,omitempty"`
	FailureBehavior Expression_Cast_FailureBehavior `protobuf:"varint,3,opt,name=failure_behavior,json=failureBehavior,proto3,enum=substrait.Expression_Cast_FailureBehavior" json:"failure_behavior,omitempty"`
	unknownFields   protoimpl.UnknownFields
	sizeCache       protoimpl.SizeCache
}

func (x *Expression_Cast) Reset() {
	*x = Expression_Cast{}
	mi := &file_substrait_algebra_proto_msgTypes[72]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Cast) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Cast) ProtoMessage() {}

func (x *Expression_Cast) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[72]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Cast.ProtoReflect.Descriptor instead.
func (*Expression_Cast) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 6}
}

func (x *Expression_Cast) GetType() *Type {
	if x != nil {
		return x.Type
	}
	return nil
}

func (x *Expression_Cast) GetInput() *Expression {
	if x != nil {
		return x.Input
	}
	return nil
}

func (x *Expression_Cast) GetFailureBehavior() Expression_Cast_FailureBehavior {
	if x != nil {
		return x.FailureBehavior
	}
	return Expression_Cast_FAILURE_BEHAVIOR_UNSPECIFIED
}

type Expression_SwitchExpression struct {
	state         protoimpl.MessageState                 `protogen:"open.v1"`
	Match         *Expression                            `protobuf:"bytes,3,opt,name=match,proto3" json:"match,omitempty"`
	Ifs           []*Expression_SwitchExpression_IfValue `protobuf:"bytes,1,rep,name=ifs,proto3" json:"ifs,omitempty"`
	Else          *Expression                            `protobuf:"bytes,2,opt,name=else,proto3" json:"else,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_SwitchExpression) Reset() {
	*x = Expression_SwitchExpression{}
	mi := &file_substrait_algebra_proto_msgTypes[73]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_SwitchExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_SwitchExpression) ProtoMessage() {}

func (x *Expression_SwitchExpression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[73]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_SwitchExpression.ProtoReflect.Descriptor instead.
func (*Expression_SwitchExpression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 7}
}

func (x *Expression_SwitchExpression) GetMatch() *Expression {
	if x != nil {
		return x.Match
	}
	return nil
}

func (x *Expression_SwitchExpression) GetIfs() []*Expression_SwitchExpression_IfValue {
	if x != nil {
		return x.Ifs
	}
	return nil
}

func (x *Expression_SwitchExpression) GetElse() *Expression {
	if x != nil {
		return x.Else
	}
	return nil
}

type Expression_SingularOrList struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Value         *Expression            `protobuf:"bytes,1,opt,name=value,proto3" json:"value,omitempty"`
	Options       []*Expression          `protobuf:"bytes,2,rep,name=options,proto3" json:"options,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_SingularOrList) Reset() {
	*x = Expression_SingularOrList{}
	mi := &file_substrait_algebra_proto_msgTypes[74]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_SingularOrList) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_SingularOrList) ProtoMessage() {}

func (x *Expression_SingularOrList) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[74]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_SingularOrList.ProtoReflect.Descriptor instead.
func (*Expression_SingularOrList) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 8}
}

func (x *Expression_SingularOrList) GetValue() *Expression {
	if x != nil {
		return x.Value
	}
	return nil
}

func (x *Expression_SingularOrList) GetOptions() []*Expression {
	if x != nil {
		return x.Options
	}
	return nil
}

type Expression_MultiOrList struct {
	state         protoimpl.MessageState           `protogen:"open.v1"`
	Value         []*Expression                    `protobuf:"bytes,1,rep,name=value,proto3" json:"value,omitempty"`
	Options       []*Expression_MultiOrList_Record `protobuf:"bytes,2,rep,name=options,proto3" json:"options,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MultiOrList) Reset() {
	*x = Expression_MultiOrList{}
	mi := &file_substrait_algebra_proto_msgTypes[75]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MultiOrList) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MultiOrList) ProtoMessage() {}

func (x *Expression_MultiOrList) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[75]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MultiOrList.ProtoReflect.Descriptor instead.
func (*Expression_MultiOrList) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 9}
}

func (x *Expression_MultiOrList) GetValue() []*Expression {
	if x != nil {
		return x.Value
	}
	return nil
}

func (x *Expression_MultiOrList) GetOptions() []*Expression_MultiOrList_Record {
	if x != nil {
		return x.Options
	}
	return nil
}

type Expression_EmbeddedFunction struct {
	state      protoimpl.MessageState `protogen:"open.v1"`
	Arguments  []*Expression          `protobuf:"bytes,1,rep,name=arguments,proto3" json:"arguments,omitempty"`
	OutputType *Type                  `protobuf:"bytes,2,opt,name=output_type,json=outputType,proto3" json:"output_type,omitempty"`
	// Types that are valid to be assigned to Kind:
	//
	//	*Expression_EmbeddedFunction_PythonPickleFunction_
	//	*Expression_EmbeddedFunction_WebAssemblyFunction_
	Kind          isExpression_EmbeddedFunction_Kind `protobuf_oneof:"kind"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_EmbeddedFunction) Reset() {
	*x = Expression_EmbeddedFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[76]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_EmbeddedFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_EmbeddedFunction) ProtoMessage() {}

func (x *Expression_EmbeddedFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[76]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_EmbeddedFunction.ProtoReflect.Descriptor instead.
func (*Expression_EmbeddedFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 10}
}

func (x *Expression_EmbeddedFunction) GetArguments() []*Expression {
	if x != nil {
		return x.Arguments
	}
	return nil
}

func (x *Expression_EmbeddedFunction) GetOutputType() *Type {
	if x != nil {
		return x.OutputType
	}
	return nil
}

func (x *Expression_EmbeddedFunction) GetKind() isExpression_EmbeddedFunction_Kind {
	if x != nil {
		return x.Kind
	}
	return nil
}

func (x *Expression_EmbeddedFunction) GetPythonPickleFunction() *Expression_EmbeddedFunction_PythonPickleFunction {
	if x != nil {
		if x, ok := x.Kind.(*Expression_EmbeddedFunction_PythonPickleFunction_); ok {
			return x.PythonPickleFunction
		}
	}
	return nil
}

func (x *Expression_EmbeddedFunction) GetWebAssemblyFunction() *Expression_EmbeddedFunction_WebAssemblyFunction {
	if x != nil {
		if x, ok := x.Kind.(*Expression_EmbeddedFunction_WebAssemblyFunction_); ok {
			return x.WebAssemblyFunction
		}
	}
	return nil
}

type isExpression_EmbeddedFunction_Kind interface {
	isExpression_EmbeddedFunction_Kind()
}

type Expression_EmbeddedFunction_PythonPickleFunction_ struct {
	PythonPickleFunction *Expression_EmbeddedFunction_PythonPickleFunction `protobuf:"bytes,3,opt,name=python_pickle_function,json=pythonPickleFunction,proto3,oneof"`
}

type Expression_EmbeddedFunction_WebAssemblyFunction_ struct {
	WebAssemblyFunction *Expression_EmbeddedFunction_WebAssemblyFunction `protobuf:"bytes,4,opt,name=web_assembly_function,json=webAssemblyFunction,proto3,oneof"`
}

func (*Expression_EmbeddedFunction_PythonPickleFunction_) isExpression_EmbeddedFunction_Kind() {}

func (*Expression_EmbeddedFunction_WebAssemblyFunction_) isExpression_EmbeddedFunction_Kind() {}

// A way to reference the inner property of a complex record. Can reference
// either a map key by literal, a struct field by the ordinal position of
// the desired field or a particular element in an array. Supports
// expressions that would roughly translate to something similar to:
// a.b[2].c['my_map_key'].x where a,b,c and x are struct field references
// (ordinalized in the internal representation here), [2] is a list offset
// and ['my_map_key'] is a reference into a map field.
type Expression_ReferenceSegment struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to ReferenceType:
	//
	//	*Expression_ReferenceSegment_MapKey_
	//	*Expression_ReferenceSegment_StructField_
	//	*Expression_ReferenceSegment_ListElement_
	ReferenceType isExpression_ReferenceSegment_ReferenceType `protobuf_oneof:"reference_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_ReferenceSegment) Reset() {
	*x = Expression_ReferenceSegment{}
	mi := &file_substrait_algebra_proto_msgTypes[77]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_ReferenceSegment) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_ReferenceSegment) ProtoMessage() {}

func (x *Expression_ReferenceSegment) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[77]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_ReferenceSegment.ProtoReflect.Descriptor instead.
func (*Expression_ReferenceSegment) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 11}
}

func (x *Expression_ReferenceSegment) GetReferenceType() isExpression_ReferenceSegment_ReferenceType {
	if x != nil {
		return x.ReferenceType
	}
	return nil
}

func (x *Expression_ReferenceSegment) GetMapKey() *Expression_ReferenceSegment_MapKey {
	if x != nil {
		if x, ok := x.ReferenceType.(*Expression_ReferenceSegment_MapKey_); ok {
			return x.MapKey
		}
	}
	return nil
}

func (x *Expression_ReferenceSegment) GetStructField() *Expression_ReferenceSegment_StructField {
	if x != nil {
		if x, ok := x.ReferenceType.(*Expression_ReferenceSegment_StructField_); ok {
			return x.StructField
		}
	}
	return nil
}

func (x *Expression_ReferenceSegment) GetListElement() *Expression_ReferenceSegment_ListElement {
	if x != nil {
		if x, ok := x.ReferenceType.(*Expression_ReferenceSegment_ListElement_); ok {
			return x.ListElement
		}
	}
	return nil
}

type isExpression_ReferenceSegment_ReferenceType interface {
	isExpression_ReferenceSegment_ReferenceType()
}

type Expression_ReferenceSegment_MapKey_ struct {
	MapKey *Expression_ReferenceSegment_MapKey `protobuf:"bytes,1,opt,name=map_key,json=mapKey,proto3,oneof"`
}

type Expression_ReferenceSegment_StructField_ struct {
	StructField *Expression_ReferenceSegment_StructField `protobuf:"bytes,2,opt,name=struct_field,json=structField,proto3,oneof"`
}

type Expression_ReferenceSegment_ListElement_ struct {
	ListElement *Expression_ReferenceSegment_ListElement `protobuf:"bytes,3,opt,name=list_element,json=listElement,proto3,oneof"`
}

func (*Expression_ReferenceSegment_MapKey_) isExpression_ReferenceSegment_ReferenceType() {}

func (*Expression_ReferenceSegment_StructField_) isExpression_ReferenceSegment_ReferenceType() {}

func (*Expression_ReferenceSegment_ListElement_) isExpression_ReferenceSegment_ReferenceType() {}

// A reference that takes an existing subtype and selectively removes fields
// from it. For example, one might initially have an inner struct with 100
// fields but a a particular operation only needs to interact with only 2 of
// those 100 fields. In this situation, one would use a mask expression to
// eliminate the 98 fields that are not relevant to the rest of the operation
// pipeline.
//
// Note that this does not fundamentally alter the structure of data beyond
// the elimination of unnecessary elements.
type Expression_MaskExpression struct {
	state                  protoimpl.MessageState                  `protogen:"open.v1"`
	Select                 *Expression_MaskExpression_StructSelect `protobuf:"bytes,1,opt,name=select,proto3" json:"select,omitempty"`
	MaintainSingularStruct bool                                    `protobuf:"varint,2,opt,name=maintain_singular_struct,json=maintainSingularStruct,proto3" json:"maintain_singular_struct,omitempty"`
	unknownFields          protoimpl.UnknownFields
	sizeCache              protoimpl.SizeCache
}

func (x *Expression_MaskExpression) Reset() {
	*x = Expression_MaskExpression{}
	mi := &file_substrait_algebra_proto_msgTypes[78]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression) ProtoMessage() {}

func (x *Expression_MaskExpression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[78]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12}
}

func (x *Expression_MaskExpression) GetSelect() *Expression_MaskExpression_StructSelect {
	if x != nil {
		return x.Select
	}
	return nil
}

func (x *Expression_MaskExpression) GetMaintainSingularStruct() bool {
	if x != nil {
		return x.MaintainSingularStruct
	}
	return false
}

// A reference to an inner part of a complex object. Can reference reference a
// single element or a masked version of elements
type Expression_FieldReference struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Whether this is composed of a single element reference or a masked
	// element subtree
	//
	// Types that are valid to be assigned to ReferenceType:
	//
	//	*Expression_FieldReference_DirectReference
	//	*Expression_FieldReference_MaskedReference
	ReferenceType isExpression_FieldReference_ReferenceType `protobuf_oneof:"reference_type"`
	// Whether this reference has an origin of a root struct or is based on the
	// ouput of an expression. When this is a RootReference and direct_reference
	// above is used, the direct_reference must be of a type StructField.
	//
	// Types that are valid to be assigned to RootType:
	//
	//	*Expression_FieldReference_Expression
	//	*Expression_FieldReference_RootReference_
	//	*Expression_FieldReference_OuterReference_
	RootType      isExpression_FieldReference_RootType `protobuf_oneof:"root_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_FieldReference) Reset() {
	*x = Expression_FieldReference{}
	mi := &file_substrait_algebra_proto_msgTypes[79]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_FieldReference) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_FieldReference) ProtoMessage() {}

func (x *Expression_FieldReference) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[79]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_FieldReference.ProtoReflect.Descriptor instead.
func (*Expression_FieldReference) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 13}
}

func (x *Expression_FieldReference) GetReferenceType() isExpression_FieldReference_ReferenceType {
	if x != nil {
		return x.ReferenceType
	}
	return nil
}

func (x *Expression_FieldReference) GetDirectReference() *Expression_ReferenceSegment {
	if x != nil {
		if x, ok := x.ReferenceType.(*Expression_FieldReference_DirectReference); ok {
			return x.DirectReference
		}
	}
	return nil
}

func (x *Expression_FieldReference) GetMaskedReference() *Expression_MaskExpression {
	if x != nil {
		if x, ok := x.ReferenceType.(*Expression_FieldReference_MaskedReference); ok {
			return x.MaskedReference
		}
	}
	return nil
}

func (x *Expression_FieldReference) GetRootType() isExpression_FieldReference_RootType {
	if x != nil {
		return x.RootType
	}
	return nil
}

func (x *Expression_FieldReference) GetExpression() *Expression {
	if x != nil {
		if x, ok := x.RootType.(*Expression_FieldReference_Expression); ok {
			return x.Expression
		}
	}
	return nil
}

func (x *Expression_FieldReference) GetRootReference() *Expression_FieldReference_RootReference {
	if x != nil {
		if x, ok := x.RootType.(*Expression_FieldReference_RootReference_); ok {
			return x.RootReference
		}
	}
	return nil
}

func (x *Expression_FieldReference) GetOuterReference() *Expression_FieldReference_OuterReference {
	if x != nil {
		if x, ok := x.RootType.(*Expression_FieldReference_OuterReference_); ok {
			return x.OuterReference
		}
	}
	return nil
}

type isExpression_FieldReference_ReferenceType interface {
	isExpression_FieldReference_ReferenceType()
}

type Expression_FieldReference_DirectReference struct {
	DirectReference *Expression_ReferenceSegment `protobuf:"bytes,1,opt,name=direct_reference,json=directReference,proto3,oneof"`
}

type Expression_FieldReference_MaskedReference struct {
	MaskedReference *Expression_MaskExpression `protobuf:"bytes,2,opt,name=masked_reference,json=maskedReference,proto3,oneof"`
}

func (*Expression_FieldReference_DirectReference) isExpression_FieldReference_ReferenceType() {}

func (*Expression_FieldReference_MaskedReference) isExpression_FieldReference_ReferenceType() {}

type isExpression_FieldReference_RootType interface {
	isExpression_FieldReference_RootType()
}

type Expression_FieldReference_Expression struct {
	Expression *Expression `protobuf:"bytes,3,opt,name=expression,proto3,oneof"`
}

type Expression_FieldReference_RootReference_ struct {
	RootReference *Expression_FieldReference_RootReference `protobuf:"bytes,4,opt,name=root_reference,json=rootReference,proto3,oneof"`
}

type Expression_FieldReference_OuterReference_ struct {
	OuterReference *Expression_FieldReference_OuterReference `protobuf:"bytes,5,opt,name=outer_reference,json=outerReference,proto3,oneof"`
}

func (*Expression_FieldReference_Expression) isExpression_FieldReference_RootType() {}

func (*Expression_FieldReference_RootReference_) isExpression_FieldReference_RootType() {}

func (*Expression_FieldReference_OuterReference_) isExpression_FieldReference_RootType() {}

// Subquery relation expression
type Expression_Subquery struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to SubqueryType:
	//
	//	*Expression_Subquery_Scalar_
	//	*Expression_Subquery_InPredicate_
	//	*Expression_Subquery_SetPredicate_
	//	*Expression_Subquery_SetComparison_
	SubqueryType  isExpression_Subquery_SubqueryType `protobuf_oneof:"subquery_type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Subquery) Reset() {
	*x = Expression_Subquery{}
	mi := &file_substrait_algebra_proto_msgTypes[80]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Subquery) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Subquery) ProtoMessage() {}

func (x *Expression_Subquery) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[80]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Subquery.ProtoReflect.Descriptor instead.
func (*Expression_Subquery) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14}
}

func (x *Expression_Subquery) GetSubqueryType() isExpression_Subquery_SubqueryType {
	if x != nil {
		return x.SubqueryType
	}
	return nil
}

func (x *Expression_Subquery) GetScalar() *Expression_Subquery_Scalar {
	if x != nil {
		if x, ok := x.SubqueryType.(*Expression_Subquery_Scalar_); ok {
			return x.Scalar
		}
	}
	return nil
}

func (x *Expression_Subquery) GetInPredicate() *Expression_Subquery_InPredicate {
	if x != nil {
		if x, ok := x.SubqueryType.(*Expression_Subquery_InPredicate_); ok {
			return x.InPredicate
		}
	}
	return nil
}

func (x *Expression_Subquery) GetSetPredicate() *Expression_Subquery_SetPredicate {
	if x != nil {
		if x, ok := x.SubqueryType.(*Expression_Subquery_SetPredicate_); ok {
			return x.SetPredicate
		}
	}
	return nil
}

func (x *Expression_Subquery) GetSetComparison() *Expression_Subquery_SetComparison {
	if x != nil {
		if x, ok := x.SubqueryType.(*Expression_Subquery_SetComparison_); ok {
			return x.SetComparison
		}
	}
	return nil
}

type isExpression_Subquery_SubqueryType interface {
	isExpression_Subquery_SubqueryType()
}

type Expression_Subquery_Scalar_ struct {
	// Scalar subquery
	Scalar *Expression_Subquery_Scalar `protobuf:"bytes,1,opt,name=scalar,proto3,oneof"`
}

type Expression_Subquery_InPredicate_ struct {
	// x IN y predicate
	InPredicate *Expression_Subquery_InPredicate `protobuf:"bytes,2,opt,name=in_predicate,json=inPredicate,proto3,oneof"`
}

type Expression_Subquery_SetPredicate_ struct {
	// EXISTS/UNIQUE predicate
	SetPredicate *Expression_Subquery_SetPredicate `protobuf:"bytes,3,opt,name=set_predicate,json=setPredicate,proto3,oneof"`
}

type Expression_Subquery_SetComparison_ struct {
	// ANY/ALL predicate
	SetComparison *Expression_Subquery_SetComparison `protobuf:"bytes,4,opt,name=set_comparison,json=setComparison,proto3,oneof"`
}

func (*Expression_Subquery_Scalar_) isExpression_Subquery_SubqueryType() {}

func (*Expression_Subquery_InPredicate_) isExpression_Subquery_SubqueryType() {}

func (*Expression_Subquery_SetPredicate_) isExpression_Subquery_SubqueryType() {}

func (*Expression_Subquery_SetComparison_) isExpression_Subquery_SubqueryType() {}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
type Expression_Enum_Empty struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Enum_Empty) Reset() {
	*x = Expression_Enum_Empty{}
	mi := &file_substrait_algebra_proto_msgTypes[81]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Enum_Empty) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Enum_Empty) ProtoMessage() {}

func (x *Expression_Enum_Empty) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[81]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Enum_Empty.ProtoReflect.Descriptor instead.
func (*Expression_Enum_Empty) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 0, 0}
}

type Expression_Literal_VarChar struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Value         string                 `protobuf:"bytes,1,opt,name=value,proto3" json:"value,omitempty"`
	Length        uint32                 `protobuf:"varint,2,opt,name=length,proto3" json:"length,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_VarChar) Reset() {
	*x = Expression_Literal_VarChar{}
	mi := &file_substrait_algebra_proto_msgTypes[82]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_VarChar) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_VarChar) ProtoMessage() {}

func (x *Expression_Literal_VarChar) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[82]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_VarChar.ProtoReflect.Descriptor instead.
func (*Expression_Literal_VarChar) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 0}
}

func (x *Expression_Literal_VarChar) GetValue() string {
	if x != nil {
		return x.Value
	}
	return ""
}

func (x *Expression_Literal_VarChar) GetLength() uint32 {
	if x != nil {
		return x.Length
	}
	return 0
}

type Expression_Literal_Decimal struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// little-endian twos-complement integer representation of complete value
	// (ignoring precision) Always 16 bytes in length
	Value []byte `protobuf:"bytes,1,opt,name=value,proto3" json:"value,omitempty"`
	// The maximum number of digits allowed in the value.
	// the maximum precision is 38.
	Precision int32 `protobuf:"varint,2,opt,name=precision,proto3" json:"precision,omitempty"`
	// declared scale of decimal literal
	Scale         int32 `protobuf:"varint,3,opt,name=scale,proto3" json:"scale,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_Decimal) Reset() {
	*x = Expression_Literal_Decimal{}
	mi := &file_substrait_algebra_proto_msgTypes[83]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_Decimal) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_Decimal) ProtoMessage() {}

func (x *Expression_Literal_Decimal) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[83]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_Decimal.ProtoReflect.Descriptor instead.
func (*Expression_Literal_Decimal) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 1}
}

func (x *Expression_Literal_Decimal) GetValue() []byte {
	if x != nil {
		return x.Value
	}
	return nil
}

func (x *Expression_Literal_Decimal) GetPrecision() int32 {
	if x != nil {
		return x.Precision
	}
	return 0
}

func (x *Expression_Literal_Decimal) GetScale() int32 {
	if x != nil {
		return x.Scale
	}
	return 0
}

type Expression_Literal_PrecisionTimestamp struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Sub-second precision, 0 means the value given is in seconds, 3 is milliseconds, 6 microseconds, 9 is nanoseconds
	Precision int32 `protobuf:"varint,1,opt,name=precision,proto3" json:"precision,omitempty"`
	// Time passed since 1970-01-01 00:00:00.000000 in UTC for PrecisionTimestampTZ and unspecified timezone for PrecisionTimestamp
	Value         int64 `protobuf:"varint,2,opt,name=value,proto3" json:"value,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_PrecisionTimestamp) Reset() {
	*x = Expression_Literal_PrecisionTimestamp{}
	mi := &file_substrait_algebra_proto_msgTypes[84]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_PrecisionTimestamp) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_PrecisionTimestamp) ProtoMessage() {}

func (x *Expression_Literal_PrecisionTimestamp) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[84]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_PrecisionTimestamp.ProtoReflect.Descriptor instead.
func (*Expression_Literal_PrecisionTimestamp) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 2}
}

func (x *Expression_Literal_PrecisionTimestamp) GetPrecision() int32 {
	if x != nil {
		return x.Precision
	}
	return 0
}

func (x *Expression_Literal_PrecisionTimestamp) GetValue() int64 {
	if x != nil {
		return x.Value
	}
	return 0
}

type Expression_Literal_Map struct {
	state         protoimpl.MessageState             `protogen:"open.v1"`
	KeyValues     []*Expression_Literal_Map_KeyValue `protobuf:"bytes,1,rep,name=key_values,json=keyValues,proto3" json:"key_values,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_Map) Reset() {
	*x = Expression_Literal_Map{}
	mi := &file_substrait_algebra_proto_msgTypes[85]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_Map) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_Map) ProtoMessage() {}

func (x *Expression_Literal_Map) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[85]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_Map.ProtoReflect.Descriptor instead.
func (*Expression_Literal_Map) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 3}
}

func (x *Expression_Literal_Map) GetKeyValues() []*Expression_Literal_Map_KeyValue {
	if x != nil {
		return x.KeyValues
	}
	return nil
}

type Expression_Literal_IntervalYearToMonth struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Years         int32                  `protobuf:"varint,1,opt,name=years,proto3" json:"years,omitempty"`
	Months        int32                  `protobuf:"varint,2,opt,name=months,proto3" json:"months,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_IntervalYearToMonth) Reset() {
	*x = Expression_Literal_IntervalYearToMonth{}
	mi := &file_substrait_algebra_proto_msgTypes[86]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_IntervalYearToMonth) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_IntervalYearToMonth) ProtoMessage() {}

func (x *Expression_Literal_IntervalYearToMonth) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[86]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_IntervalYearToMonth.ProtoReflect.Descriptor instead.
func (*Expression_Literal_IntervalYearToMonth) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 4}
}

func (x *Expression_Literal_IntervalYearToMonth) GetYears() int32 {
	if x != nil {
		return x.Years
	}
	return 0
}

func (x *Expression_Literal_IntervalYearToMonth) GetMonths() int32 {
	if x != nil {
		return x.Months
	}
	return 0
}

type Expression_Literal_IntervalDayToSecond struct {
	state   protoimpl.MessageState `protogen:"open.v1"`
	Days    int32                  `protobuf:"varint,1,opt,name=days,proto3" json:"days,omitempty"`
	Seconds int32                  `protobuf:"varint,2,opt,name=seconds,proto3" json:"seconds,omitempty"`
	// Consumers should expect either (miroseconds) to be set or (precision and subseconds) to be set
	//
	// Types that are valid to be assigned to PrecisionMode:
	//
	//	*Expression_Literal_IntervalDayToSecond_Microseconds
	//	*Expression_Literal_IntervalDayToSecond_Precision
	PrecisionMode isExpression_Literal_IntervalDayToSecond_PrecisionMode `protobuf_oneof:"precision_mode"`
	// the number of fractional seconds using 1e(-precision) units. Should only be used with precision field, not microseconds.
	Subseconds    int64 `protobuf:"varint,5,opt,name=subseconds,proto3" json:"subseconds,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_IntervalDayToSecond) Reset() {
	*x = Expression_Literal_IntervalDayToSecond{}
	mi := &file_substrait_algebra_proto_msgTypes[87]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_IntervalDayToSecond) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_IntervalDayToSecond) ProtoMessage() {}

func (x *Expression_Literal_IntervalDayToSecond) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[87]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_IntervalDayToSecond.ProtoReflect.Descriptor instead.
func (*Expression_Literal_IntervalDayToSecond) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 5}
}

func (x *Expression_Literal_IntervalDayToSecond) GetDays() int32 {
	if x != nil {
		return x.Days
	}
	return 0
}

func (x *Expression_Literal_IntervalDayToSecond) GetSeconds() int32 {
	if x != nil {
		return x.Seconds
	}
	return 0
}

func (x *Expression_Literal_IntervalDayToSecond) GetPrecisionMode() isExpression_Literal_IntervalDayToSecond_PrecisionMode {
	if x != nil {
		return x.PrecisionMode
	}
	return nil
}

// Deprecated: Marked as deprecated in substrait/algebra.proto.
func (x *Expression_Literal_IntervalDayToSecond) GetMicroseconds() int32 {
	if x != nil {
		if x, ok := x.PrecisionMode.(*Expression_Literal_IntervalDayToSecond_Microseconds); ok {
			return x.Microseconds
		}
	}
	return 0
}

func (x *Expression_Literal_IntervalDayToSecond) GetPrecision() int32 {
	if x != nil {
		if x, ok := x.PrecisionMode.(*Expression_Literal_IntervalDayToSecond_Precision); ok {
			return x.Precision
		}
	}
	return 0
}

func (x *Expression_Literal_IntervalDayToSecond) GetSubseconds() int64 {
	if x != nil {
		return x.Subseconds
	}
	return 0
}

type isExpression_Literal_IntervalDayToSecond_PrecisionMode interface {
	isExpression_Literal_IntervalDayToSecond_PrecisionMode()
}

type Expression_Literal_IntervalDayToSecond_Microseconds struct {
	// Deprecated: Marked as deprecated in substrait/algebra.proto.
	Microseconds int32 `protobuf:"varint,3,opt,name=microseconds,proto3,oneof"` // use precision and subseconds below, they cover and replace microseconds.
}

type Expression_Literal_IntervalDayToSecond_Precision struct {
	// Sub-second precision, 0 means the value given is in seconds, 3 is milliseconds, 6 microseconds, 9 is nanoseconds. Should be used with subseconds below.
	Precision int32 `protobuf:"varint,4,opt,name=precision,proto3,oneof"`
}

func (*Expression_Literal_IntervalDayToSecond_Microseconds) isExpression_Literal_IntervalDayToSecond_PrecisionMode() {
}

func (*Expression_Literal_IntervalDayToSecond_Precision) isExpression_Literal_IntervalDayToSecond_PrecisionMode() {
}

type Expression_Literal_IntervalCompound struct {
	state               protoimpl.MessageState                  `protogen:"open.v1"`
	IntervalYearToMonth *Expression_Literal_IntervalYearToMonth `protobuf:"bytes,1,opt,name=interval_year_to_month,json=intervalYearToMonth,proto3" json:"interval_year_to_month,omitempty"`
	IntervalDayToSecond *Expression_Literal_IntervalDayToSecond `protobuf:"bytes,2,opt,name=interval_day_to_second,json=intervalDayToSecond,proto3" json:"interval_day_to_second,omitempty"`
	unknownFields       protoimpl.UnknownFields
	sizeCache           protoimpl.SizeCache
}

func (x *Expression_Literal_IntervalCompound) Reset() {
	*x = Expression_Literal_IntervalCompound{}
	mi := &file_substrait_algebra_proto_msgTypes[88]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_IntervalCompound) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_IntervalCompound) ProtoMessage() {}

func (x *Expression_Literal_IntervalCompound) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[88]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_IntervalCompound.ProtoReflect.Descriptor instead.
func (*Expression_Literal_IntervalCompound) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 6}
}

func (x *Expression_Literal_IntervalCompound) GetIntervalYearToMonth() *Expression_Literal_IntervalYearToMonth {
	if x != nil {
		return x.IntervalYearToMonth
	}
	return nil
}

func (x *Expression_Literal_IntervalCompound) GetIntervalDayToSecond() *Expression_Literal_IntervalDayToSecond {
	if x != nil {
		return x.IntervalDayToSecond
	}
	return nil
}

type Expression_Literal_Struct struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A possibly heterogeneously typed list of literals
	Fields        []*Expression_Literal `protobuf:"bytes,1,rep,name=fields,proto3" json:"fields,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_Struct) Reset() {
	*x = Expression_Literal_Struct{}
	mi := &file_substrait_algebra_proto_msgTypes[89]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_Struct) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_Struct) ProtoMessage() {}

func (x *Expression_Literal_Struct) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[89]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_Struct.ProtoReflect.Descriptor instead.
func (*Expression_Literal_Struct) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 7}
}

func (x *Expression_Literal_Struct) GetFields() []*Expression_Literal {
	if x != nil {
		return x.Fields
	}
	return nil
}

type Expression_Literal_List struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A homogeneously typed list of literals
	Values        []*Expression_Literal `protobuf:"bytes,1,rep,name=values,proto3" json:"values,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_List) Reset() {
	*x = Expression_Literal_List{}
	mi := &file_substrait_algebra_proto_msgTypes[90]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_List) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_List) ProtoMessage() {}

func (x *Expression_Literal_List) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[90]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_List.ProtoReflect.Descriptor instead.
func (*Expression_Literal_List) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 8}
}

func (x *Expression_Literal_List) GetValues() []*Expression_Literal {
	if x != nil {
		return x.Values
	}
	return nil
}

type Expression_Literal_UserDefined struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// points to a type_anchor defined in this plan
	TypeReference uint32 `protobuf:"varint,1,opt,name=type_reference,json=typeReference,proto3" json:"type_reference,omitempty"`
	// The parameters to be bound to the type class, if the type class is
	// parameterizable.
	TypeParameters []*Type_Parameter `protobuf:"bytes,3,rep,name=type_parameters,json=typeParameters,proto3" json:"type_parameters,omitempty"`
	// a user-defined literal can be encoded in one of two ways
	//
	// Types that are valid to be assigned to Val:
	//
	//	*Expression_Literal_UserDefined_Value
	//	*Expression_Literal_UserDefined_Struct
	Val           isExpression_Literal_UserDefined_Val `protobuf_oneof:"val"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_UserDefined) Reset() {
	*x = Expression_Literal_UserDefined{}
	mi := &file_substrait_algebra_proto_msgTypes[91]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_UserDefined) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_UserDefined) ProtoMessage() {}

func (x *Expression_Literal_UserDefined) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[91]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_UserDefined.ProtoReflect.Descriptor instead.
func (*Expression_Literal_UserDefined) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 9}
}

func (x *Expression_Literal_UserDefined) GetTypeReference() uint32 {
	if x != nil {
		return x.TypeReference
	}
	return 0
}

func (x *Expression_Literal_UserDefined) GetTypeParameters() []*Type_Parameter {
	if x != nil {
		return x.TypeParameters
	}
	return nil
}

func (x *Expression_Literal_UserDefined) GetVal() isExpression_Literal_UserDefined_Val {
	if x != nil {
		return x.Val
	}
	return nil
}

func (x *Expression_Literal_UserDefined) GetValue() *anypb.Any {
	if x != nil {
		if x, ok := x.Val.(*Expression_Literal_UserDefined_Value); ok {
			return x.Value
		}
	}
	return nil
}

func (x *Expression_Literal_UserDefined) GetStruct() *Expression_Literal_Struct {
	if x != nil {
		if x, ok := x.Val.(*Expression_Literal_UserDefined_Struct); ok {
			return x.Struct
		}
	}
	return nil
}

type isExpression_Literal_UserDefined_Val interface {
	isExpression_Literal_UserDefined_Val()
}

type Expression_Literal_UserDefined_Value struct {
	// the value of the literal, serialized using some type-specific protobuf message
	Value *anypb.Any `protobuf:"bytes,2,opt,name=value,proto3,oneof"`
}

type Expression_Literal_UserDefined_Struct struct {
	// the value of the literal, serialized using the structure definition in its declaration
	Struct *Expression_Literal_Struct `protobuf:"bytes,4,opt,name=struct,proto3,oneof"`
}

func (*Expression_Literal_UserDefined_Value) isExpression_Literal_UserDefined_Val() {}

func (*Expression_Literal_UserDefined_Struct) isExpression_Literal_UserDefined_Val() {}

type Expression_Literal_Map_KeyValue struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Key           *Expression_Literal    `protobuf:"bytes,1,opt,name=key,proto3" json:"key,omitempty"`
	Value         *Expression_Literal    `protobuf:"bytes,2,opt,name=value,proto3" json:"value,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Literal_Map_KeyValue) Reset() {
	*x = Expression_Literal_Map_KeyValue{}
	mi := &file_substrait_algebra_proto_msgTypes[92]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Literal_Map_KeyValue) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Literal_Map_KeyValue) ProtoMessage() {}

func (x *Expression_Literal_Map_KeyValue) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[92]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Literal_Map_KeyValue.ProtoReflect.Descriptor instead.
func (*Expression_Literal_Map_KeyValue) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 1, 3, 0}
}

func (x *Expression_Literal_Map_KeyValue) GetKey() *Expression_Literal {
	if x != nil {
		return x.Key
	}
	return nil
}

func (x *Expression_Literal_Map_KeyValue) GetValue() *Expression_Literal {
	if x != nil {
		return x.Value
	}
	return nil
}

type Expression_Nested_Map struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// One or more key-value pairs. To specify an empty map, use
	// Literal.empty_map (otherwise type information would be missing).
	KeyValues     []*Expression_Nested_Map_KeyValue `protobuf:"bytes,1,rep,name=key_values,json=keyValues,proto3" json:"key_values,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Nested_Map) Reset() {
	*x = Expression_Nested_Map{}
	mi := &file_substrait_algebra_proto_msgTypes[93]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Nested_Map) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Nested_Map) ProtoMessage() {}

func (x *Expression_Nested_Map) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[93]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Nested_Map.ProtoReflect.Descriptor instead.
func (*Expression_Nested_Map) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 2, 0}
}

func (x *Expression_Nested_Map) GetKeyValues() []*Expression_Nested_Map_KeyValue {
	if x != nil {
		return x.KeyValues
	}
	return nil
}

type Expression_Nested_Struct struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Zero or more possibly heterogeneously-typed list of expressions that
	// form the struct fields.
	Fields        []*Expression `protobuf:"bytes,1,rep,name=fields,proto3" json:"fields,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Nested_Struct) Reset() {
	*x = Expression_Nested_Struct{}
	mi := &file_substrait_algebra_proto_msgTypes[94]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Nested_Struct) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Nested_Struct) ProtoMessage() {}

func (x *Expression_Nested_Struct) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[94]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Nested_Struct.ProtoReflect.Descriptor instead.
func (*Expression_Nested_Struct) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 2, 1}
}

func (x *Expression_Nested_Struct) GetFields() []*Expression {
	if x != nil {
		return x.Fields
	}
	return nil
}

type Expression_Nested_List struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A homogeneously-typed list of one or more expressions that form the
	// list entries. To specify an empty list, use Literal.empty_list
	// (otherwise type information would be missing).
	Values        []*Expression `protobuf:"bytes,1,rep,name=values,proto3" json:"values,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Nested_List) Reset() {
	*x = Expression_Nested_List{}
	mi := &file_substrait_algebra_proto_msgTypes[95]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Nested_List) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Nested_List) ProtoMessage() {}

func (x *Expression_Nested_List) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[95]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Nested_List.ProtoReflect.Descriptor instead.
func (*Expression_Nested_List) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 2, 2}
}

func (x *Expression_Nested_List) GetValues() []*Expression {
	if x != nil {
		return x.Values
	}
	return nil
}

type Expression_Nested_Map_KeyValue struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Mandatory key/value expressions.
	Key           *Expression `protobuf:"bytes,1,opt,name=key,proto3" json:"key,omitempty"`
	Value         *Expression `protobuf:"bytes,2,opt,name=value,proto3" json:"value,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Nested_Map_KeyValue) Reset() {
	*x = Expression_Nested_Map_KeyValue{}
	mi := &file_substrait_algebra_proto_msgTypes[96]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Nested_Map_KeyValue) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Nested_Map_KeyValue) ProtoMessage() {}

func (x *Expression_Nested_Map_KeyValue) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[96]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Nested_Map_KeyValue.ProtoReflect.Descriptor instead.
func (*Expression_Nested_Map_KeyValue) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 2, 0, 0}
}

func (x *Expression_Nested_Map_KeyValue) GetKey() *Expression {
	if x != nil {
		return x.Key
	}
	return nil
}

func (x *Expression_Nested_Map_KeyValue) GetValue() *Expression {
	if x != nil {
		return x.Value
	}
	return nil
}

// Defines one of the two boundaries for the window of a window function.
type Expression_WindowFunction_Bound struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to Kind:
	//
	//	*Expression_WindowFunction_Bound_Preceding_
	//	*Expression_WindowFunction_Bound_Following_
	//	*Expression_WindowFunction_Bound_CurrentRow_
	//	*Expression_WindowFunction_Bound_Unbounded_
	Kind          isExpression_WindowFunction_Bound_Kind `protobuf_oneof:"kind"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_WindowFunction_Bound) Reset() {
	*x = Expression_WindowFunction_Bound{}
	mi := &file_substrait_algebra_proto_msgTypes[97]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_WindowFunction_Bound) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_WindowFunction_Bound) ProtoMessage() {}

func (x *Expression_WindowFunction_Bound) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[97]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_WindowFunction_Bound.ProtoReflect.Descriptor instead.
func (*Expression_WindowFunction_Bound) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4, 0}
}

func (x *Expression_WindowFunction_Bound) GetKind() isExpression_WindowFunction_Bound_Kind {
	if x != nil {
		return x.Kind
	}
	return nil
}

func (x *Expression_WindowFunction_Bound) GetPreceding() *Expression_WindowFunction_Bound_Preceding {
	if x != nil {
		if x, ok := x.Kind.(*Expression_WindowFunction_Bound_Preceding_); ok {
			return x.Preceding
		}
	}
	return nil
}

func (x *Expression_WindowFunction_Bound) GetFollowing() *Expression_WindowFunction_Bound_Following {
	if x != nil {
		if x, ok := x.Kind.(*Expression_WindowFunction_Bound_Following_); ok {
			return x.Following
		}
	}
	return nil
}

func (x *Expression_WindowFunction_Bound) GetCurrentRow() *Expression_WindowFunction_Bound_CurrentRow {
	if x != nil {
		if x, ok := x.Kind.(*Expression_WindowFunction_Bound_CurrentRow_); ok {
			return x.CurrentRow
		}
	}
	return nil
}

func (x *Expression_WindowFunction_Bound) GetUnbounded() *Expression_WindowFunction_Bound_Unbounded {
	if x != nil {
		if x, ok := x.Kind.(*Expression_WindowFunction_Bound_Unbounded_); ok {
			return x.Unbounded
		}
	}
	return nil
}

type isExpression_WindowFunction_Bound_Kind interface {
	isExpression_WindowFunction_Bound_Kind()
}

type Expression_WindowFunction_Bound_Preceding_ struct {
	// The bound extends some number of records behind the current record.
	Preceding *Expression_WindowFunction_Bound_Preceding `protobuf:"bytes,1,opt,name=preceding,proto3,oneof"`
}

type Expression_WindowFunction_Bound_Following_ struct {
	// The bound extends some number of records ahead of the current
	// record.
	Following *Expression_WindowFunction_Bound_Following `protobuf:"bytes,2,opt,name=following,proto3,oneof"`
}

type Expression_WindowFunction_Bound_CurrentRow_ struct {
	// The bound extends to the current record.
	CurrentRow *Expression_WindowFunction_Bound_CurrentRow `protobuf:"bytes,3,opt,name=current_row,json=currentRow,proto3,oneof"`
}

type Expression_WindowFunction_Bound_Unbounded_ struct {
	// The bound extends to the start of the partition or the end of the
	// partition, depending on whether this represents the upper or lower
	// bound.
	Unbounded *Expression_WindowFunction_Bound_Unbounded `protobuf:"bytes,4,opt,name=unbounded,proto3,oneof"`
}

func (*Expression_WindowFunction_Bound_Preceding_) isExpression_WindowFunction_Bound_Kind() {}

func (*Expression_WindowFunction_Bound_Following_) isExpression_WindowFunction_Bound_Kind() {}

func (*Expression_WindowFunction_Bound_CurrentRow_) isExpression_WindowFunction_Bound_Kind() {}

func (*Expression_WindowFunction_Bound_Unbounded_) isExpression_WindowFunction_Bound_Kind() {}

// Defines that the bound extends this far back from the current record.
type Expression_WindowFunction_Bound_Preceding struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A strictly positive integer specifying the number of records that
	// the window extends back from the current record. Required. Use
	// CurrentRow for offset zero and Following for negative offsets.
	Offset        int64 `protobuf:"varint,1,opt,name=offset,proto3" json:"offset,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_WindowFunction_Bound_Preceding) Reset() {
	*x = Expression_WindowFunction_Bound_Preceding{}
	mi := &file_substrait_algebra_proto_msgTypes[98]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_WindowFunction_Bound_Preceding) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_WindowFunction_Bound_Preceding) ProtoMessage() {}

func (x *Expression_WindowFunction_Bound_Preceding) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[98]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_WindowFunction_Bound_Preceding.ProtoReflect.Descriptor instead.
func (*Expression_WindowFunction_Bound_Preceding) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4, 0, 0}
}

func (x *Expression_WindowFunction_Bound_Preceding) GetOffset() int64 {
	if x != nil {
		return x.Offset
	}
	return 0
}

// Defines that the bound extends this far ahead of the current record.
type Expression_WindowFunction_Bound_Following struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// A strictly positive integer specifying the number of records that
	// the window extends ahead of the current record. Required. Use
	// CurrentRow for offset zero and Preceding for negative offsets.
	Offset        int64 `protobuf:"varint,1,opt,name=offset,proto3" json:"offset,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_WindowFunction_Bound_Following) Reset() {
	*x = Expression_WindowFunction_Bound_Following{}
	mi := &file_substrait_algebra_proto_msgTypes[99]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_WindowFunction_Bound_Following) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_WindowFunction_Bound_Following) ProtoMessage() {}

func (x *Expression_WindowFunction_Bound_Following) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[99]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_WindowFunction_Bound_Following.ProtoReflect.Descriptor instead.
func (*Expression_WindowFunction_Bound_Following) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4, 0, 1}
}

func (x *Expression_WindowFunction_Bound_Following) GetOffset() int64 {
	if x != nil {
		return x.Offset
	}
	return 0
}

// Defines that the bound extends to or from the current record.
type Expression_WindowFunction_Bound_CurrentRow struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_WindowFunction_Bound_CurrentRow) Reset() {
	*x = Expression_WindowFunction_Bound_CurrentRow{}
	mi := &file_substrait_algebra_proto_msgTypes[100]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_WindowFunction_Bound_CurrentRow) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_WindowFunction_Bound_CurrentRow) ProtoMessage() {}

func (x *Expression_WindowFunction_Bound_CurrentRow) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[100]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_WindowFunction_Bound_CurrentRow.ProtoReflect.Descriptor instead.
func (*Expression_WindowFunction_Bound_CurrentRow) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4, 0, 2}
}

// Defines an "unbounded bound": for lower bounds this means the start
// of the partition, and for upper bounds this means the end of the
// partition.
type Expression_WindowFunction_Bound_Unbounded struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_WindowFunction_Bound_Unbounded) Reset() {
	*x = Expression_WindowFunction_Bound_Unbounded{}
	mi := &file_substrait_algebra_proto_msgTypes[101]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_WindowFunction_Bound_Unbounded) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_WindowFunction_Bound_Unbounded) ProtoMessage() {}

func (x *Expression_WindowFunction_Bound_Unbounded) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[101]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_WindowFunction_Bound_Unbounded.ProtoReflect.Descriptor instead.
func (*Expression_WindowFunction_Bound_Unbounded) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 4, 0, 3}
}

type Expression_IfThen_IfClause struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	If            *Expression            `protobuf:"bytes,1,opt,name=if,proto3" json:"if,omitempty"`
	Then          *Expression            `protobuf:"bytes,2,opt,name=then,proto3" json:"then,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_IfThen_IfClause) Reset() {
	*x = Expression_IfThen_IfClause{}
	mi := &file_substrait_algebra_proto_msgTypes[102]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_IfThen_IfClause) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_IfThen_IfClause) ProtoMessage() {}

func (x *Expression_IfThen_IfClause) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[102]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_IfThen_IfClause.ProtoReflect.Descriptor instead.
func (*Expression_IfThen_IfClause) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 5, 0}
}

func (x *Expression_IfThen_IfClause) GetIf() *Expression {
	if x != nil {
		return x.If
	}
	return nil
}

func (x *Expression_IfThen_IfClause) GetThen() *Expression {
	if x != nil {
		return x.Then
	}
	return nil
}

type Expression_SwitchExpression_IfValue struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	If            *Expression_Literal    `protobuf:"bytes,1,opt,name=if,proto3" json:"if,omitempty"`
	Then          *Expression            `protobuf:"bytes,2,opt,name=then,proto3" json:"then,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_SwitchExpression_IfValue) Reset() {
	*x = Expression_SwitchExpression_IfValue{}
	mi := &file_substrait_algebra_proto_msgTypes[103]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_SwitchExpression_IfValue) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_SwitchExpression_IfValue) ProtoMessage() {}

func (x *Expression_SwitchExpression_IfValue) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[103]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_SwitchExpression_IfValue.ProtoReflect.Descriptor instead.
func (*Expression_SwitchExpression_IfValue) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 7, 0}
}

func (x *Expression_SwitchExpression_IfValue) GetIf() *Expression_Literal {
	if x != nil {
		return x.If
	}
	return nil
}

func (x *Expression_SwitchExpression_IfValue) GetThen() *Expression {
	if x != nil {
		return x.Then
	}
	return nil
}

type Expression_MultiOrList_Record struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Fields        []*Expression          `protobuf:"bytes,1,rep,name=fields,proto3" json:"fields,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MultiOrList_Record) Reset() {
	*x = Expression_MultiOrList_Record{}
	mi := &file_substrait_algebra_proto_msgTypes[104]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MultiOrList_Record) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MultiOrList_Record) ProtoMessage() {}

func (x *Expression_MultiOrList_Record) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[104]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MultiOrList_Record.ProtoReflect.Descriptor instead.
func (*Expression_MultiOrList_Record) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 9, 0}
}

func (x *Expression_MultiOrList_Record) GetFields() []*Expression {
	if x != nil {
		return x.Fields
	}
	return nil
}

type Expression_EmbeddedFunction_PythonPickleFunction struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Function      []byte                 `protobuf:"bytes,1,opt,name=function,proto3" json:"function,omitempty"`
	Prerequisite  []string               `protobuf:"bytes,2,rep,name=prerequisite,proto3" json:"prerequisite,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_EmbeddedFunction_PythonPickleFunction) Reset() {
	*x = Expression_EmbeddedFunction_PythonPickleFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[105]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_EmbeddedFunction_PythonPickleFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_EmbeddedFunction_PythonPickleFunction) ProtoMessage() {}

func (x *Expression_EmbeddedFunction_PythonPickleFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[105]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_EmbeddedFunction_PythonPickleFunction.ProtoReflect.Descriptor instead.
func (*Expression_EmbeddedFunction_PythonPickleFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 10, 0}
}

func (x *Expression_EmbeddedFunction_PythonPickleFunction) GetFunction() []byte {
	if x != nil {
		return x.Function
	}
	return nil
}

func (x *Expression_EmbeddedFunction_PythonPickleFunction) GetPrerequisite() []string {
	if x != nil {
		return x.Prerequisite
	}
	return nil
}

type Expression_EmbeddedFunction_WebAssemblyFunction struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Script        []byte                 `protobuf:"bytes,1,opt,name=script,proto3" json:"script,omitempty"`
	Prerequisite  []string               `protobuf:"bytes,2,rep,name=prerequisite,proto3" json:"prerequisite,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_EmbeddedFunction_WebAssemblyFunction) Reset() {
	*x = Expression_EmbeddedFunction_WebAssemblyFunction{}
	mi := &file_substrait_algebra_proto_msgTypes[106]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_EmbeddedFunction_WebAssemblyFunction) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_EmbeddedFunction_WebAssemblyFunction) ProtoMessage() {}

func (x *Expression_EmbeddedFunction_WebAssemblyFunction) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[106]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_EmbeddedFunction_WebAssemblyFunction.ProtoReflect.Descriptor instead.
func (*Expression_EmbeddedFunction_WebAssemblyFunction) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 10, 1}
}

func (x *Expression_EmbeddedFunction_WebAssemblyFunction) GetScript() []byte {
	if x != nil {
		return x.Script
	}
	return nil
}

func (x *Expression_EmbeddedFunction_WebAssemblyFunction) GetPrerequisite() []string {
	if x != nil {
		return x.Prerequisite
	}
	return nil
}

type Expression_ReferenceSegment_MapKey struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// literal based reference to specific possible value in map.
	MapKey *Expression_Literal `protobuf:"bytes,1,opt,name=map_key,json=mapKey,proto3" json:"map_key,omitempty"`
	// Optional child segment
	Child         *Expression_ReferenceSegment `protobuf:"bytes,2,opt,name=child,proto3" json:"child,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_ReferenceSegment_MapKey) Reset() {
	*x = Expression_ReferenceSegment_MapKey{}
	mi := &file_substrait_algebra_proto_msgTypes[107]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_ReferenceSegment_MapKey) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_ReferenceSegment_MapKey) ProtoMessage() {}

func (x *Expression_ReferenceSegment_MapKey) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[107]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_ReferenceSegment_MapKey.ProtoReflect.Descriptor instead.
func (*Expression_ReferenceSegment_MapKey) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 11, 0}
}

func (x *Expression_ReferenceSegment_MapKey) GetMapKey() *Expression_Literal {
	if x != nil {
		return x.MapKey
	}
	return nil
}

func (x *Expression_ReferenceSegment_MapKey) GetChild() *Expression_ReferenceSegment {
	if x != nil {
		return x.Child
	}
	return nil
}

type Expression_ReferenceSegment_StructField struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// zero-indexed ordinal position of field in struct
	Field int32 `protobuf:"varint,1,opt,name=field,proto3" json:"field,omitempty"`
	// Optional child segment
	Child         *Expression_ReferenceSegment `protobuf:"bytes,2,opt,name=child,proto3" json:"child,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_ReferenceSegment_StructField) Reset() {
	*x = Expression_ReferenceSegment_StructField{}
	mi := &file_substrait_algebra_proto_msgTypes[108]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_ReferenceSegment_StructField) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_ReferenceSegment_StructField) ProtoMessage() {}

func (x *Expression_ReferenceSegment_StructField) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[108]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_ReferenceSegment_StructField.ProtoReflect.Descriptor instead.
func (*Expression_ReferenceSegment_StructField) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 11, 1}
}

func (x *Expression_ReferenceSegment_StructField) GetField() int32 {
	if x != nil {
		return x.Field
	}
	return 0
}

func (x *Expression_ReferenceSegment_StructField) GetChild() *Expression_ReferenceSegment {
	if x != nil {
		return x.Child
	}
	return nil
}

type Expression_ReferenceSegment_ListElement struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// zero-indexed ordinal position of element in list
	Offset int32 `protobuf:"varint,1,opt,name=offset,proto3" json:"offset,omitempty"`
	// Optional child segment
	Child         *Expression_ReferenceSegment `protobuf:"bytes,2,opt,name=child,proto3" json:"child,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_ReferenceSegment_ListElement) Reset() {
	*x = Expression_ReferenceSegment_ListElement{}
	mi := &file_substrait_algebra_proto_msgTypes[109]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_ReferenceSegment_ListElement) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_ReferenceSegment_ListElement) ProtoMessage() {}

func (x *Expression_ReferenceSegment_ListElement) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[109]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_ReferenceSegment_ListElement.ProtoReflect.Descriptor instead.
func (*Expression_ReferenceSegment_ListElement) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 11, 2}
}

func (x *Expression_ReferenceSegment_ListElement) GetOffset() int32 {
	if x != nil {
		return x.Offset
	}
	return 0
}

func (x *Expression_ReferenceSegment_ListElement) GetChild() *Expression_ReferenceSegment {
	if x != nil {
		return x.Child
	}
	return nil
}

type Expression_MaskExpression_Select struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to Type:
	//
	//	*Expression_MaskExpression_Select_Struct
	//	*Expression_MaskExpression_Select_List
	//	*Expression_MaskExpression_Select_Map
	Type          isExpression_MaskExpression_Select_Type `protobuf_oneof:"type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_Select) Reset() {
	*x = Expression_MaskExpression_Select{}
	mi := &file_substrait_algebra_proto_msgTypes[110]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_Select) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_Select) ProtoMessage() {}

func (x *Expression_MaskExpression_Select) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[110]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_Select.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_Select) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 0}
}

func (x *Expression_MaskExpression_Select) GetType() isExpression_MaskExpression_Select_Type {
	if x != nil {
		return x.Type
	}
	return nil
}

func (x *Expression_MaskExpression_Select) GetStruct() *Expression_MaskExpression_StructSelect {
	if x != nil {
		if x, ok := x.Type.(*Expression_MaskExpression_Select_Struct); ok {
			return x.Struct
		}
	}
	return nil
}

func (x *Expression_MaskExpression_Select) GetList() *Expression_MaskExpression_ListSelect {
	if x != nil {
		if x, ok := x.Type.(*Expression_MaskExpression_Select_List); ok {
			return x.List
		}
	}
	return nil
}

func (x *Expression_MaskExpression_Select) GetMap() *Expression_MaskExpression_MapSelect {
	if x != nil {
		if x, ok := x.Type.(*Expression_MaskExpression_Select_Map); ok {
			return x.Map
		}
	}
	return nil
}

type isExpression_MaskExpression_Select_Type interface {
	isExpression_MaskExpression_Select_Type()
}

type Expression_MaskExpression_Select_Struct struct {
	Struct *Expression_MaskExpression_StructSelect `protobuf:"bytes,1,opt,name=struct,proto3,oneof"`
}

type Expression_MaskExpression_Select_List struct {
	List *Expression_MaskExpression_ListSelect `protobuf:"bytes,2,opt,name=list,proto3,oneof"`
}

type Expression_MaskExpression_Select_Map struct {
	Map *Expression_MaskExpression_MapSelect `protobuf:"bytes,3,opt,name=map,proto3,oneof"`
}

func (*Expression_MaskExpression_Select_Struct) isExpression_MaskExpression_Select_Type() {}

func (*Expression_MaskExpression_Select_List) isExpression_MaskExpression_Select_Type() {}

func (*Expression_MaskExpression_Select_Map) isExpression_MaskExpression_Select_Type() {}

type Expression_MaskExpression_StructSelect struct {
	state         protoimpl.MessageState                  `protogen:"open.v1"`
	StructItems   []*Expression_MaskExpression_StructItem `protobuf:"bytes,1,rep,name=struct_items,json=structItems,proto3" json:"struct_items,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_StructSelect) Reset() {
	*x = Expression_MaskExpression_StructSelect{}
	mi := &file_substrait_algebra_proto_msgTypes[111]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_StructSelect) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_StructSelect) ProtoMessage() {}

func (x *Expression_MaskExpression_StructSelect) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[111]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_StructSelect.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_StructSelect) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 1}
}

func (x *Expression_MaskExpression_StructSelect) GetStructItems() []*Expression_MaskExpression_StructItem {
	if x != nil {
		return x.StructItems
	}
	return nil
}

type Expression_MaskExpression_StructItem struct {
	state         protoimpl.MessageState            `protogen:"open.v1"`
	Field         int32                             `protobuf:"varint,1,opt,name=field,proto3" json:"field,omitempty"`
	Child         *Expression_MaskExpression_Select `protobuf:"bytes,2,opt,name=child,proto3" json:"child,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_StructItem) Reset() {
	*x = Expression_MaskExpression_StructItem{}
	mi := &file_substrait_algebra_proto_msgTypes[112]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_StructItem) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_StructItem) ProtoMessage() {}

func (x *Expression_MaskExpression_StructItem) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[112]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_StructItem.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_StructItem) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 2}
}

func (x *Expression_MaskExpression_StructItem) GetField() int32 {
	if x != nil {
		return x.Field
	}
	return 0
}

func (x *Expression_MaskExpression_StructItem) GetChild() *Expression_MaskExpression_Select {
	if x != nil {
		return x.Child
	}
	return nil
}

type Expression_MaskExpression_ListSelect struct {
	state         protoimpl.MessageState                                 `protogen:"open.v1"`
	Selection     []*Expression_MaskExpression_ListSelect_ListSelectItem `protobuf:"bytes,1,rep,name=selection,proto3" json:"selection,omitempty"`
	Child         *Expression_MaskExpression_Select                      `protobuf:"bytes,2,opt,name=child,proto3" json:"child,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_ListSelect) Reset() {
	*x = Expression_MaskExpression_ListSelect{}
	mi := &file_substrait_algebra_proto_msgTypes[113]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_ListSelect) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_ListSelect) ProtoMessage() {}

func (x *Expression_MaskExpression_ListSelect) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[113]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_ListSelect.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_ListSelect) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 3}
}

func (x *Expression_MaskExpression_ListSelect) GetSelection() []*Expression_MaskExpression_ListSelect_ListSelectItem {
	if x != nil {
		return x.Selection
	}
	return nil
}

func (x *Expression_MaskExpression_ListSelect) GetChild() *Expression_MaskExpression_Select {
	if x != nil {
		return x.Child
	}
	return nil
}

type Expression_MaskExpression_MapSelect struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to Select:
	//
	//	*Expression_MaskExpression_MapSelect_Key
	//	*Expression_MaskExpression_MapSelect_Expression
	Select        isExpression_MaskExpression_MapSelect_Select `protobuf_oneof:"select"`
	Child         *Expression_MaskExpression_Select            `protobuf:"bytes,3,opt,name=child,proto3" json:"child,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_MapSelect) Reset() {
	*x = Expression_MaskExpression_MapSelect{}
	mi := &file_substrait_algebra_proto_msgTypes[114]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_MapSelect) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_MapSelect) ProtoMessage() {}

func (x *Expression_MaskExpression_MapSelect) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[114]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_MapSelect.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_MapSelect) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 4}
}

func (x *Expression_MaskExpression_MapSelect) GetSelect() isExpression_MaskExpression_MapSelect_Select {
	if x != nil {
		return x.Select
	}
	return nil
}

func (x *Expression_MaskExpression_MapSelect) GetKey() *Expression_MaskExpression_MapSelect_MapKey {
	if x != nil {
		if x, ok := x.Select.(*Expression_MaskExpression_MapSelect_Key); ok {
			return x.Key
		}
	}
	return nil
}

func (x *Expression_MaskExpression_MapSelect) GetExpression() *Expression_MaskExpression_MapSelect_MapKeyExpression {
	if x != nil {
		if x, ok := x.Select.(*Expression_MaskExpression_MapSelect_Expression); ok {
			return x.Expression
		}
	}
	return nil
}

func (x *Expression_MaskExpression_MapSelect) GetChild() *Expression_MaskExpression_Select {
	if x != nil {
		return x.Child
	}
	return nil
}

type isExpression_MaskExpression_MapSelect_Select interface {
	isExpression_MaskExpression_MapSelect_Select()
}

type Expression_MaskExpression_MapSelect_Key struct {
	Key *Expression_MaskExpression_MapSelect_MapKey `protobuf:"bytes,1,opt,name=key,proto3,oneof"`
}

type Expression_MaskExpression_MapSelect_Expression struct {
	Expression *Expression_MaskExpression_MapSelect_MapKeyExpression `protobuf:"bytes,2,opt,name=expression,proto3,oneof"`
}

func (*Expression_MaskExpression_MapSelect_Key) isExpression_MaskExpression_MapSelect_Select() {}

func (*Expression_MaskExpression_MapSelect_Expression) isExpression_MaskExpression_MapSelect_Select() {
}

type Expression_MaskExpression_ListSelect_ListSelectItem struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// Types that are valid to be assigned to Type:
	//
	//	*Expression_MaskExpression_ListSelect_ListSelectItem_Item
	//	*Expression_MaskExpression_ListSelect_ListSelectItem_Slice
	Type          isExpression_MaskExpression_ListSelect_ListSelectItem_Type `protobuf_oneof:"type"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem) Reset() {
	*x = Expression_MaskExpression_ListSelect_ListSelectItem{}
	mi := &file_substrait_algebra_proto_msgTypes[115]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_ListSelect_ListSelectItem) ProtoMessage() {}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[115]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_ListSelect_ListSelectItem.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_ListSelect_ListSelectItem) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 3, 0}
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem) GetType() isExpression_MaskExpression_ListSelect_ListSelectItem_Type {
	if x != nil {
		return x.Type
	}
	return nil
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem) GetItem() *Expression_MaskExpression_ListSelect_ListSelectItem_ListElement {
	if x != nil {
		if x, ok := x.Type.(*Expression_MaskExpression_ListSelect_ListSelectItem_Item); ok {
			return x.Item
		}
	}
	return nil
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem) GetSlice() *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice {
	if x != nil {
		if x, ok := x.Type.(*Expression_MaskExpression_ListSelect_ListSelectItem_Slice); ok {
			return x.Slice
		}
	}
	return nil
}

type isExpression_MaskExpression_ListSelect_ListSelectItem_Type interface {
	isExpression_MaskExpression_ListSelect_ListSelectItem_Type()
}

type Expression_MaskExpression_ListSelect_ListSelectItem_Item struct {
	Item *Expression_MaskExpression_ListSelect_ListSelectItem_ListElement `protobuf:"bytes,1,opt,name=item,proto3,oneof"`
}

type Expression_MaskExpression_ListSelect_ListSelectItem_Slice struct {
	Slice *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice `protobuf:"bytes,2,opt,name=slice,proto3,oneof"`
}

func (*Expression_MaskExpression_ListSelect_ListSelectItem_Item) isExpression_MaskExpression_ListSelect_ListSelectItem_Type() {
}

func (*Expression_MaskExpression_ListSelect_ListSelectItem_Slice) isExpression_MaskExpression_ListSelect_ListSelectItem_Type() {
}

type Expression_MaskExpression_ListSelect_ListSelectItem_ListElement struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Field         int32                  `protobuf:"varint,1,opt,name=field,proto3" json:"field,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListElement) Reset() {
	*x = Expression_MaskExpression_ListSelect_ListSelectItem_ListElement{}
	mi := &file_substrait_algebra_proto_msgTypes[116]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListElement) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_ListSelect_ListSelectItem_ListElement) ProtoMessage() {}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListElement) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[116]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_ListSelect_ListSelectItem_ListElement.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_ListSelect_ListSelectItem_ListElement) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 3, 0, 0}
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListElement) GetField() int32 {
	if x != nil {
		return x.Field
	}
	return 0
}

type Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Start         int32                  `protobuf:"varint,1,opt,name=start,proto3" json:"start,omitempty"`
	End           int32                  `protobuf:"varint,2,opt,name=end,proto3" json:"end,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) Reset() {
	*x = Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice{}
	mi := &file_substrait_algebra_proto_msgTypes[117]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) ProtoMessage() {}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[117]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 3, 0, 1}
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) GetStart() int32 {
	if x != nil {
		return x.Start
	}
	return 0
}

func (x *Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice) GetEnd() int32 {
	if x != nil {
		return x.End
	}
	return 0
}

type Expression_MaskExpression_MapSelect_MapKey struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	MapKey        string                 `protobuf:"bytes,1,opt,name=map_key,json=mapKey,proto3" json:"map_key,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_MaskExpression_MapSelect_MapKey) Reset() {
	*x = Expression_MaskExpression_MapSelect_MapKey{}
	mi := &file_substrait_algebra_proto_msgTypes[118]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_MapSelect_MapKey) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_MapSelect_MapKey) ProtoMessage() {}

func (x *Expression_MaskExpression_MapSelect_MapKey) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[118]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_MapSelect_MapKey.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_MapSelect_MapKey) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 4, 0}
}

func (x *Expression_MaskExpression_MapSelect_MapKey) GetMapKey() string {
	if x != nil {
		return x.MapKey
	}
	return ""
}

type Expression_MaskExpression_MapSelect_MapKeyExpression struct {
	state            protoimpl.MessageState `protogen:"open.v1"`
	MapKeyExpression string                 `protobuf:"bytes,1,opt,name=map_key_expression,json=mapKeyExpression,proto3" json:"map_key_expression,omitempty"`
	unknownFields    protoimpl.UnknownFields
	sizeCache        protoimpl.SizeCache
}

func (x *Expression_MaskExpression_MapSelect_MapKeyExpression) Reset() {
	*x = Expression_MaskExpression_MapSelect_MapKeyExpression{}
	mi := &file_substrait_algebra_proto_msgTypes[119]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_MaskExpression_MapSelect_MapKeyExpression) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_MaskExpression_MapSelect_MapKeyExpression) ProtoMessage() {}

func (x *Expression_MaskExpression_MapSelect_MapKeyExpression) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[119]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_MaskExpression_MapSelect_MapKeyExpression.ProtoReflect.Descriptor instead.
func (*Expression_MaskExpression_MapSelect_MapKeyExpression) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 12, 4, 1}
}

func (x *Expression_MaskExpression_MapSelect_MapKeyExpression) GetMapKeyExpression() string {
	if x != nil {
		return x.MapKeyExpression
	}
	return ""
}

// Singleton that expresses this FieldReference is rooted off the root
// incoming record type
type Expression_FieldReference_RootReference struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_FieldReference_RootReference) Reset() {
	*x = Expression_FieldReference_RootReference{}
	mi := &file_substrait_algebra_proto_msgTypes[120]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_FieldReference_RootReference) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_FieldReference_RootReference) ProtoMessage() {}

func (x *Expression_FieldReference_RootReference) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[120]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_FieldReference_RootReference.ProtoReflect.Descriptor instead.
func (*Expression_FieldReference_RootReference) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 13, 0}
}

// A root reference for the outer relation's subquery
type Expression_FieldReference_OuterReference struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// number of subquery boundaries to traverse up for this field's reference
	//
	// This value must be >= 1
	StepsOut      uint32 `protobuf:"varint,1,opt,name=steps_out,json=stepsOut,proto3" json:"steps_out,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_FieldReference_OuterReference) Reset() {
	*x = Expression_FieldReference_OuterReference{}
	mi := &file_substrait_algebra_proto_msgTypes[121]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_FieldReference_OuterReference) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_FieldReference_OuterReference) ProtoMessage() {}

func (x *Expression_FieldReference_OuterReference) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[121]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_FieldReference_OuterReference.ProtoReflect.Descriptor instead.
func (*Expression_FieldReference_OuterReference) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 13, 1}
}

func (x *Expression_FieldReference_OuterReference) GetStepsOut() uint32 {
	if x != nil {
		return x.StepsOut
	}
	return 0
}

// A subquery with one row and one column. This is often an aggregate
// though not required to be.
type Expression_Subquery_Scalar struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Input         *Rel                   `protobuf:"bytes,1,opt,name=input,proto3" json:"input,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Subquery_Scalar) Reset() {
	*x = Expression_Subquery_Scalar{}
	mi := &file_substrait_algebra_proto_msgTypes[122]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Subquery_Scalar) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Subquery_Scalar) ProtoMessage() {}

func (x *Expression_Subquery_Scalar) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[122]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Subquery_Scalar.ProtoReflect.Descriptor instead.
func (*Expression_Subquery_Scalar) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 0}
}

func (x *Expression_Subquery_Scalar) GetInput() *Rel {
	if x != nil {
		return x.Input
	}
	return nil
}

// Predicate checking that the left expression is contained in the right
// subquery
//
// Examples:
//
// x IN (SELECT * FROM t)
// (x, y) IN (SELECT a, b FROM t)
type Expression_Subquery_InPredicate struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Needles       []*Expression          `protobuf:"bytes,1,rep,name=needles,proto3" json:"needles,omitempty"`
	Haystack      *Rel                   `protobuf:"bytes,2,opt,name=haystack,proto3" json:"haystack,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Subquery_InPredicate) Reset() {
	*x = Expression_Subquery_InPredicate{}
	mi := &file_substrait_algebra_proto_msgTypes[123]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Subquery_InPredicate) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Subquery_InPredicate) ProtoMessage() {}

func (x *Expression_Subquery_InPredicate) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[123]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Subquery_InPredicate.ProtoReflect.Descriptor instead.
func (*Expression_Subquery_InPredicate) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 1}
}

func (x *Expression_Subquery_InPredicate) GetNeedles() []*Expression {
	if x != nil {
		return x.Needles
	}
	return nil
}

func (x *Expression_Subquery_InPredicate) GetHaystack() *Rel {
	if x != nil {
		return x.Haystack
	}
	return nil
}

// A predicate over a set of rows in the form of a subquery
// EXISTS and UNIQUE are common SQL forms of this operation.
type Expression_Subquery_SetPredicate struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// TODO: should allow expressions
	PredicateOp   Expression_Subquery_SetPredicate_PredicateOp `protobuf:"varint,1,opt,name=predicate_op,json=predicateOp,proto3,enum=substrait.Expression_Subquery_SetPredicate_PredicateOp" json:"predicate_op,omitempty"`
	Tuples        *Rel                                         `protobuf:"bytes,2,opt,name=tuples,proto3" json:"tuples,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Subquery_SetPredicate) Reset() {
	*x = Expression_Subquery_SetPredicate{}
	mi := &file_substrait_algebra_proto_msgTypes[124]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Subquery_SetPredicate) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Subquery_SetPredicate) ProtoMessage() {}

func (x *Expression_Subquery_SetPredicate) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[124]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Subquery_SetPredicate.ProtoReflect.Descriptor instead.
func (*Expression_Subquery_SetPredicate) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 2}
}

func (x *Expression_Subquery_SetPredicate) GetPredicateOp() Expression_Subquery_SetPredicate_PredicateOp {
	if x != nil {
		return x.PredicateOp
	}
	return Expression_Subquery_SetPredicate_PREDICATE_OP_UNSPECIFIED
}

func (x *Expression_Subquery_SetPredicate) GetTuples() *Rel {
	if x != nil {
		return x.Tuples
	}
	return nil
}

// A subquery comparison using ANY or ALL.
// Examples:
//
// SELECT *
// FROM t1
// WHERE x < ANY(SELECT y from t2)
type Expression_Subquery_SetComparison struct {
	state protoimpl.MessageState `protogen:"open.v1"`
	// ANY or ALL
	ReductionOp Expression_Subquery_SetComparison_ReductionOp `protobuf:"varint,1,opt,name=reduction_op,json=reductionOp,proto3,enum=substrait.Expression_Subquery_SetComparison_ReductionOp" json:"reduction_op,omitempty"`
	// A comparison operator
	ComparisonOp Expression_Subquery_SetComparison_ComparisonOp `protobuf:"varint,2,opt,name=comparison_op,json=comparisonOp,proto3,enum=substrait.Expression_Subquery_SetComparison_ComparisonOp" json:"comparison_op,omitempty"`
	// left side of the expression
	Left *Expression `protobuf:"bytes,3,opt,name=left,proto3" json:"left,omitempty"`
	// right side of the expression
	Right         *Rel `protobuf:"bytes,4,opt,name=right,proto3" json:"right,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *Expression_Subquery_SetComparison) Reset() {
	*x = Expression_Subquery_SetComparison{}
	mi := &file_substrait_algebra_proto_msgTypes[125]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *Expression_Subquery_SetComparison) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*Expression_Subquery_SetComparison) ProtoMessage() {}

func (x *Expression_Subquery_SetComparison) ProtoReflect() protoreflect.Message {
	mi := &file_substrait_algebra_proto_msgTypes[125]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use Expression_Subquery_SetComparison.ProtoReflect.Descriptor instead.
func (*Expression_Subquery_SetComparison) Descriptor() ([]byte, []int) {
	return file_substrait_algebra_proto_rawDescGZIP(), []int{30, 14, 3}
}

func (x *Expression_Subquery_SetComparison) GetReductionOp() Expression_Subquery_SetComparison_ReductionOp {
	if x != nil {
		return x.ReductionOp
	}
	return Expression_Subquery_SetComparison_REDUCTION_OP_UNSPECIFIED
}

func (x *Expression_Subquery_SetComparison) GetComparisonOp() Expression_Subquery_SetComparison_ComparisonOp {
	if x != nil {
		return x.ComparisonOp
	}
	return Expression_Subquery_SetComparison_COMPARISON_OP_UNSPECIFIED
}

func (x *Expression_Subquery_SetComparison) GetLeft() *Expression {
	if x != nil {
		return x.Left
	}
	return nil
}

func (x *Expression_Subquery_SetComparison) GetRight() *Rel {
	if x != nil {
		return x.Right
	}
	return nil
}

var File_substrait_algebra_proto protoreflect.FileDescriptor

var file_substrait_algebra_proto_rawDesc = []byte{
	0x0a, 0x17, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2f, 0x61, 0x6c, 0x67, 0x65,
	0x62, 0x72, 0x61, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x09, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x1a, 0x19, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f,
	0x74, 0x6f, 0x62, 0x75, 0x66, 0x2f, 0x61, 0x6e, 0x79, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a,
	0x25, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2f, 0x65, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73,
	0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x1a, 0x14, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2f, 0x74, 0x79, 0x70, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0xc5, 0x0b, 0x0a,
	0x09, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x35, 0x0a, 0x06, 0x64, 0x69,
	0x72, 0x65, 0x63, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e,
	0x2e, 0x44, 0x69, 0x72, 0x65, 0x63, 0x74, 0x48, 0x00, 0x52, 0x06, 0x64, 0x69, 0x72, 0x65, 0x63,
	0x74, 0x12, 0x2f, 0x0a, 0x04, 0x65, 0x6d, 0x69, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x19, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43,
	0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2e, 0x45, 0x6d, 0x69, 0x74, 0x48, 0x00, 0x52, 0x04, 0x65, 0x6d,
	0x69, 0x74, 0x12, 0x2d, 0x0a, 0x04, 0x68, 0x69, 0x6e, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x19, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c,
	0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2e, 0x48, 0x69, 0x6e, 0x74, 0x52, 0x04, 0x68, 0x69, 0x6e,
	0x74, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64,
	0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x08, 0x0a, 0x06, 0x44, 0x69, 0x72,
	0x65, 0x63, 0x74, 0x1a, 0x2d, 0x0a, 0x04, 0x45, 0x6d, 0x69, 0x74, 0x12, 0x25, 0x0a, 0x0e, 0x6f,
	0x75, 0x74, 0x70, 0x75, 0x74, 0x5f, 0x6d, 0x61, 0x70, 0x70, 0x69, 0x6e, 0x67, 0x18, 0x01, 0x20,
	0x03, 0x28, 0x05, 0x52, 0x0d, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x4d, 0x61, 0x70, 0x70, 0x69,
	0x6e, 0x67, 0x1a, 0x82, 0x09, 0x0a, 0x04, 0x48, 0x69, 0x6e, 0x74, 0x12, 0x35, 0x0a, 0x05, 0x73,
	0x74, 0x61, 0x74, 0x73, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1f, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e,
	0x2e, 0x48, 0x69, 0x6e, 0x74, 0x2e, 0x53, 0x74, 0x61, 0x74, 0x73, 0x52, 0x05, 0x73, 0x74, 0x61,
	0x74, 0x73, 0x12, 0x4b, 0x0a, 0x0a, 0x63, 0x6f, 0x6e, 0x73, 0x74, 0x72, 0x61, 0x69, 0x6e, 0x74,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2e, 0x48, 0x69, 0x6e,
	0x74, 0x2e, 0x52, 0x75, 0x6e, 0x74, 0x69, 0x6d, 0x65, 0x43, 0x6f, 0x6e, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x6e, 0x74, 0x52, 0x0a, 0x63, 0x6f, 0x6e, 0x73, 0x74, 0x72, 0x61, 0x69, 0x6e, 0x74, 0x12,
	0x14, 0x0a, 0x05, 0x61, 0x6c, 0x69, 0x61, 0x73, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05,
	0x61, 0x6c, 0x69, 0x61, 0x73, 0x12, 0x21, 0x0a, 0x0c, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x5f,
	0x6e, 0x61, 0x6d, 0x65, 0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x09, 0x52, 0x0b, 0x6f, 0x75, 0x74,
	0x70, 0x75, 0x74, 0x4e, 0x61, 0x6d, 0x65, 0x73, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61,
	0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61,
	0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61,
	0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x12, 0x59, 0x0a, 0x12, 0x73, 0x61, 0x76, 0x65, 0x64, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x0b, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d,
	0x6f, 0x6e, 0x2e, 0x48, 0x69, 0x6e, 0x74, 0x2e, 0x53, 0x61, 0x76, 0x65, 0x64, 0x43, 0x6f, 0x6d,
	0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x73, 0x61, 0x76, 0x65, 0x64, 0x43,
	0x6f, 0x6d, 0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x12, 0x5c, 0x0a, 0x13, 0x6c,
	0x6f, 0x61, 0x64, 0x65, 0x64, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f,
	0x6e, 0x73, 0x18, 0x0c, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2e, 0x48,
	0x69, 0x6e, 0x74, 0x2e, 0x4c, 0x6f, 0x61, 0x64, 0x65, 0x64, 0x43, 0x6f, 0x6d, 0x70, 0x75, 0x74,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x12, 0x6c, 0x6f, 0x61, 0x64, 0x65, 0x64, 0x43, 0x6f, 0x6d,
	0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x1a, 0x9d, 0x01, 0x0a, 0x05, 0x53, 0x74,
	0x61, 0x74, 0x73, 0x12, 0x1b, 0x0a, 0x09, 0x72, 0x6f, 0x77, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x01, 0x52, 0x08, 0x72, 0x6f, 0x77, 0x43, 0x6f, 0x75, 0x6e, 0x74,
	0x12, 0x1f, 0x0a, 0x0b, 0x72, 0x65, 0x63, 0x6f, 0x72, 0x64, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x01, 0x52, 0x0a, 0x72, 0x65, 0x63, 0x6f, 0x72, 0x64, 0x53, 0x69, 0x7a,
	0x65, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64,
	0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x6b, 0x0a, 0x11, 0x52, 0x75, 0x6e,
	0x74, 0x69, 0x6d, 0x65, 0x43, 0x6f, 0x6e, 0x73, 0x74, 0x72, 0x61, 0x69, 0x6e, 0x74, 0x12, 0x56,
	0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x78, 0x0a, 0x10, 0x53, 0x61, 0x76, 0x65, 0x64, 0x43,
	0x6f, 0x6d, 0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x25, 0x0a, 0x0e, 0x63, 0x6f,
	0x6d, 0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x05, 0x52, 0x0d, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x49,
	0x64, 0x12, 0x3d, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0e, 0x32,
	0x29, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43,
	0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2e, 0x48, 0x69, 0x6e, 0x74, 0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x75,
	0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x04, 0x74, 0x79, 0x70, 0x65,
	0x1a, 0x8c, 0x01, 0x0a, 0x11, 0x4c, 0x6f, 0x61, 0x64, 0x65, 0x64, 0x43, 0x6f, 0x6d, 0x70, 0x75,
	0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x38, 0x0a, 0x18, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x69, 0x64, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e,
	0x63, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x16, 0x63, 0x6f, 0x6d, 0x70, 0x75, 0x74,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x49, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65,
	0x12, 0x3d, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x29,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f,
	0x6d, 0x6d, 0x6f, 0x6e, 0x2e, 0x48, 0x69, 0x6e, 0x74, 0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x75, 0x74,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x04, 0x74, 0x79, 0x70, 0x65, 0x22,
	0x95, 0x01, 0x0a, 0x0f, 0x43, 0x6f, 0x6d, 0x70, 0x75, 0x74, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x54,
	0x79, 0x70, 0x65, 0x12, 0x20, 0x0a, 0x1c, 0x43, 0x4f, 0x4d, 0x50, 0x55, 0x54, 0x41, 0x54, 0x49,
	0x4f, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46,
	0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x1e, 0x0a, 0x1a, 0x43, 0x4f, 0x4d, 0x50, 0x55, 0x54, 0x41,
	0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x48, 0x41, 0x53, 0x48, 0x54, 0x41,
	0x42, 0x4c, 0x45, 0x10, 0x01, 0x12, 0x21, 0x0a, 0x1d, 0x43, 0x4f, 0x4d, 0x50, 0x55, 0x54, 0x41,
	0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x42, 0x4c, 0x4f, 0x4f, 0x4d, 0x5f,
	0x46, 0x49, 0x4c, 0x54, 0x45, 0x52, 0x10, 0x02, 0x12, 0x1d, 0x0a, 0x18, 0x43, 0x4f, 0x4d, 0x50,
	0x55, 0x54, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x4b,
	0x4e, 0x4f, 0x57, 0x4e, 0x10, 0x8f, 0x4e, 0x42, 0x0b, 0x0a, 0x09, 0x65, 0x6d, 0x69, 0x74, 0x5f,
	0x6b, 0x69, 0x6e, 0x64, 0x22, 0xdd, 0x14, 0x0a, 0x07, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c,
	0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c,
	0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x37,
	0x0a, 0x0b, 0x62, 0x61, 0x73, 0x65, 0x5f, 0x73, 0x63, 0x68, 0x65, 0x6d, 0x61, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x16, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x4e, 0x61, 0x6d, 0x65, 0x64, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x52, 0x0a, 0x62, 0x61, 0x73,
	0x65, 0x53, 0x63, 0x68, 0x65, 0x6d, 0x61, 0x12, 0x2d, 0x0a, 0x06, 0x66, 0x69, 0x6c, 0x74, 0x65,
	0x72, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x06,
	0x66, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x12, 0x43, 0x0a, 0x12, 0x62, 0x65, 0x73, 0x74, 0x5f, 0x65,
	0x66, 0x66, 0x6f, 0x72, 0x74, 0x5f, 0x66, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x18, 0x0b, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x10, 0x62, 0x65, 0x73, 0x74, 0x45,
	0x66, 0x66, 0x6f, 0x72, 0x74, 0x46, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x12, 0x44, 0x0a, 0x0a, 0x70,
	0x72, 0x6f, 0x6a, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x70, 0x72, 0x6f, 0x6a, 0x65, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64,
	0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x46, 0x0a, 0x0d, 0x76, 0x69, 0x72,
	0x74, 0x75, 0x61, 0x6c, 0x5f, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x1f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61,
	0x64, 0x52, 0x65, 0x6c, 0x2e, 0x56, 0x69, 0x72, 0x74, 0x75, 0x61, 0x6c, 0x54, 0x61, 0x62, 0x6c,
	0x65, 0x48, 0x00, 0x52, 0x0c, 0x76, 0x69, 0x72, 0x74, 0x75, 0x61, 0x6c, 0x54, 0x61, 0x62, 0x6c,
	0x65, 0x12, 0x40, 0x0a, 0x0b, 0x6c, 0x6f, 0x63, 0x61, 0x6c, 0x5f, 0x66, 0x69, 0x6c, 0x65, 0x73,
	0x18, 0x06, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c,
	0x46, 0x69, 0x6c, 0x65, 0x73, 0x48, 0x00, 0x52, 0x0a, 0x6c, 0x6f, 0x63, 0x61, 0x6c, 0x46, 0x69,
	0x6c, 0x65, 0x73, 0x12, 0x40, 0x0a, 0x0b, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x5f, 0x74, 0x61, 0x62,
	0x6c, 0x65, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x4e, 0x61, 0x6d,
	0x65, 0x64, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x48, 0x00, 0x52, 0x0a, 0x6e, 0x61, 0x6d, 0x65, 0x64,
	0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x4c, 0x0a, 0x0f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x5f, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x21,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52,
	0x65, 0x6c, 0x2e, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x61, 0x62, 0x6c,
	0x65, 0x48, 0x00, 0x52, 0x0e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x61,
	0x62, 0x6c, 0x65, 0x12, 0x46, 0x0a, 0x0d, 0x69, 0x63, 0x65, 0x62, 0x65, 0x72, 0x67, 0x5f, 0x74,
	0x61, 0x62, 0x6c, 0x65, 0x18, 0x09, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1f, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x49,
	0x63, 0x65, 0x62, 0x65, 0x72, 0x67, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x48, 0x00, 0x52, 0x0c, 0x69,
	0x63, 0x65, 0x62, 0x65, 0x72, 0x67, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x1a, 0x7a, 0x0a, 0x0a, 0x4e,
	0x61, 0x6d, 0x65, 0x64, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x14, 0x0a, 0x05, 0x6e, 0x61, 0x6d,
	0x65, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x09, 0x52, 0x05, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x12,
	0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f,
	0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x80, 0x02, 0x0a, 0x0c, 0x49, 0x63, 0x65, 0x62,
	0x65, 0x72, 0x67, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x4a, 0x0a, 0x06, 0x64, 0x69, 0x72, 0x65,
	0x63, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x30, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x49, 0x63, 0x65,
	0x62, 0x65, 0x72, 0x67, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x2e, 0x4d, 0x65, 0x74, 0x61, 0x64, 0x61,
	0x74, 0x61, 0x46, 0x69, 0x6c, 0x65, 0x52, 0x65, 0x61, 0x64, 0x48, 0x00, 0x52, 0x06, 0x64, 0x69,
	0x72, 0x65, 0x63, 0x74, 0x1a, 0x95, 0x01, 0x0a, 0x10, 0x4d, 0x65, 0x74, 0x61, 0x64, 0x61, 0x74,
	0x61, 0x46, 0x69, 0x6c, 0x65, 0x52, 0x65, 0x61, 0x64, 0x12, 0x21, 0x0a, 0x0c, 0x6d, 0x65, 0x74,
	0x61, 0x64, 0x61, 0x74, 0x61, 0x5f, 0x75, 0x72, 0x69, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x0b, 0x6d, 0x65, 0x74, 0x61, 0x64, 0x61, 0x74, 0x61, 0x55, 0x72, 0x69, 0x12, 0x21, 0x0a, 0x0b,
	0x73, 0x6e, 0x61, 0x70, 0x73, 0x68, 0x6f, 0x74, 0x5f, 0x69, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x09, 0x48, 0x00, 0x52, 0x0a, 0x73, 0x6e, 0x61, 0x70, 0x73, 0x68, 0x6f, 0x74, 0x49, 0x64, 0x12,
	0x2f, 0x0a, 0x12, 0x73, 0x6e, 0x61, 0x70, 0x73, 0x68, 0x6f, 0x74, 0x5f, 0x74, 0x69, 0x6d, 0x65,
	0x73, 0x74, 0x61, 0x6d, 0x70, 0x18, 0x03, 0x20, 0x01, 0x28, 0x03, 0x48, 0x00, 0x52, 0x11, 0x73,
	0x6e, 0x61, 0x70, 0x73, 0x68, 0x6f, 0x74, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70,
	0x42, 0x0a, 0x0a, 0x08, 0x73, 0x6e, 0x61, 0x70, 0x73, 0x68, 0x6f, 0x74, 0x42, 0x0c, 0x0a, 0x0a,
	0x74, 0x61, 0x62, 0x6c, 0x65, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x1a, 0x97, 0x01, 0x0a, 0x0c, 0x56,
	0x69, 0x72, 0x74, 0x75, 0x61, 0x6c, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x40, 0x0a, 0x06, 0x76,
	0x61, 0x6c, 0x75, 0x65, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x53, 0x74, 0x72, 0x75, 0x63,
	0x74, 0x42, 0x02, 0x18, 0x01, 0x52, 0x06, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x73, 0x12, 0x45, 0x0a,
	0x0b, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x02, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x23, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64,
	0x2e, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x52, 0x0b, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x73, 0x1a, 0x3e, 0x0a, 0x0e, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f,
	0x6e, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x2c, 0x0a, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x52, 0x06, 0x64, 0x65,
	0x74, 0x61, 0x69, 0x6c, 0x1a, 0x90, 0x0a, 0x0a, 0x0a, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46, 0x69,
	0x6c, 0x65, 0x73, 0x12, 0x3f, 0x0a, 0x05, 0x69, 0x74, 0x65, 0x6d, 0x73, 0x18, 0x01, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x29, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52,
	0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46, 0x69, 0x6c, 0x65,
	0x73, 0x2e, 0x46, 0x69, 0x6c, 0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x52, 0x05, 0x69,
	0x74, 0x65, 0x6d, 0x73, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64,
	0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64,
	0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e,
	0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0xe8, 0x08, 0x0a,
	0x0b, 0x46, 0x69, 0x6c, 0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x12, 0x1b, 0x0a, 0x08,
	0x75, 0x72, 0x69, 0x5f, 0x70, 0x61, 0x74, 0x68, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x48, 0x00,
	0x52, 0x07, 0x75, 0x72, 0x69, 0x50, 0x61, 0x74, 0x68, 0x12, 0x24, 0x0a, 0x0d, 0x75, 0x72, 0x69,
	0x5f, 0x70, 0x61, 0x74, 0x68, 0x5f, 0x67, 0x6c, 0x6f, 0x62, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09,
	0x48, 0x00, 0x52, 0x0b, 0x75, 0x72, 0x69, 0x50, 0x61, 0x74, 0x68, 0x47, 0x6c, 0x6f, 0x62, 0x12,
	0x1b, 0x0a, 0x08, 0x75, 0x72, 0x69, 0x5f, 0x66, 0x69, 0x6c, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28,
	0x09, 0x48, 0x00, 0x52, 0x07, 0x75, 0x72, 0x69, 0x46, 0x69, 0x6c, 0x65, 0x12, 0x1f, 0x0a, 0x0a,
	0x75, 0x72, 0x69, 0x5f, 0x66, 0x6f, 0x6c, 0x64, 0x65, 0x72, 0x18, 0x04, 0x20, 0x01, 0x28, 0x09,
	0x48, 0x00, 0x52, 0x09, 0x75, 0x72, 0x69, 0x46, 0x6f, 0x6c, 0x64, 0x65, 0x72, 0x12, 0x27, 0x0a,
	0x0f, 0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x69, 0x6e, 0x64, 0x65, 0x78,
	0x18, 0x06, 0x20, 0x01, 0x28, 0x04, 0x52, 0x0e, 0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f,
	0x6e, 0x49, 0x6e, 0x64, 0x65, 0x78, 0x12, 0x14, 0x0a, 0x05, 0x73, 0x74, 0x61, 0x72, 0x74, 0x18,
	0x07, 0x20, 0x01, 0x28, 0x04, 0x52, 0x05, 0x73, 0x74, 0x61, 0x72, 0x74, 0x12, 0x16, 0x0a, 0x06,
	0x6c, 0x65, 0x6e, 0x67, 0x74, 0x68, 0x18, 0x08, 0x20, 0x01, 0x28, 0x04, 0x52, 0x06, 0x6c, 0x65,
	0x6e, 0x67, 0x74, 0x68, 0x12, 0x58, 0x0a, 0x07, 0x70, 0x61, 0x72, 0x71, 0x75, 0x65, 0x74, 0x18,
	0x09, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x3c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46,
	0x69, 0x6c, 0x65, 0x73, 0x2e, 0x46, 0x69, 0x6c, 0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73,
	0x2e, 0x50, 0x61, 0x72, 0x71, 0x75, 0x65, 0x74, 0x52, 0x65, 0x61, 0x64, 0x4f, 0x70, 0x74, 0x69,
	0x6f, 0x6e, 0x73, 0x48, 0x01, 0x52, 0x07, 0x70, 0x61, 0x72, 0x71, 0x75, 0x65, 0x74, 0x12, 0x52,
	0x0a, 0x05, 0x61, 0x72, 0x72, 0x6f, 0x77, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x3a, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65,
	0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x2e, 0x46, 0x69, 0x6c,
	0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x2e, 0x41, 0x72, 0x72, 0x6f, 0x77, 0x52, 0x65,
	0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x48, 0x01, 0x52, 0x05, 0x61, 0x72, 0x72,
	0x6f, 0x77, 0x12, 0x4c, 0x0a, 0x03, 0x6f, 0x72, 0x63, 0x18, 0x0b, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x38, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64,
	0x52, 0x65, 0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x2e, 0x46,
	0x69, 0x6c, 0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x2e, 0x4f, 0x72, 0x63, 0x52, 0x65,
	0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x48, 0x01, 0x52, 0x03, 0x6f, 0x72, 0x63,
	0x12, 0x34, 0x0a, 0x09, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0c, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f,
	0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x48, 0x01, 0x52, 0x09, 0x65, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x4f, 0x0a, 0x04, 0x64, 0x77, 0x72, 0x66, 0x18, 0x0d,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x39, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46, 0x69,
	0x6c, 0x65, 0x73, 0x2e, 0x46, 0x69, 0x6c, 0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73, 0x2e,
	0x44, 0x77, 0x72, 0x66, 0x52, 0x65, 0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x48,
	0x01, 0x52, 0x04, 0x64, 0x77, 0x72, 0x66, 0x12, 0x61, 0x0a, 0x04, 0x74, 0x65, 0x78, 0x74, 0x18,
	0x0e, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x4b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x4c, 0x6f, 0x63, 0x61, 0x6c, 0x46,
	0x69, 0x6c, 0x65, 0x73, 0x2e, 0x46, 0x69, 0x6c, 0x65, 0x4f, 0x72, 0x46, 0x69, 0x6c, 0x65, 0x73,
	0x2e, 0x44, 0x65, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x65, 0x72, 0x53, 0x65, 0x70, 0x61, 0x72, 0x61,
	0x74, 0x65, 0x64, 0x54, 0x65, 0x78, 0x74, 0x52, 0x65, 0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f,
	0x6e, 0x73, 0x48, 0x01, 0x52, 0x04, 0x74, 0x65, 0x78, 0x74, 0x1a, 0x14, 0x0a, 0x12, 0x50, 0x61,
	0x72, 0x71, 0x75, 0x65, 0x74, 0x52, 0x65, 0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73,
	0x1a, 0x12, 0x0a, 0x10, 0x41, 0x72, 0x72, 0x6f, 0x77, 0x52, 0x65, 0x61, 0x64, 0x4f, 0x70, 0x74,
	0x69, 0x6f, 0x6e, 0x73, 0x1a, 0x10, 0x0a, 0x0e, 0x4f, 0x72, 0x63, 0x52, 0x65, 0x61, 0x64, 0x4f,
	0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x1a, 0x11, 0x0a, 0x0f, 0x44, 0x77, 0x72, 0x66, 0x52, 0x65,
	0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x1a, 0xa1, 0x02, 0x0a, 0x21, 0x44, 0x65,
	0x6c, 0x69, 0x6d, 0x69, 0x74, 0x65, 0x72, 0x53, 0x65, 0x70, 0x61, 0x72, 0x61, 0x74, 0x65, 0x64,
	0x54, 0x65, 0x78, 0x74, 0x52, 0x65, 0x61, 0x64, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x12,
	0x27, 0x0a, 0x0f, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x5f, 0x64, 0x65, 0x6c, 0x69, 0x6d, 0x69, 0x74,
	0x65, 0x72, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0e, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x44,
	0x65, 0x6c, 0x69, 0x6d, 0x69, 0x74, 0x65, 0x72, 0x12, 0x22, 0x0a, 0x0d, 0x6d, 0x61, 0x78, 0x5f,
	0x6c, 0x69, 0x6e, 0x65, 0x5f, 0x73, 0x69, 0x7a, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x04, 0x52,
	0x0b, 0x6d, 0x61, 0x78, 0x4c, 0x69, 0x6e, 0x65, 0x53, 0x69, 0x7a, 0x65, 0x12, 0x14, 0x0a, 0x05,
	0x71, 0x75, 0x6f, 0x74, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05, 0x71, 0x75, 0x6f,
	0x74, 0x65, 0x12, 0x2f, 0x0a, 0x14, 0x68, 0x65, 0x61, 0x64, 0x65, 0x72, 0x5f, 0x6c, 0x69, 0x6e,
	0x65, 0x73, 0x5f, 0x74, 0x6f, 0x5f, 0x73, 0x6b, 0x69, 0x70, 0x18, 0x04, 0x20, 0x01, 0x28, 0x04,
	0x52, 0x11, 0x68, 0x65, 0x61, 0x64, 0x65, 0x72, 0x4c, 0x69, 0x6e, 0x65, 0x73, 0x54, 0x6f, 0x53,
	0x6b, 0x69, 0x70, 0x12, 0x16, 0x0a, 0x06, 0x65, 0x73, 0x63, 0x61, 0x70, 0x65, 0x18, 0x05, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x06, 0x65, 0x73, 0x63, 0x61, 0x70, 0x65, 0x12, 0x36, 0x0a, 0x15, 0x76,
	0x61, 0x6c, 0x75, 0x65, 0x5f, 0x74, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64, 0x5f, 0x61, 0x73, 0x5f,
	0x6e, 0x75, 0x6c, 0x6c, 0x18, 0x06, 0x20, 0x01, 0x28, 0x09, 0x48, 0x00, 0x52, 0x12, 0x76, 0x61,
	0x6c, 0x75, 0x65, 0x54, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64, 0x41, 0x73, 0x4e, 0x75, 0x6c, 0x6c,
	0x88, 0x01, 0x01, 0x42, 0x18, 0x0a, 0x16, 0x5f, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x5f, 0x74, 0x72,
	0x65, 0x61, 0x74, 0x65, 0x64, 0x5f, 0x61, 0x73, 0x5f, 0x6e, 0x75, 0x6c, 0x6c, 0x42, 0x0b, 0x0a,
	0x09, 0x70, 0x61, 0x74, 0x68, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x42, 0x0d, 0x0a, 0x0b, 0x66, 0x69,
	0x6c, 0x65, 0x5f, 0x66, 0x6f, 0x72, 0x6d, 0x61, 0x74, 0x4a, 0x04, 0x08, 0x05, 0x10, 0x06, 0x52,
	0x06, 0x66, 0x6f, 0x72, 0x6d, 0x61, 0x74, 0x42, 0x0b, 0x0a, 0x09, 0x72, 0x65, 0x61, 0x64, 0x5f,
	0x74, 0x79, 0x70, 0x65, 0x22, 0xf1, 0x01, 0x0a, 0x0a, 0x50, 0x72, 0x6f, 0x6a, 0x65, 0x63, 0x74,
	0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f,
	0x6e, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c,
	0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x37, 0x0a, 0x0b, 0x65, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x52, 0x0b, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x73,
	0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45,
	0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0xcd, 0x05, 0x0a, 0x07, 0x4a, 0x6f, 0x69,
	0x6e, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d,
	0x6f, 0x6e, 0x12, 0x22, 0x0a, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c,
	0x52, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x18,
	0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x12, 0x35, 0x0a, 0x0a,
	0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70,
	0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x12, 0x3f, 0x0a, 0x10, 0x70, 0x6f, 0x73, 0x74, 0x5f, 0x6a, 0x6f, 0x69, 0x6e,
	0x5f, 0x66, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0e, 0x70, 0x6f, 0x73, 0x74, 0x4a, 0x6f, 0x69, 0x6e, 0x46, 0x69,
	0x6c, 0x74, 0x65, 0x72, 0x12, 0x2f, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x06, 0x20, 0x01,
	0x28, 0x0e, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4a,
	0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x2e, 0x4a, 0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x52,
	0x04, 0x74, 0x79, 0x70, 0x65, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65,
	0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65,
	0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61,
	0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0xc8, 0x02,
	0x0a, 0x08, 0x4a, 0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x12, 0x19, 0x0a, 0x15, 0x4a, 0x4f,
	0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46,
	0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59,
	0x50, 0x45, 0x5f, 0x49, 0x4e, 0x4e, 0x45, 0x52, 0x10, 0x01, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f,
	0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4f, 0x55, 0x54, 0x45, 0x52, 0x10, 0x02, 0x12,
	0x12, 0x0a, 0x0e, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46,
	0x54, 0x10, 0x03, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45,
	0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x10, 0x04, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e,
	0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x53, 0x45, 0x4d, 0x49, 0x10,
	0x05, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c,
	0x45, 0x46, 0x54, 0x5f, 0x41, 0x4e, 0x54, 0x49, 0x10, 0x06, 0x12, 0x19, 0x0a, 0x15, 0x4a, 0x4f,
	0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x53, 0x49, 0x4e,
	0x47, 0x4c, 0x45, 0x10, 0x07, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59,
	0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x53, 0x45, 0x4d, 0x49, 0x10, 0x08, 0x12,
	0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47,
	0x48, 0x54, 0x5f, 0x41, 0x4e, 0x54, 0x49, 0x10, 0x09, 0x12, 0x1a, 0x0a, 0x16, 0x4a, 0x4f, 0x49,
	0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x53, 0x49, 0x4e,
	0x47, 0x4c, 0x45, 0x10, 0x0a, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59,
	0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x4d, 0x41, 0x52, 0x4b, 0x10, 0x0b, 0x12, 0x18,
	0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48,
	0x54, 0x5f, 0x4d, 0x41, 0x52, 0x4b, 0x10, 0x0c, 0x22, 0xda, 0x01, 0x0a, 0x08, 0x43, 0x72, 0x6f,
	0x73, 0x73, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d,
	0x6d, 0x6f, 0x6e, 0x12, 0x22, 0x0a, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65,
	0x6c, 0x52, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74,
	0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x12, 0x56, 0x0a,
	0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73,
	0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0xff, 0x02, 0x0a, 0x08, 0x46, 0x65, 0x74, 0x63, 0x68, 0x52,
	0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52,
	0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e,
	0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52,
	0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x1c, 0x0a, 0x06, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74,
	0x18, 0x03, 0x20, 0x01, 0x28, 0x03, 0x42, 0x02, 0x18, 0x01, 0x48, 0x00, 0x52, 0x06, 0x6f, 0x66,
	0x66, 0x73, 0x65, 0x74, 0x12, 0x38, 0x0a, 0x0b, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x5f, 0x65,
	0x78, 0x70, 0x72, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x48, 0x00, 0x52, 0x0a, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x45, 0x78, 0x70, 0x72, 0x12, 0x1a,
	0x0a, 0x05, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x18, 0x04, 0x20, 0x01, 0x28, 0x03, 0x42, 0x02, 0x18,
	0x01, 0x48, 0x01, 0x52, 0x05, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x36, 0x0a, 0x0a, 0x63, 0x6f,
	0x75, 0x6e, 0x74, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48, 0x01, 0x52, 0x09, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x45, 0x78,
	0x70, 0x72, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65,
	0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65,
	0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x42, 0x0d, 0x0a, 0x0b, 0x6f, 0x66,
	0x66, 0x73, 0x65, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0x42, 0x0c, 0x0a, 0x0a, 0x63, 0x6f, 0x75,
	0x6e, 0x74, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0x22, 0x83, 0x05, 0x0a, 0x0c, 0x41, 0x67, 0x67, 0x72,
	0x65, 0x67, 0x61, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d,
	0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06,
	0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x3e, 0x0a, 0x09,
	0x67, 0x72, 0x6f, 0x75, 0x70, 0x69, 0x6e, 0x67, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28, 0x0b, 0x32,
	0x20, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72,
	0x65, 0x67, 0x61, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x47, 0x72, 0x6f, 0x75, 0x70, 0x69, 0x6e,
	0x67, 0x52, 0x09, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x69, 0x6e, 0x67, 0x73, 0x12, 0x3b, 0x0a, 0x08,
	0x6d, 0x65, 0x61, 0x73, 0x75, 0x72, 0x65, 0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1f,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65,
	0x67, 0x61, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x4d, 0x65, 0x61, 0x73, 0x75, 0x72, 0x65, 0x52,
	0x08, 0x6d, 0x65, 0x61, 0x73, 0x75, 0x72, 0x65, 0x73, 0x12, 0x48, 0x0a, 0x14, 0x67, 0x72, 0x6f,
	0x75, 0x70, 0x69, 0x6e, 0x67, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x73, 0x18, 0x05, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x13,
	0x67, 0x72, 0x6f, 0x75, 0x70, 0x69, 0x6e, 0x67, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x73, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f,
	0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45,
	0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63,
	0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x8d, 0x01, 0x0a, 0x08,
	0x47, 0x72, 0x6f, 0x75, 0x70, 0x69, 0x6e, 0x67, 0x12, 0x4c, 0x0a, 0x14, 0x67, 0x72, 0x6f, 0x75,
	0x70, 0x69, 0x6e, 0x67, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x73,
	0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x42, 0x02, 0x18,
	0x01, 0x52, 0x13, 0x67, 0x72, 0x6f, 0x75, 0x70, 0x69, 0x6e, 0x67, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x12, 0x33, 0x0a, 0x15, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x73, 0x18,
	0x02, 0x20, 0x03, 0x28, 0x0d, 0x52, 0x14, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x73, 0x1a, 0x70, 0x0a, 0x07, 0x4d,
	0x65, 0x61, 0x73, 0x75, 0x72, 0x65, 0x12, 0x36, 0x0a, 0x07, 0x6d, 0x65, 0x61, 0x73, 0x75, 0x72,
	0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65, 0x46, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x07, 0x6d, 0x65, 0x61, 0x73, 0x75, 0x72, 0x65, 0x12, 0x2d,
	0x0a, 0x06, 0x66, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x06, 0x66, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x22, 0x82, 0x08,
	0x0a, 0x1c, 0x43, 0x6f, 0x6e, 0x73, 0x69, 0x73, 0x74, 0x65, 0x6e, 0x74, 0x50, 0x61, 0x72, 0x74,
	0x69, 0x74, 0x69, 0x6f, 0x6e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x52, 0x65, 0x6c, 0x12, 0x2c,
	0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f,
	0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05,
	0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70,
	0x75, 0x74, 0x12, 0x64, 0x0a, 0x10, 0x77, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x5f, 0x66, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x39, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x43, 0x6f, 0x6e, 0x73, 0x69, 0x73, 0x74,
	0x65, 0x6e, 0x74, 0x50, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x57, 0x69, 0x6e, 0x64,
	0x6f, 0x77, 0x52, 0x65, 0x6c, 0x2e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x52, 0x65, 0x6c, 0x46,
	0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x0f, 0x77, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46,
	0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x12, 0x4a, 0x0a, 0x15, 0x70, 0x61, 0x72, 0x74,
	0x69, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x14,
	0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x73, 0x12, 0x2a, 0x0a, 0x05, 0x73, 0x6f, 0x72, 0x74, 0x73, 0x18, 0x05, 0x20,
	0x03, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x53, 0x6f, 0x72, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x05, 0x73, 0x6f, 0x72, 0x74, 0x73,
	0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45,
	0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x1a, 0xd7, 0x04, 0x0a, 0x11, 0x57, 0x69, 0x6e,
	0x64, 0x6f, 0x77, 0x52, 0x65, 0x6c, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x2d,
	0x0a, 0x12, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72,
	0x65, 0x6e, 0x63, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x11, 0x66, 0x75, 0x6e, 0x63,
	0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x39, 0x0a,
	0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x18, 0x09, 0x20, 0x03, 0x28, 0x0b,
	0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x46, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x41, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x52, 0x09, 0x61,
	0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x12, 0x33, 0x0a, 0x07, 0x6f, 0x70, 0x74, 0x69,
	0x6f, 0x6e, 0x73, 0x18, 0x0b, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x19, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4f, 0x70,
	0x74, 0x69, 0x6f, 0x6e, 0x52, 0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x12, 0x30, 0x0a,
	0x0b, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x18, 0x07, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54,
	0x79, 0x70, 0x65, 0x52, 0x0a, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x54, 0x79, 0x70, 0x65, 0x12,
	0x31, 0x0a, 0x05, 0x70, 0x68, 0x61, 0x73, 0x65, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x1b,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65,
	0x67, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x50, 0x68, 0x61, 0x73, 0x65, 0x52, 0x05, 0x70, 0x68, 0x61,
	0x73, 0x65, 0x12, 0x52, 0x0a, 0x0a, 0x69, 0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e,
	0x18, 0x0a, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x32, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65, 0x46, 0x75, 0x6e, 0x63,
	0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x69, 0x6f, 0x6e,
	0x49, 0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x69, 0x6e, 0x76, 0x6f,
	0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x4b, 0x0a, 0x0b, 0x6c, 0x6f, 0x77, 0x65, 0x72, 0x5f,
	0x62, 0x6f, 0x75, 0x6e, 0x64, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x2e, 0x42, 0x6f, 0x75, 0x6e, 0x64, 0x52, 0x0a, 0x6c, 0x6f, 0x77, 0x65, 0x72, 0x42, 0x6f,
	0x75, 0x6e, 0x64, 0x12, 0x4b, 0x0a, 0x0b, 0x75, 0x70, 0x70, 0x65, 0x72, 0x5f, 0x62, 0x6f, 0x75,
	0x6e, 0x64, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e,
	0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42,
	0x6f, 0x75, 0x6e, 0x64, 0x52, 0x0a, 0x75, 0x70, 0x70, 0x65, 0x72, 0x42, 0x6f, 0x75, 0x6e, 0x64,
	0x12, 0x50, 0x0a, 0x0b, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x73, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x18,
	0x0c, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x2f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x57, 0x69, 0x6e,
	0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42, 0x6f, 0x75, 0x6e,
	0x64, 0x73, 0x54, 0x79, 0x70, 0x65, 0x52, 0x0a, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x73, 0x54, 0x79,
	0x70, 0x65, 0x22, 0xe1, 0x01, 0x0a, 0x07, 0x53, 0x6f, 0x72, 0x74, 0x52, 0x65, 0x6c, 0x12, 0x2c,
	0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f,
	0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05,
	0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70,
	0x75, 0x74, 0x12, 0x2a, 0x0a, 0x05, 0x73, 0x6f, 0x72, 0x74, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28,
	0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x53, 0x6f,
	0x72, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x05, 0x73, 0x6f, 0x72, 0x74, 0x73, 0x12, 0x56,
	0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74,
	0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0xec, 0x01, 0x0a, 0x09, 0x46, 0x69, 0x6c, 0x74, 0x65,
	0x72, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d,
	0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65,
	0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x33, 0x0a, 0x09, 0x63, 0x6f, 0x6e, 0x64,
	0x69, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x52, 0x09, 0x63, 0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x56, 0x0a,
	0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73,
	0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0xee, 0x03, 0x0a, 0x06, 0x53, 0x65, 0x74, 0x52, 0x65, 0x6c,
	0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c,
	0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x26,
	0x0a, 0x06, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x73, 0x18, 0x02, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x0e,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x06,
	0x69, 0x6e, 0x70, 0x75, 0x74, 0x73, 0x12, 0x27, 0x0a, 0x02, 0x6f, 0x70, 0x18, 0x03, 0x20, 0x01,
	0x28, 0x0e, 0x32, 0x17, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x53,
	0x65, 0x74, 0x52, 0x65, 0x6c, 0x2e, 0x53, 0x65, 0x74, 0x4f, 0x70, 0x52, 0x02, 0x6f, 0x70, 0x12,
	0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f,
	0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0x8c, 0x02, 0x0a, 0x05, 0x53, 0x65, 0x74, 0x4f,
	0x70, 0x12, 0x16, 0x0a, 0x12, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x4e, 0x53, 0x50,
	0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x18, 0x0a, 0x14, 0x53, 0x45, 0x54,
	0x5f, 0x4f, 0x50, 0x5f, 0x4d, 0x49, 0x4e, 0x55, 0x53, 0x5f, 0x50, 0x52, 0x49, 0x4d, 0x41, 0x52,
	0x59, 0x10, 0x01, 0x12, 0x1c, 0x0a, 0x18, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x4d, 0x49,
	0x4e, 0x55, 0x53, 0x5f, 0x50, 0x52, 0x49, 0x4d, 0x41, 0x52, 0x59, 0x5f, 0x41, 0x4c, 0x4c, 0x10,
	0x07, 0x12, 0x19, 0x0a, 0x15, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x4d, 0x49, 0x4e, 0x55,
	0x53, 0x5f, 0x4d, 0x55, 0x4c, 0x54, 0x49, 0x53, 0x45, 0x54, 0x10, 0x02, 0x12, 0x1f, 0x0a, 0x1b,
	0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x49, 0x4e, 0x54, 0x45, 0x52, 0x53, 0x45, 0x43, 0x54,
	0x49, 0x4f, 0x4e, 0x5f, 0x50, 0x52, 0x49, 0x4d, 0x41, 0x52, 0x59, 0x10, 0x03, 0x12, 0x20, 0x0a,
	0x1c, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x49, 0x4e, 0x54, 0x45, 0x52, 0x53, 0x45, 0x43,
	0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x4d, 0x55, 0x4c, 0x54, 0x49, 0x53, 0x45, 0x54, 0x10, 0x04, 0x12,
	0x24, 0x0a, 0x20, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x49, 0x4e, 0x54, 0x45, 0x52, 0x53,
	0x45, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x4d, 0x55, 0x4c, 0x54, 0x49, 0x53, 0x45, 0x54, 0x5f,
	0x41, 0x4c, 0x4c, 0x10, 0x08, 0x12, 0x19, 0x0a, 0x15, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f,
	0x55, 0x4e, 0x49, 0x4f, 0x4e, 0x5f, 0x44, 0x49, 0x53, 0x54, 0x49, 0x4e, 0x43, 0x54, 0x10, 0x05,
	0x12, 0x14, 0x0a, 0x10, 0x53, 0x45, 0x54, 0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x4e, 0x49, 0x4f, 0x4e,
	0x5f, 0x41, 0x4c, 0x4c, 0x10, 0x06, 0x22, 0x96, 0x01, 0x0a, 0x12, 0x45, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x53, 0x69, 0x6e, 0x67, 0x6c, 0x65, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a,
	0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d,
	0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05, 0x69,
	0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75,
	0x74, 0x12, 0x2c, 0x0a, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x18, 0x03, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x52, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x22,
	0x6e, 0x0a, 0x10, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x4c, 0x65, 0x61, 0x66,
	0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f,
	0x6e, 0x12, 0x2c, 0x0a, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x52, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x22,
	0x97, 0x01, 0x0a, 0x11, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x4d, 0x75, 0x6c,
	0x74, 0x69, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d,
	0x6d, 0x6f, 0x6e, 0x12, 0x26, 0x0a, 0x06, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x73, 0x18, 0x02, 0x20,
	0x03, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x52, 0x06, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x73, 0x12, 0x2c, 0x0a, 0x06, 0x64,
	0x65, 0x74, 0x61, 0x69, 0x6c, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f,
	0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e,
	0x79, 0x52, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x22, 0x9a, 0x09, 0x0a, 0x0b, 0x45, 0x78,
	0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d,
	0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52,
	0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x27, 0x0a,
	0x0f, 0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74,
	0x18, 0x03, 0x20, 0x01, 0x28, 0x05, 0x52, 0x0e, 0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f,
	0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x3f, 0x0a, 0x07, 0x74, 0x61, 0x72, 0x67, 0x65, 0x74,
	0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x25, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x65, 0x6c, 0x2e,
	0x45, 0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x54, 0x61, 0x72, 0x67, 0x65, 0x74, 0x52, 0x07,
	0x74, 0x61, 0x72, 0x67, 0x65, 0x74, 0x73, 0x12, 0x52, 0x0a, 0x11, 0x73, 0x63, 0x61, 0x74, 0x74,
	0x65, 0x72, 0x5f, 0x62, 0x79, 0x5f, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x18, 0x05, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x53, 0x63, 0x61, 0x74, 0x74,
	0x65, 0x72, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x48, 0x00, 0x52, 0x0f, 0x73, 0x63, 0x61, 0x74,
	0x74, 0x65, 0x72, 0x42, 0x79, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x12, 0x54, 0x0a, 0x0d, 0x73,
	0x69, 0x6e, 0x67, 0x6c, 0x65, 0x5f, 0x74, 0x61, 0x72, 0x67, 0x65, 0x74, 0x18, 0x06, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x2d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x53, 0x69, 0x6e, 0x67, 0x6c,
	0x65, 0x42, 0x75, 0x63, 0x6b, 0x65, 0x74, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x48, 0x00, 0x52, 0x0c, 0x73, 0x69, 0x6e, 0x67, 0x6c, 0x65, 0x54, 0x61, 0x72, 0x67, 0x65,
	0x74, 0x12, 0x51, 0x0a, 0x0c, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x5f, 0x74, 0x61, 0x72, 0x67, 0x65,
	0x74, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x65, 0x6c, 0x2e,
	0x4d, 0x75, 0x6c, 0x74, 0x69, 0x42, 0x75, 0x63, 0x6b, 0x65, 0x74, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x0b, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x54, 0x61,
	0x72, 0x67, 0x65, 0x74, 0x12, 0x44, 0x0a, 0x0b, 0x72, 0x6f, 0x75, 0x6e, 0x64, 0x5f, 0x72, 0x6f,
	0x62, 0x69, 0x6e, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x21, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x52, 0x65,
	0x6c, 0x2e, 0x52, 0x6f, 0x75, 0x6e, 0x64, 0x52, 0x6f, 0x62, 0x69, 0x6e, 0x48, 0x00, 0x52, 0x0a,
	0x72, 0x6f, 0x75, 0x6e, 0x64, 0x52, 0x6f, 0x62, 0x69, 0x6e, 0x12, 0x40, 0x0a, 0x09, 0x62, 0x72,
	0x6f, 0x61, 0x64, 0x63, 0x61, 0x73, 0x74, 0x18, 0x09, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x20, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x63, 0x68, 0x61, 0x6e,
	0x67, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x42, 0x72, 0x6f, 0x61, 0x64, 0x63, 0x61, 0x73, 0x74, 0x48,
	0x00, 0x52, 0x09, 0x62, 0x72, 0x6f, 0x61, 0x64, 0x63, 0x61, 0x73, 0x74, 0x12, 0x56, 0x0a, 0x12,
	0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e,
	0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x4d, 0x0a, 0x0d, 0x53, 0x63, 0x61, 0x74, 0x74, 0x65, 0x72, 0x46,
	0x69, 0x65, 0x6c, 0x64, 0x73, 0x12, 0x3c, 0x0a, 0x06, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x18,
	0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65,
	0x6c, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x52, 0x06, 0x66, 0x69, 0x65,
	0x6c, 0x64, 0x73, 0x1a, 0x4f, 0x0a, 0x16, 0x53, 0x69, 0x6e, 0x67, 0x6c, 0x65, 0x42, 0x75, 0x63,
	0x6b, 0x65, 0x74, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x35, 0x0a,
	0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x1a, 0x80, 0x01, 0x0a, 0x15, 0x4d, 0x75, 0x6c, 0x74, 0x69, 0x42, 0x75,
	0x63, 0x6b, 0x65, 0x74, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x35,
	0x0a, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x30, 0x0a, 0x14, 0x63, 0x6f, 0x6e, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x6e, 0x65, 0x64, 0x5f, 0x74, 0x6f, 0x5f, 0x63, 0x6f, 0x75, 0x6e, 0x74, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x08, 0x52, 0x12, 0x63, 0x6f, 0x6e, 0x73, 0x74, 0x72, 0x61, 0x69, 0x6e, 0x65, 0x64,
	0x54, 0x6f, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x1a, 0x0b, 0x0a, 0x09, 0x42, 0x72, 0x6f, 0x61, 0x64,
	0x63, 0x61, 0x73, 0x74, 0x1a, 0x22, 0x0a, 0x0a, 0x52, 0x6f, 0x75, 0x6e, 0x64, 0x52, 0x6f, 0x62,
	0x69, 0x6e, 0x12, 0x14, 0x0a, 0x05, 0x65, 0x78, 0x61, 0x63, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28,
	0x08, 0x52, 0x05, 0x65, 0x78, 0x61, 0x63, 0x74, 0x1a, 0x8a, 0x01, 0x0a, 0x0e, 0x45, 0x78, 0x63,
	0x68, 0x61, 0x6e, 0x67, 0x65, 0x54, 0x61, 0x72, 0x67, 0x65, 0x74, 0x12, 0x21, 0x0a, 0x0c, 0x70,
	0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x03, 0x28,
	0x05, 0x52, 0x0b, 0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x49, 0x64, 0x12, 0x12,
	0x0a, 0x03, 0x75, 0x72, 0x69, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x48, 0x00, 0x52, 0x03, 0x75,
	0x72, 0x69, 0x12, 0x32, 0x0a, 0x08, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x64, 0x65, 0x64, 0x18, 0x03,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72,
	0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x48, 0x00, 0x52, 0x08, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x64, 0x65, 0x64, 0x42, 0x0d, 0x0a, 0x0b, 0x74, 0x61, 0x72, 0x67, 0x65, 0x74,
	0x5f, 0x74, 0x79, 0x70, 0x65, 0x42, 0x0f, 0x0a, 0x0d, 0x65, 0x78, 0x63, 0x68, 0x61, 0x6e, 0x67,
	0x65, 0x5f, 0x6b, 0x69, 0x6e, 0x64, 0x22, 0x94, 0x03, 0x0a, 0x09, 0x45, 0x78, 0x70, 0x61, 0x6e,
	0x64, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d,
	0x6f, 0x6e, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65,
	0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x38, 0x0a, 0x06, 0x66, 0x69, 0x65, 0x6c,
	0x64, 0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x20, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x61, 0x6e, 0x64, 0x52, 0x65, 0x6c, 0x2e, 0x45,
	0x78, 0x70, 0x61, 0x6e, 0x64, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x06, 0x66, 0x69, 0x65, 0x6c,
	0x64, 0x73, 0x1a, 0xaf, 0x01, 0x0a, 0x0b, 0x45, 0x78, 0x70, 0x61, 0x6e, 0x64, 0x46, 0x69, 0x65,
	0x6c, 0x64, 0x12, 0x4e, 0x0a, 0x0f, 0x73, 0x77, 0x69, 0x74, 0x63, 0x68, 0x69, 0x6e, 0x67, 0x5f,
	0x66, 0x69, 0x65, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x23, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x61, 0x6e, 0x64, 0x52, 0x65,
	0x6c, 0x2e, 0x53, 0x77, 0x69, 0x74, 0x63, 0x68, 0x69, 0x6e, 0x67, 0x46, 0x69, 0x65, 0x6c, 0x64,
	0x48, 0x00, 0x52, 0x0e, 0x73, 0x77, 0x69, 0x74, 0x63, 0x68, 0x69, 0x6e, 0x67, 0x46, 0x69, 0x65,
	0x6c, 0x64, 0x12, 0x42, 0x0a, 0x10, 0x63, 0x6f, 0x6e, 0x73, 0x69, 0x73, 0x74, 0x65, 0x6e, 0x74,
	0x5f, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x0f, 0x63, 0x6f, 0x6e, 0x73, 0x69, 0x73, 0x74, 0x65, 0x6e,
	0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x42, 0x0c, 0x0a, 0x0a, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x5f,
	0x74, 0x79, 0x70, 0x65, 0x1a, 0x47, 0x0a, 0x0e, 0x53, 0x77, 0x69, 0x74, 0x63, 0x68, 0x69, 0x6e,
	0x67, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x12, 0x35, 0x0a, 0x0a, 0x64, 0x75, 0x70, 0x6c, 0x69, 0x63,
	0x61, 0x74, 0x65, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x0a, 0x64, 0x75, 0x70, 0x6c, 0x69, 0x63, 0x61, 0x74, 0x65, 0x73, 0x22, 0x45, 0x0a,
	0x07, 0x52, 0x65, 0x6c, 0x52, 0x6f, 0x6f, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75,
	0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x14,
	0x0a, 0x05, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x18, 0x02, 0x20, 0x03, 0x28, 0x09, 0x52, 0x05, 0x6e,
	0x61, 0x6d, 0x65, 0x73, 0x22, 0xa8, 0x09, 0x0a, 0x03, 0x52, 0x65, 0x6c, 0x12, 0x28, 0x0a, 0x04,
	0x72, 0x65, 0x61, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x12, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x61, 0x64, 0x52, 0x65, 0x6c, 0x48, 0x00,
	0x52, 0x04, 0x72, 0x65, 0x61, 0x64, 0x12, 0x2e, 0x0a, 0x06, 0x66, 0x69, 0x6c, 0x74, 0x65, 0x72,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x46, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x06,
	0x66, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x12, 0x2b, 0x0a, 0x05, 0x66, 0x65, 0x74, 0x63, 0x68, 0x18,
	0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x13, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x46, 0x65, 0x74, 0x63, 0x68, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x05, 0x66, 0x65,
	0x74, 0x63, 0x68, 0x12, 0x37, 0x0a, 0x09, 0x61, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65,
	0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x17, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x48,
	0x00, 0x52, 0x09, 0x61, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65, 0x12, 0x28, 0x0a, 0x04,
	0x73, 0x6f, 0x72, 0x74, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x12, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x53, 0x6f, 0x72, 0x74, 0x52, 0x65, 0x6c, 0x48, 0x00,
	0x52, 0x04, 0x73, 0x6f, 0x72, 0x74, 0x12, 0x28, 0x0a, 0x04, 0x6a, 0x6f, 0x69, 0x6e, 0x18, 0x06,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x12, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x04, 0x6a, 0x6f, 0x69, 0x6e,
	0x12, 0x31, 0x0a, 0x07, 0x70, 0x72, 0x6f, 0x6a, 0x65, 0x63, 0x74, 0x18, 0x07, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x50, 0x72,
	0x6f, 0x6a, 0x65, 0x63, 0x74, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x07, 0x70, 0x72, 0x6f, 0x6a,
	0x65, 0x63, 0x74, 0x12, 0x25, 0x0a, 0x03, 0x73, 0x65, 0x74, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x11, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x53, 0x65, 0x74,
	0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x03, 0x73, 0x65, 0x74, 0x12, 0x4a, 0x0a, 0x10, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x5f, 0x73, 0x69, 0x6e, 0x67, 0x6c, 0x65, 0x18, 0x09,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x53, 0x69, 0x6e, 0x67, 0x6c, 0x65,
	0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x0f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x53, 0x69, 0x6e, 0x67, 0x6c, 0x65, 0x12, 0x47, 0x0a, 0x0f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x5f, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x1c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x74, 0x65,
	0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x4d, 0x75, 0x6c, 0x74, 0x69, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52,
	0x0e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x4d, 0x75, 0x6c, 0x74, 0x69, 0x12,
	0x44, 0x0a, 0x0e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x5f, 0x6c, 0x65, 0x61,
	0x66, 0x18, 0x0b, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x4c, 0x65, 0x61,
	0x66, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x0d, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f,
	0x6e, 0x4c, 0x65, 0x61, 0x66, 0x12, 0x2b, 0x0a, 0x05, 0x63, 0x72, 0x6f, 0x73, 0x73, 0x18, 0x0c,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x13, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x43, 0x72, 0x6f, 0x73, 0x73, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x05, 0x63, 0x72, 0x6f,
	0x73, 0x73, 0x12, 0x37, 0x0a, 0x09, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18,
	0x15, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x17, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x52, 0x65, 0x6c, 0x48, 0x00,
	0x52, 0x09, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x2b, 0x0a, 0x05, 0x77,
	0x72, 0x69, 0x74, 0x65, 0x18, 0x13, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x13, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x57, 0x72, 0x69, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x48,
	0x00, 0x52, 0x05, 0x77, 0x72, 0x69, 0x74, 0x65, 0x12, 0x25, 0x0a, 0x03, 0x64, 0x64, 0x6c, 0x18,
	0x14, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x11, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x44, 0x64, 0x6c, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x03, 0x64, 0x64, 0x6c, 0x12,
	0x2e, 0x0a, 0x06, 0x75, 0x70, 0x64, 0x61, 0x74, 0x65, 0x18, 0x16, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x55, 0x70, 0x64, 0x61,
	0x74, 0x65, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x06, 0x75, 0x70, 0x64, 0x61, 0x74, 0x65, 0x12,
	0x35, 0x0a, 0x09, 0x68, 0x61, 0x73, 0x68, 0x5f, 0x6a, 0x6f, 0x69, 0x6e, 0x18, 0x0d, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x16, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x48,
	0x61, 0x73, 0x68, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x08, 0x68, 0x61,
	0x73, 0x68, 0x4a, 0x6f, 0x69, 0x6e, 0x12, 0x38, 0x0a, 0x0a, 0x6d, 0x65, 0x72, 0x67, 0x65, 0x5f,
	0x6a, 0x6f, 0x69, 0x6e, 0x18, 0x0e, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x17, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4d, 0x65, 0x72, 0x67, 0x65, 0x4a, 0x6f, 0x69, 0x6e,
	0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x09, 0x6d, 0x65, 0x72, 0x67, 0x65, 0x4a, 0x6f, 0x69, 0x6e,
	0x12, 0x48, 0x0a, 0x10, 0x6e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x5f, 0x6c, 0x6f, 0x6f, 0x70, 0x5f,
	0x6a, 0x6f, 0x69, 0x6e, 0x18, 0x12, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1c, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x4c, 0x6f, 0x6f,
	0x70, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x0e, 0x6e, 0x65, 0x73, 0x74,
	0x65, 0x64, 0x4c, 0x6f, 0x6f, 0x70, 0x4a, 0x6f, 0x69, 0x6e, 0x12, 0x41, 0x0a, 0x06, 0x77, 0x69,
	0x6e, 0x64, 0x6f, 0x77, 0x18, 0x11, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x43, 0x6f, 0x6e, 0x73, 0x69, 0x73, 0x74, 0x65, 0x6e,
	0x74, 0x50, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77,
	0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x06, 0x77, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x12, 0x34, 0x0a,
	0x08, 0x65, 0x78, 0x63, 0x68, 0x61, 0x6e, 0x67, 0x65, 0x18, 0x0f, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x16, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x63, 0x68,
	0x61, 0x6e, 0x67, 0x65, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x08, 0x65, 0x78, 0x63, 0x68, 0x61,
	0x6e, 0x67, 0x65, 0x12, 0x2e, 0x0a, 0x06, 0x65, 0x78, 0x70, 0x61, 0x6e, 0x64, 0x18, 0x10, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x61, 0x6e, 0x64, 0x52, 0x65, 0x6c, 0x48, 0x00, 0x52, 0x06, 0x65, 0x78, 0x70,
	0x61, 0x6e, 0x64, 0x42, 0x0a, 0x0a, 0x08, 0x72, 0x65, 0x6c, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x22,
	0x80, 0x01, 0x0a, 0x10, 0x4e, 0x61, 0x6d, 0x65, 0x64, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x57,
	0x72, 0x69, 0x74, 0x65, 0x12, 0x14, 0x0a, 0x05, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x18, 0x01, 0x20,
	0x03, 0x28, 0x09, 0x52, 0x05, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64,
	0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64,
	0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52,
	0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x22, 0x3f, 0x0a, 0x0f, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x4f,
	0x62, 0x6a, 0x65, 0x63, 0x74, 0x12, 0x2c, 0x0a, 0x06, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70,
	0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x52, 0x06, 0x64, 0x65, 0x74,
	0x61, 0x69, 0x6c, 0x22, 0xd2, 0x05, 0x0a, 0x06, 0x44, 0x64, 0x6c, 0x52, 0x65, 0x6c, 0x12, 0x40,
	0x0a, 0x0c, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x5f, 0x6f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x4e, 0x61, 0x6d, 0x65, 0x64, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x57, 0x72, 0x69, 0x74,
	0x65, 0x48, 0x00, 0x52, 0x0b, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74,
	0x12, 0x47, 0x0a, 0x10, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x5f, 0x6f, 0x62,
	0x6a, 0x65, 0x63, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x48, 0x00, 0x52, 0x0f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73,
	0x69, 0x6f, 0x6e, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x12, 0x39, 0x0a, 0x0c, 0x74, 0x61, 0x62,
	0x6c, 0x65, 0x5f, 0x73, 0x63, 0x68, 0x65, 0x6d, 0x61, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x16, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4e, 0x61, 0x6d, 0x65,
	0x64, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x52, 0x0b, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x53, 0x63,
	0x68, 0x65, 0x6d, 0x61, 0x12, 0x4b, 0x0a, 0x0e, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x5f, 0x64, 0x65,
	0x66, 0x61, 0x75, 0x6c, 0x74, 0x73, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x53, 0x74, 0x72, 0x75,
	0x63, 0x74, 0x52, 0x0d, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x44, 0x65, 0x66, 0x61, 0x75, 0x6c, 0x74,
	0x73, 0x12, 0x33, 0x0a, 0x06, 0x6f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x18, 0x05, 0x20, 0x01, 0x28,
	0x0e, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x44, 0x64,
	0x6c, 0x52, 0x65, 0x6c, 0x2e, 0x44, 0x64, 0x6c, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x52, 0x06,
	0x6f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x12, 0x27, 0x0a, 0x02, 0x6f, 0x70, 0x18, 0x06, 0x20, 0x01,
	0x28, 0x0e, 0x32, 0x17, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x44,
	0x64, 0x6c, 0x52, 0x65, 0x6c, 0x2e, 0x44, 0x64, 0x6c, 0x4f, 0x70, 0x52, 0x02, 0x6f, 0x70, 0x12,
	0x37, 0x0a, 0x0f, 0x76, 0x69, 0x65, 0x77, 0x5f, 0x64, 0x65, 0x66, 0x69, 0x6e, 0x69, 0x74, 0x69,
	0x6f, 0x6e, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x0e, 0x76, 0x69, 0x65, 0x77, 0x44, 0x65,
	0x66, 0x69, 0x6e, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d,
	0x6f, 0x6e, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06,
	0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x22, 0x52, 0x0a, 0x09, 0x44, 0x64, 0x6c, 0x4f, 0x62, 0x6a,
	0x65, 0x63, 0x74, 0x12, 0x1a, 0x0a, 0x16, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x42, 0x4a, 0x45, 0x43,
	0x54, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12,
	0x14, 0x0a, 0x10, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x42, 0x4a, 0x45, 0x43, 0x54, 0x5f, 0x54, 0x41,
	0x42, 0x4c, 0x45, 0x10, 0x01, 0x12, 0x13, 0x0a, 0x0f, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x42, 0x4a,
	0x45, 0x43, 0x54, 0x5f, 0x56, 0x49, 0x45, 0x57, 0x10, 0x02, 0x22, 0x8d, 0x01, 0x0a, 0x05, 0x44,
	0x64, 0x6c, 0x4f, 0x70, 0x12, 0x16, 0x0a, 0x12, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x50, 0x5f, 0x55,
	0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x11, 0x0a, 0x0d,
	0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x50, 0x5f, 0x43, 0x52, 0x45, 0x41, 0x54, 0x45, 0x10, 0x01, 0x12,
	0x1c, 0x0a, 0x18, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x50, 0x5f, 0x43, 0x52, 0x45, 0x41, 0x54, 0x45,
	0x5f, 0x4f, 0x52, 0x5f, 0x52, 0x45, 0x50, 0x4c, 0x41, 0x43, 0x45, 0x10, 0x02, 0x12, 0x10, 0x0a,
	0x0c, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x50, 0x5f, 0x41, 0x4c, 0x54, 0x45, 0x52, 0x10, 0x03, 0x12,
	0x0f, 0x0a, 0x0b, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x50, 0x5f, 0x44, 0x52, 0x4f, 0x50, 0x10, 0x04,
	0x12, 0x18, 0x0a, 0x14, 0x44, 0x44, 0x4c, 0x5f, 0x4f, 0x50, 0x5f, 0x44, 0x52, 0x4f, 0x50, 0x5f,
	0x49, 0x46, 0x5f, 0x45, 0x58, 0x49, 0x53, 0x54, 0x10, 0x05, 0x42, 0x0c, 0x0a, 0x0a, 0x77, 0x72,
	0x69, 0x74, 0x65, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x22, 0xe7, 0x06, 0x0a, 0x08, 0x57, 0x72, 0x69,
	0x74, 0x65, 0x52, 0x65, 0x6c, 0x12, 0x3e, 0x0a, 0x0b, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x5f, 0x74,
	0x61, 0x62, 0x6c, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4e, 0x61, 0x6d, 0x65, 0x64, 0x4f, 0x62, 0x6a, 0x65,
	0x63, 0x74, 0x57, 0x72, 0x69, 0x74, 0x65, 0x48, 0x00, 0x52, 0x0a, 0x6e, 0x61, 0x6d, 0x65, 0x64,
	0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x45, 0x0a, 0x0f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x5f, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x48, 0x00, 0x52, 0x0e, 0x65, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x39, 0x0a, 0x0c,
	0x74, 0x61, 0x62, 0x6c, 0x65, 0x5f, 0x73, 0x63, 0x68, 0x65, 0x6d, 0x61, 0x18, 0x03, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x16, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4e,
	0x61, 0x6d, 0x65, 0x64, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x52, 0x0b, 0x74, 0x61, 0x62, 0x6c,
	0x65, 0x53, 0x63, 0x68, 0x65, 0x6d, 0x61, 0x12, 0x2b, 0x0a, 0x02, 0x6f, 0x70, 0x18, 0x04, 0x20,
	0x01, 0x28, 0x0e, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x57, 0x72, 0x69, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x57, 0x72, 0x69, 0x74, 0x65, 0x4f, 0x70,
	0x52, 0x02, 0x6f, 0x70, 0x12, 0x24, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x05, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12, 0x3f, 0x0a, 0x0b, 0x63, 0x72,
	0x65, 0x61, 0x74, 0x65, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0e, 0x32,
	0x1e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x57, 0x72, 0x69, 0x74,
	0x65, 0x52, 0x65, 0x6c, 0x2e, 0x43, 0x72, 0x65, 0x61, 0x74, 0x65, 0x4d, 0x6f, 0x64, 0x65, 0x52,
	0x0a, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x4d, 0x6f, 0x64, 0x65, 0x12, 0x36, 0x0a, 0x06, 0x6f,
	0x75, 0x74, 0x70, 0x75, 0x74, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x1e, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x57, 0x72, 0x69, 0x74, 0x65, 0x52, 0x65, 0x6c,
	0x2e, 0x4f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x4d, 0x6f, 0x64, 0x65, 0x52, 0x06, 0x6f, 0x75, 0x74,
	0x70, 0x75, 0x74, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x07, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f,
	0x6e, 0x22, 0x75, 0x0a, 0x07, 0x57, 0x72, 0x69, 0x74, 0x65, 0x4f, 0x70, 0x12, 0x18, 0x0a, 0x14,
	0x57, 0x52, 0x49, 0x54, 0x45, 0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49,
	0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x13, 0x0a, 0x0f, 0x57, 0x52, 0x49, 0x54, 0x45, 0x5f,
	0x4f, 0x50, 0x5f, 0x49, 0x4e, 0x53, 0x45, 0x52, 0x54, 0x10, 0x01, 0x12, 0x13, 0x0a, 0x0f, 0x57,
	0x52, 0x49, 0x54, 0x45, 0x5f, 0x4f, 0x50, 0x5f, 0x44, 0x45, 0x4c, 0x45, 0x54, 0x45, 0x10, 0x02,
	0x12, 0x13, 0x0a, 0x0f, 0x57, 0x52, 0x49, 0x54, 0x45, 0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x50, 0x44,
	0x41, 0x54, 0x45, 0x10, 0x03, 0x12, 0x11, 0x0a, 0x0d, 0x57, 0x52, 0x49, 0x54, 0x45, 0x5f, 0x4f,
	0x50, 0x5f, 0x43, 0x54, 0x41, 0x53, 0x10, 0x04, 0x22, 0xb1, 0x01, 0x0a, 0x0a, 0x43, 0x72, 0x65,
	0x61, 0x74, 0x65, 0x4d, 0x6f, 0x64, 0x65, 0x12, 0x1b, 0x0a, 0x17, 0x43, 0x52, 0x45, 0x41, 0x54,
	0x45, 0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49,
	0x45, 0x44, 0x10, 0x00, 0x12, 0x20, 0x0a, 0x1c, 0x43, 0x52, 0x45, 0x41, 0x54, 0x45, 0x5f, 0x4d,
	0x4f, 0x44, 0x45, 0x5f, 0x41, 0x50, 0x50, 0x45, 0x4e, 0x44, 0x5f, 0x49, 0x46, 0x5f, 0x45, 0x58,
	0x49, 0x53, 0x54, 0x53, 0x10, 0x01, 0x12, 0x21, 0x0a, 0x1d, 0x43, 0x52, 0x45, 0x41, 0x54, 0x45,
	0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x52, 0x45, 0x50, 0x4c, 0x41, 0x43, 0x45, 0x5f, 0x49, 0x46,
	0x5f, 0x45, 0x58, 0x49, 0x53, 0x54, 0x53, 0x10, 0x02, 0x12, 0x20, 0x0a, 0x1c, 0x43, 0x52, 0x45,
	0x41, 0x54, 0x45, 0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x49, 0x47, 0x4e, 0x4f, 0x52, 0x45, 0x5f,
	0x49, 0x46, 0x5f, 0x45, 0x58, 0x49, 0x53, 0x54, 0x53, 0x10, 0x03, 0x12, 0x1f, 0x0a, 0x1b, 0x43,
	0x52, 0x45, 0x41, 0x54, 0x45, 0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x45, 0x52, 0x52, 0x4f, 0x52,
	0x5f, 0x49, 0x46, 0x5f, 0x45, 0x58, 0x49, 0x53, 0x54, 0x53, 0x10, 0x04, 0x22, 0x66, 0x0a, 0x0a,
	0x4f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x4d, 0x6f, 0x64, 0x65, 0x12, 0x1b, 0x0a, 0x17, 0x4f, 0x55,
	0x54, 0x50, 0x55, 0x54, 0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43,
	0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x19, 0x0a, 0x15, 0x4f, 0x55, 0x54, 0x50, 0x55,
	0x54, 0x5f, 0x4d, 0x4f, 0x44, 0x45, 0x5f, 0x4e, 0x4f, 0x5f, 0x4f, 0x55, 0x54, 0x50, 0x55, 0x54,
	0x10, 0x01, 0x12, 0x20, 0x0a, 0x1c, 0x4f, 0x55, 0x54, 0x50, 0x55, 0x54, 0x5f, 0x4d, 0x4f, 0x44,
	0x45, 0x5f, 0x4d, 0x4f, 0x44, 0x49, 0x46, 0x49, 0x45, 0x44, 0x5f, 0x52, 0x45, 0x43, 0x4f, 0x52,
	0x44, 0x53, 0x10, 0x02, 0x42, 0x0c, 0x0a, 0x0a, 0x77, 0x72, 0x69, 0x74, 0x65, 0x5f, 0x74, 0x79,
	0x70, 0x65, 0x22, 0x93, 0x03, 0x0a, 0x09, 0x55, 0x70, 0x64, 0x61, 0x74, 0x65, 0x52, 0x65, 0x6c,
	0x12, 0x38, 0x0a, 0x0b, 0x6e, 0x61, 0x6d, 0x65, 0x64, 0x5f, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x4e, 0x61, 0x6d, 0x65, 0x64, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x48, 0x00, 0x52, 0x0a,
	0x6e, 0x61, 0x6d, 0x65, 0x64, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x39, 0x0a, 0x0c, 0x74, 0x61,
	0x62, 0x6c, 0x65, 0x5f, 0x73, 0x63, 0x68, 0x65, 0x6d, 0x61, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x16, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4e, 0x61, 0x6d,
	0x65, 0x64, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x52, 0x0b, 0x74, 0x61, 0x62, 0x6c, 0x65, 0x53,
	0x63, 0x68, 0x65, 0x6d, 0x61, 0x12, 0x33, 0x0a, 0x09, 0x63, 0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69,
	0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52,
	0x09, 0x63, 0x6f, 0x6e, 0x64, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x52, 0x0a, 0x0f, 0x74, 0x72,
	0x61, 0x6e, 0x73, 0x66, 0x6f, 0x72, 0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x04, 0x20,
	0x03, 0x28, 0x0b, 0x32, 0x28, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x55, 0x70, 0x64, 0x61, 0x74, 0x65, 0x52, 0x65, 0x6c, 0x2e, 0x54, 0x72, 0x61, 0x6e, 0x73, 0x66,
	0x6f, 0x72, 0x6d, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0f, 0x74,
	0x72, 0x61, 0x6e, 0x73, 0x66, 0x6f, 0x72, 0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x1a, 0x79,
	0x0a, 0x13, 0x54, 0x72, 0x61, 0x6e, 0x73, 0x66, 0x6f, 0x72, 0x6d, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x3d, 0x0a, 0x0e, 0x74, 0x72, 0x61, 0x6e, 0x73, 0x66, 0x6f,
	0x72, 0x6d, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0e, 0x74, 0x72, 0x61, 0x6e, 0x73, 0x66, 0x6f, 0x72, 0x6d, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x12, 0x23, 0x0a, 0x0d, 0x63, 0x6f, 0x6c, 0x75, 0x6d, 0x6e, 0x5f, 0x74,
	0x61, 0x72, 0x67, 0x65, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x05, 0x52, 0x0c, 0x63, 0x6f, 0x6c,
	0x75, 0x6d, 0x6e, 0x54, 0x61, 0x72, 0x67, 0x65, 0x74, 0x42, 0x0d, 0x0a, 0x0b, 0x75, 0x70, 0x64,
	0x61, 0x74, 0x65, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x22, 0x7a, 0x0a, 0x0a, 0x4e, 0x61, 0x6d, 0x65,
	0x64, 0x54, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x14, 0x0a, 0x05, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x18,
	0x01, 0x20, 0x03, 0x28, 0x09, 0x52, 0x05, 0x6e, 0x61, 0x6d, 0x65, 0x73, 0x12, 0x56, 0x0a, 0x12,
	0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e,
	0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x22, 0xbb, 0x04, 0x0a, 0x11, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69,
	0x73, 0x6f, 0x6e, 0x4a, 0x6f, 0x69, 0x6e, 0x4b, 0x65, 0x79, 0x12, 0x38, 0x0a, 0x04, 0x6c, 0x65,
	0x66, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e,
	0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x52, 0x04,
	0x6c, 0x65, 0x66, 0x74, 0x12, 0x3a, 0x0a, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64,
	0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74,
	0x12, 0x4b, 0x0a, 0x0a, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x18, 0x03,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x4a, 0x6f, 0x69, 0x6e, 0x4b,
	0x65, 0x79, 0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x54, 0x79, 0x70,
	0x65, 0x52, 0x0a, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x1a, 0xa9, 0x01,
	0x0a, 0x0e, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x54, 0x79, 0x70, 0x65,
	0x12, 0x4b, 0x0a, 0x06, 0x73, 0x69, 0x6d, 0x70, 0x6c, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0e,
	0x32, 0x31, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x43, 0x6f, 0x6d,
	0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x4a, 0x6f, 0x69, 0x6e, 0x4b, 0x65, 0x79, 0x2e, 0x53,
	0x69, 0x6d, 0x70, 0x6c, 0x65, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x54,
	0x79, 0x70, 0x65, 0x48, 0x00, 0x52, 0x06, 0x73, 0x69, 0x6d, 0x70, 0x6c, 0x65, 0x12, 0x3c, 0x0a,
	0x19, 0x63, 0x75, 0x73, 0x74, 0x6f, 0x6d, 0x5f, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e,
	0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0d,
	0x48, 0x00, 0x52, 0x17, 0x63, 0x75, 0x73, 0x74, 0x6f, 0x6d, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69,
	0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x42, 0x0c, 0x0a, 0x0a, 0x69,
	0x6e, 0x6e, 0x65, 0x72, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x22, 0xb6, 0x01, 0x0a, 0x14, 0x53, 0x69,
	0x6d, 0x70, 0x6c, 0x65, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x54, 0x79,
	0x70, 0x65, 0x12, 0x26, 0x0a, 0x22, 0x53, 0x49, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x43, 0x4f, 0x4d,
	0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53,
	0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x1d, 0x0a, 0x19, 0x53, 0x49,
	0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f,
	0x54, 0x59, 0x50, 0x45, 0x5f, 0x45, 0x51, 0x10, 0x01, 0x12, 0x2f, 0x0a, 0x2b, 0x53, 0x49, 0x4d,
	0x50, 0x4c, 0x45, 0x5f, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f, 0x54,
	0x59, 0x50, 0x45, 0x5f, 0x49, 0x53, 0x5f, 0x4e, 0x4f, 0x54, 0x5f, 0x44, 0x49, 0x53, 0x54, 0x49,
	0x4e, 0x43, 0x54, 0x5f, 0x46, 0x52, 0x4f, 0x4d, 0x10, 0x02, 0x12, 0x26, 0x0a, 0x22, 0x53, 0x49,
	0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f,
	0x54, 0x59, 0x50, 0x45, 0x5f, 0x4d, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x45, 0x51, 0x55, 0x41, 0x4c,
	0x10, 0x03, 0x22, 0xe0, 0x06, 0x0a, 0x0b, 0x48, 0x61, 0x73, 0x68, 0x4a, 0x6f, 0x69, 0x6e, 0x52,
	0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52,
	0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e,
	0x12, 0x22, 0x0a, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x04,
	0x6c, 0x65, 0x66, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x18, 0x03, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x12, 0x45, 0x0a, 0x09, 0x6c, 0x65,
	0x66, 0x74, 0x5f, 0x6b, 0x65, 0x79, 0x73, 0x18, 0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x24, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65,
	0x6e, 0x63, 0x65, 0x42, 0x02, 0x18, 0x01, 0x52, 0x08, 0x6c, 0x65, 0x66, 0x74, 0x4b, 0x65, 0x79,
	0x73, 0x12, 0x47, 0x0a, 0x0a, 0x72, 0x69, 0x67, 0x68, 0x74, 0x5f, 0x6b, 0x65, 0x79, 0x73, 0x18,
	0x05, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65,
	0x6c, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x42, 0x02, 0x18, 0x01, 0x52,
	0x09, 0x72, 0x69, 0x67, 0x68, 0x74, 0x4b, 0x65, 0x79, 0x73, 0x12, 0x30, 0x0a, 0x04, 0x6b, 0x65,
	0x79, 0x73, 0x18, 0x08, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x4a,
	0x6f, 0x69, 0x6e, 0x4b, 0x65, 0x79, 0x52, 0x04, 0x6b, 0x65, 0x79, 0x73, 0x12, 0x3f, 0x0a, 0x10,
	0x70, 0x6f, 0x73, 0x74, 0x5f, 0x6a, 0x6f, 0x69, 0x6e, 0x5f, 0x66, 0x69, 0x6c, 0x74, 0x65, 0x72,
	0x18, 0x06, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0e, 0x70,
	0x6f, 0x73, 0x74, 0x4a, 0x6f, 0x69, 0x6e, 0x46, 0x69, 0x6c, 0x74, 0x65, 0x72, 0x12, 0x33, 0x0a,
	0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x1f, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x48, 0x61, 0x73, 0x68, 0x4a, 0x6f, 0x69, 0x6e,
	0x52, 0x65, 0x6c, 0x2e, 0x4a, 0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x04, 0x74, 0x79,
	0x70, 0x65, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65,
	0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e,
	0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78,
	0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65,
	0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22, 0xc8, 0x02, 0x0a, 0x08, 0x4a,
	0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x12, 0x19, 0x0a, 0x15, 0x4a, 0x4f, 0x49, 0x4e, 0x5f,
	0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44,
	0x10, 0x00, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f,
	0x49, 0x4e, 0x4e, 0x45, 0x52, 0x10, 0x01, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f,
	0x54, 0x59, 0x50, 0x45, 0x5f, 0x4f, 0x55, 0x54, 0x45, 0x52, 0x10, 0x02, 0x12, 0x12, 0x0a, 0x0e,
	0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x10, 0x03,
	0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49,
	0x47, 0x48, 0x54, 0x10, 0x04, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59,
	0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x53, 0x45, 0x4d, 0x49, 0x10, 0x05, 0x12, 0x18,
	0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48,
	0x54, 0x5f, 0x53, 0x45, 0x4d, 0x49, 0x10, 0x06, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e,
	0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x41, 0x4e, 0x54, 0x49, 0x10,
	0x07, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52,
	0x49, 0x47, 0x48, 0x54, 0x5f, 0x41, 0x4e, 0x54, 0x49, 0x10, 0x08, 0x12, 0x19, 0x0a, 0x15, 0x4a,
	0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x53, 0x49,
	0x4e, 0x47, 0x4c, 0x45, 0x10, 0x09, 0x12, 0x1a, 0x0a, 0x16, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54,
	0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x53, 0x49, 0x4e, 0x47, 0x4c, 0x45,
	0x10, 0x0a, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f,
	0x4c, 0x45, 0x46, 0x54, 0x5f, 0x4d, 0x41, 0x52, 0x4b, 0x10, 0x0b, 0x12, 0x18, 0x0a, 0x14, 0x4a,
	0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x4d,
	0x41, 0x52, 0x4b, 0x10, 0x0c, 0x22, 0xe2, 0x06, 0x0a, 0x0c, 0x4d, 0x65, 0x72, 0x67, 0x65, 0x4a,
	0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f,
	0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x22, 0x0a, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x18, 0x02, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52,
	0x65, 0x6c, 0x52, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x72, 0x69, 0x67, 0x68,
	0x74, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x12, 0x45,
	0x0a, 0x09, 0x6c, 0x65, 0x66, 0x74, 0x5f, 0x6b, 0x65, 0x79, 0x73, 0x18, 0x04, 0x20, 0x03, 0x28,
	0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x65,
	0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x42, 0x02, 0x18, 0x01, 0x52, 0x08, 0x6c, 0x65, 0x66,
	0x74, 0x4b, 0x65, 0x79, 0x73, 0x12, 0x47, 0x0a, 0x0a, 0x72, 0x69, 0x67, 0x68, 0x74, 0x5f, 0x6b,
	0x65, 0x79, 0x73, 0x18, 0x05, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x42,
	0x02, 0x18, 0x01, 0x52, 0x09, 0x72, 0x69, 0x67, 0x68, 0x74, 0x4b, 0x65, 0x79, 0x73, 0x12, 0x30,
	0x0a, 0x04, 0x6b, 0x65, 0x79, 0x73, 0x18, 0x08, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1c, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69,
	0x73, 0x6f, 0x6e, 0x4a, 0x6f, 0x69, 0x6e, 0x4b, 0x65, 0x79, 0x52, 0x04, 0x6b, 0x65, 0x79, 0x73,
	0x12, 0x3f, 0x0a, 0x10, 0x70, 0x6f, 0x73, 0x74, 0x5f, 0x6a, 0x6f, 0x69, 0x6e, 0x5f, 0x66, 0x69,
	0x6c, 0x74, 0x65, 0x72, 0x18, 0x06, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x0e, 0x70, 0x6f, 0x73, 0x74, 0x4a, 0x6f, 0x69, 0x6e, 0x46, 0x69, 0x6c, 0x74, 0x65,
	0x72, 0x12, 0x34, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0e, 0x32,
	0x20, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4d, 0x65, 0x72, 0x67,
	0x65, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x2e, 0x4a, 0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70,
	0x65, 0x52, 0x04, 0x74, 0x79, 0x70, 0x65, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64, 0x76, 0x61, 0x6e,
	0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64, 0x76, 0x61, 0x6e,
	0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x11, 0x61, 0x64,
	0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x22,
	0xc8, 0x02, 0x0a, 0x08, 0x4a, 0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x12, 0x19, 0x0a, 0x15,
	0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43,
	0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f,
	0x54, 0x59, 0x50, 0x45, 0x5f, 0x49, 0x4e, 0x4e, 0x45, 0x52, 0x10, 0x01, 0x12, 0x13, 0x0a, 0x0f,
	0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4f, 0x55, 0x54, 0x45, 0x52, 0x10,
	0x02, 0x12, 0x12, 0x0a, 0x0e, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c,
	0x45, 0x46, 0x54, 0x10, 0x03, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59,
	0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x10, 0x04, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f,
	0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x53, 0x45, 0x4d,
	0x49, 0x10, 0x05, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45,
	0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x53, 0x45, 0x4d, 0x49, 0x10, 0x06, 0x12, 0x17, 0x0a,
	0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f,
	0x41, 0x4e, 0x54, 0x49, 0x10, 0x07, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54,
	0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x41, 0x4e, 0x54, 0x49, 0x10, 0x08,
	0x12, 0x19, 0x0a, 0x15, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45,
	0x46, 0x54, 0x5f, 0x53, 0x49, 0x4e, 0x47, 0x4c, 0x45, 0x10, 0x09, 0x12, 0x1a, 0x0a, 0x16, 0x4a,
	0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x53,
	0x49, 0x4e, 0x47, 0x4c, 0x45, 0x10, 0x0a, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f,
	0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x4d, 0x41, 0x52, 0x4b, 0x10, 0x0b,
	0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49,
	0x47, 0x48, 0x54, 0x5f, 0x4d, 0x41, 0x52, 0x4b, 0x10, 0x0c, 0x22, 0xa0, 0x05, 0x0a, 0x11, 0x4e,
	0x65, 0x73, 0x74, 0x65, 0x64, 0x4c, 0x6f, 0x6f, 0x70, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c,
	0x12, 0x2c, 0x0a, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c,
	0x43, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x52, 0x06, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x12, 0x22,
	0x0a, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x04, 0x6c, 0x65,
	0x66, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65,
	0x6c, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68, 0x74, 0x12, 0x35, 0x0a, 0x0a, 0x65, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12,
	0x39, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x25, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64,
	0x4c, 0x6f, 0x6f, 0x70, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x65, 0x6c, 0x2e, 0x4a, 0x6f, 0x69, 0x6e,
	0x54, 0x79, 0x70, 0x65, 0x52, 0x04, 0x74, 0x79, 0x70, 0x65, 0x12, 0x56, 0x0a, 0x12, 0x61, 0x64,
	0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x5f, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e,
	0x18, 0x0a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x27, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x65, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x73, 0x2e, 0x41, 0x64,
	0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69, 0x6f, 0x6e, 0x52,
	0x11, 0x61, 0x64, 0x76, 0x61, 0x6e, 0x63, 0x65, 0x64, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x73, 0x69,
	0x6f, 0x6e, 0x22, 0xc8, 0x02, 0x0a, 0x08, 0x4a, 0x6f, 0x69, 0x6e, 0x54, 0x79, 0x70, 0x65, 0x12,
	0x19, 0x0a, 0x15, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53,
	0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f,
	0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x49, 0x4e, 0x4e, 0x45, 0x52, 0x10, 0x01, 0x12,
	0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4f, 0x55, 0x54,
	0x45, 0x52, 0x10, 0x02, 0x12, 0x12, 0x0a, 0x0e, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50,
	0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x10, 0x03, 0x12, 0x13, 0x0a, 0x0f, 0x4a, 0x4f, 0x49, 0x4e,
	0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x10, 0x04, 0x12, 0x17, 0x0a,
	0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f,
	0x53, 0x45, 0x4d, 0x49, 0x10, 0x05, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54,
	0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x53, 0x45, 0x4d, 0x49, 0x10, 0x06,
	0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45,
	0x46, 0x54, 0x5f, 0x41, 0x4e, 0x54, 0x49, 0x10, 0x07, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49,
	0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x41, 0x4e, 0x54,
	0x49, 0x10, 0x08, 0x12, 0x19, 0x0a, 0x15, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45,
	0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x53, 0x49, 0x4e, 0x47, 0x4c, 0x45, 0x10, 0x09, 0x12, 0x1a,
	0x0a, 0x16, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x49, 0x47, 0x48,
	0x54, 0x5f, 0x53, 0x49, 0x4e, 0x47, 0x4c, 0x45, 0x10, 0x0a, 0x12, 0x17, 0x0a, 0x13, 0x4a, 0x4f,
	0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x4c, 0x45, 0x46, 0x54, 0x5f, 0x4d, 0x41, 0x52,
	0x4b, 0x10, 0x0b, 0x12, 0x18, 0x0a, 0x14, 0x4a, 0x4f, 0x49, 0x4e, 0x5f, 0x54, 0x59, 0x50, 0x45,
	0x5f, 0x52, 0x49, 0x47, 0x48, 0x54, 0x5f, 0x4d, 0x41, 0x52, 0x4b, 0x10, 0x0c, 0x22, 0x8a, 0x01,
	0x0a, 0x10, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x41, 0x72, 0x67, 0x75, 0x6d, 0x65,
	0x6e, 0x74, 0x12, 0x14, 0x0a, 0x04, 0x65, 0x6e, 0x75, 0x6d, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09,
	0x48, 0x00, 0x52, 0x04, 0x65, 0x6e, 0x75, 0x6d, 0x12, 0x25, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x48, 0x00, 0x52, 0x04, 0x74, 0x79, 0x70, 0x65, 0x12,
	0x2d, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x42, 0x0a,
	0x0a, 0x08, 0x61, 0x72, 0x67, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x22, 0x44, 0x0a, 0x0e, 0x46, 0x75,
	0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x12, 0x0a, 0x04,
	0x6e, 0x61, 0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x04, 0x6e, 0x61, 0x6d, 0x65,
	0x12, 0x1e, 0x0a, 0x0a, 0x70, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x02,
	0x20, 0x03, 0x28, 0x09, 0x52, 0x0a, 0x70, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65,
	0x22, 0xe8, 0x59, 0x0a, 0x0a, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12,
	0x39, 0x0a, 0x07, 0x6c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70,
	0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x48,
	0x00, 0x52, 0x07, 0x6c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x12, 0x44, 0x0a, 0x09, 0x73, 0x65,
	0x6c, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65,
	0x6e, 0x63, 0x65, 0x48, 0x00, 0x52, 0x09, 0x73, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e,
	0x12, 0x4f, 0x0a, 0x0f, 0x73, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x5f, 0x66, 0x75, 0x6e, 0x63, 0x74,
	0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x53, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x48,
	0x00, 0x52, 0x0e, 0x73, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x12, 0x4f, 0x0a, 0x0f, 0x77, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x5f, 0x66, 0x75, 0x6e, 0x63,
	0x74, 0x69, 0x6f, 0x6e, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x2e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e,
	0x48, 0x00, 0x52, 0x0e, 0x77, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69,
	0x6f, 0x6e, 0x12, 0x37, 0x0a, 0x07, 0x69, 0x66, 0x5f, 0x74, 0x68, 0x65, 0x6e, 0x18, 0x06, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x1c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x49, 0x66, 0x54, 0x68, 0x65,
	0x6e, 0x48, 0x00, 0x52, 0x06, 0x69, 0x66, 0x54, 0x68, 0x65, 0x6e, 0x12, 0x55, 0x0a, 0x11, 0x73,
	0x77, 0x69, 0x74, 0x63, 0x68, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x18, 0x07, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x26, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x77,
	0x69, 0x74, 0x63, 0x68, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48, 0x00,
	0x52, 0x10, 0x73, 0x77, 0x69, 0x74, 0x63, 0x68, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x12, 0x50, 0x0a, 0x10, 0x73, 0x69, 0x6e, 0x67, 0x75, 0x6c, 0x61, 0x72, 0x5f, 0x6f,
	0x72, 0x5f, 0x6c, 0x69, 0x73, 0x74, 0x18, 0x08, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x69, 0x6e, 0x67, 0x75, 0x6c, 0x61, 0x72, 0x4f, 0x72, 0x4c, 0x69,
	0x73, 0x74, 0x48, 0x00, 0x52, 0x0e, 0x73, 0x69, 0x6e, 0x67, 0x75, 0x6c, 0x61, 0x72, 0x4f, 0x72,
	0x4c, 0x69, 0x73, 0x74, 0x12, 0x47, 0x0a, 0x0d, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x5f, 0x6f, 0x72,
	0x5f, 0x6c, 0x69, 0x73, 0x74, 0x18, 0x09, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x21, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x4d, 0x75, 0x6c, 0x74, 0x69, 0x4f, 0x72, 0x4c, 0x69, 0x73, 0x74, 0x48, 0x00,
	0x52, 0x0b, 0x6d, 0x75, 0x6c, 0x74, 0x69, 0x4f, 0x72, 0x4c, 0x69, 0x73, 0x74, 0x12, 0x30, 0x0a,
	0x04, 0x63, 0x61, 0x73, 0x74, 0x18, 0x0b, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x43, 0x61, 0x73, 0x74, 0x48, 0x00, 0x52, 0x04, 0x63, 0x61, 0x73, 0x74, 0x12,
	0x3c, 0x0a, 0x08, 0x73, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x18, 0x0c, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x1e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72,
	0x79, 0x48, 0x00, 0x52, 0x08, 0x73, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x12, 0x36, 0x0a,
	0x06, 0x6e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x18, 0x0d, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1c, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x48, 0x00, 0x52, 0x06, 0x6e,
	0x65, 0x73, 0x74, 0x65, 0x64, 0x12, 0x34, 0x0a, 0x04, 0x65, 0x6e, 0x75, 0x6d, 0x18, 0x0a, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x45, 0x6e, 0x75, 0x6d, 0x42,
	0x02, 0x18, 0x01, 0x48, 0x00, 0x52, 0x04, 0x65, 0x6e, 0x75, 0x6d, 0x1a, 0x8a, 0x01, 0x0a, 0x04,
	0x45, 0x6e, 0x75, 0x6d, 0x12, 0x1e, 0x0a, 0x09, 0x73, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69, 0x65,
	0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x48, 0x00, 0x52, 0x09, 0x73, 0x70, 0x65, 0x63, 0x69,
	0x66, 0x69, 0x65, 0x64, 0x12, 0x44, 0x0a, 0x0b, 0x75, 0x6e, 0x73, 0x70, 0x65, 0x63, 0x69, 0x66,
	0x69, 0x65, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x20, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x45, 0x6e, 0x75, 0x6d, 0x2e, 0x45, 0x6d, 0x70, 0x74, 0x79, 0x48, 0x00, 0x52, 0x0b, 0x75,
	0x6e, 0x73, 0x70, 0x65, 0x63, 0x69, 0x66, 0x69, 0x65, 0x64, 0x1a, 0x0b, 0x0a, 0x05, 0x45, 0x6d,
	0x70, 0x74, 0x79, 0x3a, 0x02, 0x18, 0x01, 0x3a, 0x02, 0x18, 0x01, 0x42, 0x0b, 0x0a, 0x09, 0x65,
	0x6e, 0x75, 0x6d, 0x5f, 0x6b, 0x69, 0x6e, 0x64, 0x1a, 0xa3, 0x16, 0x0a, 0x07, 0x4c, 0x69, 0x74,
	0x65, 0x72, 0x61, 0x6c, 0x12, 0x1a, 0x0a, 0x07, 0x62, 0x6f, 0x6f, 0x6c, 0x65, 0x61, 0x6e, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x08, 0x48, 0x00, 0x52, 0x07, 0x62, 0x6f, 0x6f, 0x6c, 0x65, 0x61, 0x6e,
	0x12, 0x10, 0x0a, 0x02, 0x69, 0x38, 0x18, 0x02, 0x20, 0x01, 0x28, 0x05, 0x48, 0x00, 0x52, 0x02,
	0x69, 0x38, 0x12, 0x12, 0x0a, 0x03, 0x69, 0x31, 0x36, 0x18, 0x03, 0x20, 0x01, 0x28, 0x05, 0x48,
	0x00, 0x52, 0x03, 0x69, 0x31, 0x36, 0x12, 0x12, 0x0a, 0x03, 0x69, 0x33, 0x32, 0x18, 0x05, 0x20,
	0x01, 0x28, 0x05, 0x48, 0x00, 0x52, 0x03, 0x69, 0x33, 0x32, 0x12, 0x12, 0x0a, 0x03, 0x69, 0x36,
	0x34, 0x18, 0x07, 0x20, 0x01, 0x28, 0x03, 0x48, 0x00, 0x52, 0x03, 0x69, 0x36, 0x34, 0x12, 0x14,
	0x0a, 0x04, 0x66, 0x70, 0x33, 0x32, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x02, 0x48, 0x00, 0x52, 0x04,
	0x66, 0x70, 0x33, 0x32, 0x12, 0x14, 0x0a, 0x04, 0x66, 0x70, 0x36, 0x34, 0x18, 0x0b, 0x20, 0x01,
	0x28, 0x01, 0x48, 0x00, 0x52, 0x04, 0x66, 0x70, 0x36, 0x34, 0x12, 0x18, 0x0a, 0x06, 0x73, 0x74,
	0x72, 0x69, 0x6e, 0x67, 0x18, 0x0c, 0x20, 0x01, 0x28, 0x09, 0x48, 0x00, 0x52, 0x06, 0x73, 0x74,
	0x72, 0x69, 0x6e, 0x67, 0x12, 0x18, 0x0a, 0x06, 0x62, 0x69, 0x6e, 0x61, 0x72, 0x79, 0x18, 0x0d,
	0x20, 0x01, 0x28, 0x0c, 0x48, 0x00, 0x52, 0x06, 0x62, 0x69, 0x6e, 0x61, 0x72, 0x79, 0x12, 0x22,
	0x0a, 0x09, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x18, 0x0e, 0x20, 0x01, 0x28,
	0x03, 0x42, 0x02, 0x18, 0x01, 0x48, 0x00, 0x52, 0x09, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61,
	0x6d, 0x70, 0x12, 0x14, 0x0a, 0x04, 0x64, 0x61, 0x74, 0x65, 0x18, 0x10, 0x20, 0x01, 0x28, 0x05,
	0x48, 0x00, 0x52, 0x04, 0x64, 0x61, 0x74, 0x65, 0x12, 0x14, 0x0a, 0x04, 0x74, 0x69, 0x6d, 0x65,
	0x18, 0x11, 0x20, 0x01, 0x28, 0x03, 0x48, 0x00, 0x52, 0x04, 0x74, 0x69, 0x6d, 0x65, 0x12, 0x68,
	0x0a, 0x16, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x5f, 0x79, 0x65, 0x61, 0x72, 0x5f,
	0x74, 0x6f, 0x5f, 0x6d, 0x6f, 0x6e, 0x74, 0x68, 0x18, 0x13, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x31,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x49, 0x6e,
	0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x59, 0x65, 0x61, 0x72, 0x54, 0x6f, 0x4d, 0x6f, 0x6e, 0x74,
	0x68, 0x48, 0x00, 0x52, 0x13, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x59, 0x65, 0x61,
	0x72, 0x54, 0x6f, 0x4d, 0x6f, 0x6e, 0x74, 0x68, 0x12, 0x68, 0x0a, 0x16, 0x69, 0x6e, 0x74, 0x65,
	0x72, 0x76, 0x61, 0x6c, 0x5f, 0x64, 0x61, 0x79, 0x5f, 0x74, 0x6f, 0x5f, 0x73, 0x65, 0x63, 0x6f,
	0x6e, 0x64, 0x18, 0x14, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x31, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e,
	0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x49, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c,
	0x44, 0x61, 0x79, 0x54, 0x6f, 0x53, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x48, 0x00, 0x52, 0x13, 0x69,
	0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x44, 0x61, 0x79, 0x54, 0x6f, 0x53, 0x65, 0x63, 0x6f,
	0x6e, 0x64, 0x12, 0x5d, 0x0a, 0x11, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x5f, 0x63,
	0x6f, 0x6d, 0x70, 0x6f, 0x75, 0x6e, 0x64, 0x18, 0x24, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2e, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x49, 0x6e, 0x74,
	0x65, 0x72, 0x76, 0x61, 0x6c, 0x43, 0x6f, 0x6d, 0x70, 0x6f, 0x75, 0x6e, 0x64, 0x48, 0x00, 0x52,
	0x10, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x43, 0x6f, 0x6d, 0x70, 0x6f, 0x75, 0x6e,
	0x64, 0x12, 0x1f, 0x0a, 0x0a, 0x66, 0x69, 0x78, 0x65, 0x64, 0x5f, 0x63, 0x68, 0x61, 0x72, 0x18,
	0x15, 0x20, 0x01, 0x28, 0x09, 0x48, 0x00, 0x52, 0x09, 0x66, 0x69, 0x78, 0x65, 0x64, 0x43, 0x68,
	0x61, 0x72, 0x12, 0x42, 0x0a, 0x08, 0x76, 0x61, 0x72, 0x5f, 0x63, 0x68, 0x61, 0x72, 0x18, 0x16,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x25, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65,
	0x72, 0x61, 0x6c, 0x2e, 0x56, 0x61, 0x72, 0x43, 0x68, 0x61, 0x72, 0x48, 0x00, 0x52, 0x07, 0x76,
	0x61, 0x72, 0x43, 0x68, 0x61, 0x72, 0x12, 0x23, 0x0a, 0x0c, 0x66, 0x69, 0x78, 0x65, 0x64, 0x5f,
	0x62, 0x69, 0x6e, 0x61, 0x72, 0x79, 0x18, 0x17, 0x20, 0x01, 0x28, 0x0c, 0x48, 0x00, 0x52, 0x0b,
	0x66, 0x69, 0x78, 0x65, 0x64, 0x42, 0x69, 0x6e, 0x61, 0x72, 0x79, 0x12, 0x41, 0x0a, 0x07, 0x64,
	0x65, 0x63, 0x69, 0x6d, 0x61, 0x6c, 0x18, 0x18, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x25, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x44, 0x65, 0x63, 0x69,
	0x6d, 0x61, 0x6c, 0x48, 0x00, 0x52, 0x07, 0x64, 0x65, 0x63, 0x69, 0x6d, 0x61, 0x6c, 0x12, 0x63,
	0x0a, 0x13, 0x70, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x5f, 0x74, 0x69, 0x6d, 0x65,
	0x73, 0x74, 0x61, 0x6d, 0x70, 0x18, 0x22, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x30, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x50, 0x72, 0x65, 0x63, 0x69,
	0x73, 0x69, 0x6f, 0x6e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x48, 0x00, 0x52,
	0x12, 0x70, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74,
	0x61, 0x6d, 0x70, 0x12, 0x68, 0x0a, 0x16, 0x70, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e,
	0x5f, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x5f, 0x74, 0x7a, 0x18, 0x23, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x30, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72,
	0x61, 0x6c, 0x2e, 0x50, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x54, 0x69, 0x6d, 0x65,
	0x73, 0x74, 0x61, 0x6d, 0x70, 0x48, 0x00, 0x52, 0x14, 0x70, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69,
	0x6f, 0x6e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x54, 0x7a, 0x12, 0x3e, 0x0a,
	0x06, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x18, 0x19, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x53, 0x74, 0x72,
	0x75, 0x63, 0x74, 0x48, 0x00, 0x52, 0x06, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x12, 0x35, 0x0a,
	0x03, 0x6d, 0x61, 0x70, 0x18, 0x1a, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x21, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x4d, 0x61, 0x70, 0x48, 0x00, 0x52,
	0x03, 0x6d, 0x61, 0x70, 0x12, 0x27, 0x0a, 0x0c, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d,
	0x70, 0x5f, 0x74, 0x7a, 0x18, 0x1b, 0x20, 0x01, 0x28, 0x03, 0x42, 0x02, 0x18, 0x01, 0x48, 0x00,
	0x52, 0x0b, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x54, 0x7a, 0x12, 0x14, 0x0a,
	0x04, 0x75, 0x75, 0x69, 0x64, 0x18, 0x1c, 0x20, 0x01, 0x28, 0x0c, 0x48, 0x00, 0x52, 0x04, 0x75,
	0x75, 0x69, 0x64, 0x12, 0x25, 0x0a, 0x04, 0x6e, 0x75, 0x6c, 0x6c, 0x18, 0x1d, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79,
	0x70, 0x65, 0x48, 0x00, 0x52, 0x04, 0x6e, 0x75, 0x6c, 0x6c, 0x12, 0x38, 0x0a, 0x04, 0x6c, 0x69,
	0x73, 0x74, 0x18, 0x1e, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x22, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e,
	0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x48, 0x00, 0x52, 0x04,
	0x6c, 0x69, 0x73, 0x74, 0x12, 0x35, 0x0a, 0x0a, 0x65, 0x6d, 0x70, 0x74, 0x79, 0x5f, 0x6c, 0x69,
	0x73, 0x74, 0x18, 0x1f, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x48, 0x00,
	0x52, 0x09, 0x65, 0x6d, 0x70, 0x74, 0x79, 0x4c, 0x69, 0x73, 0x74, 0x12, 0x32, 0x0a, 0x09, 0x65,
	0x6d, 0x70, 0x74, 0x79, 0x5f, 0x6d, 0x61, 0x70, 0x18, 0x20, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x13,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x2e,
	0x4d, 0x61, 0x70, 0x48, 0x00, 0x52, 0x08, 0x65, 0x6d, 0x70, 0x74, 0x79, 0x4d, 0x61, 0x70, 0x12,
	0x4e, 0x0a, 0x0c, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x64, 0x65, 0x66, 0x69, 0x6e, 0x65, 0x64, 0x18,
	0x21, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x29, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74,
	0x65, 0x72, 0x61, 0x6c, 0x2e, 0x55, 0x73, 0x65, 0x72, 0x44, 0x65, 0x66, 0x69, 0x6e, 0x65, 0x64,
	0x48, 0x00, 0x52, 0x0b, 0x75, 0x73, 0x65, 0x72, 0x44, 0x65, 0x66, 0x69, 0x6e, 0x65, 0x64, 0x12,
	0x1a, 0x0a, 0x08, 0x6e, 0x75, 0x6c, 0x6c, 0x61, 0x62, 0x6c, 0x65, 0x18, 0x32, 0x20, 0x01, 0x28,
	0x08, 0x52, 0x08, 0x6e, 0x75, 0x6c, 0x6c, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x38, 0x0a, 0x18, 0x74,
	0x79, 0x70, 0x65, 0x5f, 0x76, 0x61, 0x72, 0x69, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x72, 0x65,
	0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x33, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x16, 0x74,
	0x79, 0x70, 0x65, 0x56, 0x61, 0x72, 0x69, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65,
	0x72, 0x65, 0x6e, 0x63, 0x65, 0x1a, 0x37, 0x0a, 0x07, 0x56, 0x61, 0x72, 0x43, 0x68, 0x61, 0x72,
	0x12, 0x14, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x16, 0x0a, 0x06, 0x6c, 0x65, 0x6e, 0x67, 0x74, 0x68,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x06, 0x6c, 0x65, 0x6e, 0x67, 0x74, 0x68, 0x1a, 0x53,
	0x0a, 0x07, 0x44, 0x65, 0x63, 0x69, 0x6d, 0x61, 0x6c, 0x12, 0x14, 0x0a, 0x05, 0x76, 0x61, 0x6c,
	0x75, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0c, 0x52, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x12,
	0x1c, 0x0a, 0x09, 0x70, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x02, 0x20, 0x01,
	0x28, 0x05, 0x52, 0x09, 0x70, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x14, 0x0a,
	0x05, 0x73, 0x63, 0x61, 0x6c, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x05, 0x52, 0x05, 0x73, 0x63,
	0x61, 0x6c, 0x65, 0x1a, 0x48, 0x0a, 0x12, 0x50, 0x72, 0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e,
	0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x12, 0x1c, 0x0a, 0x09, 0x70, 0x72, 0x65,
	0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x09, 0x70, 0x72,
	0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x14, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x03, 0x52, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x1a, 0xc2, 0x01,
	0x0a, 0x03, 0x4d, 0x61, 0x70, 0x12, 0x49, 0x0a, 0x0a, 0x6b, 0x65, 0x79, 0x5f, 0x76, 0x61, 0x6c,
	0x75, 0x65, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x4d, 0x61, 0x70, 0x2e, 0x4b, 0x65, 0x79,
	0x56, 0x61, 0x6c, 0x75, 0x65, 0x52, 0x09, 0x6b, 0x65, 0x79, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x73,
	0x1a, 0x70, 0x0a, 0x08, 0x4b, 0x65, 0x79, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x2f, 0x0a, 0x03,
	0x6b, 0x65, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x52, 0x03, 0x6b, 0x65, 0x79, 0x12, 0x33, 0x0a,
	0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x52, 0x05, 0x76, 0x61, 0x6c,
	0x75, 0x65, 0x1a, 0x43, 0x0a, 0x13, 0x49, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x59, 0x65,
	0x61, 0x72, 0x54, 0x6f, 0x4d, 0x6f, 0x6e, 0x74, 0x68, 0x12, 0x14, 0x0a, 0x05, 0x79, 0x65, 0x61,
	0x72, 0x73, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x05, 0x79, 0x65, 0x61, 0x72, 0x73, 0x12,
	0x16, 0x0a, 0x06, 0x6d, 0x6f, 0x6e, 0x74, 0x68, 0x73, 0x18, 0x02, 0x20, 0x01, 0x28, 0x05, 0x52,
	0x06, 0x6d, 0x6f, 0x6e, 0x74, 0x68, 0x73, 0x1a, 0xbf, 0x01, 0x0a, 0x13, 0x49, 0x6e, 0x74, 0x65,
	0x72, 0x76, 0x61, 0x6c, 0x44, 0x61, 0x79, 0x54, 0x6f, 0x53, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x12,
	0x12, 0x0a, 0x04, 0x64, 0x61, 0x79, 0x73, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x04, 0x64,
	0x61, 0x79, 0x73, 0x12, 0x18, 0x0a, 0x07, 0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x73, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x05, 0x52, 0x07, 0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x73, 0x12, 0x28, 0x0a,
	0x0c, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x73, 0x18, 0x03, 0x20,
	0x01, 0x28, 0x05, 0x42, 0x02, 0x18, 0x01, 0x48, 0x00, 0x52, 0x0c, 0x6d, 0x69, 0x63, 0x72, 0x6f,
	0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x73, 0x12, 0x1e, 0x0a, 0x09, 0x70, 0x72, 0x65, 0x63, 0x69,
	0x73, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x05, 0x48, 0x00, 0x52, 0x09, 0x70, 0x72,
	0x65, 0x63, 0x69, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x1e, 0x0a, 0x0a, 0x73, 0x75, 0x62, 0x73, 0x65,
	0x63, 0x6f, 0x6e, 0x64, 0x73, 0x18, 0x05, 0x20, 0x01, 0x28, 0x03, 0x52, 0x0a, 0x73, 0x75, 0x62,
	0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x73, 0x42, 0x10, 0x0a, 0x0e, 0x70, 0x72, 0x65, 0x63, 0x69,
	0x73, 0x69, 0x6f, 0x6e, 0x5f, 0x6d, 0x6f, 0x64, 0x65, 0x1a, 0xe2, 0x01, 0x0a, 0x10, 0x49, 0x6e,
	0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x43, 0x6f, 0x6d, 0x70, 0x6f, 0x75, 0x6e, 0x64, 0x12, 0x66,
	0x0a, 0x16, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x5f, 0x79, 0x65, 0x61, 0x72, 0x5f,
	0x74, 0x6f, 0x5f, 0x6d, 0x6f, 0x6e, 0x74, 0x68, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x31,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x49, 0x6e,
	0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x59, 0x65, 0x61, 0x72, 0x54, 0x6f, 0x4d, 0x6f, 0x6e, 0x74,
	0x68, 0x52, 0x13, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x59, 0x65, 0x61, 0x72, 0x54,
	0x6f, 0x4d, 0x6f, 0x6e, 0x74, 0x68, 0x12, 0x66, 0x0a, 0x16, 0x69, 0x6e, 0x74, 0x65, 0x72, 0x76,
	0x61, 0x6c, 0x5f, 0x64, 0x61, 0x79, 0x5f, 0x74, 0x6f, 0x5f, 0x73, 0x65, 0x63, 0x6f, 0x6e, 0x64,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x31, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69,
	0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x49, 0x6e, 0x74, 0x65, 0x72, 0x76, 0x61, 0x6c, 0x44, 0x61,
	0x79, 0x54, 0x6f, 0x53, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x52, 0x13, 0x69, 0x6e, 0x74, 0x65, 0x72,
	0x76, 0x61, 0x6c, 0x44, 0x61, 0x79, 0x54, 0x6f, 0x53, 0x65, 0x63, 0x6f, 0x6e, 0x64, 0x1a, 0x3f,
	0x0a, 0x06, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x12, 0x35, 0x0a, 0x06, 0x66, 0x69, 0x65, 0x6c,
	0x64, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e,
	0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x52, 0x06, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x1a,
	0x3d, 0x0a, 0x04, 0x4c, 0x69, 0x73, 0x74, 0x12, 0x35, 0x0a, 0x06, 0x76, 0x61, 0x6c, 0x75, 0x65,
	0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c,
	0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x52, 0x06, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x73, 0x1a, 0xed,
	0x01, 0x0a, 0x0b, 0x55, 0x73, 0x65, 0x72, 0x44, 0x65, 0x66, 0x69, 0x6e, 0x65, 0x64, 0x12, 0x25,
	0x0a, 0x0e, 0x74, 0x79, 0x70, 0x65, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x0d, 0x74, 0x79, 0x70, 0x65, 0x52, 0x65, 0x66, 0x65,
	0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x42, 0x0a, 0x0f, 0x74, 0x79, 0x70, 0x65, 0x5f, 0x70, 0x61,
	0x72, 0x61, 0x6d, 0x65, 0x74, 0x65, 0x72, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x19,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x2e,
	0x50, 0x61, 0x72, 0x61, 0x6d, 0x65, 0x74, 0x65, 0x72, 0x52, 0x0e, 0x74, 0x79, 0x70, 0x65, 0x50,
	0x61, 0x72, 0x61, 0x6d, 0x65, 0x74, 0x65, 0x72, 0x73, 0x12, 0x2c, 0x0a, 0x05, 0x76, 0x61, 0x6c,
	0x75, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c,
	0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x41, 0x6e, 0x79, 0x48, 0x00,
	0x52, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x3e, 0x0a, 0x06, 0x73, 0x74, 0x72, 0x75, 0x63,
	0x74, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c,
	0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x2e, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x48, 0x00, 0x52,
	0x06, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x42, 0x05, 0x0a, 0x03, 0x76, 0x61, 0x6c, 0x42, 0x0e,
	0x0a, 0x0c, 0x6c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x1a, 0xbf,
	0x04, 0x0a, 0x06, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x12, 0x1a, 0x0a, 0x08, 0x6e, 0x75, 0x6c,
	0x6c, 0x61, 0x62, 0x6c, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x08, 0x52, 0x08, 0x6e, 0x75, 0x6c,
	0x6c, 0x61, 0x62, 0x6c, 0x65, 0x12, 0x38, 0x0a, 0x18, 0x74, 0x79, 0x70, 0x65, 0x5f, 0x76, 0x61,
	0x72, 0x69, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63,
	0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x16, 0x74, 0x79, 0x70, 0x65, 0x56, 0x61, 0x72,
	0x69, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12,
	0x3d, 0x0a, 0x06, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x23, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x2e, 0x53, 0x74,
	0x72, 0x75, 0x63, 0x74, 0x48, 0x00, 0x52, 0x06, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x12, 0x37,
	0x0a, 0x04, 0x6c, 0x69, 0x73, 0x74, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x21, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x48,
	0x00, 0x52, 0x04, 0x6c, 0x69, 0x73, 0x74, 0x12, 0x34, 0x0a, 0x03, 0x6d, 0x61, 0x70, 0x18, 0x05,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x20, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4e, 0x65, 0x73, 0x74,
	0x65, 0x64, 0x2e, 0x4d, 0x61, 0x70, 0x48, 0x00, 0x52, 0x03, 0x6d, 0x61, 0x70, 0x1a, 0xb1, 0x01,
	0x0a, 0x03, 0x4d, 0x61, 0x70, 0x12, 0x48, 0x0a, 0x0a, 0x6b, 0x65, 0x79, 0x5f, 0x76, 0x61, 0x6c,
	0x75, 0x65, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x29, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x4e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x2e, 0x4d, 0x61, 0x70, 0x2e, 0x4b, 0x65, 0x79, 0x56,
	0x61, 0x6c, 0x75, 0x65, 0x52, 0x09, 0x6b, 0x65, 0x79, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x73, 0x1a,
	0x60, 0x0a, 0x08, 0x4b, 0x65, 0x79, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x27, 0x0a, 0x03, 0x6b,
	0x65, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52,
	0x03, 0x6b, 0x65, 0x79, 0x12, 0x2b, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x05, 0x76, 0x61, 0x6c, 0x75,
	0x65, 0x1a, 0x37, 0x0a, 0x06, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x12, 0x2d, 0x0a, 0x06, 0x66,
	0x69, 0x65, 0x6c, 0x64, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x52, 0x06, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x1a, 0x35, 0x0a, 0x04, 0x4c, 0x69,
	0x73, 0x74, 0x12, 0x2d, 0x0a, 0x06, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x73, 0x18, 0x01, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x06, 0x76, 0x61, 0x6c, 0x75, 0x65,
	0x73, 0x42, 0x0d, 0x0a, 0x0b, 0x6e, 0x65, 0x73, 0x74, 0x65, 0x64, 0x5f, 0x74, 0x79, 0x70, 0x65,
	0x1a, 0x90, 0x02, 0x0a, 0x0e, 0x53, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x46, 0x75, 0x6e, 0x63, 0x74,
	0x69, 0x6f, 0x6e, 0x12, 0x2d, 0x0a, 0x12, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x5f,
	0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0d, 0x52,
	0x11, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e,
	0x63, 0x65, 0x12, 0x39, 0x0a, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x18,
	0x04, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x41, 0x72, 0x67, 0x75, 0x6d, 0x65,
	0x6e, 0x74, 0x52, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x12, 0x33, 0x0a,
	0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x05, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x19,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x46, 0x75, 0x6e, 0x63, 0x74,
	0x69, 0x6f, 0x6e, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f,
	0x6e, 0x73, 0x12, 0x30, 0x0a, 0x0b, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x5f, 0x74, 0x79, 0x70,
	0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x0a, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74,
	0x54, 0x79, 0x70, 0x65, 0x12, 0x2d, 0x0a, 0x04, 0x61, 0x72, 0x67, 0x73, 0x18, 0x02, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x42, 0x02, 0x18, 0x01, 0x52, 0x04, 0x61,
	0x72, 0x67, 0x73, 0x1a, 0x91, 0x0a, 0x0a, 0x0e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75,
	0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x2d, 0x0a, 0x12, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69,
	0x6f, 0x6e, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x0d, 0x52, 0x11, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65,
	0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x39, 0x0a, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e,
	0x74, 0x73, 0x18, 0x09, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x41, 0x72, 0x67,
	0x75, 0x6d, 0x65, 0x6e, 0x74, 0x52, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73,
	0x12, 0x33, 0x0a, 0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x0b, 0x20, 0x03, 0x28,
	0x0b, 0x32, 0x19, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x46, 0x75,
	0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x07, 0x6f, 0x70,
	0x74, 0x69, 0x6f, 0x6e, 0x73, 0x12, 0x30, 0x0a, 0x0b, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x5f,
	0x74, 0x79, 0x70, 0x65, 0x18, 0x07, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x0a, 0x6f, 0x75, 0x74,
	0x70, 0x75, 0x74, 0x54, 0x79, 0x70, 0x65, 0x12, 0x31, 0x0a, 0x05, 0x70, 0x68, 0x61, 0x73, 0x65,
	0x18, 0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x50, 0x68,
	0x61, 0x73, 0x65, 0x52, 0x05, 0x70, 0x68, 0x61, 0x73, 0x65, 0x12, 0x2a, 0x0a, 0x05, 0x73, 0x6f,
	0x72, 0x74, 0x73, 0x18, 0x03, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x53, 0x6f, 0x72, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52,
	0x05, 0x73, 0x6f, 0x72, 0x74, 0x73, 0x12, 0x52, 0x0a, 0x0a, 0x69, 0x6e, 0x76, 0x6f, 0x63, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x18, 0x0a, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x32, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65,
	0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x49, 0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x0a,
	0x69, 0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x35, 0x0a, 0x0a, 0x70, 0x61,
	0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x02, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x70, 0x61, 0x72, 0x74, 0x69, 0x74, 0x69, 0x6f, 0x6e,
	0x73, 0x12, 0x50, 0x0a, 0x0b, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x73, 0x5f, 0x74, 0x79, 0x70, 0x65,
	0x18, 0x0c, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x2f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x57, 0x69,
	0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42, 0x6f, 0x75,
	0x6e, 0x64, 0x73, 0x54, 0x79, 0x70, 0x65, 0x52, 0x0a, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x73, 0x54,
	0x79, 0x70, 0x65, 0x12, 0x4b, 0x0a, 0x0b, 0x6c, 0x6f, 0x77, 0x65, 0x72, 0x5f, 0x62, 0x6f, 0x75,
	0x6e, 0x64, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e,
	0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42,
	0x6f, 0x75, 0x6e, 0x64, 0x52, 0x0a, 0x6c, 0x6f, 0x77, 0x65, 0x72, 0x42, 0x6f, 0x75, 0x6e, 0x64,
	0x12, 0x4b, 0x0a, 0x0b, 0x75, 0x70, 0x70, 0x65, 0x72, 0x5f, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x18,
	0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x57, 0x69, 0x6e,
	0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42, 0x6f, 0x75, 0x6e,
	0x64, 0x52, 0x0a, 0x75, 0x70, 0x70, 0x65, 0x72, 0x42, 0x6f, 0x75, 0x6e, 0x64, 0x12, 0x2d, 0x0a,
	0x04, 0x61, 0x72, 0x67, 0x73, 0x18, 0x08, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x42, 0x02, 0x18, 0x01, 0x52, 0x04, 0x61, 0x72, 0x67, 0x73, 0x1a, 0xd0, 0x03, 0x0a,
	0x05, 0x42, 0x6f, 0x75, 0x6e, 0x64, 0x12, 0x54, 0x0a, 0x09, 0x70, 0x72, 0x65, 0x63, 0x65, 0x64,
	0x69, 0x6e, 0x67, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x34, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e,
	0x42, 0x6f, 0x75, 0x6e, 0x64, 0x2e, 0x50, 0x72, 0x65, 0x63, 0x65, 0x64, 0x69, 0x6e, 0x67, 0x48,
	0x00, 0x52, 0x09, 0x70, 0x72, 0x65, 0x63, 0x65, 0x64, 0x69, 0x6e, 0x67, 0x12, 0x54, 0x0a, 0x09,
	0x66, 0x6f, 0x6c, 0x6c, 0x6f, 0x77, 0x69, 0x6e, 0x67, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x34, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42, 0x6f, 0x75, 0x6e, 0x64, 0x2e, 0x46, 0x6f, 0x6c, 0x6c,
	0x6f, 0x77, 0x69, 0x6e, 0x67, 0x48, 0x00, 0x52, 0x09, 0x66, 0x6f, 0x6c, 0x6c, 0x6f, 0x77, 0x69,
	0x6e, 0x67, 0x12, 0x58, 0x0a, 0x0b, 0x63, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x74, 0x5f, 0x72, 0x6f,
	0x77, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x35, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x57,
	0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42, 0x6f,
	0x75, 0x6e, 0x64, 0x2e, 0x43, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x74, 0x52, 0x6f, 0x77, 0x48, 0x00,
	0x52, 0x0a, 0x63, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x74, 0x52, 0x6f, 0x77, 0x12, 0x54, 0x0a, 0x09,
	0x75, 0x6e, 0x62, 0x6f, 0x75, 0x6e, 0x64, 0x65, 0x64, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x34, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x57, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x46, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x42, 0x6f, 0x75, 0x6e, 0x64, 0x2e, 0x55, 0x6e, 0x62, 0x6f,
	0x75, 0x6e, 0x64, 0x65, 0x64, 0x48, 0x00, 0x52, 0x09, 0x75, 0x6e, 0x62, 0x6f, 0x75, 0x6e, 0x64,
	0x65, 0x64, 0x1a, 0x23, 0x0a, 0x09, 0x50, 0x72, 0x65, 0x63, 0x65, 0x64, 0x69, 0x6e, 0x67, 0x12,
	0x16, 0x0a, 0x06, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x03, 0x52,
	0x06, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x1a, 0x23, 0x0a, 0x09, 0x46, 0x6f, 0x6c, 0x6c, 0x6f,
	0x77, 0x69, 0x6e, 0x67, 0x12, 0x16, 0x0a, 0x06, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x03, 0x52, 0x06, 0x6f, 0x66, 0x66, 0x73, 0x65, 0x74, 0x1a, 0x0c, 0x0a, 0x0a,
	0x43, 0x75, 0x72, 0x72, 0x65, 0x6e, 0x74, 0x52, 0x6f, 0x77, 0x1a, 0x0b, 0x0a, 0x09, 0x55, 0x6e,
	0x62, 0x6f, 0x75, 0x6e, 0x64, 0x65, 0x64, 0x42, 0x06, 0x0a, 0x04, 0x6b, 0x69, 0x6e, 0x64, 0x22,
	0x56, 0x0a, 0x0a, 0x42, 0x6f, 0x75, 0x6e, 0x64, 0x73, 0x54, 0x79, 0x70, 0x65, 0x12, 0x1b, 0x0a,
	0x17, 0x42, 0x4f, 0x55, 0x4e, 0x44, 0x53, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x55, 0x4e, 0x53,
	0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x14, 0x0a, 0x10, 0x42, 0x4f,
	0x55, 0x4e, 0x44, 0x53, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f, 0x52, 0x4f, 0x57, 0x53, 0x10, 0x01,
	0x12, 0x15, 0x0a, 0x11, 0x42, 0x4f, 0x55, 0x4e, 0x44, 0x53, 0x5f, 0x54, 0x59, 0x50, 0x45, 0x5f,
	0x52, 0x41, 0x4e, 0x47, 0x45, 0x10, 0x02, 0x1a, 0xca, 0x01, 0x0a, 0x06, 0x49, 0x66, 0x54, 0x68,
	0x65, 0x6e, 0x12, 0x37, 0x0a, 0x03, 0x69, 0x66, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32,
	0x25, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x49, 0x66, 0x54, 0x68, 0x65, 0x6e, 0x2e, 0x49, 0x66,
	0x43, 0x6c, 0x61, 0x75, 0x73, 0x65, 0x52, 0x03, 0x69, 0x66, 0x73, 0x12, 0x29, 0x0a, 0x04, 0x65,
	0x6c, 0x73, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x52, 0x04, 0x65, 0x6c, 0x73, 0x65, 0x1a, 0x5c, 0x0a, 0x08, 0x49, 0x66, 0x43, 0x6c, 0x61, 0x75,
	0x73, 0x65, 0x12, 0x25, 0x0a, 0x02, 0x69, 0x66, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x02, 0x69, 0x66, 0x12, 0x29, 0x0a, 0x04, 0x74, 0x68, 0x65,
	0x6e, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x04,
	0x74, 0x68, 0x65, 0x6e, 0x1a, 0xac, 0x02, 0x0a, 0x04, 0x43, 0x61, 0x73, 0x74, 0x12, 0x23, 0x0a,
	0x04, 0x74, 0x79, 0x70, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x04, 0x74, 0x79,
	0x70, 0x65, 0x12, 0x2b, 0x0a, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75, 0x74, 0x12,
	0x55, 0x0a, 0x10, 0x66, 0x61, 0x69, 0x6c, 0x75, 0x72, 0x65, 0x5f, 0x62, 0x65, 0x68, 0x61, 0x76,
	0x69, 0x6f, 0x72, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x2a, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x43, 0x61, 0x73, 0x74, 0x2e, 0x46, 0x61, 0x69, 0x6c, 0x75, 0x72, 0x65, 0x42, 0x65, 0x68,
	0x61, 0x76, 0x69, 0x6f, 0x72, 0x52, 0x0f, 0x66, 0x61, 0x69, 0x6c, 0x75, 0x72, 0x65, 0x42, 0x65,
	0x68, 0x61, 0x76, 0x69, 0x6f, 0x72, 0x22, 0x7b, 0x0a, 0x0f, 0x46, 0x61, 0x69, 0x6c, 0x75, 0x72,
	0x65, 0x42, 0x65, 0x68, 0x61, 0x76, 0x69, 0x6f, 0x72, 0x12, 0x20, 0x0a, 0x1c, 0x46, 0x41, 0x49,
	0x4c, 0x55, 0x52, 0x45, 0x5f, 0x42, 0x45, 0x48, 0x41, 0x56, 0x49, 0x4f, 0x52, 0x5f, 0x55, 0x4e,
	0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x20, 0x0a, 0x1c, 0x46,
	0x41, 0x49, 0x4c, 0x55, 0x52, 0x45, 0x5f, 0x42, 0x45, 0x48, 0x41, 0x56, 0x49, 0x4f, 0x52, 0x5f,
	0x52, 0x45, 0x54, 0x55, 0x52, 0x4e, 0x5f, 0x4e, 0x55, 0x4c, 0x4c, 0x10, 0x01, 0x12, 0x24, 0x0a,
	0x20, 0x46, 0x41, 0x49, 0x4c, 0x55, 0x52, 0x45, 0x5f, 0x42, 0x45, 0x48, 0x41, 0x56, 0x49, 0x4f,
	0x52, 0x5f, 0x54, 0x48, 0x52, 0x4f, 0x57, 0x5f, 0x45, 0x58, 0x43, 0x45, 0x50, 0x54, 0x49, 0x4f,
	0x4e, 0x10, 0x02, 0x1a, 0x91, 0x02, 0x0a, 0x10, 0x53, 0x77, 0x69, 0x74, 0x63, 0x68, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x2b, 0x0a, 0x05, 0x6d, 0x61, 0x74, 0x63,
	0x68, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x05,
	0x6d, 0x61, 0x74, 0x63, 0x68, 0x12, 0x40, 0x0a, 0x03, 0x69, 0x66, 0x73, 0x18, 0x01, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x2e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x77, 0x69, 0x74, 0x63, 0x68,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x49, 0x66, 0x56, 0x61, 0x6c,
	0x75, 0x65, 0x52, 0x03, 0x69, 0x66, 0x73, 0x12, 0x29, 0x0a, 0x04, 0x65, 0x6c, 0x73, 0x65, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x04, 0x65, 0x6c,
	0x73, 0x65, 0x1a, 0x63, 0x0a, 0x07, 0x49, 0x66, 0x56, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x2d, 0x0a,
	0x02, 0x69, 0x66, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72, 0x61, 0x6c, 0x52, 0x02, 0x69, 0x66, 0x12, 0x29, 0x0a, 0x04,
	0x74, 0x68, 0x65, 0x6e, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x52, 0x04, 0x74, 0x68, 0x65, 0x6e, 0x1a, 0x6e, 0x0a, 0x0e, 0x53, 0x69, 0x6e, 0x67, 0x75,
	0x6c, 0x61, 0x72, 0x4f, 0x72, 0x4c, 0x69, 0x73, 0x74, 0x12, 0x2b, 0x0a, 0x05, 0x76, 0x61, 0x6c,
	0x75, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52,
	0x05, 0x76, 0x61, 0x6c, 0x75, 0x65, 0x12, 0x2f, 0x0a, 0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e,
	0x73, 0x18, 0x02, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x07,
	0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x1a, 0xb7, 0x01, 0x0a, 0x0b, 0x4d, 0x75, 0x6c, 0x74,
	0x69, 0x4f, 0x72, 0x4c, 0x69, 0x73, 0x74, 0x12, 0x2b, 0x0a, 0x05, 0x76, 0x61, 0x6c, 0x75, 0x65,
	0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x05, 0x76,
	0x61, 0x6c, 0x75, 0x65, 0x12, 0x42, 0x0a, 0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18,
	0x02, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x28, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x75, 0x6c,
	0x74, 0x69, 0x4f, 0x72, 0x4c, 0x69, 0x73, 0x74, 0x2e, 0x52, 0x65, 0x63, 0x6f, 0x72, 0x64, 0x52,
	0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x1a, 0x37, 0x0a, 0x06, 0x52, 0x65, 0x63, 0x6f,
	0x72, 0x64, 0x12, 0x2d, 0x0a, 0x06, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x73, 0x18, 0x01, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x06, 0x66, 0x69, 0x65, 0x6c, 0x64,
	0x73, 0x1a, 0x93, 0x04, 0x0a, 0x10, 0x45, 0x6d, 0x62, 0x65, 0x64, 0x64, 0x65, 0x64, 0x46, 0x75,
	0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x33, 0x0a, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65,
	0x6e, 0x74, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x52, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x12, 0x30, 0x0a, 0x0b, 0x6f,
	0x75, 0x74, 0x70, 0x75, 0x74, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x54, 0x79, 0x70,
	0x65, 0x52, 0x0a, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x54, 0x79, 0x70, 0x65, 0x12, 0x73, 0x0a,
	0x16, 0x70, 0x79, 0x74, 0x68, 0x6f, 0x6e, 0x5f, 0x70, 0x69, 0x63, 0x6b, 0x6c, 0x65, 0x5f, 0x66,
	0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x3b, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x45, 0x6d, 0x62, 0x65, 0x64, 0x64, 0x65, 0x64, 0x46, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x50, 0x79, 0x74, 0x68, 0x6f, 0x6e, 0x50, 0x69, 0x63, 0x6b,
	0x6c, 0x65, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x14, 0x70, 0x79,
	0x74, 0x68, 0x6f, 0x6e, 0x50, 0x69, 0x63, 0x6b, 0x6c, 0x65, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69,
	0x6f, 0x6e, 0x12, 0x70, 0x0a, 0x15, 0x77, 0x65, 0x62, 0x5f, 0x61, 0x73, 0x73, 0x65, 0x6d, 0x62,
	0x6c, 0x79, 0x5f, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x3a, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x45, 0x6d, 0x62, 0x65, 0x64, 0x64, 0x65,
	0x64, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x57, 0x65, 0x62, 0x41, 0x73, 0x73,
	0x65, 0x6d, 0x62, 0x6c, 0x79, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52,
	0x13, 0x77, 0x65, 0x62, 0x41, 0x73, 0x73, 0x65, 0x6d, 0x62, 0x6c, 0x79, 0x46, 0x75, 0x6e, 0x63,
	0x74, 0x69, 0x6f, 0x6e, 0x1a, 0x56, 0x0a, 0x14, 0x50, 0x79, 0x74, 0x68, 0x6f, 0x6e, 0x50, 0x69,
	0x63, 0x6b, 0x6c, 0x65, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x1a, 0x0a, 0x08,
	0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0c, 0x52, 0x08,
	0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x22, 0x0a, 0x0c, 0x70, 0x72, 0x65, 0x72,
	0x65, 0x71, 0x75, 0x69, 0x73, 0x69, 0x74, 0x65, 0x18, 0x02, 0x20, 0x03, 0x28, 0x09, 0x52, 0x0c,
	0x70, 0x72, 0x65, 0x72, 0x65, 0x71, 0x75, 0x69, 0x73, 0x69, 0x74, 0x65, 0x1a, 0x51, 0x0a, 0x13,
	0x57, 0x65, 0x62, 0x41, 0x73, 0x73, 0x65, 0x6d, 0x62, 0x6c, 0x79, 0x46, 0x75, 0x6e, 0x63, 0x74,
	0x69, 0x6f, 0x6e, 0x12, 0x16, 0x0a, 0x06, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x18, 0x01, 0x20,
	0x01, 0x28, 0x0c, 0x52, 0x06, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x12, 0x22, 0x0a, 0x0c, 0x70,
	0x72, 0x65, 0x72, 0x65, 0x71, 0x75, 0x69, 0x73, 0x69, 0x74, 0x65, 0x18, 0x02, 0x20, 0x03, 0x28,
	0x09, 0x52, 0x0c, 0x70, 0x72, 0x65, 0x72, 0x65, 0x71, 0x75, 0x69, 0x73, 0x69, 0x74, 0x65, 0x42,
	0x06, 0x0a, 0x04, 0x6b, 0x69, 0x6e, 0x64, 0x1a, 0xe8, 0x04, 0x0a, 0x10, 0x52, 0x65, 0x66, 0x65,
	0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65, 0x67, 0x6d, 0x65, 0x6e, 0x74, 0x12, 0x48, 0x0a, 0x07,
	0x6d, 0x61, 0x70, 0x5f, 0x6b, 0x65, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2d, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65,
	0x67, 0x6d, 0x65, 0x6e, 0x74, 0x2e, 0x4d, 0x61, 0x70, 0x4b, 0x65, 0x79, 0x48, 0x00, 0x52, 0x06,
	0x6d, 0x61, 0x70, 0x4b, 0x65, 0x79, 0x12, 0x57, 0x0a, 0x0c, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74,
	0x5f, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x32, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65, 0x67,
	0x6d, 0x65, 0x6e, 0x74, 0x2e, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64,
	0x48, 0x00, 0x52, 0x0b, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x12,
	0x57, 0x0a, 0x0c, 0x6c, 0x69, 0x73, 0x74, 0x5f, 0x65, 0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x18,
	0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x32, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x66,
	0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65, 0x67, 0x6d, 0x65, 0x6e, 0x74, 0x2e, 0x4c, 0x69,
	0x73, 0x74, 0x45, 0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x48, 0x00, 0x52, 0x0b, 0x6c, 0x69, 0x73,
	0x74, 0x45, 0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x1a, 0x7e, 0x0a, 0x06, 0x4d, 0x61, 0x70, 0x4b,
	0x65, 0x79, 0x12, 0x36, 0x0a, 0x07, 0x6d, 0x61, 0x70, 0x5f, 0x6b, 0x65, 0x79, 0x18, 0x01, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x1d, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x74, 0x65, 0x72,
	0x61, 0x6c, 0x52, 0x06, 0x6d, 0x61, 0x70, 0x4b, 0x65, 0x79, 0x12, 0x3c, 0x0a, 0x05, 0x63, 0x68,
	0x69, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x26, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65, 0x67, 0x6d, 0x65, 0x6e,
	0x74, 0x52, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x1a, 0x61, 0x0a, 0x0b, 0x53, 0x74, 0x72, 0x75,
	0x63, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x12, 0x14, 0x0a, 0x05, 0x66, 0x69, 0x65, 0x6c, 0x64,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x05, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x12, 0x3c, 0x0a,
	0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x26, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65, 0x67,
	0x6d, 0x65, 0x6e, 0x74, 0x52, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x1a, 0x63, 0x0a, 0x0b, 0x4c,
	0x69, 0x73, 0x74, 0x45, 0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x12, 0x16, 0x0a, 0x06, 0x6f, 0x66,
	0x66, 0x73, 0x65, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x06, 0x6f, 0x66, 0x66, 0x73,
	0x65, 0x74, 0x12, 0x3c, 0x0a, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x26, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e,
	0x63, 0x65, 0x53, 0x65, 0x67, 0x6d, 0x65, 0x6e, 0x74, 0x52, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64,
	0x42, 0x10, 0x0a, 0x0e, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x5f, 0x74, 0x79,
	0x70, 0x65, 0x1a, 0xa2, 0x0b, 0x0a, 0x0e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x49, 0x0a, 0x06, 0x73, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x31, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73,
	0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x74, 0x72, 0x75,
	0x63, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x52, 0x06, 0x73, 0x65, 0x6c, 0x65, 0x63, 0x74,
	0x12, 0x38, 0x0a, 0x18, 0x6d, 0x61, 0x69, 0x6e, 0x74, 0x61, 0x69, 0x6e, 0x5f, 0x73, 0x69, 0x6e,
	0x67, 0x75, 0x6c, 0x61, 0x72, 0x5f, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x18, 0x02, 0x20, 0x01,
	0x28, 0x08, 0x52, 0x16, 0x6d, 0x61, 0x69, 0x6e, 0x74, 0x61, 0x69, 0x6e, 0x53, 0x69, 0x6e, 0x67,
	0x75, 0x6c, 0x61, 0x72, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x1a, 0xe8, 0x01, 0x0a, 0x06, 0x53,
	0x65, 0x6c, 0x65, 0x63, 0x74, 0x12, 0x4b, 0x0a, 0x06, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x31, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73,
	0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x74, 0x72, 0x75,
	0x63, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x48, 0x00, 0x52, 0x06, 0x73, 0x74, 0x72, 0x75,
	0x63, 0x74, 0x12, 0x45, 0x0a, 0x04, 0x6c, 0x69, 0x73, 0x74, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b,
	0x32, 0x2f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70,
	0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72,
	0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63,
	0x74, 0x48, 0x00, 0x52, 0x04, 0x6c, 0x69, 0x73, 0x74, 0x12, 0x42, 0x0a, 0x03, 0x6d, 0x61, 0x70,
	0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61,
	0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x70,
	0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x48, 0x00, 0x52, 0x03, 0x6d, 0x61, 0x70, 0x42, 0x06, 0x0a,
	0x04, 0x74, 0x79, 0x70, 0x65, 0x1a, 0x62, 0x0a, 0x0c, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x53,
	0x65, 0x6c, 0x65, 0x63, 0x74, 0x12, 0x52, 0x0a, 0x0c, 0x73, 0x74, 0x72, 0x75, 0x63, 0x74, 0x5f,
	0x69, 0x74, 0x65, 0x6d, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x2f, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f,
	0x6e, 0x2e, 0x53, 0x74, 0x72, 0x75, 0x63, 0x74, 0x49, 0x74, 0x65, 0x6d, 0x52, 0x0b, 0x73, 0x74,
	0x72, 0x75, 0x63, 0x74, 0x49, 0x74, 0x65, 0x6d, 0x73, 0x1a, 0x65, 0x0a, 0x0a, 0x53, 0x74, 0x72,
	0x75, 0x63, 0x74, 0x49, 0x74, 0x65, 0x6d, 0x12, 0x14, 0x0a, 0x05, 0x66, 0x69, 0x65, 0x6c, 0x64,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x05, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x12, 0x41, 0x0a,
	0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x52, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64,
	0x1a, 0xe6, 0x03, 0x0a, 0x0a, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x12,
	0x5c, 0x0a, 0x09, 0x73, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x03,
	0x28, 0x0b, 0x32, 0x3e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c,
	0x65, 0x63, 0x74, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x49, 0x74,
	0x65, 0x6d, 0x52, 0x09, 0x73, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x41, 0x0a,
	0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73,
	0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x52, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64,
	0x1a, 0xb6, 0x02, 0x0a, 0x0e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x49,
	0x74, 0x65, 0x6d, 0x12, 0x60, 0x0a, 0x04, 0x69, 0x74, 0x65, 0x6d, 0x18, 0x01, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x4a, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70,
	0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65,
	0x63, 0x74, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x49, 0x74, 0x65,
	0x6d, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x45, 0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x48, 0x00, 0x52,
	0x04, 0x69, 0x74, 0x65, 0x6d, 0x12, 0x60, 0x0a, 0x05, 0x73, 0x6c, 0x69, 0x63, 0x65, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x48, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53,
	0x65, 0x6c, 0x65, 0x63, 0x74, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74,
	0x49, 0x74, 0x65, 0x6d, 0x2e, 0x4c, 0x69, 0x73, 0x74, 0x53, 0x6c, 0x69, 0x63, 0x65, 0x48, 0x00,
	0x52, 0x05, 0x73, 0x6c, 0x69, 0x63, 0x65, 0x1a, 0x23, 0x0a, 0x0b, 0x4c, 0x69, 0x73, 0x74, 0x45,
	0x6c, 0x65, 0x6d, 0x65, 0x6e, 0x74, 0x12, 0x14, 0x0a, 0x05, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x18,
	0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x05, 0x66, 0x69, 0x65, 0x6c, 0x64, 0x1a, 0x33, 0x0a, 0x09,
	0x4c, 0x69, 0x73, 0x74, 0x53, 0x6c, 0x69, 0x63, 0x65, 0x12, 0x14, 0x0a, 0x05, 0x73, 0x74, 0x61,
	0x72, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x05, 0x73, 0x74, 0x61, 0x72, 0x74, 0x12,
	0x10, 0x0a, 0x03, 0x65, 0x6e, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x05, 0x52, 0x03, 0x65, 0x6e,
	0x64, 0x42, 0x06, 0x0a, 0x04, 0x74, 0x79, 0x70, 0x65, 0x1a, 0xeb, 0x02, 0x0a, 0x09, 0x4d, 0x61,
	0x70, 0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x12, 0x49, 0x0a, 0x03, 0x6b, 0x65, 0x79, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x35, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x70, 0x53, 0x65,
	0x6c, 0x65, 0x63, 0x74, 0x2e, 0x4d, 0x61, 0x70, 0x4b, 0x65, 0x79, 0x48, 0x00, 0x52, 0x03, 0x6b,
	0x65, 0x79, 0x12, 0x61, 0x0a, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x3f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61,
	0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x70,
	0x53, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x2e, 0x4d, 0x61, 0x70, 0x4b, 0x65, 0x79, 0x45, 0x78, 0x70,
	0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x41, 0x0a, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x18, 0x03,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x4d, 0x61, 0x73, 0x6b,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x65, 0x6c, 0x65, 0x63,
	0x74, 0x52, 0x05, 0x63, 0x68, 0x69, 0x6c, 0x64, 0x1a, 0x21, 0x0a, 0x06, 0x4d, 0x61, 0x70, 0x4b,
	0x65, 0x79, 0x12, 0x17, 0x0a, 0x07, 0x6d, 0x61, 0x70, 0x5f, 0x6b, 0x65, 0x79, 0x18, 0x01, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x06, 0x6d, 0x61, 0x70, 0x4b, 0x65, 0x79, 0x1a, 0x40, 0x0a, 0x10, 0x4d,
	0x61, 0x70, 0x4b, 0x65, 0x79, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12,
	0x2c, 0x0a, 0x12, 0x6d, 0x61, 0x70, 0x5f, 0x6b, 0x65, 0x79, 0x5f, 0x65, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x10, 0x6d, 0x61, 0x70,
	0x4b, 0x65, 0x79, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x42, 0x08, 0x0a,
	0x06, 0x73, 0x65, 0x6c, 0x65, 0x63, 0x74, 0x1a, 0x8d, 0x04, 0x0a, 0x0e, 0x46, 0x69, 0x65, 0x6c,
	0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x53, 0x0a, 0x10, 0x64, 0x69,
	0x72, 0x65, 0x63, 0x74, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x26, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x66, 0x65,
	0x72, 0x65, 0x6e, 0x63, 0x65, 0x53, 0x65, 0x67, 0x6d, 0x65, 0x6e, 0x74, 0x48, 0x00, 0x52, 0x0f,
	0x64, 0x69, 0x72, 0x65, 0x63, 0x74, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12,
	0x51, 0x0a, 0x10, 0x6d, 0x61, 0x73, 0x6b, 0x65, 0x64, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65,
	0x6e, 0x63, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x24, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x4d, 0x61, 0x73, 0x6b, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48,
	0x00, 0x52, 0x0f, 0x6d, 0x61, 0x73, 0x6b, 0x65, 0x64, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e,
	0x63, 0x65, 0x12, 0x37, 0x0a, 0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61,
	0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x48, 0x01, 0x52,
	0x0a, 0x65, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x12, 0x5b, 0x0a, 0x0e, 0x72,
	0x6f, 0x6f, 0x74, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x04, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x32, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64,
	0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x2e, 0x52, 0x6f, 0x6f, 0x74, 0x52, 0x65,
	0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x48, 0x01, 0x52, 0x0d, 0x72, 0x6f, 0x6f, 0x74, 0x52,
	0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x5e, 0x0a, 0x0f, 0x6f, 0x75, 0x74, 0x65,
	0x72, 0x5f, 0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x05, 0x20, 0x01, 0x28,
	0x0b, 0x32, 0x33, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x65,
	0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x2e, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x52, 0x65, 0x66,
	0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x48, 0x01, 0x52, 0x0e, 0x6f, 0x75, 0x74, 0x65, 0x72, 0x52,
	0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x1a, 0x0f, 0x0a, 0x0d, 0x52, 0x6f, 0x6f, 0x74,
	0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x1a, 0x2d, 0x0a, 0x0e, 0x4f, 0x75, 0x74,
	0x65, 0x72, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x12, 0x1b, 0x0a, 0x09, 0x73,
	0x74, 0x65, 0x70, 0x73, 0x5f, 0x6f, 0x75, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x08,
	0x73, 0x74, 0x65, 0x70, 0x73, 0x4f, 0x75, 0x74, 0x42, 0x10, 0x0a, 0x0e, 0x72, 0x65, 0x66, 0x65,
	0x72, 0x65, 0x6e, 0x63, 0x65, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x42, 0x0b, 0x0a, 0x09, 0x72, 0x6f,
	0x6f, 0x74, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x1a, 0x95, 0x0a, 0x0a, 0x08, 0x53, 0x75, 0x62, 0x71,
	0x75, 0x65, 0x72, 0x79, 0x12, 0x3f, 0x0a, 0x06, 0x73, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0b, 0x32, 0x25, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x75, 0x62, 0x71,
	0x75, 0x65, 0x72, 0x79, 0x2e, 0x53, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x48, 0x00, 0x52, 0x06, 0x73,
	0x63, 0x61, 0x6c, 0x61, 0x72, 0x12, 0x4f, 0x0a, 0x0c, 0x69, 0x6e, 0x5f, 0x70, 0x72, 0x65, 0x64,
	0x69, 0x63, 0x61, 0x74, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2a, 0x2e, 0x73, 0x75,
	0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69,
	0x6f, 0x6e, 0x2e, 0x53, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x2e, 0x49, 0x6e, 0x50, 0x72,
	0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x48, 0x00, 0x52, 0x0b, 0x69, 0x6e, 0x50, 0x72, 0x65,
	0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x12, 0x52, 0x0a, 0x0d, 0x73, 0x65, 0x74, 0x5f, 0x70, 0x72,
	0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x2b, 0x2e,
	0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73,
	0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x2e, 0x53, 0x65,
	0x74, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x48, 0x00, 0x52, 0x0c, 0x73, 0x65,
	0x74, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x12, 0x55, 0x0a, 0x0e, 0x73, 0x65,
	0x74, 0x5f, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01,
	0x28, 0x0b, 0x32, 0x2c, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45,
	0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x75, 0x62, 0x71, 0x75, 0x65,
	0x72, 0x79, 0x2e, 0x53, 0x65, 0x74, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e,
	0x48, 0x00, 0x52, 0x0d, 0x73, 0x65, 0x74, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f,
	0x6e, 0x1a, 0x2e, 0x0a, 0x06, 0x53, 0x63, 0x61, 0x6c, 0x61, 0x72, 0x12, 0x24, 0x0a, 0x05, 0x69,
	0x6e, 0x70, 0x75, 0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x69, 0x6e, 0x70, 0x75,
	0x74, 0x1a, 0x6a, 0x0a, 0x0b, 0x49, 0x6e, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65,
	0x12, 0x2f, 0x0a, 0x07, 0x6e, 0x65, 0x65, 0x64, 0x6c, 0x65, 0x73, 0x18, 0x01, 0x20, 0x03, 0x28,
	0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78,
	0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x07, 0x6e, 0x65, 0x65, 0x64, 0x6c, 0x65,
	0x73, 0x12, 0x2a, 0x0a, 0x08, 0x68, 0x61, 0x79, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x52, 0x65, 0x6c, 0x52, 0x08, 0x68, 0x61, 0x79, 0x73, 0x74, 0x61, 0x63, 0x6b, 0x1a, 0xf1, 0x01,
	0x0a, 0x0c, 0x53, 0x65, 0x74, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x12, 0x5a,
	0x0a, 0x0c, 0x70, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x5f, 0x6f, 0x70, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x0e, 0x32, 0x37, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53, 0x75, 0x62, 0x71,
	0x75, 0x65, 0x72, 0x79, 0x2e, 0x53, 0x65, 0x74, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74,
	0x65, 0x2e, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x4f, 0x70, 0x52, 0x0b, 0x70,
	0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x4f, 0x70, 0x12, 0x26, 0x0a, 0x06, 0x74, 0x75,
	0x70, 0x6c, 0x65, 0x73, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x06, 0x74, 0x75, 0x70, 0x6c,
	0x65, 0x73, 0x22, 0x5d, 0x0a, 0x0b, 0x50, 0x72, 0x65, 0x64, 0x69, 0x63, 0x61, 0x74, 0x65, 0x4f,
	0x70, 0x12, 0x1c, 0x0a, 0x18, 0x50, 0x52, 0x45, 0x44, 0x49, 0x43, 0x41, 0x54, 0x45, 0x5f, 0x4f,
	0x50, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12,
	0x17, 0x0a, 0x13, 0x50, 0x52, 0x45, 0x44, 0x49, 0x43, 0x41, 0x54, 0x45, 0x5f, 0x4f, 0x50, 0x5f,
	0x45, 0x58, 0x49, 0x53, 0x54, 0x53, 0x10, 0x01, 0x12, 0x17, 0x0a, 0x13, 0x50, 0x52, 0x45, 0x44,
	0x49, 0x43, 0x41, 0x54, 0x45, 0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x4e, 0x49, 0x51, 0x55, 0x45, 0x10,
	0x02, 0x1a, 0xaa, 0x04, 0x0a, 0x0d, 0x53, 0x65, 0x74, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69,
	0x73, 0x6f, 0x6e, 0x12, 0x5b, 0x0a, 0x0c, 0x72, 0x65, 0x64, 0x75, 0x63, 0x74, 0x69, 0x6f, 0x6e,
	0x5f, 0x6f, 0x70, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x38, 0x2e, 0x73, 0x75, 0x62, 0x73,
	0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e,
	0x2e, 0x53, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x2e, 0x53, 0x65, 0x74, 0x43, 0x6f, 0x6d,
	0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x2e, 0x52, 0x65, 0x64, 0x75, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x4f, 0x70, 0x52, 0x0b, 0x72, 0x65, 0x64, 0x75, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x4f, 0x70,
	0x12, 0x5e, 0x0a, 0x0d, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x5f, 0x6f,
	0x70, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x39, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x2e, 0x53,
	0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x2e, 0x53, 0x65, 0x74, 0x43, 0x6f, 0x6d, 0x70, 0x61,
	0x72, 0x69, 0x73, 0x6f, 0x6e, 0x2e, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e,
	0x4f, 0x70, 0x52, 0x0c, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x4f, 0x70,
	0x12, 0x29, 0x0a, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15,
	0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65,
	0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x04, 0x6c, 0x65, 0x66, 0x74, 0x12, 0x24, 0x0a, 0x05, 0x72,
	0x69, 0x67, 0x68, 0x74, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0e, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x52, 0x65, 0x6c, 0x52, 0x05, 0x72, 0x69, 0x67, 0x68,
	0x74, 0x22, 0xb1, 0x01, 0x0a, 0x0c, 0x43, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e,
	0x4f, 0x70, 0x12, 0x1d, 0x0a, 0x19, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e,
	0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10,
	0x00, 0x12, 0x14, 0x0a, 0x10, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f,
	0x4f, 0x50, 0x5f, 0x45, 0x51, 0x10, 0x01, 0x12, 0x14, 0x0a, 0x10, 0x43, 0x4f, 0x4d, 0x50, 0x41,
	0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f, 0x4f, 0x50, 0x5f, 0x4e, 0x45, 0x10, 0x02, 0x12, 0x14, 0x0a,
	0x10, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f, 0x4f, 0x50, 0x5f, 0x4c,
	0x54, 0x10, 0x03, 0x12, 0x14, 0x0a, 0x10, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f,
	0x4e, 0x5f, 0x4f, 0x50, 0x5f, 0x47, 0x54, 0x10, 0x04, 0x12, 0x14, 0x0a, 0x10, 0x43, 0x4f, 0x4d,
	0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f, 0x4f, 0x50, 0x5f, 0x4c, 0x45, 0x10, 0x05, 0x12,
	0x14, 0x0a, 0x10, 0x43, 0x4f, 0x4d, 0x50, 0x41, 0x52, 0x49, 0x53, 0x4f, 0x4e, 0x5f, 0x4f, 0x50,
	0x5f, 0x47, 0x45, 0x10, 0x06, 0x22, 0x57, 0x0a, 0x0b, 0x52, 0x65, 0x64, 0x75, 0x63, 0x74, 0x69,
	0x6f, 0x6e, 0x4f, 0x70, 0x12, 0x1c, 0x0a, 0x18, 0x52, 0x45, 0x44, 0x55, 0x43, 0x54, 0x49, 0x4f,
	0x4e, 0x5f, 0x4f, 0x50, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44,
	0x10, 0x00, 0x12, 0x14, 0x0a, 0x10, 0x52, 0x45, 0x44, 0x55, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x5f,
	0x4f, 0x50, 0x5f, 0x41, 0x4e, 0x59, 0x10, 0x01, 0x12, 0x14, 0x0a, 0x10, 0x52, 0x45, 0x44, 0x55,
	0x43, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x4f, 0x50, 0x5f, 0x41, 0x4c, 0x4c, 0x10, 0x02, 0x42, 0x0f,
	0x0a, 0x0d, 0x73, 0x75, 0x62, 0x71, 0x75, 0x65, 0x72, 0x79, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x42,
	0x0a, 0x0a, 0x08, 0x72, 0x65, 0x78, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x22, 0xad, 0x03, 0x0a, 0x09,
	0x53, 0x6f, 0x72, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x12, 0x29, 0x0a, 0x04, 0x65, 0x78, 0x70,
	0x72, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x52, 0x04,
	0x65, 0x78, 0x70, 0x72, 0x12, 0x42, 0x0a, 0x09, 0x64, 0x69, 0x72, 0x65, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x22, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72,
	0x61, 0x69, 0x74, 0x2e, 0x53, 0x6f, 0x72, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x2e, 0x53, 0x6f,
	0x72, 0x74, 0x44, 0x69, 0x72, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x09, 0x64,
	0x69, 0x72, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x44, 0x0a, 0x1d, 0x63, 0x6f, 0x6d, 0x70,
	0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x5f, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x5f,
	0x72, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0d, 0x48,
	0x00, 0x52, 0x1b, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x72, 0x69, 0x73, 0x6f, 0x6e, 0x46, 0x75, 0x6e,
	0x63, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x22, 0xdd,
	0x01, 0x0a, 0x0d, 0x53, 0x6f, 0x72, 0x74, 0x44, 0x69, 0x72, 0x65, 0x63, 0x74, 0x69, 0x6f, 0x6e,
	0x12, 0x1e, 0x0a, 0x1a, 0x53, 0x4f, 0x52, 0x54, 0x5f, 0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x49,
	0x4f, 0x4e, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00,
	0x12, 0x22, 0x0a, 0x1e, 0x53, 0x4f, 0x52, 0x54, 0x5f, 0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x49,
	0x4f, 0x4e, 0x5f, 0x41, 0x53, 0x43, 0x5f, 0x4e, 0x55, 0x4c, 0x4c, 0x53, 0x5f, 0x46, 0x49, 0x52,
	0x53, 0x54, 0x10, 0x01, 0x12, 0x21, 0x0a, 0x1d, 0x53, 0x4f, 0x52, 0x54, 0x5f, 0x44, 0x49, 0x52,
	0x45, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x41, 0x53, 0x43, 0x5f, 0x4e, 0x55, 0x4c, 0x4c, 0x53,
	0x5f, 0x4c, 0x41, 0x53, 0x54, 0x10, 0x02, 0x12, 0x23, 0x0a, 0x1f, 0x53, 0x4f, 0x52, 0x54, 0x5f,
	0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x44, 0x45, 0x53, 0x43, 0x5f, 0x4e,
	0x55, 0x4c, 0x4c, 0x53, 0x5f, 0x46, 0x49, 0x52, 0x53, 0x54, 0x10, 0x03, 0x12, 0x22, 0x0a, 0x1e,
	0x53, 0x4f, 0x52, 0x54, 0x5f, 0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x44,
	0x45, 0x53, 0x43, 0x5f, 0x4e, 0x55, 0x4c, 0x4c, 0x53, 0x5f, 0x4c, 0x41, 0x53, 0x54, 0x10, 0x04,
	0x12, 0x1c, 0x0a, 0x18, 0x53, 0x4f, 0x52, 0x54, 0x5f, 0x44, 0x49, 0x52, 0x45, 0x43, 0x54, 0x49,
	0x4f, 0x4e, 0x5f, 0x43, 0x4c, 0x55, 0x53, 0x54, 0x45, 0x52, 0x45, 0x44, 0x10, 0x05, 0x42, 0x0b,
	0x0a, 0x09, 0x73, 0x6f, 0x72, 0x74, 0x5f, 0x6b, 0x69, 0x6e, 0x64, 0x22, 0xcd, 0x04, 0x0a, 0x11,
	0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x12, 0x2d, 0x0a, 0x12, 0x66, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x72, 0x65,
	0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x11, 0x66,
	0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65,
	0x12, 0x39, 0x0a, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x18, 0x07, 0x20,
	0x03, 0x28, 0x0b, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f, 0x6e, 0x41, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74,
	0x52, 0x09, 0x61, 0x72, 0x67, 0x75, 0x6d, 0x65, 0x6e, 0x74, 0x73, 0x12, 0x33, 0x0a, 0x07, 0x6f,
	0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73, 0x18, 0x08, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x19, 0x2e, 0x73,
	0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x46, 0x75, 0x6e, 0x63, 0x74, 0x69, 0x6f,
	0x6e, 0x4f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x07, 0x6f, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x73,
	0x12, 0x30, 0x0a, 0x0b, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x5f, 0x74, 0x79, 0x70, 0x65, 0x18,
	0x05, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x0f, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x54, 0x79, 0x70, 0x65, 0x52, 0x0a, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x54, 0x79,
	0x70, 0x65, 0x12, 0x31, 0x0a, 0x05, 0x70, 0x68, 0x61, 0x73, 0x65, 0x18, 0x04, 0x20, 0x01, 0x28,
	0x0e, 0x32, 0x1b, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x41, 0x67,
	0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x50, 0x68, 0x61, 0x73, 0x65, 0x52, 0x05,
	0x70, 0x68, 0x61, 0x73, 0x65, 0x12, 0x2a, 0x0a, 0x05, 0x73, 0x6f, 0x72, 0x74, 0x73, 0x18, 0x03,
	0x20, 0x03, 0x28, 0x0b, 0x32, 0x14, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74,
	0x2e, 0x53, 0x6f, 0x72, 0x74, 0x46, 0x69, 0x65, 0x6c, 0x64, 0x52, 0x05, 0x73, 0x6f, 0x72, 0x74,
	0x73, 0x12, 0x52, 0x0a, 0x0a, 0x69, 0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18,
	0x06, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x32, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x65, 0x46, 0x75, 0x6e, 0x63, 0x74,
	0x69, 0x6f, 0x6e, 0x2e, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x49,
	0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x52, 0x0a, 0x69, 0x6e, 0x76, 0x6f, 0x63,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x2d, 0x0a, 0x04, 0x61, 0x72, 0x67, 0x73, 0x18, 0x02, 0x20,
	0x03, 0x28, 0x0b, 0x32, 0x15, 0x2e, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e,
	0x45, 0x78, 0x70, 0x72, 0x65, 0x73, 0x73, 0x69, 0x6f, 0x6e, 0x42, 0x02, 0x18, 0x01, 0x52, 0x04,
	0x61, 0x72, 0x67, 0x73, 0x22, 0x84, 0x01, 0x0a, 0x15, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x49, 0x6e, 0x76, 0x6f, 0x63, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x12, 0x26,
	0x0a, 0x22, 0x41, 0x47, 0x47, 0x52, 0x45, 0x47, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x49, 0x4e,
	0x56, 0x4f, 0x43, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49,
	0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x1e, 0x0a, 0x1a, 0x41, 0x47, 0x47, 0x52, 0x45, 0x47,
	0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x49, 0x4e, 0x56, 0x4f, 0x43, 0x41, 0x54, 0x49, 0x4f, 0x4e,
	0x5f, 0x41, 0x4c, 0x4c, 0x10, 0x01, 0x12, 0x23, 0x0a, 0x1f, 0x41, 0x47, 0x47, 0x52, 0x45, 0x47,
	0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x49, 0x4e, 0x56, 0x4f, 0x43, 0x41, 0x54, 0x49, 0x4f, 0x4e,
	0x5f, 0x44, 0x49, 0x53, 0x54, 0x49, 0x4e, 0x43, 0x54, 0x10, 0x02, 0x22, 0x37, 0x0a, 0x0c, 0x52,
	0x65, 0x66, 0x65, 0x72, 0x65, 0x6e, 0x63, 0x65, 0x52, 0x65, 0x6c, 0x12, 0x27, 0x0a, 0x0f, 0x73,
	0x75, 0x62, 0x74, 0x72, 0x65, 0x65, 0x5f, 0x6f, 0x72, 0x64, 0x69, 0x6e, 0x61, 0x6c, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x05, 0x52, 0x0e, 0x73, 0x75, 0x62, 0x74, 0x72, 0x65, 0x65, 0x4f, 0x72, 0x64,
	0x69, 0x6e, 0x61, 0x6c, 0x2a, 0xef, 0x01, 0x0a, 0x10, 0x41, 0x67, 0x67, 0x72, 0x65, 0x67, 0x61,
	0x74, 0x69, 0x6f, 0x6e, 0x50, 0x68, 0x61, 0x73, 0x65, 0x12, 0x21, 0x0a, 0x1d, 0x41, 0x47, 0x47,
	0x52, 0x45, 0x47, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x50, 0x48, 0x41, 0x53, 0x45, 0x5f, 0x55,
	0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12, 0x2d, 0x0a, 0x29,
	0x41, 0x47, 0x47, 0x52, 0x45, 0x47, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x50, 0x48, 0x41, 0x53,
	0x45, 0x5f, 0x49, 0x4e, 0x49, 0x54, 0x49, 0x41, 0x4c, 0x5f, 0x54, 0x4f, 0x5f, 0x49, 0x4e, 0x54,
	0x45, 0x52, 0x4d, 0x45, 0x44, 0x49, 0x41, 0x54, 0x45, 0x10, 0x01, 0x12, 0x32, 0x0a, 0x2e, 0x41,
	0x47, 0x47, 0x52, 0x45, 0x47, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x50, 0x48, 0x41, 0x53, 0x45,
	0x5f, 0x49, 0x4e, 0x54, 0x45, 0x52, 0x4d, 0x45, 0x44, 0x49, 0x41, 0x54, 0x45, 0x5f, 0x54, 0x4f,
	0x5f, 0x49, 0x4e, 0x54, 0x45, 0x52, 0x4d, 0x45, 0x44, 0x49, 0x41, 0x54, 0x45, 0x10, 0x02, 0x12,
	0x27, 0x0a, 0x23, 0x41, 0x47, 0x47, 0x52, 0x45, 0x47, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x50,
	0x48, 0x41, 0x53, 0x45, 0x5f, 0x49, 0x4e, 0x49, 0x54, 0x49, 0x41, 0x4c, 0x5f, 0x54, 0x4f, 0x5f,
	0x52, 0x45, 0x53, 0x55, 0x4c, 0x54, 0x10, 0x03, 0x12, 0x2c, 0x0a, 0x28, 0x41, 0x47, 0x47, 0x52,
	0x45, 0x47, 0x41, 0x54, 0x49, 0x4f, 0x4e, 0x5f, 0x50, 0x48, 0x41, 0x53, 0x45, 0x5f, 0x49, 0x4e,
	0x54, 0x45, 0x52, 0x4d, 0x45, 0x44, 0x49, 0x41, 0x54, 0x45, 0x5f, 0x54, 0x4f, 0x5f, 0x52, 0x45,
	0x53, 0x55, 0x4c, 0x54, 0x10, 0x04, 0x42, 0x57, 0x0a, 0x12, 0x69, 0x6f, 0x2e, 0x73, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x50, 0x01, 0x5a, 0x2a,
	0x67, 0x69, 0x74, 0x68, 0x75, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x73, 0x75, 0x62, 0x73, 0x74,
	0x72, 0x61, 0x69, 0x74, 0x2d, 0x69, 0x6f, 0x2f, 0x73, 0x75, 0x62, 0x73, 0x74, 0x72, 0x61, 0x69,
	0x74, 0x2d, 0x67, 0x6f, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0xaa, 0x02, 0x12, 0x53, 0x75, 0x62,
	0x73, 0x74, 0x72, 0x61, 0x69, 0x74, 0x2e, 0x50, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x62,
	0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_substrait_algebra_proto_rawDescOnce sync.Once
	file_substrait_algebra_proto_rawDescData = file_substrait_algebra_proto_rawDesc
)

func file_substrait_algebra_proto_rawDescGZIP() []byte {
	file_substrait_algebra_proto_rawDescOnce.Do(func() {
		file_substrait_algebra_proto_rawDescData = protoimpl.X.CompressGZIP(file_substrait_algebra_proto_rawDescData)
	})
	return file_substrait_algebra_proto_rawDescData
}

var file_substrait_algebra_proto_enumTypes = make([]protoimpl.EnumInfo, 20)
var file_substrait_algebra_proto_msgTypes = make([]protoimpl.MessageInfo, 126)
var file_substrait_algebra_proto_goTypes = []any{
	(AggregationPhase)(0),                                     // 0: substrait.AggregationPhase
	(RelCommon_Hint_ComputationType)(0),                       // 1: substrait.RelCommon.Hint.ComputationType
	(JoinRel_JoinType)(0),                                     // 2: substrait.JoinRel.JoinType
	(SetRel_SetOp)(0),                                         // 3: substrait.SetRel.SetOp
	(DdlRel_DdlObject)(0),                                     // 4: substrait.DdlRel.DdlObject
	(DdlRel_DdlOp)(0),                                         // 5: substrait.DdlRel.DdlOp
	(WriteRel_WriteOp)(0),                                     // 6: substrait.WriteRel.WriteOp
	(WriteRel_CreateMode)(0),                                  // 7: substrait.WriteRel.CreateMode
	(WriteRel_OutputMode)(0),                                  // 8: substrait.WriteRel.OutputMode
	(ComparisonJoinKey_SimpleComparisonType)(0),               // 9: substrait.ComparisonJoinKey.SimpleComparisonType
	(HashJoinRel_JoinType)(0),                                 // 10: substrait.HashJoinRel.JoinType
	(MergeJoinRel_JoinType)(0),                                // 11: substrait.MergeJoinRel.JoinType
	(NestedLoopJoinRel_JoinType)(0),                           // 12: substrait.NestedLoopJoinRel.JoinType
	(Expression_WindowFunction_BoundsType)(0),                 // 13: substrait.Expression.WindowFunction.BoundsType
	(Expression_Cast_FailureBehavior)(0),                      // 14: substrait.Expression.Cast.FailureBehavior
	(Expression_Subquery_SetPredicate_PredicateOp)(0),         // 15: substrait.Expression.Subquery.SetPredicate.PredicateOp
	(Expression_Subquery_SetComparison_ComparisonOp)(0),       // 16: substrait.Expression.Subquery.SetComparison.ComparisonOp
	(Expression_Subquery_SetComparison_ReductionOp)(0),        // 17: substrait.Expression.Subquery.SetComparison.ReductionOp
	(SortField_SortDirection)(0),                              // 18: substrait.SortField.SortDirection
	(AggregateFunction_AggregationInvocation)(0),              // 19: substrait.AggregateFunction.AggregationInvocation
	(*RelCommon)(nil),                                         // 20: substrait.RelCommon
	(*ReadRel)(nil),                                           // 21: substrait.ReadRel
	(*ProjectRel)(nil),                                        // 22: substrait.ProjectRel
	(*JoinRel)(nil),                                           // 23: substrait.JoinRel
	(*CrossRel)(nil),                                          // 24: substrait.CrossRel
	(*FetchRel)(nil),                                          // 25: substrait.FetchRel
	(*AggregateRel)(nil),                                      // 26: substrait.AggregateRel
	(*ConsistentPartitionWindowRel)(nil),                      // 27: substrait.ConsistentPartitionWindowRel
	(*SortRel)(nil),                                           // 28: substrait.SortRel
	(*FilterRel)(nil),                                         // 29: substrait.FilterRel
	(*SetRel)(nil),                                            // 30: substrait.SetRel
	(*ExtensionSingleRel)(nil),                                // 31: substrait.ExtensionSingleRel
	(*ExtensionLeafRel)(nil),                                  // 32: substrait.ExtensionLeafRel
	(*ExtensionMultiRel)(nil),                                 // 33: substrait.ExtensionMultiRel
	(*ExchangeRel)(nil),                                       // 34: substrait.ExchangeRel
	(*ExpandRel)(nil),                                         // 35: substrait.ExpandRel
	(*RelRoot)(nil),                                           // 36: substrait.RelRoot
	(*Rel)(nil),                                               // 37: substrait.Rel
	(*NamedObjectWrite)(nil),                                  // 38: substrait.NamedObjectWrite
	(*ExtensionObject)(nil),                                   // 39: substrait.ExtensionObject
	(*DdlRel)(nil),                                            // 40: substrait.DdlRel
	(*WriteRel)(nil),                                          // 41: substrait.WriteRel
	(*UpdateRel)(nil),                                         // 42: substrait.UpdateRel
	(*NamedTable)(nil),                                        // 43: substrait.NamedTable
	(*ComparisonJoinKey)(nil),                                 // 44: substrait.ComparisonJoinKey
	(*HashJoinRel)(nil),                                       // 45: substrait.HashJoinRel
	(*MergeJoinRel)(nil),                                      // 46: substrait.MergeJoinRel
	(*NestedLoopJoinRel)(nil),                                 // 47: substrait.NestedLoopJoinRel
	(*FunctionArgument)(nil),                                  // 48: substrait.FunctionArgument
	(*FunctionOption)(nil),                                    // 49: substrait.FunctionOption
	(*Expression)(nil),                                        // 50: substrait.Expression
	(*SortField)(nil),                                         // 51: substrait.SortField
	(*AggregateFunction)(nil),                                 // 52: substrait.AggregateFunction
	(*ReferenceRel)(nil),                                      // 53: substrait.ReferenceRel
	(*RelCommon_Direct)(nil),                                  // 54: substrait.RelCommon.Direct
	(*RelCommon_Emit)(nil),                                    // 55: substrait.RelCommon.Emit
	(*RelCommon_Hint)(nil),                                    // 56: substrait.RelCommon.Hint
	(*RelCommon_Hint_Stats)(nil),                              // 57: substrait.RelCommon.Hint.Stats
	(*RelCommon_Hint_RuntimeConstraint)(nil),                  // 58: substrait.RelCommon.Hint.RuntimeConstraint
	(*RelCommon_Hint_SavedComputation)(nil),                   // 59: substrait.RelCommon.Hint.SavedComputation
	(*RelCommon_Hint_LoadedComputation)(nil),                  // 60: substrait.RelCommon.Hint.LoadedComputation
	(*ReadRel_NamedTable)(nil),                                // 61: substrait.ReadRel.NamedTable
	(*ReadRel_IcebergTable)(nil),                              // 62: substrait.ReadRel.IcebergTable
	(*ReadRel_VirtualTable)(nil),                              // 63: substrait.ReadRel.VirtualTable
	(*ReadRel_ExtensionTable)(nil),                            // 64: substrait.ReadRel.ExtensionTable
	(*ReadRel_LocalFiles)(nil),                                // 65: substrait.ReadRel.LocalFiles
	(*ReadRel_IcebergTable_MetadataFileRead)(nil),             // 66: substrait.ReadRel.IcebergTable.MetadataFileRead
	(*ReadRel_LocalFiles_FileOrFiles)(nil),                    // 67: substrait.ReadRel.LocalFiles.FileOrFiles
	(*ReadRel_LocalFiles_FileOrFiles_ParquetReadOptions)(nil), // 68: substrait.ReadRel.LocalFiles.FileOrFiles.ParquetReadOptions
	(*ReadRel_LocalFiles_FileOrFiles_ArrowReadOptions)(nil),   // 69: substrait.ReadRel.LocalFiles.FileOrFiles.ArrowReadOptions
	(*ReadRel_LocalFiles_FileOrFiles_OrcReadOptions)(nil),     // 70: substrait.ReadRel.LocalFiles.FileOrFiles.OrcReadOptions
	(*ReadRel_LocalFiles_FileOrFiles_DwrfReadOptions)(nil),    // 71: substrait.ReadRel.LocalFiles.FileOrFiles.DwrfReadOptions
	(*ReadRel_LocalFiles_FileOrFiles_DelimiterSeparatedTextReadOptions)(nil), // 72: substrait.ReadRel.LocalFiles.FileOrFiles.DelimiterSeparatedTextReadOptions
	(*AggregateRel_Grouping)(nil),                                            // 73: substrait.AggregateRel.Grouping
	(*AggregateRel_Measure)(nil),                                             // 74: substrait.AggregateRel.Measure
	(*ConsistentPartitionWindowRel_WindowRelFunction)(nil),                   // 75: substrait.ConsistentPartitionWindowRel.WindowRelFunction
	(*ExchangeRel_ScatterFields)(nil),                                        // 76: substrait.ExchangeRel.ScatterFields
	(*ExchangeRel_SingleBucketExpression)(nil),                               // 77: substrait.ExchangeRel.SingleBucketExpression
	(*ExchangeRel_MultiBucketExpression)(nil),                                // 78: substrait.ExchangeRel.MultiBucketExpression
	(*ExchangeRel_Broadcast)(nil),                                            // 79: substrait.ExchangeRel.Broadcast
	(*ExchangeRel_RoundRobin)(nil),                                           // 80: substrait.ExchangeRel.RoundRobin
	(*ExchangeRel_ExchangeTarget)(nil),                                       // 81: substrait.ExchangeRel.ExchangeTarget
	(*ExpandRel_ExpandField)(nil),                                            // 82: substrait.ExpandRel.ExpandField
	(*ExpandRel_SwitchingField)(nil),                                         // 83: substrait.ExpandRel.SwitchingField
	(*UpdateRel_TransformExpression)(nil),                                    // 84: substrait.UpdateRel.TransformExpression
	(*ComparisonJoinKey_ComparisonType)(nil),                                 // 85: substrait.ComparisonJoinKey.ComparisonType
	(*Expression_Enum)(nil),                                                  // 86: substrait.Expression.Enum
	(*Expression_Literal)(nil),                                               // 87: substrait.Expression.Literal
	(*Expression_Nested)(nil),                                                // 88: substrait.Expression.Nested
	(*Expression_ScalarFunction)(nil),                                        // 89: substrait.Expression.ScalarFunction
	(*Expression_WindowFunction)(nil),                                        // 90: substrait.Expression.WindowFunction
	(*Expression_IfThen)(nil),                                                // 91: substrait.Expression.IfThen
	(*Expression_Cast)(nil),                                                  // 92: substrait.Expression.Cast
	(*Expression_SwitchExpression)(nil),                                      // 93: substrait.Expression.SwitchExpression
	(*Expression_SingularOrList)(nil),                                        // 94: substrait.Expression.SingularOrList
	(*Expression_MultiOrList)(nil),                                           // 95: substrait.Expression.MultiOrList
	(*Expression_EmbeddedFunction)(nil),                                      // 96: substrait.Expression.EmbeddedFunction
	(*Expression_ReferenceSegment)(nil),                                      // 97: substrait.Expression.ReferenceSegment
	(*Expression_MaskExpression)(nil),                                        // 98: substrait.Expression.MaskExpression
	(*Expression_FieldReference)(nil),                                        // 99: substrait.Expression.FieldReference
	(*Expression_Subquery)(nil),                                              // 100: substrait.Expression.Subquery
	(*Expression_Enum_Empty)(nil),                                            // 101: substrait.Expression.Enum.Empty
	(*Expression_Literal_VarChar)(nil),                                       // 102: substrait.Expression.Literal.VarChar
	(*Expression_Literal_Decimal)(nil),                                       // 103: substrait.Expression.Literal.Decimal
	(*Expression_Literal_PrecisionTimestamp)(nil),                            // 104: substrait.Expression.Literal.PrecisionTimestamp
	(*Expression_Literal_Map)(nil),                                           // 105: substrait.Expression.Literal.Map
	(*Expression_Literal_IntervalYearToMonth)(nil),                           // 106: substrait.Expression.Literal.IntervalYearToMonth
	(*Expression_Literal_IntervalDayToSecond)(nil),                           // 107: substrait.Expression.Literal.IntervalDayToSecond
	(*Expression_Literal_IntervalCompound)(nil),                              // 108: substrait.Expression.Literal.IntervalCompound
	(*Expression_Literal_Struct)(nil),                                        // 109: substrait.Expression.Literal.Struct
	(*Expression_Literal_List)(nil),                                          // 110: substrait.Expression.Literal.List
	(*Expression_Literal_UserDefined)(nil),                                   // 111: substrait.Expression.Literal.UserDefined
	(*Expression_Literal_Map_KeyValue)(nil),                                  // 112: substrait.Expression.Literal.Map.KeyValue
	(*Expression_Nested_Map)(nil),                                            // 113: substrait.Expression.Nested.Map
	(*Expression_Nested_Struct)(nil),                                         // 114: substrait.Expression.Nested.Struct
	(*Expression_Nested_List)(nil),                                           // 115: substrait.Expression.Nested.List
	(*Expression_Nested_Map_KeyValue)(nil),                                   // 116: substrait.Expression.Nested.Map.KeyValue
	(*Expression_WindowFunction_Bound)(nil),                                  // 117: substrait.Expression.WindowFunction.Bound
	(*Expression_WindowFunction_Bound_Preceding)(nil),                        // 118: substrait.Expression.WindowFunction.Bound.Preceding
	(*Expression_WindowFunction_Bound_Following)(nil),                        // 119: substrait.Expression.WindowFunction.Bound.Following
	(*Expression_WindowFunction_Bound_CurrentRow)(nil),                       // 120: substrait.Expression.WindowFunction.Bound.CurrentRow
	(*Expression_WindowFunction_Bound_Unbounded)(nil),                        // 121: substrait.Expression.WindowFunction.Bound.Unbounded
	(*Expression_IfThen_IfClause)(nil),                                       // 122: substrait.Expression.IfThen.IfClause
	(*Expression_SwitchExpression_IfValue)(nil),                              // 123: substrait.Expression.SwitchExpression.IfValue
	(*Expression_MultiOrList_Record)(nil),                                    // 124: substrait.Expression.MultiOrList.Record
	(*Expression_EmbeddedFunction_PythonPickleFunction)(nil),                 // 125: substrait.Expression.EmbeddedFunction.PythonPickleFunction
	(*Expression_EmbeddedFunction_WebAssemblyFunction)(nil),                  // 126: substrait.Expression.EmbeddedFunction.WebAssemblyFunction
	(*Expression_ReferenceSegment_MapKey)(nil),                               // 127: substrait.Expression.ReferenceSegment.MapKey
	(*Expression_ReferenceSegment_StructField)(nil),                          // 128: substrait.Expression.ReferenceSegment.StructField
	(*Expression_ReferenceSegment_ListElement)(nil),                          // 129: substrait.Expression.ReferenceSegment.ListElement
	(*Expression_MaskExpression_Select)(nil),                                 // 130: substrait.Expression.MaskExpression.Select
	(*Expression_MaskExpression_StructSelect)(nil),                           // 131: substrait.Expression.MaskExpression.StructSelect
	(*Expression_MaskExpression_StructItem)(nil),                             // 132: substrait.Expression.MaskExpression.StructItem
	(*Expression_MaskExpression_ListSelect)(nil),                             // 133: substrait.Expression.MaskExpression.ListSelect
	(*Expression_MaskExpression_MapSelect)(nil),                              // 134: substrait.Expression.MaskExpression.MapSelect
	(*Expression_MaskExpression_ListSelect_ListSelectItem)(nil),              // 135: substrait.Expression.MaskExpression.ListSelect.ListSelectItem
	(*Expression_MaskExpression_ListSelect_ListSelectItem_ListElement)(nil),  // 136: substrait.Expression.MaskExpression.ListSelect.ListSelectItem.ListElement
	(*Expression_MaskExpression_ListSelect_ListSelectItem_ListSlice)(nil),    // 137: substrait.Expression.MaskExpression.ListSelect.ListSelectItem.ListSlice
	(*Expression_MaskExpression_MapSelect_MapKey)(nil),                       // 138: substrait.Expression.MaskExpression.MapSelect.MapKey
	(*Expression_MaskExpression_MapSelect_MapKeyExpression)(nil),             // 139: substrait.Expression.MaskExpression.MapSelect.MapKeyExpression
	(*Expression_FieldReference_RootReference)(nil),                          // 140: substrait.Expression.FieldReference.RootReference
	(*Expression_FieldReference_OuterReference)(nil),                         // 141: substrait.Expression.FieldReference.OuterReference
	(*Expression_Subquery_Scalar)(nil),                                       // 142: substrait.Expression.Subquery.Scalar
	(*Expression_Subquery_InPredicate)(nil),                                  // 143: substrait.Expression.Subquery.InPredicate
	(*Expression_Subquery_SetPredicate)(nil),                                 // 144: substrait.Expression.Subquery.SetPredicate
	(*Expression_Subquery_SetComparison)(nil),                                // 145: substrait.Expression.Subquery.SetComparison
	(*extensions.AdvancedExtension)(nil),                                     // 146: substrait.extensions.AdvancedExtension
	(*NamedStruct)(nil),                                                      // 147: substrait.NamedStruct
	(*anypb.Any)(nil),                                                        // 148: google.protobuf.Any
	(*Type)(nil),                                                             // 149: substrait.Type
	(*Type_List)(nil),                                                        // 150: substrait.Type.List
	(*Type_Map)(nil),                                                         // 151: substrait.Type.Map
	(*Type_Parameter)(nil),                                                   // 152: substrait.Type.Parameter
}
var file_substrait_algebra_proto_depIdxs = []int32{
	54,  // 0: substrait.RelCommon.direct:type_name -> substrait.RelCommon.Direct
	55,  // 1: substrait.RelCommon.emit:type_name -> substrait.RelCommon.Emit
	56,  // 2: substrait.RelCommon.hint:type_name -> substrait.RelCommon.Hint
	146, // 3: substrait.RelCommon.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 4: substrait.ReadRel.common:type_name -> substrait.RelCommon
	147, // 5: substrait.ReadRel.base_schema:type_name -> substrait.NamedStruct
	50,  // 6: substrait.ReadRel.filter:type_name -> substrait.Expression
	50,  // 7: substrait.ReadRel.best_effort_filter:type_name -> substrait.Expression
	98,  // 8: substrait.ReadRel.projection:type_name -> substrait.Expression.MaskExpression
	146, // 9: substrait.ReadRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	63,  // 10: substrait.ReadRel.virtual_table:type_name -> substrait.ReadRel.VirtualTable
	65,  // 11: substrait.ReadRel.local_files:type_name -> substrait.ReadRel.LocalFiles
	61,  // 12: substrait.ReadRel.named_table:type_name -> substrait.ReadRel.NamedTable
	64,  // 13: substrait.ReadRel.extension_table:type_name -> substrait.ReadRel.ExtensionTable
	62,  // 14: substrait.ReadRel.iceberg_table:type_name -> substrait.ReadRel.IcebergTable
	20,  // 15: substrait.ProjectRel.common:type_name -> substrait.RelCommon
	37,  // 16: substrait.ProjectRel.input:type_name -> substrait.Rel
	50,  // 17: substrait.ProjectRel.expressions:type_name -> substrait.Expression
	146, // 18: substrait.ProjectRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 19: substrait.JoinRel.common:type_name -> substrait.RelCommon
	37,  // 20: substrait.JoinRel.left:type_name -> substrait.Rel
	37,  // 21: substrait.JoinRel.right:type_name -> substrait.Rel
	50,  // 22: substrait.JoinRel.expression:type_name -> substrait.Expression
	50,  // 23: substrait.JoinRel.post_join_filter:type_name -> substrait.Expression
	2,   // 24: substrait.JoinRel.type:type_name -> substrait.JoinRel.JoinType
	146, // 25: substrait.JoinRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 26: substrait.CrossRel.common:type_name -> substrait.RelCommon
	37,  // 27: substrait.CrossRel.left:type_name -> substrait.Rel
	37,  // 28: substrait.CrossRel.right:type_name -> substrait.Rel
	146, // 29: substrait.CrossRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 30: substrait.FetchRel.common:type_name -> substrait.RelCommon
	37,  // 31: substrait.FetchRel.input:type_name -> substrait.Rel
	50,  // 32: substrait.FetchRel.offset_expr:type_name -> substrait.Expression
	50,  // 33: substrait.FetchRel.count_expr:type_name -> substrait.Expression
	146, // 34: substrait.FetchRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 35: substrait.AggregateRel.common:type_name -> substrait.RelCommon
	37,  // 36: substrait.AggregateRel.input:type_name -> substrait.Rel
	73,  // 37: substrait.AggregateRel.groupings:type_name -> substrait.AggregateRel.Grouping
	74,  // 38: substrait.AggregateRel.measures:type_name -> substrait.AggregateRel.Measure
	50,  // 39: substrait.AggregateRel.grouping_expressions:type_name -> substrait.Expression
	146, // 40: substrait.AggregateRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 41: substrait.ConsistentPartitionWindowRel.common:type_name -> substrait.RelCommon
	37,  // 42: substrait.ConsistentPartitionWindowRel.input:type_name -> substrait.Rel
	75,  // 43: substrait.ConsistentPartitionWindowRel.window_functions:type_name -> substrait.ConsistentPartitionWindowRel.WindowRelFunction
	50,  // 44: substrait.ConsistentPartitionWindowRel.partition_expressions:type_name -> substrait.Expression
	51,  // 45: substrait.ConsistentPartitionWindowRel.sorts:type_name -> substrait.SortField
	146, // 46: substrait.ConsistentPartitionWindowRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 47: substrait.SortRel.common:type_name -> substrait.RelCommon
	37,  // 48: substrait.SortRel.input:type_name -> substrait.Rel
	51,  // 49: substrait.SortRel.sorts:type_name -> substrait.SortField
	146, // 50: substrait.SortRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 51: substrait.FilterRel.common:type_name -> substrait.RelCommon
	37,  // 52: substrait.FilterRel.input:type_name -> substrait.Rel
	50,  // 53: substrait.FilterRel.condition:type_name -> substrait.Expression
	146, // 54: substrait.FilterRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 55: substrait.SetRel.common:type_name -> substrait.RelCommon
	37,  // 56: substrait.SetRel.inputs:type_name -> substrait.Rel
	3,   // 57: substrait.SetRel.op:type_name -> substrait.SetRel.SetOp
	146, // 58: substrait.SetRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 59: substrait.ExtensionSingleRel.common:type_name -> substrait.RelCommon
	37,  // 60: substrait.ExtensionSingleRel.input:type_name -> substrait.Rel
	148, // 61: substrait.ExtensionSingleRel.detail:type_name -> google.protobuf.Any
	20,  // 62: substrait.ExtensionLeafRel.common:type_name -> substrait.RelCommon
	148, // 63: substrait.ExtensionLeafRel.detail:type_name -> google.protobuf.Any
	20,  // 64: substrait.ExtensionMultiRel.common:type_name -> substrait.RelCommon
	37,  // 65: substrait.ExtensionMultiRel.inputs:type_name -> substrait.Rel
	148, // 66: substrait.ExtensionMultiRel.detail:type_name -> google.protobuf.Any
	20,  // 67: substrait.ExchangeRel.common:type_name -> substrait.RelCommon
	37,  // 68: substrait.ExchangeRel.input:type_name -> substrait.Rel
	81,  // 69: substrait.ExchangeRel.targets:type_name -> substrait.ExchangeRel.ExchangeTarget
	76,  // 70: substrait.ExchangeRel.scatter_by_fields:type_name -> substrait.ExchangeRel.ScatterFields
	77,  // 71: substrait.ExchangeRel.single_target:type_name -> substrait.ExchangeRel.SingleBucketExpression
	78,  // 72: substrait.ExchangeRel.multi_target:type_name -> substrait.ExchangeRel.MultiBucketExpression
	80,  // 73: substrait.ExchangeRel.round_robin:type_name -> substrait.ExchangeRel.RoundRobin
	79,  // 74: substrait.ExchangeRel.broadcast:type_name -> substrait.ExchangeRel.Broadcast
	146, // 75: substrait.ExchangeRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 76: substrait.ExpandRel.common:type_name -> substrait.RelCommon
	37,  // 77: substrait.ExpandRel.input:type_name -> substrait.Rel
	82,  // 78: substrait.ExpandRel.fields:type_name -> substrait.ExpandRel.ExpandField
	37,  // 79: substrait.RelRoot.input:type_name -> substrait.Rel
	21,  // 80: substrait.Rel.read:type_name -> substrait.ReadRel
	29,  // 81: substrait.Rel.filter:type_name -> substrait.FilterRel
	25,  // 82: substrait.Rel.fetch:type_name -> substrait.FetchRel
	26,  // 83: substrait.Rel.aggregate:type_name -> substrait.AggregateRel
	28,  // 84: substrait.Rel.sort:type_name -> substrait.SortRel
	23,  // 85: substrait.Rel.join:type_name -> substrait.JoinRel
	22,  // 86: substrait.Rel.project:type_name -> substrait.ProjectRel
	30,  // 87: substrait.Rel.set:type_name -> substrait.SetRel
	31,  // 88: substrait.Rel.extension_single:type_name -> substrait.ExtensionSingleRel
	33,  // 89: substrait.Rel.extension_multi:type_name -> substrait.ExtensionMultiRel
	32,  // 90: substrait.Rel.extension_leaf:type_name -> substrait.ExtensionLeafRel
	24,  // 91: substrait.Rel.cross:type_name -> substrait.CrossRel
	53,  // 92: substrait.Rel.reference:type_name -> substrait.ReferenceRel
	41,  // 93: substrait.Rel.write:type_name -> substrait.WriteRel
	40,  // 94: substrait.Rel.ddl:type_name -> substrait.DdlRel
	42,  // 95: substrait.Rel.update:type_name -> substrait.UpdateRel
	45,  // 96: substrait.Rel.hash_join:type_name -> substrait.HashJoinRel
	46,  // 97: substrait.Rel.merge_join:type_name -> substrait.MergeJoinRel
	47,  // 98: substrait.Rel.nested_loop_join:type_name -> substrait.NestedLoopJoinRel
	27,  // 99: substrait.Rel.window:type_name -> substrait.ConsistentPartitionWindowRel
	34,  // 100: substrait.Rel.exchange:type_name -> substrait.ExchangeRel
	35,  // 101: substrait.Rel.expand:type_name -> substrait.ExpandRel
	146, // 102: substrait.NamedObjectWrite.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	148, // 103: substrait.ExtensionObject.detail:type_name -> google.protobuf.Any
	38,  // 104: substrait.DdlRel.named_object:type_name -> substrait.NamedObjectWrite
	39,  // 105: substrait.DdlRel.extension_object:type_name -> substrait.ExtensionObject
	147, // 106: substrait.DdlRel.table_schema:type_name -> substrait.NamedStruct
	109, // 107: substrait.DdlRel.table_defaults:type_name -> substrait.Expression.Literal.Struct
	4,   // 108: substrait.DdlRel.object:type_name -> substrait.DdlRel.DdlObject
	5,   // 109: substrait.DdlRel.op:type_name -> substrait.DdlRel.DdlOp
	37,  // 110: substrait.DdlRel.view_definition:type_name -> substrait.Rel
	20,  // 111: substrait.DdlRel.common:type_name -> substrait.RelCommon
	38,  // 112: substrait.WriteRel.named_table:type_name -> substrait.NamedObjectWrite
	39,  // 113: substrait.WriteRel.extension_table:type_name -> substrait.ExtensionObject
	147, // 114: substrait.WriteRel.table_schema:type_name -> substrait.NamedStruct
	6,   // 115: substrait.WriteRel.op:type_name -> substrait.WriteRel.WriteOp
	37,  // 116: substrait.WriteRel.input:type_name -> substrait.Rel
	7,   // 117: substrait.WriteRel.create_mode:type_name -> substrait.WriteRel.CreateMode
	8,   // 118: substrait.WriteRel.output:type_name -> substrait.WriteRel.OutputMode
	20,  // 119: substrait.WriteRel.common:type_name -> substrait.RelCommon
	43,  // 120: substrait.UpdateRel.named_table:type_name -> substrait.NamedTable
	147, // 121: substrait.UpdateRel.table_schema:type_name -> substrait.NamedStruct
	50,  // 122: substrait.UpdateRel.condition:type_name -> substrait.Expression
	84,  // 123: substrait.UpdateRel.transformations:type_name -> substrait.UpdateRel.TransformExpression
	146, // 124: substrait.NamedTable.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	99,  // 125: substrait.ComparisonJoinKey.left:type_name -> substrait.Expression.FieldReference
	99,  // 126: substrait.ComparisonJoinKey.right:type_name -> substrait.Expression.FieldReference
	85,  // 127: substrait.ComparisonJoinKey.comparison:type_name -> substrait.ComparisonJoinKey.ComparisonType
	20,  // 128: substrait.HashJoinRel.common:type_name -> substrait.RelCommon
	37,  // 129: substrait.HashJoinRel.left:type_name -> substrait.Rel
	37,  // 130: substrait.HashJoinRel.right:type_name -> substrait.Rel
	99,  // 131: substrait.HashJoinRel.left_keys:type_name -> substrait.Expression.FieldReference
	99,  // 132: substrait.HashJoinRel.right_keys:type_name -> substrait.Expression.FieldReference
	44,  // 133: substrait.HashJoinRel.keys:type_name -> substrait.ComparisonJoinKey
	50,  // 134: substrait.HashJoinRel.post_join_filter:type_name -> substrait.Expression
	10,  // 135: substrait.HashJoinRel.type:type_name -> substrait.HashJoinRel.JoinType
	146, // 136: substrait.HashJoinRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 137: substrait.MergeJoinRel.common:type_name -> substrait.RelCommon
	37,  // 138: substrait.MergeJoinRel.left:type_name -> substrait.Rel
	37,  // 139: substrait.MergeJoinRel.right:type_name -> substrait.Rel
	99,  // 140: substrait.MergeJoinRel.left_keys:type_name -> substrait.Expression.FieldReference
	99,  // 141: substrait.MergeJoinRel.right_keys:type_name -> substrait.Expression.FieldReference
	44,  // 142: substrait.MergeJoinRel.keys:type_name -> substrait.ComparisonJoinKey
	50,  // 143: substrait.MergeJoinRel.post_join_filter:type_name -> substrait.Expression
	11,  // 144: substrait.MergeJoinRel.type:type_name -> substrait.MergeJoinRel.JoinType
	146, // 145: substrait.MergeJoinRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	20,  // 146: substrait.NestedLoopJoinRel.common:type_name -> substrait.RelCommon
	37,  // 147: substrait.NestedLoopJoinRel.left:type_name -> substrait.Rel
	37,  // 148: substrait.NestedLoopJoinRel.right:type_name -> substrait.Rel
	50,  // 149: substrait.NestedLoopJoinRel.expression:type_name -> substrait.Expression
	12,  // 150: substrait.NestedLoopJoinRel.type:type_name -> substrait.NestedLoopJoinRel.JoinType
	146, // 151: substrait.NestedLoopJoinRel.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	149, // 152: substrait.FunctionArgument.type:type_name -> substrait.Type
	50,  // 153: substrait.FunctionArgument.value:type_name -> substrait.Expression
	87,  // 154: substrait.Expression.literal:type_name -> substrait.Expression.Literal
	99,  // 155: substrait.Expression.selection:type_name -> substrait.Expression.FieldReference
	89,  // 156: substrait.Expression.scalar_function:type_name -> substrait.Expression.ScalarFunction
	90,  // 157: substrait.Expression.window_function:type_name -> substrait.Expression.WindowFunction
	91,  // 158: substrait.Expression.if_then:type_name -> substrait.Expression.IfThen
	93,  // 159: substrait.Expression.switch_expression:type_name -> substrait.Expression.SwitchExpression
	94,  // 160: substrait.Expression.singular_or_list:type_name -> substrait.Expression.SingularOrList
	95,  // 161: substrait.Expression.multi_or_list:type_name -> substrait.Expression.MultiOrList
	92,  // 162: substrait.Expression.cast:type_name -> substrait.Expression.Cast
	100, // 163: substrait.Expression.subquery:type_name -> substrait.Expression.Subquery
	88,  // 164: substrait.Expression.nested:type_name -> substrait.Expression.Nested
	86,  // 165: substrait.Expression.enum:type_name -> substrait.Expression.Enum
	50,  // 166: substrait.SortField.expr:type_name -> substrait.Expression
	18,  // 167: substrait.SortField.direction:type_name -> substrait.SortField.SortDirection
	48,  // 168: substrait.AggregateFunction.arguments:type_name -> substrait.FunctionArgument
	49,  // 169: substrait.AggregateFunction.options:type_name -> substrait.FunctionOption
	149, // 170: substrait.AggregateFunction.output_type:type_name -> substrait.Type
	0,   // 171: substrait.AggregateFunction.phase:type_name -> substrait.AggregationPhase
	51,  // 172: substrait.AggregateFunction.sorts:type_name -> substrait.SortField
	19,  // 173: substrait.AggregateFunction.invocation:type_name -> substrait.AggregateFunction.AggregationInvocation
	50,  // 174: substrait.AggregateFunction.args:type_name -> substrait.Expression
	57,  // 175: substrait.RelCommon.Hint.stats:type_name -> substrait.RelCommon.Hint.Stats
	58,  // 176: substrait.RelCommon.Hint.constraint:type_name -> substrait.RelCommon.Hint.RuntimeConstraint
	146, // 177: substrait.RelCommon.Hint.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	59,  // 178: substrait.RelCommon.Hint.saved_computations:type_name -> substrait.RelCommon.Hint.SavedComputation
	60,  // 179: substrait.RelCommon.Hint.loaded_computations:type_name -> substrait.RelCommon.Hint.LoadedComputation
	146, // 180: substrait.RelCommon.Hint.Stats.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	146, // 181: substrait.RelCommon.Hint.RuntimeConstraint.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	1,   // 182: substrait.RelCommon.Hint.SavedComputation.type:type_name -> substrait.RelCommon.Hint.ComputationType
	1,   // 183: substrait.RelCommon.Hint.LoadedComputation.type:type_name -> substrait.RelCommon.Hint.ComputationType
	146, // 184: substrait.ReadRel.NamedTable.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	66,  // 185: substrait.ReadRel.IcebergTable.direct:type_name -> substrait.ReadRel.IcebergTable.MetadataFileRead
	109, // 186: substrait.ReadRel.VirtualTable.values:type_name -> substrait.Expression.Literal.Struct
	114, // 187: substrait.ReadRel.VirtualTable.expressions:type_name -> substrait.Expression.Nested.Struct
	148, // 188: substrait.ReadRel.ExtensionTable.detail:type_name -> google.protobuf.Any
	67,  // 189: substrait.ReadRel.LocalFiles.items:type_name -> substrait.ReadRel.LocalFiles.FileOrFiles
	146, // 190: substrait.ReadRel.LocalFiles.advanced_extension:type_name -> substrait.extensions.AdvancedExtension
	68,  // 191: substrait.ReadRel.LocalFiles.FileOrFiles.parquet:type_name -> substrait.ReadRel.LocalFiles.FileOrFiles.ParquetReadOptions
	69,  // 192: substrait.ReadRel.LocalFiles.FileOrFiles.arrow:type_name -> substrait.ReadRel.LocalFiles.FileOrFiles.ArrowReadOptions
	70,  // 193: substrait.ReadRel.LocalFiles.FileOrFiles.orc:type_name -> substrait.ReadRel.LocalFiles.FileOrFiles.OrcReadOptions
	148, // 194: substrait.ReadRel.LocalFiles.FileOrFiles.extension:type_name -> google.protobuf.Any
	71,  // 195: substrait.ReadRel.LocalFiles.FileOrFiles.dwrf:type_name -> substrait.ReadRel.LocalFiles.FileOrFiles.DwrfReadOptions
	72,  // 196: substrait.ReadRel.LocalFiles.FileOrFiles.text:type_name -> substrait.ReadRel.LocalFiles.FileOrFiles.DelimiterSeparatedTextReadOptions
	50,  // 197: substrait.AggregateRel.Grouping.grouping_expressions:type_name -> substrait.Expression
	52,  // 198: substrait.AggregateRel.Measure.measure:type_name -> substrait.AggregateFunction
	50,  // 199: substrait.AggregateRel.Measure.filter:type_name -> substrait.Expression
	48,  // 200: substrait.ConsistentPartitionWindowRel.WindowRelFunction.arguments:type_name -> substrait.FunctionArgument
	49,  // 201: substrait.ConsistentPartitionWindowRel.WindowRelFunction.options:type_name -> substrait.FunctionOption
	149, // 202: substrait.ConsistentPartitionWindowRel.WindowRelFunction.output_type:type_name -> substrait.Type
	0,   // 203: substrait.ConsistentPartitionWindowRel.WindowRelFunction.phase:type_name -> substrait.AggregationPhase
	19,  // 204: substrait.ConsistentPartitionWindowRel.WindowRelFunction.invocation:type_name -> substrait.AggregateFunction.AggregationInvocation
	117, // 205: substrait.ConsistentPartitionWindowRel.WindowRelFunction.lower_bound:type_name -> substrait.Expression.WindowFunction.Bound
	117, // 206: substrait.ConsistentPartitionWindowRel.WindowRelFunction.upper_bound:type_name -> substrait.Expression.WindowFunction.Bound
	13,  // 207: substrait.ConsistentPartitionWindowRel.WindowRelFunction.bounds_type:type_name -> substrait.Expression.WindowFunction.BoundsType
	99,  // 208: substrait.ExchangeRel.ScatterFields.fields:type_name -> substrait.Expression.FieldReference
	50,  // 209: substrait.ExchangeRel.SingleBucketExpression.expression:type_name -> substrait.Expression
	50,  // 210: substrait.ExchangeRel.MultiBucketExpression.expression:type_name -> substrait.Expression
	148, // 211: substrait.ExchangeRel.ExchangeTarget.extended:type_name -> google.protobuf.Any
	83,  // 212: substrait.ExpandRel.ExpandField.switching_field:type_name -> substrait.ExpandRel.SwitchingField
	50,  // 213: substrait.ExpandRel.ExpandField.consistent_field:type_name -> substrait.Expression
	50,  // 214: substrait.ExpandRel.SwitchingField.duplicates:type_name -> substrait.Expression
	50,  // 215: substrait.UpdateRel.TransformExpression.transformation:type_name -> substrait.Expression
	9,   // 216: substrait.ComparisonJoinKey.ComparisonType.simple:type_name -> substrait.ComparisonJoinKey.SimpleComparisonType
	101, // 217: substrait.Expression.Enum.unspecified:type_name -> substrait.Expression.Enum.Empty
	106, // 218: substrait.Expression.Literal.interval_year_to_month:type_name -> substrait.Expression.Literal.IntervalYearToMonth
	107, // 219: substrait.Expression.Literal.interval_day_to_second:type_name -> substrait.Expression.Literal.IntervalDayToSecond
	108, // 220: substrait.Expression.Literal.interval_compound:type_name -> substrait.Expression.Literal.IntervalCompound
	102, // 221: substrait.Expression.Literal.var_char:type_name -> substrait.Expression.Literal.VarChar
	103, // 222: substrait.Expression.Literal.decimal:type_name -> substrait.Expression.Literal.Decimal
	104, // 223: substrait.Expression.Literal.precision_timestamp:type_name -> substrait.Expression.Literal.PrecisionTimestamp
	104, // 224: substrait.Expression.Literal.precision_timestamp_tz:type_name -> substrait.Expression.Literal.PrecisionTimestamp
	109, // 225: substrait.Expression.Literal.struct:type_name -> substrait.Expression.Literal.Struct
	105, // 226: substrait.Expression.Literal.map:type_name -> substrait.Expression.Literal.Map
	149, // 227: substrait.Expression.Literal.null:type_name -> substrait.Type
	110, // 228: substrait.Expression.Literal.list:type_name -> substrait.Expression.Literal.List
	150, // 229: substrait.Expression.Literal.empty_list:type_name -> substrait.Type.List
	151, // 230: substrait.Expression.Literal.empty_map:type_name -> substrait.Type.Map
	111, // 231: substrait.Expression.Literal.user_defined:type_name -> substrait.Expression.Literal.UserDefined
	114, // 232: substrait.Expression.Nested.struct:type_name -> substrait.Expression.Nested.Struct
	115, // 233: substrait.Expression.Nested.list:type_name -> substrait.Expression.Nested.List
	113, // 234: substrait.Expression.Nested.map:type_name -> substrait.Expression.Nested.Map
	48,  // 235: substrait.Expression.ScalarFunction.arguments:type_name -> substrait.FunctionArgument
	49,  // 236: substrait.Expression.ScalarFunction.options:type_name -> substrait.FunctionOption
	149, // 237: substrait.Expression.ScalarFunction.output_type:type_name -> substrait.Type
	50,  // 238: substrait.Expression.ScalarFunction.args:type_name -> substrait.Expression
	48,  // 239: substrait.Expression.WindowFunction.arguments:type_name -> substrait.FunctionArgument
	49,  // 240: substrait.Expression.WindowFunction.options:type_name -> substrait.FunctionOption
	149, // 241: substrait.Expression.WindowFunction.output_type:type_name -> substrait.Type
	0,   // 242: substrait.Expression.WindowFunction.phase:type_name -> substrait.AggregationPhase
	51,  // 243: substrait.Expression.WindowFunction.sorts:type_name -> substrait.SortField
	19,  // 244: substrait.Expression.WindowFunction.invocation:type_name -> substrait.AggregateFunction.AggregationInvocation
	50,  // 245: substrait.Expression.WindowFunction.partitions:type_name -> substrait.Expression
	13,  // 246: substrait.Expression.WindowFunction.bounds_type:type_name -> substrait.Expression.WindowFunction.BoundsType
	117, // 247: substrait.Expression.WindowFunction.lower_bound:type_name -> substrait.Expression.WindowFunction.Bound
	117, // 248: substrait.Expression.WindowFunction.upper_bound:type_name -> substrait.Expression.WindowFunction.Bound
	50,  // 249: substrait.Expression.WindowFunction.args:type_name -> substrait.Expression
	122, // 250: substrait.Expression.IfThen.ifs:type_name -> substrait.Expression.IfThen.IfClause
	50,  // 251: substrait.Expression.IfThen.else:type_name -> substrait.Expression
	149, // 252: substrait.Expression.Cast.type:type_name -> substrait.Type
	50,  // 253: substrait.Expression.Cast.input:type_name -> substrait.Expression
	14,  // 254: substrait.Expression.Cast.failure_behavior:type_name -> substrait.Expression.Cast.FailureBehavior
	50,  // 255: substrait.Expression.SwitchExpression.match:type_name -> substrait.Expression
	123, // 256: substrait.Expression.SwitchExpression.ifs:type_name -> substrait.Expression.SwitchExpression.IfValue
	50,  // 257: substrait.Expression.SwitchExpression.else:type_name -> substrait.Expression
	50,  // 258: substrait.Expression.SingularOrList.value:type_name -> substrait.Expression
	50,  // 259: substrait.Expression.SingularOrList.options:type_name -> substrait.Expression
	50,  // 260: substrait.Expression.MultiOrList.value:type_name -> substrait.Expression
	124, // 261: substrait.Expression.MultiOrList.options:type_name -> substrait.Expression.MultiOrList.Record
	50,  // 262: substrait.Expression.EmbeddedFunction.arguments:type_name -> substrait.Expression
	149, // 263: substrait.Expression.EmbeddedFunction.output_type:type_name -> substrait.Type
	125, // 264: substrait.Expression.EmbeddedFunction.python_pickle_function:type_name -> substrait.Expression.EmbeddedFunction.PythonPickleFunction
	126, // 265: substrait.Expression.EmbeddedFunction.web_assembly_function:type_name -> substrait.Expression.EmbeddedFunction.WebAssemblyFunction
	127, // 266: substrait.Expression.ReferenceSegment.map_key:type_name -> substrait.Expression.ReferenceSegment.MapKey
	128, // 267: substrait.Expression.ReferenceSegment.struct_field:type_name -> substrait.Expression.ReferenceSegment.StructField
	129, // 268: substrait.Expression.ReferenceSegment.list_element:type_name -> substrait.Expression.ReferenceSegment.ListElement
	131, // 269: substrait.Expression.MaskExpression.select:type_name -> substrait.Expression.MaskExpression.StructSelect
	97,  // 270: substrait.Expression.FieldReference.direct_reference:type_name -> substrait.Expression.ReferenceSegment
	98,  // 271: substrait.Expression.FieldReference.masked_reference:type_name -> substrait.Expression.MaskExpression
	50,  // 272: substrait.Expression.FieldReference.expression:type_name -> substrait.Expression
	140, // 273: substrait.Expression.FieldReference.root_reference:type_name -> substrait.Expression.FieldReference.RootReference
	141, // 274: substrait.Expression.FieldReference.outer_reference:type_name -> substrait.Expression.FieldReference.OuterReference
	142, // 275: substrait.Expression.Subquery.scalar:type_name -> substrait.Expression.Subquery.Scalar
	143, // 276: substrait.Expression.Subquery.in_predicate:type_name -> substrait.Expression.Subquery.InPredicate
	144, // 277: substrait.Expression.Subquery.set_predicate:type_name -> substrait.Expression.Subquery.SetPredicate
	145, // 278: substrait.Expression.Subquery.set_comparison:type_name -> substrait.Expression.Subquery.SetComparison
	112, // 279: substrait.Expression.Literal.Map.key_values:type_name -> substrait.Expression.Literal.Map.KeyValue
	106, // 280: substrait.Expression.Literal.IntervalCompound.interval_year_to_month:type_name -> substrait.Expression.Literal.IntervalYearToMonth
	107, // 281: substrait.Expression.Literal.IntervalCompound.interval_day_to_second:type_name -> substrait.Expression.Literal.IntervalDayToSecond
	87,  // 282: substrait.Expression.Literal.Struct.fields:type_name -> substrait.Expression.Literal
	87,  // 283: substrait.Expression.Literal.List.values:type_name -> substrait.Expression.Literal
	152, // 284: substrait.Expression.Literal.UserDefined.type_parameters:type_name -> substrait.Type.Parameter
	148, // 285: substrait.Expression.Literal.UserDefined.value:type_name -> google.protobuf.Any
	109, // 286: substrait.Expression.Literal.UserDefined.struct:type_name -> substrait.Expression.Literal.Struct
	87,  // 287: substrait.Expression.Literal.Map.KeyValue.key:type_name -> substrait.Expression.Literal
	87,  // 288: substrait.Expression.Literal.Map.KeyValue.value:type_name -> substrait.Expression.Literal
	116, // 289: substrait.Expression.Nested.Map.key_values:type_name -> substrait.Expression.Nested.Map.KeyValue
	50,  // 290: substrait.Expression.Nested.Struct.fields:type_name -> substrait.Expression
	50,  // 291: substrait.Expression.Nested.List.values:type_name -> substrait.Expression
	50,  // 292: substrait.Expression.Nested.Map.KeyValue.key:type_name -> substrait.Expression
	50,  // 293: substrait.Expression.Nested.Map.KeyValue.value:type_name -> substrait.Expression
	118, // 294: substrait.Expression.WindowFunction.Bound.preceding:type_name -> substrait.Expression.WindowFunction.Bound.Preceding
	119, // 295: substrait.Expression.WindowFunction.Bound.following:type_name -> substrait.Expression.WindowFunction.Bound.Following
	120, // 296: substrait.Expression.WindowFunction.Bound.current_row:type_name -> substrait.Expression.WindowFunction.Bound.CurrentRow
	121, // 297: substrait.Expression.WindowFunction.Bound.unbounded:type_name -> substrait.Expression.WindowFunction.Bound.Unbounded
	50,  // 298: substrait.Expression.IfThen.IfClause.if:type_name -> substrait.Expression
	50,  // 299: substrait.Expression.IfThen.IfClause.then:type_name -> substrait.Expression
	87,  // 300: substrait.Expression.SwitchExpression.IfValue.if:type_name -> substrait.Expression.Literal
	50,  // 301: substrait.Expression.SwitchExpression.IfValue.then:type_name -> substrait.Expression
	50,  // 302: substrait.Expression.MultiOrList.Record.fields:type_name -> substrait.Expression
	87,  // 303: substrait.Expression.ReferenceSegment.MapKey.map_key:type_name -> substrait.Expression.Literal
	97,  // 304: substrait.Expression.ReferenceSegment.MapKey.child:type_name -> substrait.Expression.ReferenceSegment
	97,  // 305: substrait.Expression.ReferenceSegment.StructField.child:type_name -> substrait.Expression.ReferenceSegment
	97,  // 306: substrait.Expression.ReferenceSegment.ListElement.child:type_name -> substrait.Expression.ReferenceSegment
	131, // 307: substrait.Expression.MaskExpression.Select.struct:type_name -> substrait.Expression.MaskExpression.StructSelect
	133, // 308: substrait.Expression.MaskExpression.Select.list:type_name -> substrait.Expression.MaskExpression.ListSelect
	134, // 309: substrait.Expression.MaskExpression.Select.map:type_name -> substrait.Expression.MaskExpression.MapSelect
	132, // 310: substrait.Expression.MaskExpression.StructSelect.struct_items:type_name -> substrait.Expression.MaskExpression.StructItem
	130, // 311: substrait.Expression.MaskExpression.StructItem.child:type_name -> substrait.Expression.MaskExpression.Select
	135, // 312: substrait.Expression.MaskExpression.ListSelect.selection:type_name -> substrait.Expression.MaskExpression.ListSelect.ListSelectItem
	130, // 313: substrait.Expression.MaskExpression.ListSelect.child:type_name -> substrait.Expression.MaskExpression.Select
	138, // 314: substrait.Expression.MaskExpression.MapSelect.key:type_name -> substrait.Expression.MaskExpression.MapSelect.MapKey
	139, // 315: substrait.Expression.MaskExpression.MapSelect.expression:type_name -> substrait.Expression.MaskExpression.MapSelect.MapKeyExpression
	130, // 316: substrait.Expression.MaskExpression.MapSelect.child:type_name -> substrait.Expression.MaskExpression.Select
	136, // 317: substrait.Expression.MaskExpression.ListSelect.ListSelectItem.item:type_name -> substrait.Expression.MaskExpression.ListSelect.ListSelectItem.ListElement
	137, // 318: substrait.Expression.MaskExpression.ListSelect.ListSelectItem.slice:type_name -> substrait.Expression.MaskExpression.ListSelect.ListSelectItem.ListSlice
	37,  // 319: substrait.Expression.Subquery.Scalar.input:type_name -> substrait.Rel
	50,  // 320: substrait.Expression.Subquery.InPredicate.needles:type_name -> substrait.Expression
	37,  // 321: substrait.Expression.Subquery.InPredicate.haystack:type_name -> substrait.Rel
	15,  // 322: substrait.Expression.Subquery.SetPredicate.predicate_op:type_name -> substrait.Expression.Subquery.SetPredicate.PredicateOp
	37,  // 323: substrait.Expression.Subquery.SetPredicate.tuples:type_name -> substrait.Rel
	17,  // 324: substrait.Expression.Subquery.SetComparison.reduction_op:type_name -> substrait.Expression.Subquery.SetComparison.ReductionOp
	16,  // 325: substrait.Expression.Subquery.SetComparison.comparison_op:type_name -> substrait.Expression.Subquery.SetComparison.ComparisonOp
	50,  // 326: substrait.Expression.Subquery.SetComparison.left:type_name -> substrait.Expression
	37,  // 327: substrait.Expression.Subquery.SetComparison.right:type_name -> substrait.Rel
	328, // [328:328] is the sub-list for method output_type
	328, // [328:328] is the sub-list for method input_type
	328, // [328:328] is the sub-list for extension type_name
	328, // [328:328] is the sub-list for extension extendee
	0,   // [0:328] is the sub-list for field type_name
}

func init() { file_substrait_algebra_proto_init() }
func file_substrait_algebra_proto_init() {
	if File_substrait_algebra_proto != nil {
		return
	}
	file_substrait_type_proto_init()
	file_substrait_algebra_proto_msgTypes[0].OneofWrappers = []any{
		(*RelCommon_Direct_)(nil),
		(*RelCommon_Emit_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[1].OneofWrappers = []any{
		(*ReadRel_VirtualTable_)(nil),
		(*ReadRel_LocalFiles_)(nil),
		(*ReadRel_NamedTable_)(nil),
		(*ReadRel_ExtensionTable_)(nil),
		(*ReadRel_IcebergTable_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[5].OneofWrappers = []any{
		(*FetchRel_Offset)(nil),
		(*FetchRel_OffsetExpr)(nil),
		(*FetchRel_Count)(nil),
		(*FetchRel_CountExpr)(nil),
	}
	file_substrait_algebra_proto_msgTypes[14].OneofWrappers = []any{
		(*ExchangeRel_ScatterByFields)(nil),
		(*ExchangeRel_SingleTarget)(nil),
		(*ExchangeRel_MultiTarget)(nil),
		(*ExchangeRel_RoundRobin_)(nil),
		(*ExchangeRel_Broadcast_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[17].OneofWrappers = []any{
		(*Rel_Read)(nil),
		(*Rel_Filter)(nil),
		(*Rel_Fetch)(nil),
		(*Rel_Aggregate)(nil),
		(*Rel_Sort)(nil),
		(*Rel_Join)(nil),
		(*Rel_Project)(nil),
		(*Rel_Set)(nil),
		(*Rel_ExtensionSingle)(nil),
		(*Rel_ExtensionMulti)(nil),
		(*Rel_ExtensionLeaf)(nil),
		(*Rel_Cross)(nil),
		(*Rel_Reference)(nil),
		(*Rel_Write)(nil),
		(*Rel_Ddl)(nil),
		(*Rel_Update)(nil),
		(*Rel_HashJoin)(nil),
		(*Rel_MergeJoin)(nil),
		(*Rel_NestedLoopJoin)(nil),
		(*Rel_Window)(nil),
		(*Rel_Exchange)(nil),
		(*Rel_Expand)(nil),
	}
	file_substrait_algebra_proto_msgTypes[20].OneofWrappers = []any{
		(*DdlRel_NamedObject)(nil),
		(*DdlRel_ExtensionObject)(nil),
	}
	file_substrait_algebra_proto_msgTypes[21].OneofWrappers = []any{
		(*WriteRel_NamedTable)(nil),
		(*WriteRel_ExtensionTable)(nil),
	}
	file_substrait_algebra_proto_msgTypes[22].OneofWrappers = []any{
		(*UpdateRel_NamedTable)(nil),
	}
	file_substrait_algebra_proto_msgTypes[28].OneofWrappers = []any{
		(*FunctionArgument_Enum)(nil),
		(*FunctionArgument_Type)(nil),
		(*FunctionArgument_Value)(nil),
	}
	file_substrait_algebra_proto_msgTypes[30].OneofWrappers = []any{
		(*Expression_Literal_)(nil),
		(*Expression_Selection)(nil),
		(*Expression_ScalarFunction_)(nil),
		(*Expression_WindowFunction_)(nil),
		(*Expression_IfThen_)(nil),
		(*Expression_SwitchExpression_)(nil),
		(*Expression_SingularOrList_)(nil),
		(*Expression_MultiOrList_)(nil),
		(*Expression_Cast_)(nil),
		(*Expression_Subquery_)(nil),
		(*Expression_Nested_)(nil),
		(*Expression_Enum_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[31].OneofWrappers = []any{
		(*SortField_Direction)(nil),
		(*SortField_ComparisonFunctionReference)(nil),
	}
	file_substrait_algebra_proto_msgTypes[42].OneofWrappers = []any{
		(*ReadRel_IcebergTable_Direct)(nil),
	}
	file_substrait_algebra_proto_msgTypes[46].OneofWrappers = []any{
		(*ReadRel_IcebergTable_MetadataFileRead_SnapshotId)(nil),
		(*ReadRel_IcebergTable_MetadataFileRead_SnapshotTimestamp)(nil),
	}
	file_substrait_algebra_proto_msgTypes[47].OneofWrappers = []any{
		(*ReadRel_LocalFiles_FileOrFiles_UriPath)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_UriPathGlob)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_UriFile)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_UriFolder)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_Parquet)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_Arrow)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_Orc)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_Extension)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_Dwrf)(nil),
		(*ReadRel_LocalFiles_FileOrFiles_Text)(nil),
	}
	file_substrait_algebra_proto_msgTypes[52].OneofWrappers = []any{}
	file_substrait_algebra_proto_msgTypes[61].OneofWrappers = []any{
		(*ExchangeRel_ExchangeTarget_Uri)(nil),
		(*ExchangeRel_ExchangeTarget_Extended)(nil),
	}
	file_substrait_algebra_proto_msgTypes[62].OneofWrappers = []any{
		(*ExpandRel_ExpandField_SwitchingField)(nil),
		(*ExpandRel_ExpandField_ConsistentField)(nil),
	}
	file_substrait_algebra_proto_msgTypes[65].OneofWrappers = []any{
		(*ComparisonJoinKey_ComparisonType_Simple)(nil),
		(*ComparisonJoinKey_ComparisonType_CustomFunctionReference)(nil),
	}
	file_substrait_algebra_proto_msgTypes[66].OneofWrappers = []any{
		(*Expression_Enum_Specified)(nil),
		(*Expression_Enum_Unspecified)(nil),
	}
	file_substrait_algebra_proto_msgTypes[67].OneofWrappers = []any{
		(*Expression_Literal_Boolean)(nil),
		(*Expression_Literal_I8)(nil),
		(*Expression_Literal_I16)(nil),
		(*Expression_Literal_I32)(nil),
		(*Expression_Literal_I64)(nil),
		(*Expression_Literal_Fp32)(nil),
		(*Expression_Literal_Fp64)(nil),
		(*Expression_Literal_String_)(nil),
		(*Expression_Literal_Binary)(nil),
		(*Expression_Literal_Timestamp)(nil),
		(*Expression_Literal_Date)(nil),
		(*Expression_Literal_Time)(nil),
		(*Expression_Literal_IntervalYearToMonth_)(nil),
		(*Expression_Literal_IntervalDayToSecond_)(nil),
		(*Expression_Literal_IntervalCompound_)(nil),
		(*Expression_Literal_FixedChar)(nil),
		(*Expression_Literal_VarChar_)(nil),
		(*Expression_Literal_FixedBinary)(nil),
		(*Expression_Literal_Decimal_)(nil),
		(*Expression_Literal_PrecisionTimestamp_)(nil),
		(*Expression_Literal_PrecisionTimestampTz)(nil),
		(*Expression_Literal_Struct_)(nil),
		(*Expression_Literal_Map_)(nil),
		(*Expression_Literal_TimestampTz)(nil),
		(*Expression_Literal_Uuid)(nil),
		(*Expression_Literal_Null)(nil),
		(*Expression_Literal_List_)(nil),
		(*Expression_Literal_EmptyList)(nil),
		(*Expression_Literal_EmptyMap)(nil),
		(*Expression_Literal_UserDefined_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[68].OneofWrappers = []any{
		(*Expression_Nested_Struct_)(nil),
		(*Expression_Nested_List_)(nil),
		(*Expression_Nested_Map_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[76].OneofWrappers = []any{
		(*Expression_EmbeddedFunction_PythonPickleFunction_)(nil),
		(*Expression_EmbeddedFunction_WebAssemblyFunction_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[77].OneofWrappers = []any{
		(*Expression_ReferenceSegment_MapKey_)(nil),
		(*Expression_ReferenceSegment_StructField_)(nil),
		(*Expression_ReferenceSegment_ListElement_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[79].OneofWrappers = []any{
		(*Expression_FieldReference_DirectReference)(nil),
		(*Expression_FieldReference_MaskedReference)(nil),
		(*Expression_FieldReference_Expression)(nil),
		(*Expression_FieldReference_RootReference_)(nil),
		(*Expression_FieldReference_OuterReference_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[80].OneofWrappers = []any{
		(*Expression_Subquery_Scalar_)(nil),
		(*Expression_Subquery_InPredicate_)(nil),
		(*Expression_Subquery_SetPredicate_)(nil),
		(*Expression_Subquery_SetComparison_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[87].OneofWrappers = []any{
		(*Expression_Literal_IntervalDayToSecond_Microseconds)(nil),
		(*Expression_Literal_IntervalDayToSecond_Precision)(nil),
	}
	file_substrait_algebra_proto_msgTypes[91].OneofWrappers = []any{
		(*Expression_Literal_UserDefined_Value)(nil),
		(*Expression_Literal_UserDefined_Struct)(nil),
	}
	file_substrait_algebra_proto_msgTypes[97].OneofWrappers = []any{
		(*Expression_WindowFunction_Bound_Preceding_)(nil),
		(*Expression_WindowFunction_Bound_Following_)(nil),
		(*Expression_WindowFunction_Bound_CurrentRow_)(nil),
		(*Expression_WindowFunction_Bound_Unbounded_)(nil),
	}
	file_substrait_algebra_proto_msgTypes[110].OneofWrappers = []any{
		(*Expression_MaskExpression_Select_Struct)(nil),
		(*Expression_MaskExpression_Select_List)(nil),
		(*Expression_MaskExpression_Select_Map)(nil),
	}
	file_substrait_algebra_proto_msgTypes[114].OneofWrappers = []any{
		(*Expression_MaskExpression_MapSelect_Key)(nil),
		(*Expression_MaskExpression_MapSelect_Expression)(nil),
	}
	file_substrait_algebra_proto_msgTypes[115].OneofWrappers = []any{
		(*Expression_MaskExpression_ListSelect_ListSelectItem_Item)(nil),
		(*Expression_MaskExpression_ListSelect_ListSelectItem_Slice)(nil),
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_substrait_algebra_proto_rawDesc,
			NumEnums:      20,
			NumMessages:   126,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_substrait_algebra_proto_goTypes,
		DependencyIndexes: file_substrait_algebra_proto_depIdxs,
		EnumInfos:         file_substrait_algebra_proto_enumTypes,
		MessageInfos:      file_substrait_algebra_proto_msgTypes,
	}.Build()
	File_substrait_algebra_proto = out.File
	file_substrait_algebra_proto_rawDesc = nil
	file_substrait_algebra_proto_goTypes = nil
	file_substrait_algebra_proto_depIdxs = nil
}
